%define name SyFi 
%define version 0.3.2 
%define release 1

Summary: C++ library for computing and using finite elements symbolically 
Name: %{name}
Version: %{version}
Release: %{release}
Copyright: GPL
Group: System Environment/Libraries
Source: http://www.sf.net/projects/syfi 
URL: http://syfi.sf.net
Packager: Kent-Andre Mardal <kent-and@simula.no>
Prereq: /sbin/install-info
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

Requires: ginac >= 1.3.0

%description
SyFi is an open framework for computing and using finite elements based 
on the symbolic engine GiNaC


%package devel
Summary: SyFi development libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
SyFi is an open framework for computing and using finite elements based 
on the symbolic engine GiNaC

This package contains the libraries, include files and other resources you
use to develop GiNaC applications.



%prep
%setup -q

%build
CFLAGS=${RPM_OPT_FLAGS} CXXFLAGS=${RPM_OPT_FLAGS} ./configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir}
if [ -x /usr/bin/getconf ] ; then
  NCPU=$(/usr/bin/getconf _NPROCESSORS_ONLN)
  if [ $NCPU -eq 0 ] ; then
    NCPU=1
  fi
else  
  NCPU=1
fi
(make -k -j $NCPU; exit 0)
make

%install
rm -rf ${RPM_BUILD_ROOT}
make DESTDIR=${RPM_BUILD_ROOT} install
gzip -9nf ${RPM_BUILD_ROOT}%{_infodir}/syfi.info*
rm ${RPM_BUILD_ROOT}%{_infodir}/dir

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%post devel
/sbin/install-info %{_infodir}/syfi.info.gz %{_infodir}/dir

%preun devel
if [ "$1" = 0 ]; then
  /sbin/install-info --delete %{_infodir}/syfi.info.gz %{_infodir}/dir
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/syfi.pc
%{_includedir}/syfi
%{_infodir}/*.info*
%{_mandir}/man1/syfi-config.1*
%{_bindir}/syfi-config
%{_datadir}/aclocal/syfi.m4


