
#include <Poisson1.h>
#include <Mat_real.h>
void SyFicalcElmMatVec2D (int element, ElmMatVec& elmat, FiniteElement& fe){

  Mat(double) G(3,2); 
  fe.grid().getElmCoor(G,element); 


  double x0 = G(1,1); double y0 = G(1,2); 
  double x1 = G(2,1); double y1 = G(2,2); 
  double x2 = G(3,1); double y2 = G(3,2); 

  double a = x1 - x0; 
  double b = x2 - x0;  
  double c = y1 - y0; 
  double d = y2 - y0; 

  static double A[3][3]; 

  double JJ00 = 1.0/(a*d-c*b)*d;
  double JJ01 = -1.0*1.0/(a*d-c*b)*c;
  double JJ10 = -1.0*1.0/(a*d-c*b)*b;
  double JJ11 = 1.0/(a*d-c*b)*a;


  double D = fabs(a*d - b*c);  


  A[0][0]=(JJ01*JJ01)/2.0+(JJ11*JJ11)/2.0+JJ00*JJ01+(JJ00*JJ00)/2.0+JJ11*JJ10+(JJ10*JJ10)/2.0;
  A[0][1]=-JJ00*JJ01/2.0-(JJ00*JJ00)/2.0-JJ11*JJ10/2.0-(JJ10*JJ10)/2.0;
  A[0][2]=-(JJ01*JJ01)/2.0-(JJ11*JJ11)/2.0-JJ00*JJ01/2.0-JJ11*JJ10/2.0;
  A[1][0]=-JJ00*JJ01/2.0-(JJ00*JJ00)/2.0-JJ11*JJ10/2.0-(JJ10*JJ10)/2.0;
  A[1][1]=(JJ00*JJ00)/2.0+(JJ10*JJ10)/2.0;
  A[1][2]=JJ00*JJ01/2.0+JJ11*JJ10/2.0;
  A[2][0]=-(JJ01*JJ01)/2.0-(JJ11*JJ11)/2.0-JJ00*JJ01/2.0-JJ11*JJ10/2.0;
  A[2][1]=JJ00*JJ01/2.0+JJ11*JJ10/2.0;
  A[2][2]=(JJ01*JJ01)/2.0+(JJ11*JJ11)/2.0;


  elmat.A(1,1) = A[0][0]*D;
  elmat.A(1,2) = A[0][1]*D;
  elmat.A(1,3) = A[0][2]*D;
  elmat.A(2,1) = A[1][0]*D;
  elmat.A(2,2) = A[1][1]*D;
  elmat.A(2,3) = A[1][2]*D;
  elmat.A(3,1) = A[2][0]*D;
  elmat.A(3,2) = A[2][1]*D;
  elmat.A(3,3) = A[2][2]*D;

}
