#!/usr/bin/python 

from swiginac import *
from SyFi import *


a = symbol("a"); b = symbol("b"); 
c = symbol("c"); d = symbol("d") 

J = matrix(2,2, [a,c,b,d]) 
Jinv = J.inverse()
JJ = symbolic_matrix(2,2,"JJ")



p0 = [0,0]; p1 = [1,0]; p2 = [0,1]
triangle = Triangle(toex(p0), toex(p1), toex(p2))

fe = LagrangeFE()
fe.set(triangle) 
fe.set(1)
fe.compute_basis_functions()
A_str =""
for i in range(1,fe.nbf()+1): 
  print fe.N(i).eval() 
  for j in range(1,fe.nbf()+1): 
    gradNi    = (JJ*(grad(fe.N(i)).eval())).evalm()
    gradNj    = (JJ*(grad(fe.N(j)).eval())).evalm()
    integrand = inner(toex(gradNi), toex(gradNj))  
    Aij = triangle.integrate(integrand) 
    # print "A(%d,%d)="%(i,j), Aij.eval()
    A_str += "  A[%d][%d]=%s;\n"%(i-1,j-1,Aij.eval().printc())

A_str += "\n\n" 

for i in range(1,fe.nbf()+1): 
  for j in range(1,fe.nbf()+1): 
    if i == 1: k = 0
    if i == 2: k = 1
    if i == 3: k = 2
    if j == 1: l = 0
    if j == 2: l = 1
    if j == 3: l = 2

    A_str += "  elmat.A(%d,%d) = A[%d][%d]*D;\n"%(i,j,k,l)


J_str = ""
for i in range(0,JJ.nops()):
  J_str += "  double " +  JJ.op(i).eval().printc() +  " = " + Jinv.op(i).eval().printc() + ";\n"  
  



s = """
#include <Poisson1.h>
#include <Mat_real.h>
void SyFicalcElmMatVec2D (int element, ElmMatVec& elmat, FiniteElement& fe){

  Mat(double) G(3,2); 
  fe.grid().getElmCoor(G,element); 


  double x0 = G(1,1); double y0 = G(1,2); 
  double x1 = G(2,1); double y1 = G(2,2); 
  double x2 = G(3,1); double y2 = G(3,2); 

  double a = x1 - x0; 
  double b = x2 - x0;  
  double c = y1 - y0; 
  double d = y2 - y0; 

  static double A[3][3]; 

%s

  double D = fabs(a*d - b*c);  


%s
}
"""% (J_str,A_str) 



print "writing C code to the file SyFicalcElmMatVec2D.cpp"
cfile = open("SyFicalcElmMatVec2D.cpp",'w')
cfile.write(s)



