#!/usr/bin/python 


from swiginac import *
from SyFi import *


cvar.nsd = 3

a = symbol("a"); b = symbol("b"); c = symbol("c"); d = symbol("d") 
e = symbol("e"); f = symbol("f"); g = symbol("g"); h = symbol("h"); k = symbol("k") 

J = matrix(3,3, [a,d,g,b,e,h,c,f,k]) 
Jinv = J.inverse()
JJ = symbolic_matrix(3,3,"JJ")

print J 
print Jinv


p0 = [0,0,0]; p1 = [1,0,0]; p2 = [0,1,0]; p3 = [0,0,1]

tetrahedon = Tetrahedron(toex(p0), toex(p1), toex(p2), toex(p3))

fe = LagrangeFE()
fe.set(tetrahedon) 
fe.set(1)
fe.compute_basis_functions()
A_str =""
for i in range(1,fe.nbf()+1): 
  for j in range(1,fe.nbf()+1): 
    gradNi    = (JJ*(grad(fe.N(i)).eval())).evalm()
    gradNj    = (JJ*(grad(fe.N(j)).eval())).evalm()
    integrand = inner(toex(gradNi), toex(gradNj))  
    Aij = tetrahedon.integrate(integrand) 
    # print "A(%d,%d)="%(i,j), Aij.eval()
    A_str += "  A[%d][%d]=%s;\n"%(i-1,j-1,Aij.eval().printc())


A_str += "\n\n" 

for i in range(1,fe.nbf()+1): 
  for j in range(1,fe.nbf()+1): 
    if i == 1: k = 0
    if i == 2: k = 1
    if i == 3: k = 2
    if i == 4: k = 3

    if j == 1: l = 0
    if j == 2: l = 1
    if j == 3: l = 2
    if j == 4: l = 3

    A_str += "  elmat.A(%d,%d) = A[%d][%d]*D;\n"%(i,j,k,l)


J_str = ""
for i in range(0,JJ.nops()):
  J_str += "  double " +  JJ.op(i).eval().printc() +  " = " + Jinv.op(i).eval().printc() + ";\n"  
 


s = """
#include <Poisson1.h>
#include <Mat_real.h>
void SyFicalcElmMatVec3D (int element, ElmMatVec& elmat, FiniteElement& fe){

  Mat(double) G(4,3); 
  fe.grid().getElmCoor(G,element); 


  double x0 = G(1,1); double y0 = G(1,2); double z0 = G(1,3);  
  double x1 = G(2,1); double y1 = G(2,2); double z1 = G(2,3); 
  double x2 = G(3,1); double y2 = G(3,2); double z2 = G(3,3);  
  double x3 = G(4,1); double y3 = G(4,2); double z3 = G(4,3);  


  double a   = x1 - x0;
  double d   = y1 - y0;
  double g   = z1 - z0;

  double b   = x2 - x0;
  double e   = y2 - y0;
  double h   = z2 - z0;

  double c   = x3 - x0;
  double f   = y3 - y0;
  double k   = z3 - z0;


  double D = a*(e*k-f*h) - b*(d*k-f*g) + c*(d*h-g*e);   

%s

  static double A[4][4]; 


%s
}
"""% (J_str,A_str) 



print "writing C code to the file SyFicalcElmMatVec3D.cpp"
cfile = open("SyFicalcElmMatVec3D.cpp",'w')
cfile.write(s)



