#ifndef ELEMENTMATRIXCALCULATOR_IS_INCLUDED
#define ELEMENTMATRIXCALCULATOR_IS_INCLUDED

#include <math.h>
#include <utility>
#include <map>
#include <ptv.h>
#include <DofT.h>
#include <ScalarFunction.h>
  
using namespace std; 
 
//mass 2D

void matrix_factory_mass_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_mass_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_mass_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_mass_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_mass_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 

//mass 3D

void matrix_factory_mass_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_mass_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_mass_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3]); 

//mass 2D with c 

void matrix_factory_mass_2D_with_c_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double c); 
void matrix_factory_mass_2D_with_c_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double c); 
void matrix_factory_mass_2D_with_c_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double c); 
void matrix_factory_mass_2D_with_c_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double c); 
void matrix_factory_mass_2D_with_c_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double c); 

//mass 3D with c

void matrix_factory_mass_3D_with_c_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3], double c); 
void matrix_factory_mass_3D_with_c_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3], double c); 
void matrix_factory_mass_3D_with_c_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3], double c); 




//vector mass 2D

void matrix_factory_vector_mass_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_mass_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_mass_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_mass_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_mass_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 

//vector mass 3D

void matrix_factory_vector_mass_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_mass_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_mass_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[3], double pp2[3], double pp3[3]); 




//stiffness 2D


void matrix_factory_stiffness_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 



void matrix_factory_stiffness_2D_with_M_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_with_M_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_with_M_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_with_M_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_stiffness_2D_with_M_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 

//stiffness 3D

void matrix_factory_stiffness_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_stiffness_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_stiffness_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 


void matrix_factory_stiffness_3D_with_M_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_stiffness_3D_with_M_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_stiffness_3D_with_M_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 


//vector stiffness 2D

void matrix_factory_vector_stiffness_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2]); 

void matrix_factory_vector_stiffness_2D_with_M_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_with_M_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_with_M_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_with_M_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 
void matrix_factory_vector_stiffness_2D_with_M_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[2][2], double pp0[2], double pp1[2], double pp2[2]); 


//vector stiffness 3D
//


void matrix_factory_vector_stiffness_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_stiffness_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_stiffness_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 


void matrix_factory_vector_stiffness_3D_with_M_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_stiffness_3D_with_M_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 
void matrix_factory_vector_stiffness_3D_with_M_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double M[3][3], double pp0[3], double pp1[3], double pp2[3], double pp3[3]); 


//div matrix 2D 
//


void matrix_factory_div_2D_order1_0 (map<pair<int,int>,double>& matrix,
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[2], double pp1[2], double pp2[2]);

void matrix_factory_div_2D_order2_0 (map<pair<int,int>,double>& matrix,
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[2], double pp1[2], double pp2[2]);

void matrix_factory_div_2D_order2_1 (map<pair<int,int>,double>& matrix,
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element,  double pp0[2], double pp1[2], double pp2[2]);

void matrix_factory_div_2D_order3_1 (map<pair<int,int>,double>& matrix,
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element,  double pp0[2], double pp1[2], double pp2[2]);


void matrix_factory_div_3D_order2_0 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]);

void matrix_factory_div_3D_order2_1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]);

void matrix_factory_div_3D_order3_1 (map<pair<int,int>,double>& matrix, 
	 DofT<ptv,ptv_is_less>& idof, DofT<ptv,ptv_is_less>& jdof, 
         int element,  double pp0[3], double pp1[3], double pp2[3], double pp3[3]);


// right hand side computed with quadrature  

void rhs_factory_2D_order1 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[2], double pp1[2], double pp2[2]);
void rhs_factory_2D_order2 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[2], double pp1[2], double pp2[2]);
void rhs_factory_2D_order3 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[2], double pp1[2], double pp2[2]);
void rhs_factory_2D_order4 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[2], double pp1[2], double pp2[2]);
void rhs_factory_2D_order5 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[2], double pp1[2], double pp2[2]);

void rhs_factory_3D_order1 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]);
void rhs_factory_3D_order2 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]);
void rhs_factory_3D_order3 (map<int,double>& rhs, DofT<ptv,ptv_is_less>& dof, 
         ScalarFunction& f, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]);


// scalar convection matrix 2D 

void matrix_factory_conv_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double v0, double v1); 
void matrix_factory_conv_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double v0, double v1); 
void matrix_factory_conv_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double v0, double v1); 
void matrix_factory_conv_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double v0, double v1); 
void matrix_factory_conv_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double v0, double v1); 

// scalar convection matrix 3D 

void matrix_factory_conv_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3], double v0, double v1, double v2); 
void matrix_factory_conv_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3], double v0, double v1, double v2); 
void matrix_factory_conv_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3], double v0, double v1, double v2); 


// vector convection matrix 2D 


void matrix_factory_vector_conv_2D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double* v, int size);
void matrix_factory_vector_conv_2D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double* v, int size);
void matrix_factory_vector_conv_2D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double* v, int size);
void matrix_factory_vector_conv_2D_order4 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double* v, int size);
void matrix_factory_vector_conv_2D_order5 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double* v, int size);
 

void matrix_factory_vector_conv_3D_order1 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double pp3[3], double* v, int size);
void matrix_factory_vector_conv_3D_order2 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double pp3[3], double* v, int size);
void matrix_factory_vector_conv_3D_order3 (map<pair<int,int>,double>& matrix, DofT<ptv,ptv_is_less>& dof, int element, double pp0[2], double pp1[2], double pp2[2], double pp3[3], double* v, int size);

#endif 



