#!/usr/bin/python 

from swiginac import *
from SyFi import *
from code_gen import *
  


# create finite element
cvar.nsd = nsd = 3
tetrahedron = ReferenceTetrahedron()
vfe = VectorLagrangeFE()
vfe.set(tetrahedron) 
vfe.set_size(nsd)

pfe = LagrangeFE()
pfe.set(tetrahedron) 



G = symbolic_matrix(nsd,nsd,"G") 
x0 = symbol("x0"); y0 = symbol("y0"); z0 = symbol("z0")  
p0 = matrix(nsd,1,[x0,y0,z0])  
M = symbolic_matrix(nsd,nsd,"M") 

orders = [[2,1], [3,1]] 

filename = "matrix_factory_div_3D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 



for vorder,porder in orders: 
  

  vfe.set(vorder)
  vfe.compute_basis_functions()

  pfe.set(porder) 
  pfe.compute_basis_functions()

  funcname = "%s_order%d_%d"% (filename,vorder,porder)

  dof_string1 = create_vector_dof_string(vfe,G,p0,"v","i") 
  dof_string2 = create_dof_string(pfe,G,p0,"p","j") 
  dof_string = dof_string1 + dof_string2 
  elmat_string = create_A_string_div(vfe,pfe,G)
  cfunc_string = create_function_string_3D_with_2dofs(funcname, dof_string, elmat_string)  

  print "computing 3D divergence element matrix for order %d %d  "% (vorder,porder)
  cfile.write("\n\n/* ------------- order %d %d ---------------*/\n\n"%(vorder,porder))   
  cfile.write(cfunc_string)
 





