#!/usr/bin/python 

from swiginac import *
from SyFi import *
from code_gen import *
  
 


# create finite element
nsd = 3
tetrahedon = ReferenceTetrahedron()
fe = LagrangeFE()
fe.set(tetrahedon) 

G = symbolic_matrix(3,3,"G") 
x0 = symbol("x0"); y0 = symbol("y0"); z0 = symbol("z0") 
p0 = matrix(nsd,1,[x0,y0,z0])  

filename = "matrix_factory_mass_3D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 


for order in range(1,4): 
#for order in range(1,3): 

  fe.set(order)
  fe.compute_basis_functions()


  dof_string = create_dof_string(fe,G,p0) 
  elmat_string = create_A_string_mass(fe)
  funcname = "%s_order%d"%(filename,order)
  cfunc_string = create_function_string_3D(funcname, dof_string, elmat_string)  

  print "computing 2D mass element matrix for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)


for order in range(1,4): 
#for order in range(1,3): 

  fe.set(order)
  fe.compute_basis_functions()


  dof_string = create_dof_string(fe,G,p0) 
  elmat_string = create_A_string_mass_with_c(fe)
  funcname = "%s_with_c_order%d"%(filename,order)
  cfunc_string = create_function_string_3D_with_c(funcname, dof_string, elmat_string)  

  print "computing 2D mass element matrix with c for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)


