#!/usr/bin/python 

from swiginac import *
from SyFi import *
from code_gen import *
  
 


# create finite element
nsd = 3; cvar.nsd = 3
tetrahedon = ReferenceTetrahedron()
fe = LagrangeFE()
fe.set(tetrahedon) 

G = symbolic_matrix(nsd,nsd,"G") 
x0 = symbol("x0"); y0 = symbol("y0"); z0 = symbol("z0") 
p0 = matrix(nsd,1,[x0,y0,z0])  
M = symbolic_matrix(nsd,nsd,"M") 


filename = "matrix_factory_stiffness_3D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 



for order in range(1,4): 
#for order in range(1,3): 

  fe.set(order)
  fe.compute_basis_functions()

  dof_string = create_dof_string(fe,G,p0) 
  elmat_string = create_A_string_stiffness(fe,G)
  funcname = "%s_order%d"%(filename,order)
  cfunc_string = create_function_string_3D(funcname, dof_string, elmat_string)  

  print "computing 3D stiffness element matrix for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)
 

for order in range(1,4): 
#for order in range(1,3): 

  fe.set(order)
  fe.compute_basis_functions()

  dof_string = create_dof_string(fe,G,p0) 
  elmat_string = create_A_string_stiffness_with_M(fe,G,M)
  funcname = "%s_with_M_order%d"%(filename,order)
  cfunc_string = create_function_string_3D_with_M(funcname, dof_string, elmat_string)  

  print "computing 3D stiffness element matrix with M for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)
 







