#!/usr/bin/python 

from swiginac import *
from SyFi import *
from code_gen import *
  


# create finite element
nsd = 2
triangle = ReferenceTriangle()
fe = VectorLagrangeFE()
fe.set(triangle) 
fe.set_size(nsd)

G = symbolic_matrix(2,2,"G") 
x0 = symbol("x0"); y0 = symbol("y0") 
p0 = matrix(nsd,1,[x0,y0])  
M = symbolic_matrix(2,2,"M") 

filename = "matrix_factory_vector_stiffness_2D"
cfile = open("%s.cc"%filename,'w')
header = create_header() 
cfile.write(header) 




#for order in range(1,2): 
for order in range(1,6): 

  fe.set(order)
  fe.compute_basis_functions()


  dof_string   = create_vector_dof_string(fe,G,p0) 
  elmat_string = create_A_string_vector_stiffness(fe,G)
  funcname = "%s_order%d"%(filename,order)
  cfunc_string = create_function_string_2D(funcname, dof_string, elmat_string)  

  print "computing 2D vector stiffness element matrix for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)

for order in range(1,6): 

  fe.set(order)
  fe.compute_basis_functions()


  dof_string   = create_vector_dof_string(fe,G,p0) 
  elmat_string = create_A_string_vector_stiffness_with_M(fe,G,M)
  funcname = "%s_with_M_order%d"%(filename,order)
  cfunc_string = create_function_string_2D_with_M(funcname, dof_string, elmat_string)  

  print "computing 2D vector stiffness element matrix with M for order %d  "% order
  cfile.write("\n\n/* ------------- order %d ---------------*/\n\n"%order)   
  cfile.write(cfunc_string)
 
 








