#include <compute_conductivity.h>
#include <iostream>
using namespace std;

Conductivity* cond;
double* tensor_diag;
int cell_indicator;

void set_cond_interpolator(Conductivity *_cond) { cond = _cond; }

void set_tensor_diag(int n, double *x) { 
    if (tensor_diag == NULL)
        tensor_diag = (double *)malloc(n*sizeof(double));

    for (int i=0;i<n;i++)
        tensor_diag[i] = x[i]; 

}
void set_cell_indicator(int _cell_indicator) { cell_indicator = _cell_indicator; }

void computeM2D(double M[2][2], double p[2], int cell_id){  
#ifdef DEBUG
    cout << "2D Tensor = " << tensor_diag[0] <<", " << tensor_diag[1] << endl;
#endif
    M[0][0] = tensor_diag[0]; M[0][1] = 0.0; 
    M[1][0] = 0.0;  M[1][1] = tensor_diag[1]; 
}

void computeM3D(double M[3][3], double p[3], int cell_id){ 
  M[0][0] = tensor_diag[0]; M[0][1] = 0.0;  M[0][2] = 0.0; 
  M[1][0] = 0.0;  M[1][1] = tensor_diag[1]; M[1][2] = 0.0; 
  M[2][0] = 0.0;  M[2][1] = 0.0;  M[2][2] = tensor_diag[2]; 
}

void cond2D(double M[2][2], double p[2], int cell_id){  
#ifdef DEBUG
    cout << "Cell id = " << cell_id << endl;
#endif
    if (cell_id <= cell_indicator)
        cond->pt(2, &p[0], &M[0][0]);
    else 
        computeM2D(M, p, cell_id);
}

void cond3D(double M[3][3], double p[3], int cell_id){ 
    if (cell_id <= cell_indicator)
        cond->pt(3, &p[0], &M[0][0]);
    else 
        computeM3D(M, p, cell_id);
}
