#include <MatrixFactory_highorder.h>

using namespace std;
using namespace dolfin;
int main(){

  Mesh mesh2D("mesh2D.xml.gz");  
//  mesh2D.refineUniformly(2); 
  MapMatrixFactory mf = MapMatrixFactory(&mesh2D);
  mf.order1 = 1; 

  mf.computeMassMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "M2D", "M2D.m"); 
#endif 

  mf.computeStiffnessMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "A2D", "A2D.m"); 
#endif 

  mf.order1 = 2; 
  mf.computeVectorMassMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "MV2D", "MV2D.m"); 
#endif 

  mf.computeVectorStiffnessMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "AV2D", "AV2D.m"); 
#endif 


  mf.order2 = 1; 
  mf.computeDivMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "B2D", "B2D.m"); 
#endif 





  Mesh mesh3D("mesh3D.xml.gz");  
  mesh3D.refineUniformly(1); 
  mf = MapMatrixFactory(&mesh3D);
  mf.order1 = 1; 
  mf.computeMassMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "M3D", "M3D.m"); 
#endif 

  mf.order1 = 1; 
  mf.computeStiffnessMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "A3D", "A3D.m"); 
#endif 


  mf.order1 = 2; 
  mf.computeVectorMassMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "MV3D", "MV3D.m"); 
#endif 

  mf.computeVectorStiffnessMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "AV3D", "AV3D.m"); 
#endif 

  mf.order2 = 1; 
  mf.computeDivMatrix(); 
#ifdef VERBOSE 
  dump_to_matlab(*(mf.matrix), "B3D", "B3D.m"); 
#endif 

}


