
#include <math.h>
#include <utility>
#include <map>
#include <ptv.h>
#include <DofT.h>
#include <ScalarFunction.h>

using namespace std; 



/* ------------- order 2 1 ---------------*/


  
void matrix_factory_div_3D_order2_1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, 
         DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    ivdof[30];
  double vdof0[4];
  vdof0[0]=x0;  vdof0[1]=y0;  vdof0[2]=z0;
  vdof0[3] = 0.0;
  ptv vpdof0(4,vdof0);
  ivdof[0] = idof.insert_dof(element,0,vpdof0);

  double vdof1[4];
  vdof1[0]=x0;  vdof1[1]=y0;  vdof1[2]=z0;
  vdof1[3] = 1.0;
  ptv vpdof1(4,vdof1);
  ivdof[1] = idof.insert_dof(element,1,vpdof1);

  double vdof2[4];
  vdof2[0]=x0;  vdof2[1]=y0;  vdof2[2]=z0;
  vdof2[3] = 2.0;
  ptv vpdof2(4,vdof2);
  ivdof[2] = idof.insert_dof(element,2,vpdof2);

  double vdof3[4];
  vdof3[0]=G00/2.0+x0;  vdof3[1]=y0+G10/2.0;  vdof3[2]=z0+G20/2.0;
  vdof3[3] = 0.0;
  ptv vpdof3(4,vdof3);
  ivdof[3] = idof.insert_dof(element,3,vpdof3);

  double vdof4[4];
  vdof4[0]=G00/2.0+x0;  vdof4[1]=y0+G10/2.0;  vdof4[2]=z0+G20/2.0;
  vdof4[3] = 1.0;
  ptv vpdof4(4,vdof4);
  ivdof[4] = idof.insert_dof(element,4,vpdof4);

  double vdof5[4];
  vdof5[0]=G00/2.0+x0;  vdof5[1]=y0+G10/2.0;  vdof5[2]=z0+G20/2.0;
  vdof5[3] = 2.0;
  ptv vpdof5(4,vdof5);
  ivdof[5] = idof.insert_dof(element,5,vpdof5);

  double vdof6[4];
  vdof6[0]=G00+x0;  vdof6[1]=y0+G10;  vdof6[2]=z0+G20;
  vdof6[3] = 0.0;
  ptv vpdof6(4,vdof6);
  ivdof[6] = idof.insert_dof(element,6,vpdof6);

  double vdof7[4];
  vdof7[0]=G00+x0;  vdof7[1]=y0+G10;  vdof7[2]=z0+G20;
  vdof7[3] = 1.0;
  ptv vpdof7(4,vdof7);
  ivdof[7] = idof.insert_dof(element,7,vpdof7);

  double vdof8[4];
  vdof8[0]=G00+x0;  vdof8[1]=y0+G10;  vdof8[2]=z0+G20;
  vdof8[3] = 2.0;
  ptv vpdof8(4,vdof8);
  ivdof[8] = idof.insert_dof(element,8,vpdof8);

  double vdof9[4];
  vdof9[0]=G01/2.0+x0;  vdof9[1]=y0+G11/2.0;  vdof9[2]=G21/2.0+z0;
  vdof9[3] = 0.0;
  ptv vpdof9(4,vdof9);
  ivdof[9] = idof.insert_dof(element,9,vpdof9);

  double vdof10[4];
  vdof10[0]=G01/2.0+x0;  vdof10[1]=y0+G11/2.0;  vdof10[2]=G21/2.0+z0;
  vdof10[3] = 1.0;
  ptv vpdof10(4,vdof10);
  ivdof[10] = idof.insert_dof(element,10,vpdof10);

  double vdof11[4];
  vdof11[0]=G01/2.0+x0;  vdof11[1]=y0+G11/2.0;  vdof11[2]=G21/2.0+z0;
  vdof11[3] = 2.0;
  ptv vpdof11(4,vdof11);
  ivdof[11] = idof.insert_dof(element,11,vpdof11);

  double vdof12[4];
  vdof12[0]=G01/2.0+G00/2.0+x0;  vdof12[1]=y0+G11/2.0+G10/2.0;  vdof12[2]=G21/2.0+z0+G20/2.0;
  vdof12[3] = 0.0;
  ptv vpdof12(4,vdof12);
  ivdof[12] = idof.insert_dof(element,12,vpdof12);

  double vdof13[4];
  vdof13[0]=G01/2.0+G00/2.0+x0;  vdof13[1]=y0+G11/2.0+G10/2.0;  vdof13[2]=G21/2.0+z0+G20/2.0;
  vdof13[3] = 1.0;
  ptv vpdof13(4,vdof13);
  ivdof[13] = idof.insert_dof(element,13,vpdof13);

  double vdof14[4];
  vdof14[0]=G01/2.0+G00/2.0+x0;  vdof14[1]=y0+G11/2.0+G10/2.0;  vdof14[2]=G21/2.0+z0+G20/2.0;
  vdof14[3] = 2.0;
  ptv vpdof14(4,vdof14);
  ivdof[14] = idof.insert_dof(element,14,vpdof14);

  double vdof15[4];
  vdof15[0]=G01+x0;  vdof15[1]=y0+G11;  vdof15[2]=G21+z0;
  vdof15[3] = 0.0;
  ptv vpdof15(4,vdof15);
  ivdof[15] = idof.insert_dof(element,15,vpdof15);

  double vdof16[4];
  vdof16[0]=G01+x0;  vdof16[1]=y0+G11;  vdof16[2]=G21+z0;
  vdof16[3] = 1.0;
  ptv vpdof16(4,vdof16);
  ivdof[16] = idof.insert_dof(element,16,vpdof16);

  double vdof17[4];
  vdof17[0]=G01+x0;  vdof17[1]=y0+G11;  vdof17[2]=G21+z0;
  vdof17[3] = 2.0;
  ptv vpdof17(4,vdof17);
  ivdof[17] = idof.insert_dof(element,17,vpdof17);

  double vdof18[4];
  vdof18[0]=G02/2.0+x0;  vdof18[1]=G12/2.0+y0;  vdof18[2]=G22/2.0+z0;
  vdof18[3] = 0.0;
  ptv vpdof18(4,vdof18);
  ivdof[18] = idof.insert_dof(element,18,vpdof18);

  double vdof19[4];
  vdof19[0]=G02/2.0+x0;  vdof19[1]=G12/2.0+y0;  vdof19[2]=G22/2.0+z0;
  vdof19[3] = 1.0;
  ptv vpdof19(4,vdof19);
  ivdof[19] = idof.insert_dof(element,19,vpdof19);

  double vdof20[4];
  vdof20[0]=G02/2.0+x0;  vdof20[1]=G12/2.0+y0;  vdof20[2]=G22/2.0+z0;
  vdof20[3] = 2.0;
  ptv vpdof20(4,vdof20);
  ivdof[20] = idof.insert_dof(element,20,vpdof20);

  double vdof21[4];
  vdof21[0]=G02/2.0+G00/2.0+x0;  vdof21[1]=G12/2.0+y0+G10/2.0;  vdof21[2]=G22/2.0+z0+G20/2.0;
  vdof21[3] = 0.0;
  ptv vpdof21(4,vdof21);
  ivdof[21] = idof.insert_dof(element,21,vpdof21);

  double vdof22[4];
  vdof22[0]=G02/2.0+G00/2.0+x0;  vdof22[1]=G12/2.0+y0+G10/2.0;  vdof22[2]=G22/2.0+z0+G20/2.0;
  vdof22[3] = 1.0;
  ptv vpdof22(4,vdof22);
  ivdof[22] = idof.insert_dof(element,22,vpdof22);

  double vdof23[4];
  vdof23[0]=G02/2.0+G00/2.0+x0;  vdof23[1]=G12/2.0+y0+G10/2.0;  vdof23[2]=G22/2.0+z0+G20/2.0;
  vdof23[3] = 2.0;
  ptv vpdof23(4,vdof23);
  ivdof[23] = idof.insert_dof(element,23,vpdof23);

  double vdof24[4];
  vdof24[0]=G02/2.0+G01/2.0+x0;  vdof24[1]=G12/2.0+y0+G11/2.0;  vdof24[2]=G22/2.0+G21/2.0+z0;
  vdof24[3] = 0.0;
  ptv vpdof24(4,vdof24);
  ivdof[24] = idof.insert_dof(element,24,vpdof24);

  double vdof25[4];
  vdof25[0]=G02/2.0+G01/2.0+x0;  vdof25[1]=G12/2.0+y0+G11/2.0;  vdof25[2]=G22/2.0+G21/2.0+z0;
  vdof25[3] = 1.0;
  ptv vpdof25(4,vdof25);
  ivdof[25] = idof.insert_dof(element,25,vpdof25);

  double vdof26[4];
  vdof26[0]=G02/2.0+G01/2.0+x0;  vdof26[1]=G12/2.0+y0+G11/2.0;  vdof26[2]=G22/2.0+G21/2.0+z0;
  vdof26[3] = 2.0;
  ptv vpdof26(4,vdof26);
  ivdof[26] = idof.insert_dof(element,26,vpdof26);

  double vdof27[4];
  vdof27[0]=G02+x0;  vdof27[1]=G12+y0;  vdof27[2]=G22+z0;
  vdof27[3] = 0.0;
  ptv vpdof27(4,vdof27);
  ivdof[27] = idof.insert_dof(element,27,vpdof27);

  double vdof28[4];
  vdof28[0]=G02+x0;  vdof28[1]=G12+y0;  vdof28[2]=G22+z0;
  vdof28[3] = 1.0;
  ptv vpdof28(4,vdof28);
  ivdof[28] = idof.insert_dof(element,28,vpdof28);

  double vdof29[4];
  vdof29[0]=G02+x0;  vdof29[1]=G12+y0;  vdof29[2]=G22+z0;
  vdof29[3] = 2.0;
  ptv vpdof29(4,vdof29);
  ivdof[29] = idof.insert_dof(element,29,vpdof29);

  int    ipdof[4];
  double dof0[3];
  dof0[0]=x0;  dof0[1]=y0;  dof0[2]=z0;
  ptv pdof0(3,dof0);
  ipdof[0] = jdof.insert_dof(element,0,pdof0);

  double dof1[3];
  dof1[0]=G00+x0;  dof1[1]=y0+G10;  dof1[2]=z0+G20;
  ptv pdof1(3,dof1);
  ipdof[1] = jdof.insert_dof(element,1,pdof1);

  double dof2[3];
  dof2[0]=G01+x0;  dof2[1]=y0+G11;  dof2[2]=G21+z0;
  ptv pdof2(3,dof2);
  ipdof[2] = jdof.insert_dof(element,2,pdof2);

  double dof3[3];
  dof3[0]=G02+x0;  dof3[1]=G12+y0;  dof3[2]=G22+z0;
  ptv pdof3(3,dof3);
  ipdof[3] = jdof.insert_dof(element,3,pdof3);

 
  double Jinv00 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G22*G11-G21*G12);
  double Jinv01 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G20*G12-G22*G10);
  double Jinv02 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G21*G10-G20*G11);
  double Jinv10 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G21*G02-G22*G01);
  double Jinv11 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G22*G00-G02*G20);
  double Jinv12 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(-G21*G00+G01*G20);
  double Jinv20 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G01*G12-G02*G11);
  double Jinv21 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(-G12*G00+G02*G10);
  double Jinv22 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G00*G11-G01*G10);


  double A[4][30];
  A[0][0]=(-2.5000000000000001e-02*Jinv01-2.5000000000000001e-02*Jinv00-2.5000000000000001e-02*Jinv02)*D;
  A[0][1]=(-2.5000000000000001e-02*Jinv12-2.5000000000000001e-02*Jinv11-2.5000000000000001e-02*Jinv10)*D;
  A[0][2]=(-2.5000000000000001e-02*Jinv21-2.5000000000000001e-02*Jinv20-2.5000000000000001e-02*Jinv22)*D;
  A[0][3]=(-3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00-3.3333333333333333e-02*Jinv02)*D;
  A[0][4]=(-3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[0][5]=(-3.3333333333333333e-02*Jinv21+3.3333333333333333e-02*Jinv20-3.3333333333333333e-02*Jinv22)*D;
  A[0][6]=(-8.3333333333333332e-03*Jinv00)*D;
  A[0][7]=(-8.3333333333333332e-03*Jinv10)*D;
  A[0][8]=(-8.3333333333333332e-03*Jinv20)*D;
  A[0][9]=(3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00-3.3333333333333333e-02*Jinv02)*D;
  A[0][10]=(-3.3333333333333333e-02*Jinv12+3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[0][11]=(3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv20-3.3333333333333333e-02*Jinv22)*D;
  A[0][12]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[0][13]=(3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[0][14]=(3.3333333333333333e-02*Jinv21+3.3333333333333333e-02*Jinv20)*D;
  A[0][15]=(-8.3333333333333332e-03*Jinv01)*D;
  A[0][16]=(-8.3333333333333332e-03*Jinv11)*D;
  A[0][17]=(-8.3333333333333332e-03*Jinv21)*D;
  A[0][18]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00+3.3333333333333333e-02*Jinv02)*D;
  A[0][19]=(3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[0][20]=(-3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv20+3.3333333333333333e-02*Jinv22)*D;
  A[0][21]=(3.3333333333333333e-02*Jinv00+3.3333333333333333e-02*Jinv02)*D;
  A[0][22]=(3.3333333333333333e-02*Jinv12+3.3333333333333333e-02*Jinv10)*D;
  A[0][23]=(3.3333333333333333e-02*Jinv20+3.3333333333333333e-02*Jinv22)*D;
  A[0][24]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv02)*D;
  A[0][25]=(3.3333333333333333e-02*Jinv12+3.3333333333333333e-02*Jinv11)*D;
  A[0][26]=(3.3333333333333333e-02*Jinv21+3.3333333333333333e-02*Jinv22)*D;
  A[0][27]=(-8.3333333333333332e-03*Jinv02)*D;
  A[0][28]=(-8.3333333333333332e-03*Jinv12)*D;
  A[0][29]=(-8.3333333333333332e-03*Jinv22)*D;
  A[1][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00+8.3333333333333332e-03*Jinv02)*D;
  A[1][1]=(8.3333333333333332e-03*Jinv12+8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[1][2]=(8.3333333333333332e-03*Jinv21+8.3333333333333332e-03*Jinv20+8.3333333333333332e-03*Jinv22)*D;
  A[1][3]=(-6.6666666666666666e-02*Jinv01-3.3333333333333333e-02*Jinv00-6.6666666666666666e-02*Jinv02)*D;
  A[1][4]=(-6.6666666666666666e-02*Jinv12-6.6666666666666666e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[1][5]=(-6.6666666666666666e-02*Jinv21-3.3333333333333333e-02*Jinv20-6.6666666666666666e-02*Jinv22)*D;
  A[1][6]=(2.5000000000000001e-02*Jinv00)*D;
  A[1][7]=(2.5000000000000001e-02*Jinv10)*D;
  A[1][8]=(2.5000000000000001e-02*Jinv20)*D;
  A[1][9]=(-3.3333333333333333e-02*Jinv00-3.3333333333333333e-02*Jinv02)*D;
  A[1][10]=(-3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv10)*D;
  A[1][11]=(-3.3333333333333333e-02*Jinv20-3.3333333333333333e-02*Jinv22)*D;
  A[1][12]=(6.6666666666666666e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[1][13]=(6.6666666666666666e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[1][14]=(6.6666666666666666e-02*Jinv21+3.3333333333333333e-02*Jinv20)*D;
  A[1][15]=(-8.3333333333333332e-03*Jinv01)*D;
  A[1][16]=(-8.3333333333333332e-03*Jinv11)*D;
  A[1][17]=(-8.3333333333333332e-03*Jinv21)*D;
  A[1][18]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[1][19]=(-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[1][20]=(-3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv20)*D;
  A[1][21]=(3.3333333333333333e-02*Jinv00+6.6666666666666666e-02*Jinv02)*D;
  A[1][22]=(6.6666666666666666e-02*Jinv12+3.3333333333333333e-02*Jinv10)*D;
  A[1][23]=(3.3333333333333333e-02*Jinv20+6.6666666666666666e-02*Jinv22)*D;
  A[1][24]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv02)*D;
  A[1][25]=(3.3333333333333333e-02*Jinv12+3.3333333333333333e-02*Jinv11)*D;
  A[1][26]=(3.3333333333333333e-02*Jinv21+3.3333333333333333e-02*Jinv22)*D;
  A[1][27]=(-8.3333333333333332e-03*Jinv02)*D;
  A[1][28]=(-8.3333333333333332e-03*Jinv12)*D;
  A[1][29]=(-8.3333333333333332e-03*Jinv22)*D;
  A[2][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00+8.3333333333333332e-03*Jinv02)*D;
  A[2][1]=(8.3333333333333332e-03*Jinv12+8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[2][2]=(8.3333333333333332e-03*Jinv21+8.3333333333333332e-03*Jinv20+8.3333333333333332e-03*Jinv22)*D;
  A[2][3]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv02)*D;
  A[2][4]=(-3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv11)*D;
  A[2][5]=(-3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv22)*D;
  A[2][6]=(-8.3333333333333332e-03*Jinv00)*D;
  A[2][7]=(-8.3333333333333332e-03*Jinv10)*D;
  A[2][8]=(-8.3333333333333332e-03*Jinv20)*D;
  A[2][9]=(-3.3333333333333333e-02*Jinv01-6.6666666666666666e-02*Jinv00-6.6666666666666666e-02*Jinv02)*D;
  A[2][10]=(-6.6666666666666666e-02*Jinv12-3.3333333333333333e-02*Jinv11-6.6666666666666666e-02*Jinv10)*D;
  A[2][11]=(-3.3333333333333333e-02*Jinv21-6.6666666666666666e-02*Jinv20-6.6666666666666666e-02*Jinv22)*D;
  A[2][12]=(3.3333333333333333e-02*Jinv01+6.6666666666666666e-02*Jinv00)*D;
  A[2][13]=(3.3333333333333333e-02*Jinv11+6.6666666666666666e-02*Jinv10)*D;
  A[2][14]=(3.3333333333333333e-02*Jinv21+6.6666666666666666e-02*Jinv20)*D;
  A[2][15]=(2.5000000000000001e-02*Jinv01)*D;
  A[2][16]=(2.5000000000000001e-02*Jinv11)*D;
  A[2][17]=(2.5000000000000001e-02*Jinv21)*D;
  A[2][18]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv00)*D;
  A[2][19]=(-3.3333333333333333e-02*Jinv11-3.3333333333333333e-02*Jinv10)*D;
  A[2][20]=(-3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv20)*D;
  A[2][21]=(3.3333333333333333e-02*Jinv00+3.3333333333333333e-02*Jinv02)*D;
  A[2][22]=(3.3333333333333333e-02*Jinv12+3.3333333333333333e-02*Jinv10)*D;
  A[2][23]=(3.3333333333333333e-02*Jinv20+3.3333333333333333e-02*Jinv22)*D;
  A[2][24]=(3.3333333333333333e-02*Jinv01+6.6666666666666666e-02*Jinv02)*D;
  A[2][25]=(6.6666666666666666e-02*Jinv12+3.3333333333333333e-02*Jinv11)*D;
  A[2][26]=(3.3333333333333333e-02*Jinv21+6.6666666666666666e-02*Jinv22)*D;
  A[2][27]=(-8.3333333333333332e-03*Jinv02)*D;
  A[2][28]=(-8.3333333333333332e-03*Jinv12)*D;
  A[2][29]=(-8.3333333333333332e-03*Jinv22)*D;
  A[3][0]=(8.3333333333333332e-03*Jinv01+8.3333333333333332e-03*Jinv00+8.3333333333333332e-03*Jinv02)*D;
  A[3][1]=(8.3333333333333332e-03*Jinv12+8.3333333333333332e-03*Jinv11+8.3333333333333332e-03*Jinv10)*D;
  A[3][2]=(8.3333333333333332e-03*Jinv21+8.3333333333333332e-03*Jinv20+8.3333333333333332e-03*Jinv22)*D;
  A[3][3]=(-3.3333333333333333e-02*Jinv01-3.3333333333333333e-02*Jinv02)*D;
  A[3][4]=(-3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv11)*D;
  A[3][5]=(-3.3333333333333333e-02*Jinv21-3.3333333333333333e-02*Jinv22)*D;
  A[3][6]=(-8.3333333333333332e-03*Jinv00)*D;
  A[3][7]=(-8.3333333333333332e-03*Jinv10)*D;
  A[3][8]=(-8.3333333333333332e-03*Jinv20)*D;
  A[3][9]=(-3.3333333333333333e-02*Jinv00-3.3333333333333333e-02*Jinv02)*D;
  A[3][10]=(-3.3333333333333333e-02*Jinv12-3.3333333333333333e-02*Jinv10)*D;
  A[3][11]=(-3.3333333333333333e-02*Jinv20-3.3333333333333333e-02*Jinv22)*D;
  A[3][12]=(3.3333333333333333e-02*Jinv01+3.3333333333333333e-02*Jinv00)*D;
  A[3][13]=(3.3333333333333333e-02*Jinv11+3.3333333333333333e-02*Jinv10)*D;
  A[3][14]=(3.3333333333333333e-02*Jinv21+3.3333333333333333e-02*Jinv20)*D;
  A[3][15]=(-8.3333333333333332e-03*Jinv01)*D;
  A[3][16]=(-8.3333333333333332e-03*Jinv11)*D;
  A[3][17]=(-8.3333333333333332e-03*Jinv21)*D;
  A[3][18]=(-6.6666666666666666e-02*Jinv01-6.6666666666666666e-02*Jinv00-3.3333333333333333e-02*Jinv02)*D;
  A[3][19]=(-3.3333333333333333e-02*Jinv12-6.6666666666666666e-02*Jinv11-6.6666666666666666e-02*Jinv10)*D;
  A[3][20]=(-6.6666666666666666e-02*Jinv21-6.6666666666666666e-02*Jinv20-3.3333333333333333e-02*Jinv22)*D;
  A[3][21]=(6.6666666666666666e-02*Jinv00+3.3333333333333333e-02*Jinv02)*D;
  A[3][22]=(3.3333333333333333e-02*Jinv12+6.6666666666666666e-02*Jinv10)*D;
  A[3][23]=(6.6666666666666666e-02*Jinv20+3.3333333333333333e-02*Jinv22)*D;
  A[3][24]=(6.6666666666666666e-02*Jinv01+3.3333333333333333e-02*Jinv02)*D;
  A[3][25]=(3.3333333333333333e-02*Jinv12+6.6666666666666666e-02*Jinv11)*D;
  A[3][26]=(6.6666666666666666e-02*Jinv21+3.3333333333333333e-02*Jinv22)*D;
  A[3][27]=(2.5000000000000001e-02*Jinv02)*D;
  A[3][28]=(2.5000000000000001e-02*Jinv12)*D;
  A[3][29]=(2.5000000000000001e-02*Jinv22)*D;
  int vnbf = 30;  int pnbf = 4;  

  pair<int,int> index; 
  for (int i=0; i< pnbf; i++) {
    index.first = ipdof[i]; 
    for (int j=0; j< vnbf; j++) {
      index.second = ivdof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}


/* ------------- order 3 1 ---------------*/


  
void matrix_factory_div_3D_order3_1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& idof, 
         DofT<ptv,ptv_is_less>& jdof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    ivdof[60];
  double vdof0[4];
  vdof0[0]=x0;  vdof0[1]=y0;  vdof0[2]=z0;
  vdof0[3] = 0.0;
  ptv vpdof0(4,vdof0);
  ivdof[0] = idof.insert_dof(element,0,vpdof0);

  double vdof1[4];
  vdof1[0]=x0;  vdof1[1]=y0;  vdof1[2]=z0;
  vdof1[3] = 1.0;
  ptv vpdof1(4,vdof1);
  ivdof[1] = idof.insert_dof(element,1,vpdof1);

  double vdof2[4];
  vdof2[0]=x0;  vdof2[1]=y0;  vdof2[2]=z0;
  vdof2[3] = 2.0;
  ptv vpdof2(4,vdof2);
  ivdof[2] = idof.insert_dof(element,2,vpdof2);

  double vdof3[4];
  vdof3[0]=G00/3.0+x0;  vdof3[1]=y0+G10/3.0;  vdof3[2]=z0+G20/3.0;
  vdof3[3] = 0.0;
  ptv vpdof3(4,vdof3);
  ivdof[3] = idof.insert_dof(element,3,vpdof3);

  double vdof4[4];
  vdof4[0]=G00/3.0+x0;  vdof4[1]=y0+G10/3.0;  vdof4[2]=z0+G20/3.0;
  vdof4[3] = 1.0;
  ptv vpdof4(4,vdof4);
  ivdof[4] = idof.insert_dof(element,4,vpdof4);

  double vdof5[4];
  vdof5[0]=G00/3.0+x0;  vdof5[1]=y0+G10/3.0;  vdof5[2]=z0+G20/3.0;
  vdof5[3] = 2.0;
  ptv vpdof5(4,vdof5);
  ivdof[5] = idof.insert_dof(element,5,vpdof5);

  double vdof6[4];
  vdof6[0]=(2.0/3.0)*G00+x0;  vdof6[1]=y0+(2.0/3.0)*G10;  vdof6[2]=z0+(2.0/3.0)*G20;
  vdof6[3] = 0.0;
  ptv vpdof6(4,vdof6);
  ivdof[6] = idof.insert_dof(element,6,vpdof6);

  double vdof7[4];
  vdof7[0]=(2.0/3.0)*G00+x0;  vdof7[1]=y0+(2.0/3.0)*G10;  vdof7[2]=z0+(2.0/3.0)*G20;
  vdof7[3] = 1.0;
  ptv vpdof7(4,vdof7);
  ivdof[7] = idof.insert_dof(element,7,vpdof7);

  double vdof8[4];
  vdof8[0]=(2.0/3.0)*G00+x0;  vdof8[1]=y0+(2.0/3.0)*G10;  vdof8[2]=z0+(2.0/3.0)*G20;
  vdof8[3] = 2.0;
  ptv vpdof8(4,vdof8);
  ivdof[8] = idof.insert_dof(element,8,vpdof8);

  double vdof9[4];
  vdof9[0]=G00+x0;  vdof9[1]=y0+G10;  vdof9[2]=z0+G20;
  vdof9[3] = 0.0;
  ptv vpdof9(4,vdof9);
  ivdof[9] = idof.insert_dof(element,9,vpdof9);

  double vdof10[4];
  vdof10[0]=G00+x0;  vdof10[1]=y0+G10;  vdof10[2]=z0+G20;
  vdof10[3] = 1.0;
  ptv vpdof10(4,vdof10);
  ivdof[10] = idof.insert_dof(element,10,vpdof10);

  double vdof11[4];
  vdof11[0]=G00+x0;  vdof11[1]=y0+G10;  vdof11[2]=z0+G20;
  vdof11[3] = 2.0;
  ptv vpdof11(4,vdof11);
  ivdof[11] = idof.insert_dof(element,11,vpdof11);

  double vdof12[4];
  vdof12[0]=G01/3.0+x0;  vdof12[1]=y0+G11/3.0;  vdof12[2]=G21/3.0+z0;
  vdof12[3] = 0.0;
  ptv vpdof12(4,vdof12);
  ivdof[12] = idof.insert_dof(element,12,vpdof12);

  double vdof13[4];
  vdof13[0]=G01/3.0+x0;  vdof13[1]=y0+G11/3.0;  vdof13[2]=G21/3.0+z0;
  vdof13[3] = 1.0;
  ptv vpdof13(4,vdof13);
  ivdof[13] = idof.insert_dof(element,13,vpdof13);

  double vdof14[4];
  vdof14[0]=G01/3.0+x0;  vdof14[1]=y0+G11/3.0;  vdof14[2]=G21/3.0+z0;
  vdof14[3] = 2.0;
  ptv vpdof14(4,vdof14);
  ivdof[14] = idof.insert_dof(element,14,vpdof14);

  double vdof15[4];
  vdof15[0]=G01/3.0+G00/3.0+x0;  vdof15[1]=y0+G11/3.0+G10/3.0;  vdof15[2]=G21/3.0+z0+G20/3.0;
  vdof15[3] = 0.0;
  ptv vpdof15(4,vdof15);
  ivdof[15] = idof.insert_dof(element,15,vpdof15);

  double vdof16[4];
  vdof16[0]=G01/3.0+G00/3.0+x0;  vdof16[1]=y0+G11/3.0+G10/3.0;  vdof16[2]=G21/3.0+z0+G20/3.0;
  vdof16[3] = 1.0;
  ptv vpdof16(4,vdof16);
  ivdof[16] = idof.insert_dof(element,16,vpdof16);

  double vdof17[4];
  vdof17[0]=G01/3.0+G00/3.0+x0;  vdof17[1]=y0+G11/3.0+G10/3.0;  vdof17[2]=G21/3.0+z0+G20/3.0;
  vdof17[3] = 2.0;
  ptv vpdof17(4,vdof17);
  ivdof[17] = idof.insert_dof(element,17,vpdof17);

  double vdof18[4];
  vdof18[0]=G01/3.0+(2.0/3.0)*G00+x0;  vdof18[1]=y0+G11/3.0+(2.0/3.0)*G10;  vdof18[2]=G21/3.0+z0+(2.0/3.0)*G20;
  vdof18[3] = 0.0;
  ptv vpdof18(4,vdof18);
  ivdof[18] = idof.insert_dof(element,18,vpdof18);

  double vdof19[4];
  vdof19[0]=G01/3.0+(2.0/3.0)*G00+x0;  vdof19[1]=y0+G11/3.0+(2.0/3.0)*G10;  vdof19[2]=G21/3.0+z0+(2.0/3.0)*G20;
  vdof19[3] = 1.0;
  ptv vpdof19(4,vdof19);
  ivdof[19] = idof.insert_dof(element,19,vpdof19);

  double vdof20[4];
  vdof20[0]=G01/3.0+(2.0/3.0)*G00+x0;  vdof20[1]=y0+G11/3.0+(2.0/3.0)*G10;  vdof20[2]=G21/3.0+z0+(2.0/3.0)*G20;
  vdof20[3] = 2.0;
  ptv vpdof20(4,vdof20);
  ivdof[20] = idof.insert_dof(element,20,vpdof20);

  double vdof21[4];
  vdof21[0]=(2.0/3.0)*G01+x0;  vdof21[1]=y0+(2.0/3.0)*G11;  vdof21[2]=(2.0/3.0)*G21+z0;
  vdof21[3] = 0.0;
  ptv vpdof21(4,vdof21);
  ivdof[21] = idof.insert_dof(element,21,vpdof21);

  double vdof22[4];
  vdof22[0]=(2.0/3.0)*G01+x0;  vdof22[1]=y0+(2.0/3.0)*G11;  vdof22[2]=(2.0/3.0)*G21+z0;
  vdof22[3] = 1.0;
  ptv vpdof22(4,vdof22);
  ivdof[22] = idof.insert_dof(element,22,vpdof22);

  double vdof23[4];
  vdof23[0]=(2.0/3.0)*G01+x0;  vdof23[1]=y0+(2.0/3.0)*G11;  vdof23[2]=(2.0/3.0)*G21+z0;
  vdof23[3] = 2.0;
  ptv vpdof23(4,vdof23);
  ivdof[23] = idof.insert_dof(element,23,vpdof23);

  double vdof24[4];
  vdof24[0]=(2.0/3.0)*G01+G00/3.0+x0;  vdof24[1]=y0+(2.0/3.0)*G11+G10/3.0;  vdof24[2]=(2.0/3.0)*G21+z0+G20/3.0;
  vdof24[3] = 0.0;
  ptv vpdof24(4,vdof24);
  ivdof[24] = idof.insert_dof(element,24,vpdof24);

  double vdof25[4];
  vdof25[0]=(2.0/3.0)*G01+G00/3.0+x0;  vdof25[1]=y0+(2.0/3.0)*G11+G10/3.0;  vdof25[2]=(2.0/3.0)*G21+z0+G20/3.0;
  vdof25[3] = 1.0;
  ptv vpdof25(4,vdof25);
  ivdof[25] = idof.insert_dof(element,25,vpdof25);

  double vdof26[4];
  vdof26[0]=(2.0/3.0)*G01+G00/3.0+x0;  vdof26[1]=y0+(2.0/3.0)*G11+G10/3.0;  vdof26[2]=(2.0/3.0)*G21+z0+G20/3.0;
  vdof26[3] = 2.0;
  ptv vpdof26(4,vdof26);
  ivdof[26] = idof.insert_dof(element,26,vpdof26);

  double vdof27[4];
  vdof27[0]=G01+x0;  vdof27[1]=y0+G11;  vdof27[2]=G21+z0;
  vdof27[3] = 0.0;
  ptv vpdof27(4,vdof27);
  ivdof[27] = idof.insert_dof(element,27,vpdof27);

  double vdof28[4];
  vdof28[0]=G01+x0;  vdof28[1]=y0+G11;  vdof28[2]=G21+z0;
  vdof28[3] = 1.0;
  ptv vpdof28(4,vdof28);
  ivdof[28] = idof.insert_dof(element,28,vpdof28);

  double vdof29[4];
  vdof29[0]=G01+x0;  vdof29[1]=y0+G11;  vdof29[2]=G21+z0;
  vdof29[3] = 2.0;
  ptv vpdof29(4,vdof29);
  ivdof[29] = idof.insert_dof(element,29,vpdof29);

  double vdof30[4];
  vdof30[0]=G02/3.0+x0;  vdof30[1]=G12/3.0+y0;  vdof30[2]=G22/3.0+z0;
  vdof30[3] = 0.0;
  ptv vpdof30(4,vdof30);
  ivdof[30] = idof.insert_dof(element,30,vpdof30);

  double vdof31[4];
  vdof31[0]=G02/3.0+x0;  vdof31[1]=G12/3.0+y0;  vdof31[2]=G22/3.0+z0;
  vdof31[3] = 1.0;
  ptv vpdof31(4,vdof31);
  ivdof[31] = idof.insert_dof(element,31,vpdof31);

  double vdof32[4];
  vdof32[0]=G02/3.0+x0;  vdof32[1]=G12/3.0+y0;  vdof32[2]=G22/3.0+z0;
  vdof32[3] = 2.0;
  ptv vpdof32(4,vdof32);
  ivdof[32] = idof.insert_dof(element,32,vpdof32);

  double vdof33[4];
  vdof33[0]=G02/3.0+G00/3.0+x0;  vdof33[1]=G12/3.0+y0+G10/3.0;  vdof33[2]=G22/3.0+z0+G20/3.0;
  vdof33[3] = 0.0;
  ptv vpdof33(4,vdof33);
  ivdof[33] = idof.insert_dof(element,33,vpdof33);

  double vdof34[4];
  vdof34[0]=G02/3.0+G00/3.0+x0;  vdof34[1]=G12/3.0+y0+G10/3.0;  vdof34[2]=G22/3.0+z0+G20/3.0;
  vdof34[3] = 1.0;
  ptv vpdof34(4,vdof34);
  ivdof[34] = idof.insert_dof(element,34,vpdof34);

  double vdof35[4];
  vdof35[0]=G02/3.0+G00/3.0+x0;  vdof35[1]=G12/3.0+y0+G10/3.0;  vdof35[2]=G22/3.0+z0+G20/3.0;
  vdof35[3] = 2.0;
  ptv vpdof35(4,vdof35);
  ivdof[35] = idof.insert_dof(element,35,vpdof35);

  double vdof36[4];
  vdof36[0]=G02/3.0+(2.0/3.0)*G00+x0;  vdof36[1]=G12/3.0+y0+(2.0/3.0)*G10;  vdof36[2]=G22/3.0+z0+(2.0/3.0)*G20;
  vdof36[3] = 0.0;
  ptv vpdof36(4,vdof36);
  ivdof[36] = idof.insert_dof(element,36,vpdof36);

  double vdof37[4];
  vdof37[0]=G02/3.0+(2.0/3.0)*G00+x0;  vdof37[1]=G12/3.0+y0+(2.0/3.0)*G10;  vdof37[2]=G22/3.0+z0+(2.0/3.0)*G20;
  vdof37[3] = 1.0;
  ptv vpdof37(4,vdof37);
  ivdof[37] = idof.insert_dof(element,37,vpdof37);

  double vdof38[4];
  vdof38[0]=G02/3.0+(2.0/3.0)*G00+x0;  vdof38[1]=G12/3.0+y0+(2.0/3.0)*G10;  vdof38[2]=G22/3.0+z0+(2.0/3.0)*G20;
  vdof38[3] = 2.0;
  ptv vpdof38(4,vdof38);
  ivdof[38] = idof.insert_dof(element,38,vpdof38);

  double vdof39[4];
  vdof39[0]=G02/3.0+G01/3.0+x0;  vdof39[1]=G12/3.0+y0+G11/3.0;  vdof39[2]=G22/3.0+G21/3.0+z0;
  vdof39[3] = 0.0;
  ptv vpdof39(4,vdof39);
  ivdof[39] = idof.insert_dof(element,39,vpdof39);

  double vdof40[4];
  vdof40[0]=G02/3.0+G01/3.0+x0;  vdof40[1]=G12/3.0+y0+G11/3.0;  vdof40[2]=G22/3.0+G21/3.0+z0;
  vdof40[3] = 1.0;
  ptv vpdof40(4,vdof40);
  ivdof[40] = idof.insert_dof(element,40,vpdof40);

  double vdof41[4];
  vdof41[0]=G02/3.0+G01/3.0+x0;  vdof41[1]=G12/3.0+y0+G11/3.0;  vdof41[2]=G22/3.0+G21/3.0+z0;
  vdof41[3] = 2.0;
  ptv vpdof41(4,vdof41);
  ivdof[41] = idof.insert_dof(element,41,vpdof41);

  double vdof42[4];
  vdof42[0]=G02/3.0+G01/3.0+G00/3.0+x0;  vdof42[1]=G12/3.0+y0+G11/3.0+G10/3.0;  vdof42[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  vdof42[3] = 0.0;
  ptv vpdof42(4,vdof42);
  ivdof[42] = idof.insert_dof(element,42,vpdof42);

  double vdof43[4];
  vdof43[0]=G02/3.0+G01/3.0+G00/3.0+x0;  vdof43[1]=G12/3.0+y0+G11/3.0+G10/3.0;  vdof43[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  vdof43[3] = 1.0;
  ptv vpdof43(4,vdof43);
  ivdof[43] = idof.insert_dof(element,43,vpdof43);

  double vdof44[4];
  vdof44[0]=G02/3.0+G01/3.0+G00/3.0+x0;  vdof44[1]=G12/3.0+y0+G11/3.0+G10/3.0;  vdof44[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  vdof44[3] = 2.0;
  ptv vpdof44(4,vdof44);
  ivdof[44] = idof.insert_dof(element,44,vpdof44);

  double vdof45[4];
  vdof45[0]=G02/3.0+(2.0/3.0)*G01+x0;  vdof45[1]=G12/3.0+y0+(2.0/3.0)*G11;  vdof45[2]=G22/3.0+(2.0/3.0)*G21+z0;
  vdof45[3] = 0.0;
  ptv vpdof45(4,vdof45);
  ivdof[45] = idof.insert_dof(element,45,vpdof45);

  double vdof46[4];
  vdof46[0]=G02/3.0+(2.0/3.0)*G01+x0;  vdof46[1]=G12/3.0+y0+(2.0/3.0)*G11;  vdof46[2]=G22/3.0+(2.0/3.0)*G21+z0;
  vdof46[3] = 1.0;
  ptv vpdof46(4,vdof46);
  ivdof[46] = idof.insert_dof(element,46,vpdof46);

  double vdof47[4];
  vdof47[0]=G02/3.0+(2.0/3.0)*G01+x0;  vdof47[1]=G12/3.0+y0+(2.0/3.0)*G11;  vdof47[2]=G22/3.0+(2.0/3.0)*G21+z0;
  vdof47[3] = 2.0;
  ptv vpdof47(4,vdof47);
  ivdof[47] = idof.insert_dof(element,47,vpdof47);

  double vdof48[4];
  vdof48[0]=(2.0/3.0)*G02+x0;  vdof48[1]=(2.0/3.0)*G12+y0;  vdof48[2]=(2.0/3.0)*G22+z0;
  vdof48[3] = 0.0;
  ptv vpdof48(4,vdof48);
  ivdof[48] = idof.insert_dof(element,48,vpdof48);

  double vdof49[4];
  vdof49[0]=(2.0/3.0)*G02+x0;  vdof49[1]=(2.0/3.0)*G12+y0;  vdof49[2]=(2.0/3.0)*G22+z0;
  vdof49[3] = 1.0;
  ptv vpdof49(4,vdof49);
  ivdof[49] = idof.insert_dof(element,49,vpdof49);

  double vdof50[4];
  vdof50[0]=(2.0/3.0)*G02+x0;  vdof50[1]=(2.0/3.0)*G12+y0;  vdof50[2]=(2.0/3.0)*G22+z0;
  vdof50[3] = 2.0;
  ptv vpdof50(4,vdof50);
  ivdof[50] = idof.insert_dof(element,50,vpdof50);

  double vdof51[4];
  vdof51[0]=(2.0/3.0)*G02+G00/3.0+x0;  vdof51[1]=(2.0/3.0)*G12+y0+G10/3.0;  vdof51[2]=(2.0/3.0)*G22+z0+G20/3.0;
  vdof51[3] = 0.0;
  ptv vpdof51(4,vdof51);
  ivdof[51] = idof.insert_dof(element,51,vpdof51);

  double vdof52[4];
  vdof52[0]=(2.0/3.0)*G02+G00/3.0+x0;  vdof52[1]=(2.0/3.0)*G12+y0+G10/3.0;  vdof52[2]=(2.0/3.0)*G22+z0+G20/3.0;
  vdof52[3] = 1.0;
  ptv vpdof52(4,vdof52);
  ivdof[52] = idof.insert_dof(element,52,vpdof52);

  double vdof53[4];
  vdof53[0]=(2.0/3.0)*G02+G00/3.0+x0;  vdof53[1]=(2.0/3.0)*G12+y0+G10/3.0;  vdof53[2]=(2.0/3.0)*G22+z0+G20/3.0;
  vdof53[3] = 2.0;
  ptv vpdof53(4,vdof53);
  ivdof[53] = idof.insert_dof(element,53,vpdof53);

  double vdof54[4];
  vdof54[0]=(2.0/3.0)*G02+G01/3.0+x0;  vdof54[1]=(2.0/3.0)*G12+y0+G11/3.0;  vdof54[2]=(2.0/3.0)*G22+G21/3.0+z0;
  vdof54[3] = 0.0;
  ptv vpdof54(4,vdof54);
  ivdof[54] = idof.insert_dof(element,54,vpdof54);

  double vdof55[4];
  vdof55[0]=(2.0/3.0)*G02+G01/3.0+x0;  vdof55[1]=(2.0/3.0)*G12+y0+G11/3.0;  vdof55[2]=(2.0/3.0)*G22+G21/3.0+z0;
  vdof55[3] = 1.0;
  ptv vpdof55(4,vdof55);
  ivdof[55] = idof.insert_dof(element,55,vpdof55);

  double vdof56[4];
  vdof56[0]=(2.0/3.0)*G02+G01/3.0+x0;  vdof56[1]=(2.0/3.0)*G12+y0+G11/3.0;  vdof56[2]=(2.0/3.0)*G22+G21/3.0+z0;
  vdof56[3] = 2.0;
  ptv vpdof56(4,vdof56);
  ivdof[56] = idof.insert_dof(element,56,vpdof56);

  double vdof57[4];
  vdof57[0]=G02+x0;  vdof57[1]=G12+y0;  vdof57[2]=G22+z0;
  vdof57[3] = 0.0;
  ptv vpdof57(4,vdof57);
  ivdof[57] = idof.insert_dof(element,57,vpdof57);

  double vdof58[4];
  vdof58[0]=G02+x0;  vdof58[1]=G12+y0;  vdof58[2]=G22+z0;
  vdof58[3] = 1.0;
  ptv vpdof58(4,vdof58);
  ivdof[58] = idof.insert_dof(element,58,vpdof58);

  double vdof59[4];
  vdof59[0]=G02+x0;  vdof59[1]=G12+y0;  vdof59[2]=G22+z0;
  vdof59[3] = 2.0;
  ptv vpdof59(4,vdof59);
  ivdof[59] = idof.insert_dof(element,59,vpdof59);

  int    ipdof[4];
  double dof0[3];
  dof0[0]=x0;  dof0[1]=y0;  dof0[2]=z0;
  ptv pdof0(3,dof0);
  ipdof[0] = jdof.insert_dof(element,0,pdof0);

  double dof1[3];
  dof1[0]=G00+x0;  dof1[1]=y0+G10;  dof1[2]=z0+G20;
  ptv pdof1(3,dof1);
  ipdof[1] = jdof.insert_dof(element,1,pdof1);

  double dof2[3];
  dof2[0]=G01+x0;  dof2[1]=y0+G11;  dof2[2]=G21+z0;
  ptv pdof2(3,dof2);
  ipdof[2] = jdof.insert_dof(element,2,pdof2);

  double dof3[3];
  dof3[0]=G02+x0;  dof3[1]=G12+y0;  dof3[2]=G22+z0;
  ptv pdof3(3,dof3);
  ipdof[3] = jdof.insert_dof(element,3,pdof3);

 
  double Jinv00 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G22*G11-G21*G12);
  double Jinv01 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G20*G12-G22*G10);
  double Jinv02 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G21*G10-G20*G11);
  double Jinv10 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G21*G02-G22*G01);
  double Jinv11 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G22*G00-G02*G20);
  double Jinv12 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(-G21*G00+G01*G20);
  double Jinv20 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G01*G12-G02*G11);
  double Jinv21 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(-G12*G00+G02*G10);
  double Jinv22 = 1.0/(G22*G00*G11+G21*G02*G10-G02*G20*G11-G22*G01*G10+G01*G20*G12-G21*G12*G00)*(G00*G11-G01*G10);


  double A[4][60];
  A[0][0]=(-4.1666666666666666e-03*Jinv02-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[0][1]=(-4.1666666666666666e-03*Jinv10-4.1666666666666666e-03*Jinv12-4.1666666666666666e-03*Jinv11)*D;
  A[0][2]=(-4.1666666666666666e-03*Jinv22-4.1666666666666666e-03*Jinv21-4.1666666666666666e-03*Jinv20)*D;
  A[0][3]=(-3.7499999999999999e-02*Jinv02-3.7499999999999999e-02*Jinv01)*D;
  A[0][4]=(-3.7499999999999999e-02*Jinv12-3.7499999999999999e-02*Jinv11)*D;
  A[0][5]=(-3.7499999999999999e-02*Jinv22-3.7499999999999999e-02*Jinv21)*D;
  A[0][6]=(0.0)*D;
  A[0][7]=(0.0)*D;
  A[0][8]=(0.0)*D;
  A[0][9]=(4.1666666666666666e-03*Jinv00)*D;
  A[0][10]=(4.1666666666666666e-03*Jinv10)*D;
  A[0][11]=(4.1666666666666666e-03*Jinv20)*D;
  A[0][12]=(-3.7499999999999999e-02*Jinv02-3.7499999999999999e-02*Jinv00)*D;
  A[0][13]=(-3.7499999999999999e-02*Jinv10-3.7499999999999999e-02*Jinv12)*D;
  A[0][14]=(-3.7499999999999999e-02*Jinv22-3.7499999999999999e-02*Jinv20)*D;
  A[0][15]=(-3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][16]=(3.7499999999999999e-02*Jinv10-3.7499999999999999e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[0][17]=(-3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[0][18]=(0.0)*D;
  A[0][19]=(0.0)*D;
  A[0][20]=(0.0)*D;
  A[0][21]=(0.0)*D;
  A[0][22]=(0.0)*D;
  A[0][23]=(0.0)*D;
  A[0][24]=(0.0)*D;
  A[0][25]=(0.0)*D;
  A[0][26]=(0.0)*D;
  A[0][27]=(4.1666666666666666e-03*Jinv01)*D;
  A[0][28]=(4.1666666666666666e-03*Jinv11)*D;
  A[0][29]=(4.1666666666666666e-03*Jinv21)*D;
  A[0][30]=(-3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[0][31]=(-3.7499999999999999e-02*Jinv10-3.7499999999999999e-02*Jinv11)*D;
  A[0][32]=(-3.7499999999999999e-02*Jinv21-3.7499999999999999e-02*Jinv20)*D;
  A[0][33]=(3.7499999999999999e-02*Jinv02-3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][34]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv12-3.7499999999999999e-02*Jinv11)*D;
  A[0][35]=(3.7499999999999999e-02*Jinv22-3.7499999999999999e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[0][36]=(0.0)*D;
  A[0][37]=(0.0)*D;
  A[0][38]=(0.0)*D;
  A[0][39]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[0][40]=(-3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[0][41]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv21-3.7499999999999999e-02*Jinv20)*D;
  A[0][42]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[0][43]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[0][44]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[0][45]=(0.0)*D;
  A[0][46]=(0.0)*D;
  A[0][47]=(0.0)*D;
  A[0][48]=(0.0)*D;
  A[0][49]=(0.0)*D;
  A[0][50]=(0.0)*D;
  A[0][51]=(0.0)*D;
  A[0][52]=(0.0)*D;
  A[0][53]=(0.0)*D;
  A[0][54]=(0.0)*D;
  A[0][55]=(0.0)*D;
  A[0][56]=(0.0)*D;
  A[0][57]=(4.1666666666666666e-03*Jinv02)*D;
  A[0][58]=(4.1666666666666666e-03*Jinv12)*D;
  A[0][59]=(4.1666666666666666e-03*Jinv22)*D;
  A[1][0]=(-4.1666666666666666e-03*Jinv02-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[1][1]=(-4.1666666666666666e-03*Jinv10-4.1666666666666666e-03*Jinv12-4.1666666666666666e-03*Jinv11)*D;
  A[1][2]=(-4.1666666666666666e-03*Jinv22-4.1666666666666666e-03*Jinv21-4.1666666666666666e-03*Jinv20)*D;
  A[1][3]=(0.0)*D;
  A[1][4]=(0.0)*D;
  A[1][5]=(0.0)*D;
  A[1][6]=(-3.7499999999999999e-02*Jinv02-3.7499999999999999e-02*Jinv01)*D;
  A[1][7]=(-3.7499999999999999e-02*Jinv12-3.7499999999999999e-02*Jinv11)*D;
  A[1][8]=(-3.7499999999999999e-02*Jinv22-3.7499999999999999e-02*Jinv21)*D;
  A[1][9]=(4.1666666666666666e-03*Jinv00)*D;
  A[1][10]=(4.1666666666666666e-03*Jinv10)*D;
  A[1][11]=(4.1666666666666666e-03*Jinv20)*D;
  A[1][12]=(0.0)*D;
  A[1][13]=(0.0)*D;
  A[1][14]=(0.0)*D;
  A[1][15]=(-7.4999999999999997e-02*Jinv02-3.7499999999999999e-02*Jinv00)*D;
  A[1][16]=(-3.7499999999999999e-02*Jinv10-7.4999999999999997e-02*Jinv12)*D;
  A[1][17]=(-7.4999999999999997e-02*Jinv22-3.7499999999999999e-02*Jinv20)*D;
  A[1][18]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[1][19]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv11)*D;
  A[1][20]=(3.7499999999999999e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[1][21]=(0.0)*D;
  A[1][22]=(0.0)*D;
  A[1][23]=(0.0)*D;
  A[1][24]=(0.0)*D;
  A[1][25]=(0.0)*D;
  A[1][26]=(0.0)*D;
  A[1][27]=(4.1666666666666666e-03*Jinv01)*D;
  A[1][28]=(4.1666666666666666e-03*Jinv11)*D;
  A[1][29]=(4.1666666666666666e-03*Jinv21)*D;
  A[1][30]=(0.0)*D;
  A[1][31]=(0.0)*D;
  A[1][32]=(0.0)*D;
  A[1][33]=(-7.4999999999999997e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[1][34]=(-3.7499999999999999e-02*Jinv10-7.4999999999999997e-02*Jinv11)*D;
  A[1][35]=(-7.4999999999999997e-02*Jinv21-3.7499999999999999e-02*Jinv20)*D;
  A[1][36]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv00)*D;
  A[1][37]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv12)*D;
  A[1][38]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv20)*D;
  A[1][39]=(-3.7499999999999999e-02*Jinv00)*D;
  A[1][40]=(-3.7499999999999999e-02*Jinv10)*D;
  A[1][41]=(-3.7499999999999999e-02*Jinv20)*D;
  A[1][42]=(7.4999999999999997e-02*Jinv02+7.4999999999999997e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[1][43]=(3.7499999999999999e-02*Jinv10+7.4999999999999997e-02*Jinv12+7.4999999999999997e-02*Jinv11)*D;
  A[1][44]=(7.4999999999999997e-02*Jinv22+7.4999999999999997e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[1][45]=(0.0)*D;
  A[1][46]=(0.0)*D;
  A[1][47]=(0.0)*D;
  A[1][48]=(0.0)*D;
  A[1][49]=(0.0)*D;
  A[1][50]=(0.0)*D;
  A[1][51]=(0.0)*D;
  A[1][52]=(0.0)*D;
  A[1][53]=(0.0)*D;
  A[1][54]=(0.0)*D;
  A[1][55]=(0.0)*D;
  A[1][56]=(0.0)*D;
  A[1][57]=(4.1666666666666666e-03*Jinv02)*D;
  A[1][58]=(4.1666666666666666e-03*Jinv12)*D;
  A[1][59]=(4.1666666666666666e-03*Jinv22)*D;
  A[2][0]=(-4.1666666666666666e-03*Jinv02-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[2][1]=(-4.1666666666666666e-03*Jinv10-4.1666666666666666e-03*Jinv12-4.1666666666666666e-03*Jinv11)*D;
  A[2][2]=(-4.1666666666666666e-03*Jinv22-4.1666666666666666e-03*Jinv21-4.1666666666666666e-03*Jinv20)*D;
  A[2][3]=(0.0)*D;
  A[2][4]=(0.0)*D;
  A[2][5]=(0.0)*D;
  A[2][6]=(0.0)*D;
  A[2][7]=(0.0)*D;
  A[2][8]=(0.0)*D;
  A[2][9]=(4.1666666666666666e-03*Jinv00)*D;
  A[2][10]=(4.1666666666666666e-03*Jinv10)*D;
  A[2][11]=(4.1666666666666666e-03*Jinv20)*D;
  A[2][12]=(0.0)*D;
  A[2][13]=(0.0)*D;
  A[2][14]=(0.0)*D;
  A[2][15]=(-7.4999999999999997e-02*Jinv02-3.7499999999999999e-02*Jinv01)*D;
  A[2][16]=(-7.4999999999999997e-02*Jinv12-3.7499999999999999e-02*Jinv11)*D;
  A[2][17]=(-7.4999999999999997e-02*Jinv22-3.7499999999999999e-02*Jinv21)*D;
  A[2][18]=(0.0)*D;
  A[2][19]=(0.0)*D;
  A[2][20]=(0.0)*D;
  A[2][21]=(-3.7499999999999999e-02*Jinv02-3.7499999999999999e-02*Jinv00)*D;
  A[2][22]=(-3.7499999999999999e-02*Jinv10-3.7499999999999999e-02*Jinv12)*D;
  A[2][23]=(-3.7499999999999999e-02*Jinv22-3.7499999999999999e-02*Jinv20)*D;
  A[2][24]=(3.7499999999999999e-02*Jinv01+3.7499999999999999e-02*Jinv00)*D;
  A[2][25]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv11)*D;
  A[2][26]=(3.7499999999999999e-02*Jinv21+3.7499999999999999e-02*Jinv20)*D;
  A[2][27]=(4.1666666666666666e-03*Jinv01)*D;
  A[2][28]=(4.1666666666666666e-03*Jinv11)*D;
  A[2][29]=(4.1666666666666666e-03*Jinv21)*D;
  A[2][30]=(0.0)*D;
  A[2][31]=(0.0)*D;
  A[2][32]=(0.0)*D;
  A[2][33]=(-3.7499999999999999e-02*Jinv01)*D;
  A[2][34]=(-3.7499999999999999e-02*Jinv11)*D;
  A[2][35]=(-3.7499999999999999e-02*Jinv21)*D;
  A[2][36]=(0.0)*D;
  A[2][37]=(0.0)*D;
  A[2][38]=(0.0)*D;
  A[2][39]=(-3.7499999999999999e-02*Jinv01-7.4999999999999997e-02*Jinv00)*D;
  A[2][40]=(-7.4999999999999997e-02*Jinv10-3.7499999999999999e-02*Jinv11)*D;
  A[2][41]=(-3.7499999999999999e-02*Jinv21-7.4999999999999997e-02*Jinv20)*D;
  A[2][42]=(7.4999999999999997e-02*Jinv02+3.7499999999999999e-02*Jinv01+7.4999999999999997e-02*Jinv00)*D;
  A[2][43]=(7.4999999999999997e-02*Jinv10+7.4999999999999997e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[2][44]=(7.4999999999999997e-02*Jinv22+3.7499999999999999e-02*Jinv21+7.4999999999999997e-02*Jinv20)*D;
  A[2][45]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv01)*D;
  A[2][46]=(3.7499999999999999e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[2][47]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv21)*D;
  A[2][48]=(0.0)*D;
  A[2][49]=(0.0)*D;
  A[2][50]=(0.0)*D;
  A[2][51]=(0.0)*D;
  A[2][52]=(0.0)*D;
  A[2][53]=(0.0)*D;
  A[2][54]=(0.0)*D;
  A[2][55]=(0.0)*D;
  A[2][56]=(0.0)*D;
  A[2][57]=(4.1666666666666666e-03*Jinv02)*D;
  A[2][58]=(4.1666666666666666e-03*Jinv12)*D;
  A[2][59]=(4.1666666666666666e-03*Jinv22)*D;
  A[3][0]=(-4.1666666666666666e-03*Jinv02-4.1666666666666666e-03*Jinv01-4.1666666666666666e-03*Jinv00)*D;
  A[3][1]=(-4.1666666666666666e-03*Jinv10-4.1666666666666666e-03*Jinv12-4.1666666666666666e-03*Jinv11)*D;
  A[3][2]=(-4.1666666666666666e-03*Jinv22-4.1666666666666666e-03*Jinv21-4.1666666666666666e-03*Jinv20)*D;
  A[3][3]=(0.0)*D;
  A[3][4]=(0.0)*D;
  A[3][5]=(0.0)*D;
  A[3][6]=(0.0)*D;
  A[3][7]=(0.0)*D;
  A[3][8]=(0.0)*D;
  A[3][9]=(4.1666666666666666e-03*Jinv00)*D;
  A[3][10]=(4.1666666666666666e-03*Jinv10)*D;
  A[3][11]=(4.1666666666666666e-03*Jinv20)*D;
  A[3][12]=(0.0)*D;
  A[3][13]=(0.0)*D;
  A[3][14]=(0.0)*D;
  A[3][15]=(-3.7499999999999999e-02*Jinv02)*D;
  A[3][16]=(-3.7499999999999999e-02*Jinv12)*D;
  A[3][17]=(-3.7499999999999999e-02*Jinv22)*D;
  A[3][18]=(0.0)*D;
  A[3][19]=(0.0)*D;
  A[3][20]=(0.0)*D;
  A[3][21]=(0.0)*D;
  A[3][22]=(0.0)*D;
  A[3][23]=(0.0)*D;
  A[3][24]=(0.0)*D;
  A[3][25]=(0.0)*D;
  A[3][26]=(0.0)*D;
  A[3][27]=(4.1666666666666666e-03*Jinv01)*D;
  A[3][28]=(4.1666666666666666e-03*Jinv11)*D;
  A[3][29]=(4.1666666666666666e-03*Jinv21)*D;
  A[3][30]=(0.0)*D;
  A[3][31]=(0.0)*D;
  A[3][32]=(0.0)*D;
  A[3][33]=(-3.7499999999999999e-02*Jinv02-7.4999999999999997e-02*Jinv01)*D;
  A[3][34]=(-3.7499999999999999e-02*Jinv12-7.4999999999999997e-02*Jinv11)*D;
  A[3][35]=(-3.7499999999999999e-02*Jinv22-7.4999999999999997e-02*Jinv21)*D;
  A[3][36]=(0.0)*D;
  A[3][37]=(0.0)*D;
  A[3][38]=(0.0)*D;
  A[3][39]=(-3.7499999999999999e-02*Jinv02-7.4999999999999997e-02*Jinv00)*D;
  A[3][40]=(-7.4999999999999997e-02*Jinv10-3.7499999999999999e-02*Jinv12)*D;
  A[3][41]=(-3.7499999999999999e-02*Jinv22-7.4999999999999997e-02*Jinv20)*D;
  A[3][42]=(3.7499999999999999e-02*Jinv02+7.4999999999999997e-02*Jinv01+7.4999999999999997e-02*Jinv00)*D;
  A[3][43]=(7.4999999999999997e-02*Jinv10+3.7499999999999999e-02*Jinv12+7.4999999999999997e-02*Jinv11)*D;
  A[3][44]=(3.7499999999999999e-02*Jinv22+7.4999999999999997e-02*Jinv21+7.4999999999999997e-02*Jinv20)*D;
  A[3][45]=(0.0)*D;
  A[3][46]=(0.0)*D;
  A[3][47]=(0.0)*D;
  A[3][48]=(-3.7499999999999999e-02*Jinv01-3.7499999999999999e-02*Jinv00)*D;
  A[3][49]=(-3.7499999999999999e-02*Jinv10-3.7499999999999999e-02*Jinv11)*D;
  A[3][50]=(-3.7499999999999999e-02*Jinv21-3.7499999999999999e-02*Jinv20)*D;
  A[3][51]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv00)*D;
  A[3][52]=(3.7499999999999999e-02*Jinv10+3.7499999999999999e-02*Jinv12)*D;
  A[3][53]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv20)*D;
  A[3][54]=(3.7499999999999999e-02*Jinv02+3.7499999999999999e-02*Jinv01)*D;
  A[3][55]=(3.7499999999999999e-02*Jinv12+3.7499999999999999e-02*Jinv11)*D;
  A[3][56]=(3.7499999999999999e-02*Jinv22+3.7499999999999999e-02*Jinv21)*D;
  A[3][57]=(4.1666666666666666e-03*Jinv02)*D;
  A[3][58]=(4.1666666666666666e-03*Jinv12)*D;
  A[3][59]=(4.1666666666666666e-03*Jinv22)*D;
  int vnbf = 60;  int pnbf = 4;  

  pair<int,int> index; 
  for (int i=0; i< pnbf; i++) {
    index.first = ipdof[i]; 
    for (int j=0; j< vnbf; j++) {
      index.second = ivdof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
