#ifndef MatrixFactory_h_IS_INCLUDED
#define MatrixFactory_h_IS_INCLUDED

#include <dolfin.h>
#include <map>
#include <iostream>
#include <fstream>
#include <TensorFunction.h>
#include <FastMatSparse.h>

using namespace dolfin;
using namespace std;


class MatrixFactory 
{
    public:
        TensorFunction *tf;
        Mesh *mesh;
        MatrixFactory(Mesh *_mesh);
        map<pair<int,int>,double> *matrix;

        FastMatSparse* computeMassMatrix();
        FastMatSparse* computeStiffnessMatrix(); 
        void dump_to_matlab(map<pair<int,int>,double> A, const char *varname, const char *s);
};

#endif
