#!/usr/bin/python 

from swiginac import *
from SyFi import *



funcname = "matrix_factory_mass_3D"
nsd = 3


p0 = [0,0,0]; p1 = [1,0,0]; p2 = [0,1,0]; p3 = [0,0,1] 
tetrahedon = Tetrahedron(toex(p0), toex(p1), toex(p2), toex(p3))

a = symbol("a"); b = symbol("b"); c = symbol("c"); d = symbol("d") 
e = symbol("e"); f = symbol("f"); g = symbol("g"); h = symbol("h"); k = symbol("k") 

J = matrix(3,3, [a,d,g,b,e,h,c,f,k]) 
Jinv = J.inverse()
D = J.determinant()




fe = LagrangeFE()
fe.set(tetrahedon) 
fe.set(1)
fe.compute_basis_functions()
A_str =""
for i in range(1,fe.nbf()+1): 
  for j in range(1,fe.nbf()+1): 
    integrand = fe.N(i).eval()*fe.N(j).eval()*D  
    Aij = tetrahedon.integrate(toex(integrand)) 
    A_str += "  A[%d][%d]=%s;\n"%(i-1,j-1,Aij.eval().printc())




s = """
#include <math.h>
void %s (double A[%d][%d], double p0[%d], double p1[%d], double p2[%d], double p3[%d]){



  double x0 = p0[0]; double y0 = p0[1]; double z0 = p0[2];  
  double x1 = p1[0]; double y1 = p1[1]; double z1 = p1[2];  
  double x2 = p2[0]; double y2 = p2[1]; double z2 = p2[2];  
  double x3 = p3[0]; double y3 = p3[1]; double z3 = p3[2];  

  double a = p1[0] - p0[0];
  double d = p1[1] - p0[1];
  double g = p1[2] - p0[2];

  double b = p2[0] - p0[0];
  double e = p2[1] - p0[1];
  double h = p2[2] - p0[2];

  double c = p3[0] - p0[0];
  double f = p3[1] - p0[1];
  double k = p3[2] - p0[2];

  //variables 

  double D = a*(e*k-f*h) - b*(d*k-f*g) + c*(d*h-g*e);   


%s
}
"""% (funcname,fe.nbf(),fe.nbf(),nsd,nsd,nsd,nsd,A_str) 



print "writing C code to the file %s.pre"%funcname
cfile = open("%s.pre"%funcname,'w')
cfile.write(s)



