
from swiginac import *
from SyFi import *

from tools import * 

nsd = 3; cvar.nsd = 3
order = 2 

t = ReferenceTetrahedron()

fe_sigma = ArnoldFalkWintherWeakSymSigma()
fe_sigma.set(t)
fe_sigma.set(order)
fe_sigma.compute_basis_functions()


fe_u = ArnoldFalkWintherWeakSymU()
fe_u.set(t)
fe_u.set(order)
fe_u.compute_basis_functions()

fe_p = ArnoldFalkWintherWeakSymP()
fe_p.set(t)
fe_p.set(order)
fe_p.compute_basis_functions()

G = symbolic_matrix(3,3, "G") 
p0 = symbolic_matrix(3,1, "p") 
# dof for sigma 

ptvs = {}
ptv_counter = 0 
simplices = {}
simplices_counter = 0 
dof_map = {}
for i in range(0, fe_sigma.nbf()): 
#for i in range(0, 1): 
    dof = fe_sigma.dof(i)
    points, ints = find_points_and_ints(dof) 
    global_points = []
    for p in points:  
        tmp = matrix(1,3,p)
        global_points.append(G.mul(tmp.transpose()).add(p0))

    for g in global_points:  
        if ptvs.has_key(str(g)):  
            ptvs[str(g)][1] += 1 
        else: 
            ptvs[str(g)] = [ptv_counter, 1, g] 
            ptv_counter += 1 


    if simplices.has_key(str(global_points)):
        simplices[str(global_points)][1] += 1 
    else: 
        tmp = []
        for g in global_points: 
            tmp.append(ptvs[str(g)][0])
        simplices[str(global_points)] = [ simplices_counter, 1, tmp]
                                                
        simplices_counter += 1 
    

    dof_map[i] = [simplices[str(global_points)],ints]


ptv_str = ""
counter1 = 0 
for pp in ptvs.keys(): 
    g = ptvs[pp][2]
    ptv_str += "  double ptv%d[3];\n"%counter1    
    counter2 = 0 
    for i in range(0,g.nops()):  
        ptv_str += "  ptv%d[%d] = %s;\n"%(counter1,i,g.op(i)) 

    ptv_str += "\n"
    counter1 += 1 


simplex_str  = "" 
simplices_counter = 0 
print "simplices ", simplices
for s in simplices.keys(): 
    tmp_str = ""
    for i in range(0,len(simplices[s][2])-1): 
        tmp_str += "ptv%d, "% simplices[s][2][i] 
    tmp_str += "ptv%d"% simplices[s][2][len(simplices[s][2])-1] 
    print "tmp_str ", tmp_str 

    simplex_str += "  simplex s%d(%s);\n" %(simplices_counter, tmp_str)   
    simplices_counter += 1 

simplex_str += "\n"


print ptv_str
print simplex_str

dof_str = ""
for i in dof_map.keys(): 
    dof = dof_map[i]
    print "dof ", dof
    print "0 ", dof[0]
    print "10 ", dof[1][0]
    print "11 ", dof[1][1]
    dof_str += "  simplex_dof dof%d(s%d,%d,%d);\n" % (i,dof[0][0], dof[1][0], dof[1][1]) 

dof_str += "\n"

    

ccfile = open("mass_el.cc", 'w')
ccfile.write(ptv_str)
ccfile.write(simplex_str)
ccfile.write(dof_str)


"""

# mass matrix for sigma
A = {}
A_str = "  double A[%d][%d];\n"%(fe_sigma.nbf(), fe_sigma.nbf()) 
for i in range(0, fe_sigma.nbf()): 
    for j in range(0, fe_sigma.nbf()): 
        integrand = inner(fe_sigma.N(i),fe_sigma.N(j))
#        print "integrand ", integrand
        A[(i,j)] = t.integrate(integrand) 
        A_str += "  A[%d][%d] = (%s)*D;\n" % (i,j,(A[(i,j)]).evalf().printc()) 
 

print A_str



# div matrix for sigma U 
# FIXME: Piola is missing 
B = {}
for i in range(0, fe_sigma.nbf()): 
    for j in range(0, fe_u.nbf()): 
#        print "div ", div(fe_sigma.N(i))
        integrand = inner(div(fe_sigma.N(i)),fe_u.N(j))
#        print "integrand ", integrand
        B[(i,j)] = t.integrate(integrand) 


print A
print B


"""


