
from swiginac import *
from SyFi import *

nsd = 1; cvar.nsd = 1

headers = """
#include <math.h>
#include <utility>
#include <map>
#include <Dof_double.h>

"""

def code_gen(integrand_func, name): 

    file = open("%s.cc"%name, 'w')
    file.write(headers) 
    line = ReferenceLine()
    fe = LagrangeFE()
    fe.set(line)
    J = symbol("D")
    Jinv = 1/J 
    for order in range(1,6): 
        fe.set(order)
        fe.compute_basis_functions()
        dof_str = "  int nbf = %d;\n" % fe.nbf() 
        dof_str += "  int idof[%d];\n" % fe.nbf() 
        for i in range(0,fe.nbf()): 
            dof_str += "  double dof%d = x0 + (x1-x0)*%e;\n" % (i,fe.dof(i).evalf()) 
            dof_str += "  idof[%d] = dof.insert_dof(element,%d,dof%d);\n\n" % (i,i,i) 
        matrix_str = "  double A[%d][%d];\n"%(fe.nbf(),fe.nbf())
        for i in range(0,fe.nbf()): 
            for j in range(0,fe.nbf()): 
                integrand = integrand_func(fe.N(i),fe.N(j), Jinv)
                Aij = line.integrate(integrand) 
                matrix_str += "  A[%d][%d] = (%s)*D;\n" %(i,j,Aij.evalf().printc())  





        A_str = """
void %s_%d(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
%s 
%s

  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
""" % ("%s_matrix_1D"%name, order,  dof_str, matrix_str) 

        file.write(A_str)



def mass_integrand(Ni, Nj, Jinv): 
    return Ni*Nj 

def stiffness_integrand(Ni, Nj, Jinv): 
    return Jinv*grad(Ni)*Jinv*grad(Nj) 

def conv_integrand(Ni, Nj, Jinv): 
    return Jinv*grad(Ni)*Nj 








code_gen(mass_integrand, "mass") 
code_gen(stiffness_integrand, "stiffness") 
code_gen(conv_integrand, "conv") 

