from swiginac import *
from SyFi import *
from quad_rules import *

x = cvar.x 

def integral(f,order):
    tmp = 0
    for p,w in scaled_quadrature_rules[order]: 
#        print "f ", f 
#        print "p,w ", p,w 
        tmp += f.subs(x==p)*w       
#        print tmp
    return tmp


def code_gen_quad(order,quad_order,func,funcname): 

    nsd = 1; cvar.nsd = 1
    line = ReferenceLine()
    fe = LagrangeFE()
    fe.set(line)
    J = symbol("D")
    Jinv = 1/J 
    fe.set(order)
    fe.compute_basis_functions()

    Qi = symbolic_matrix(1,fe.nbf(), "Q") 
    Ai = symbolic_matrix(1,fe.nbf(), "A") 

    A = 0 
    for i in range(0,fe.nbf()): 
        A += Ai.op(i)*fe.N(i)

    Q = 0 
    for i in range(0,fe.nbf()): 
        Q += Qi.op(i)*fe.N(i)

    dof_str = ""

    dof_str += "  int nbf = %d;\n" % fe.nbf()
    dof_str += "  int idof[%d];\n" % fe.nbf() 
    for i in range(0,fe.nbf()): 
        dof_str += "  double dof%d = x0 + (x1-x0)*%e;\n" % (i,fe.dof(i).evalf()) 
        dof_str += "  idof[%d] = dof.insert_dof(element,%d,dof%d);\n\n" % (i,i,i) 
 

    f_string = dof_str
    for i in range(0,fe.nbf()): 
        f_string += "  double Q%d"%i + "= Q[idof[%d]];"%i + "\n"   
    f_string += "\n"
    for i in range(0,fe.nbf()): 
        f_string += "  double A%d"%i + "= A[idof[%d]];"%i + "\n"   


    f_string += "\n  double ff[%d]" % fe.nbf() + ";\n" 
    for i in range(0,fe.nbf()):
        f_string += "  ff[%d] = "%i + integral(func(fe.N(i), Q, A), quad_order).printc() +  ";\n\n" 



    function_string = """
#include <vector>
#include <utility>
#include <map>
#include <Dof_double.h>
#include <math.h>

using namespace std; 


void %s (vector<double>& f, vector<double>& Q, vector<double>& A, Dof_double& dof, int element, double x0, double x1){ 

%s

  for (int i=0; i< nbf; i++) {
    f[idof[i]] += ff[i];   
  }


}
""" % ("%s_%d"%(funcname,order), f_string)


    f.write(function_string)


def computing_Q2overA(Ni, Q, A): 
    return Ni*pow(Q,2)/A

def computing_QoverA(Ni, Q, A): 
    return Ni*Q/A



f = open("sfunc.cc", 'w')
code_gen_quad(1,3,computing_Q2overA, "computing_Q2overA")
code_gen_quad(3,5,computing_Q2overA, "computing_Q2overA")
code_gen_quad(5,7,computing_Q2overA, "computing_Q2overA")

code_gen_quad(1,3,computing_QoverA, "computing_QoverA")
code_gen_quad(3,5,computing_QoverA, "computing_QoverA")
code_gen_quad(5,7,computing_QoverA, "computing_QoverA")





