
#include <math.h>
#include <utility>
#include <map>
#include <Dof_double.h>


void conv_matrix_1D_1(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 2;
  int idof[2];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*1.000000e+00;
  idof[1] = dof.insert_dof(element,1,dof1);

 
  double A[2][2];
  A[0][0] = (-5.0000000000000000e-01*1.0/D)*D;
  A[0][1] = (-5.0000000000000000e-01*1.0/D)*D;
  A[1][0] = (5.0000000000000000e-01*1.0/D)*D;
  A[1][1] = (5.0000000000000000e-01*1.0/D)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void conv_matrix_1D_2(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 3;
  int idof[3];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*5.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*1.000000e+00;
  idof[2] = dof.insert_dof(element,2,dof2);

 
  double A[3][3];
  A[0][0] = (-5.0000000000000000e-01*1.0/D)*D;
  A[0][1] = (-6.6666666666666663e-01*1.0/D)*D;
  A[0][2] = (1.6666666666666666e-01*1.0/D)*D;
  A[1][0] = (6.6666666666666663e-01*1.0/D)*D;
  A[1][1] = (0.0)*D;
  A[1][2] = (-6.6666666666666663e-01*1.0/D)*D;
  A[2][0] = (-1.6666666666666666e-01*1.0/D)*D;
  A[2][1] = (6.6666666666666663e-01*1.0/D)*D;
  A[2][2] = (5.0000000000000000e-01*1.0/D)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void conv_matrix_1D_3(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 4;
  int idof[4];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*3.333333e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*6.666667e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*1.000000e+00;
  idof[3] = dof.insert_dof(element,3,dof3);

 
  double A[4][4];
  A[0][0] = (-5.0000000000000000e-01*1.0/D)*D;
  A[0][1] = (-7.1250000000000002e-01*1.0/D)*D;
  A[0][2] = (2.9999999999999999e-01*1.0/D)*D;
  A[0][3] = (-8.7499999999999994e-02*1.0/D)*D;
  A[1][0] = (7.1250000000000002e-01*1.0/D)*D;
  A[1][1] = (0.0)*D;
  A[1][2] = (-1.0125000000000000e+00*1.0/D)*D;
  A[1][3] = (2.9999999999999999e-01*1.0/D)*D;
  A[2][0] = (-2.9999999999999999e-01*1.0/D)*D;
  A[2][1] = (1.0125000000000000e+00*1.0/D)*D;
  A[2][2] = (0.0)*D;
  A[2][3] = (-7.1250000000000002e-01*1.0/D)*D;
  A[3][0] = (8.7499999999999994e-02*1.0/D)*D;
  A[3][1] = (-2.9999999999999999e-01*1.0/D)*D;
  A[3][2] = (7.1250000000000002e-01*1.0/D)*D;
  A[3][3] = (5.0000000000000000e-01*1.0/D)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void conv_matrix_1D_4(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 5;
  int idof[5];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.500000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*5.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*7.500000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*1.000000e+00;
  idof[4] = dof.insert_dof(element,4,dof4);

 
  double A[5][5];
  A[0][0] = (-5.0000000000000000e-01*1.0/D)*D;
  A[0][1] = (-7.7883597883597888e-01*1.0/D)*D;
  A[0][2] = (4.2539682539682538e-01*1.0/D)*D;
  A[0][3] = (-2.0317460317460317e-01*1.0/D)*D;
  A[0][4] = (5.6613756613756616e-02*1.0/D)*D;
  A[1][0] = (7.7883597883597888e-01*1.0/D)*D;
  A[1][1] = (0.0)*D;
  A[1][2] = (-1.1174603174603175e+00*1.0/D)*D;
  A[1][3] = (5.4179894179894184e-01*1.0/D)*D;
  A[1][4] = (-2.0317460317460317e-01*1.0/D)*D;
  A[2][0] = (-4.2539682539682538e-01*1.0/D)*D;
  A[2][1] = (1.1174603174603175e+00*1.0/D)*D;
  A[2][2] = (0.0)*D;
  A[2][3] = (-1.1174603174603175e+00*1.0/D)*D;
  A[2][4] = (4.2539682539682538e-01*1.0/D)*D;
  A[3][0] = (2.0317460317460317e-01*1.0/D)*D;
  A[3][1] = (-5.4179894179894184e-01*1.0/D)*D;
  A[3][2] = (1.1174603174603175e+00*1.0/D)*D;
  A[3][3] = (0.0)*D;
  A[3][4] = (-7.7883597883597888e-01*1.0/D)*D;
  A[4][0] = (-5.6613756613756616e-02*1.0/D)*D;
  A[4][1] = (2.0317460317460317e-01*1.0/D)*D;
  A[4][2] = (-4.2539682539682538e-01*1.0/D)*D;
  A[4][3] = (7.7883597883597888e-01*1.0/D)*D;
  A[4][4] = (5.0000000000000000e-01*1.0/D)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void conv_matrix_1D_5(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 6;
  int idof[6];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*4.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*6.000000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*8.000000e-01;
  idof[4] = dof.insert_dof(element,4,dof4);

  double dof5 = x0 + (x1-x0)*1.000000e+00;
  idof[5] = dof.insert_dof(element,5,dof5);

 
  double A[6][6];
  A[0][0] = (-5.0000000000000000e-01*1.0/D)*D;
  A[0][1] = (-8.5031553130511461e-01*1.0/D)*D;
  A[0][2] = (6.1005015432098764e-01*1.0/D)*D;
  A[0][3] = (-3.8029100529100529e-01*1.0/D)*D;
  A[0][4] = (1.6155478395061729e-01*1.0/D)*D;
  A[0][5] = (-4.0998401675485012e-02*1.0/D)*D;
  A[1][0] = (8.5031553130511461e-01*1.0/D)*D;
  A[1][1] = (0.0)*D;
  A[1][2] = (-1.3261959876543210e+00*1.0/D)*D;
  A[1][3] = (7.1476796737213399e-01*1.0/D)*D;
  A[1][4] = (-4.0044229497354500e-01*1.0/D)*D;
  A[1][5] = (1.6155478395061729e-01*1.0/D)*D;
  A[2][0] = (-6.1005015432098764e-01*1.0/D)*D;
  A[2][1] = (1.3261959876543210e+00*1.0/D)*D;
  A[2][2] = (0.0)*D;
  A[2][3] = (-1.0506227954144620e+00*1.0/D)*D;
  A[2][4] = (7.1476796737213399e-01*1.0/D)*D;
  A[2][5] = (-3.8029100529100529e-01*1.0/D)*D;
  A[3][0] = (3.8029100529100529e-01*1.0/D)*D;
  A[3][1] = (-7.1476796737213399e-01*1.0/D)*D;
  A[3][2] = (1.0506227954144620e+00*1.0/D)*D;
  A[3][3] = (0.0)*D;
  A[3][4] = (-1.3261959876543210e+00*1.0/D)*D;
  A[3][5] = (6.1005015432098764e-01*1.0/D)*D;
  A[4][0] = (-1.6155478395061729e-01*1.0/D)*D;
  A[4][1] = (4.0044229497354500e-01*1.0/D)*D;
  A[4][2] = (-7.1476796737213399e-01*1.0/D)*D;
  A[4][3] = (1.3261959876543210e+00*1.0/D)*D;
  A[4][4] = (0.0)*D;
  A[4][5] = (-8.5031553130511461e-01*1.0/D)*D;
  A[5][0] = (4.0998401675485012e-02*1.0/D)*D;
  A[5][1] = (-1.6155478395061729e-01*1.0/D)*D;
  A[5][2] = (3.8029100529100529e-01*1.0/D)*D;
  A[5][3] = (-6.1005015432098764e-01*1.0/D)*D;
  A[5][4] = (8.5031553130511461e-01*1.0/D)*D;
  A[5][5] = (5.0000000000000000e-01*1.0/D)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
