#include  <MatrixFactory1D.h>

using namespace std; 

int main() {
    vector<double> mesh; 
    mesh.push_back(0.0); 
    mesh.push_back(0.5); 
    mesh.push_back(1.0); 

    Dof_double dof(true,true); 
    dof.insert_dof(0,1,0.5); 
    dof.insert_dof(1,1,0.5); 
    dof.insert_dof(2,1,0.5); 

    for (int i = 0; i< dof.size(); i++) {
        cout <<dof.glob_dof(i)<<endl; 
    }


    MapMatrixFactory* matrix_factory = new MapMatrixFactory(&mesh); 
    matrix_factory->order = 1; 
    matrix_factory->computeMassMatrix();
    dump_to_matlab(*(matrix_factory->matrix), "M", "M.m"); 
    matrix_factory->computeStiffnessMatrix();
    dump_to_matlab(*(matrix_factory->matrix), "A", "A.m"); 
}

