
#include <math.h>
#include <utility>
#include <map>
#include <Dof_double.h>


void mass_matrix_1D_1(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 2;
  int idof[2];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*1.000000e+00;
  idof[1] = dof.insert_dof(element,1,dof1);

 
  double A[2][2];
  A[0][0] = (3.3333333333333331e-01)*D;
  A[0][1] = (1.6666666666666666e-01)*D;
  A[1][0] = (1.6666666666666666e-01)*D;
  A[1][1] = (3.3333333333333331e-01)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void mass_matrix_1D_2(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 3;
  int idof[3];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*5.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*1.000000e+00;
  idof[2] = dof.insert_dof(element,2,dof2);

 
  double A[3][3];
  A[0][0] = (1.3333333333333333e-01)*D;
  A[0][1] = (6.6666666666666666e-02)*D;
  A[0][2] = (-3.3333333333333333e-02)*D;
  A[1][0] = (6.6666666666666666e-02)*D;
  A[1][1] = (5.3333333333333333e-01)*D;
  A[1][2] = (6.6666666666666666e-02)*D;
  A[2][0] = (-3.3333333333333333e-02)*D;
  A[2][1] = (6.6666666666666666e-02)*D;
  A[2][2] = (1.3333333333333333e-01)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void mass_matrix_1D_3(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 4;
  int idof[4];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*3.333333e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*6.666667e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*1.000000e+00;
  idof[3] = dof.insert_dof(element,3,dof3);

 
  double A[4][4];
  A[0][0] = (7.6190476190476197e-02)*D;
  A[0][1] = (5.8928571428571427e-02)*D;
  A[0][2] = (-2.1428571428571429e-02)*D;
  A[0][3] = (1.1309523809523809e-02)*D;
  A[1][0] = (5.8928571428571427e-02)*D;
  A[1][1] = (3.8571428571428573e-01)*D;
  A[1][2] = (-4.8214285714285716e-02)*D;
  A[1][3] = (-2.1428571428571429e-02)*D;
  A[2][0] = (-2.1428571428571429e-02)*D;
  A[2][1] = (-4.8214285714285716e-02)*D;
  A[2][2] = (3.8571428571428573e-01)*D;
  A[2][3] = (5.8928571428571427e-02)*D;
  A[3][0] = (1.1309523809523809e-02)*D;
  A[3][1] = (-2.1428571428571429e-02)*D;
  A[3][2] = (5.8928571428571427e-02)*D;
  A[3][3] = (7.6190476190476197e-02)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void mass_matrix_1D_4(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 5;
  int idof[5];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.500000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*5.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*7.500000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*1.000000e+00;
  idof[4] = dof.insert_dof(element,4,dof4);

 
  double A[5][5];
  A[0][0] = (5.1499118165784834e-02)*D;
  A[0][1] = (5.2204585537918874e-02)*D;
  A[0][2] = (-3.0687830687830688e-02)*D;
  A[0][3] = (9.8765432098765430e-03)*D;
  A[0][4] = (-5.1146384479717815e-03)*D;
  A[1][0] = (5.2204585537918874e-02)*D;
  A[1][1] = (3.1604938271604938e-01)*D;
  A[1][2] = (-6.7724867724867729e-02)*D;
  A[1][3] = (4.5149911816578486e-02)*D;
  A[1][4] = (9.8765432098765430e-03)*D;
  A[2][0] = (-3.0687830687830688e-02)*D;
  A[2][1] = (-6.7724867724867729e-02)*D;
  A[2][2] = (3.3015873015873015e-01)*D;
  A[2][3] = (-6.7724867724867729e-02)*D;
  A[2][4] = (-3.0687830687830688e-02)*D;
  A[3][0] = (9.8765432098765430e-03)*D;
  A[3][1] = (4.5149911816578486e-02)*D;
  A[3][2] = (-6.7724867724867729e-02)*D;
  A[3][3] = (3.1604938271604938e-01)*D;
  A[3][4] = (5.2204585537918874e-02)*D;
  A[4][0] = (-5.1146384479717815e-03)*D;
  A[4][1] = (9.8765432098765430e-03)*D;
  A[4][2] = (-3.0687830687830688e-02)*D;
  A[4][3] = (5.2204585537918874e-02)*D;
  A[4][4] = (5.1499118165784834e-02)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void mass_matrix_1D_5(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 6;
  int idof[6];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*4.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*6.000000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*8.000000e-01;
  idof[4] = dof.insert_dof(element,4,dof4);

  double dof5 = x0 + (x1-x0)*1.000000e+00;
  idof[5] = dof.insert_dof(element,5,dof5);

 
  double A[6][6];
  A[0][0] = (3.8219496552829885e-02)*D;
  A[0][1] = (4.6549948893698893e-02)*D;
  A[0][2] = (-3.7296326358826362e-02)*D;
  A[0][3] = (2.1450867805034472e-02)*D;
  A[0][4] = (-5.7306697931697936e-03)*D;
  A[0][5] = (2.7789051226551225e-03)*D;
  A[1][0] = (4.6549948893698893e-02)*D;
  A[1][1] = (2.7964415985249319e-01)*D;
  A[1][2] = (-9.2536225348725354e-02)*D;
  A[1][3] = (7.1868235930735935e-02)*D;
  A[1][4] = (-3.9378782868366199e-02)*D;
  A[1][5] = (-5.7306697931697936e-03)*D;
  A[2][0] = (-3.7296326358826362e-02)*D;
  A[2][1] = (-9.2536225348725354e-02)*D;
  A[2][2] = (3.1252505210838544e-01)*D;
  A[2][3] = (-1.0240049302549302e-01)*D;
  A[2][4] = (7.1868235930735935e-02)*D;
  A[2][5] = (2.1450867805034472e-02)*D;
  A[3][0] = (2.1450867805034472e-02)*D;
  A[3][1] = (7.1868235930735935e-02)*D;
  A[3][2] = (-1.0240049302549302e-01)*D;
  A[3][3] = (3.1252505210838544e-01)*D;
  A[3][4] = (-9.2536225348725354e-02)*D;
  A[3][5] = (-3.7296326358826362e-02)*D;
  A[4][0] = (-5.7306697931697936e-03)*D;
  A[4][1] = (-3.9378782868366199e-02)*D;
  A[4][2] = (7.1868235930735935e-02)*D;
  A[4][3] = (-9.2536225348725354e-02)*D;
  A[4][4] = (2.7964415985249319e-01)*D;
  A[4][5] = (4.6549948893698893e-02)*D;
  A[5][0] = (2.7789051226551225e-03)*D;
  A[5][1] = (-5.7306697931697936e-03)*D;
  A[5][2] = (2.1450867805034472e-02)*D;
  A[5][3] = (-3.7296326358826362e-02)*D;
  A[5][4] = (4.6549948893698893e-02)*D;
  A[5][5] = (3.8219496552829885e-02)*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
