
#include <math.h>
#include <utility>
#include <map>
#include <Dof_double.h>


void stiffness_matrix_1D_1(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 2;
  int idof[2];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*1.000000e+00;
  idof[1] = dof.insert_dof(element,1,dof1);

 
  double A[2][2];
  A[0][0] = (1.0/(D*D))*D;
  A[0][1] = (-1.0000000000000000e+00*1.0/(D*D))*D;
  A[1][0] = (-1.0000000000000000e+00*1.0/(D*D))*D;
  A[1][1] = (1.0/(D*D))*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void stiffness_matrix_1D_2(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 3;
  int idof[3];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*5.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*1.000000e+00;
  idof[2] = dof.insert_dof(element,2,dof2);

 
  double A[3][3];
  A[0][0] = (2.3333333333333335e+00*1.0/(D*D))*D;
  A[0][1] = (-2.6666666666666665e+00*1.0/(D*D))*D;
  A[0][2] = (3.3333333333333331e-01*1.0/(D*D))*D;
  A[1][0] = (-2.6666666666666665e+00*1.0/(D*D))*D;
  A[1][1] = (5.3333333333333330e+00*1.0/(D*D))*D;
  A[1][2] = (-2.6666666666666665e+00*1.0/(D*D))*D;
  A[2][0] = (3.3333333333333331e-01*1.0/(D*D))*D;
  A[2][1] = (-2.6666666666666665e+00*1.0/(D*D))*D;
  A[2][2] = (2.3333333333333335e+00*1.0/(D*D))*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void stiffness_matrix_1D_3(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 4;
  int idof[4];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*3.333333e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*6.666667e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*1.000000e+00;
  idof[3] = dof.insert_dof(element,3,dof3);

 
  double A[4][4];
  A[0][0] = (3.7000000000000002e+00*1.0/(D*D))*D;
  A[0][1] = (-4.7249999999999996e+00*1.0/(D*D))*D;
  A[0][2] = (1.3500000000000001e+00*1.0/(D*D))*D;
  A[0][3] = (-3.2500000000000001e-01*1.0/(D*D))*D;
  A[1][0] = (-4.7249999999999996e+00*1.0/(D*D))*D;
  A[1][1] = (1.0800000000000001e+01*1.0/(D*D))*D;
  A[1][2] = (-7.4249999999999998e+00*1.0/(D*D))*D;
  A[1][3] = (1.3500000000000001e+00*1.0/(D*D))*D;
  A[2][0] = (1.3500000000000001e+00*1.0/(D*D))*D;
  A[2][1] = (-7.4249999999999998e+00*1.0/(D*D))*D;
  A[2][2] = (1.0800000000000001e+01*1.0/(D*D))*D;
  A[2][3] = (-4.7249999999999996e+00*1.0/(D*D))*D;
  A[3][0] = (-3.2500000000000001e-01*1.0/(D*D))*D;
  A[3][1] = (1.3500000000000001e+00*1.0/(D*D))*D;
  A[3][2] = (-4.7249999999999996e+00*1.0/(D*D))*D;
  A[3][3] = (3.7000000000000002e+00*1.0/(D*D))*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void stiffness_matrix_1D_4(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 5;
  int idof[5];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.500000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*5.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*7.500000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*1.000000e+00;
  idof[4] = dof.insert_dof(element,4,dof4);

 
  double A[5][5];
  A[0][0] = (5.2116402116402121e+00*1.0/(D*D))*D;
  A[0][1] = (-7.2465608465608469e+00*1.0/(D*D))*D;
  A[0][2] = (3.2253968253968255e+00*1.0/(D*D))*D;
  A[0][3] = (-1.5576719576719578e+00*1.0/(D*D))*D;
  A[0][4] = (3.6719576719576719e-01*1.0/(D*D))*D;
  A[1][0] = (-7.2465608465608469e+00*1.0/(D*D))*D;
  A[1][1] = (1.7608465608465607e+01*1.0/(D*D))*D;
  A[1][2] = (-1.5034920634920635e+01*1.0/(D*D))*D;
  A[1][3] = (6.2306878306878311e+00*1.0/(D*D))*D;
  A[1][4] = (-1.5576719576719578e+00*1.0/(D*D))*D;
  A[2][0] = (3.2253968253968255e+00*1.0/(D*D))*D;
  A[2][1] = (-1.5034920634920635e+01*1.0/(D*D))*D;
  A[2][2] = (2.3619047619047620e+01*1.0/(D*D))*D;
  A[2][3] = (-1.5034920634920635e+01*1.0/(D*D))*D;
  A[2][4] = (3.2253968253968255e+00*1.0/(D*D))*D;
  A[3][0] = (-1.5576719576719578e+00*1.0/(D*D))*D;
  A[3][1] = (6.2306878306878311e+00*1.0/(D*D))*D;
  A[3][2] = (-1.5034920634920635e+01*1.0/(D*D))*D;
  A[3][3] = (1.7608465608465607e+01*1.0/(D*D))*D;
  A[3][4] = (-7.2465608465608469e+00*1.0/(D*D))*D;
  A[4][0] = (3.6719576719576719e-01*1.0/(D*D))*D;
  A[4][1] = (-1.5576719576719578e+00*1.0/(D*D))*D;
  A[4][2] = (3.2253968253968255e+00*1.0/(D*D))*D;
  A[4][3] = (-7.2465608465608469e+00*1.0/(D*D))*D;
  A[4][4] = (5.2116402116402121e+00*1.0/(D*D))*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}

void stiffness_matrix_1D_5(map<pair<int,int>,double>& matrix, Dof_double& dof, 
        double x0, double x1,int element){

  double D = x1 - x0; 
  int nbf = 6;
  int idof[6];
  double dof0 = x0 + (x1-x0)*0.000000e+00;
  idof[0] = dof.insert_dof(element,0,dof0);

  double dof1 = x0 + (x1-x0)*2.000000e-01;
  idof[1] = dof.insert_dof(element,1,dof1);

  double dof2 = x0 + (x1-x0)*4.000000e-01;
  idof[2] = dof.insert_dof(element,2,dof2);

  double dof3 = x0 + (x1-x0)*6.000000e-01;
  idof[3] = dof.insert_dof(element,3,dof3);

  double dof4 = x0 + (x1-x0)*8.000000e-01;
  idof[4] = dof.insert_dof(element,4,dof4);

  double dof5 = x0 + (x1-x0)*1.000000e+00;
  idof[5] = dof.insert_dof(element,5,dof5);

 
  double A[6][6];
  A[0][0] = (6.8559303350970016e+00*1.0/(D*D))*D;
  A[0][1] = (-1.0420111331569665e+01*1.0/(D*D))*D;
  A[0][2] = (6.3726300705467374e+00*1.0/(D*D))*D;
  A[0][3] = (-4.3058311287477951e+00*1.0/(D*D))*D;
  A[0][4] = (1.8945656966490301e+00*1.0/(D*D))*D;
  A[0][5] = (-3.9718364197530864e-01*1.0/(D*D))*D;
  A[1][0] = (-1.0420111331569665e+01*1.0/(D*D))*D;
  A[1][1] = (2.7143959435626101e+01*1.0/(D*D))*D;
  A[1][2] = (-2.7316192680776012e+01*1.0/(D*D))*D;
  A[1][3] = (1.6775518077601411e+01*1.0/(D*D))*D;
  A[1][4] = (-8.0777391975308639e+00*1.0/(D*D))*D;
  A[1][5] = (1.8945656966490301e+00*1.0/(D*D))*D;
  A[2][0] = (6.3726300705467374e+00*1.0/(D*D))*D;
  A[2][1] = (-2.7316192680776012e+01*1.0/(D*D))*D;
  A[2][2] = (4.3678350970017640e+01*1.0/(D*D))*D;
  A[2][3] = (-3.5204475308641975e+01*1.0/(D*D))*D;
  A[2][4] = (1.6775518077601411e+01*1.0/(D*D))*D;
  A[2][5] = (-4.3058311287477951e+00*1.0/(D*D))*D;
  A[3][0] = (-4.3058311287477951e+00*1.0/(D*D))*D;
  A[3][1] = (1.6775518077601411e+01*1.0/(D*D))*D;
  A[3][2] = (-3.5204475308641975e+01*1.0/(D*D))*D;
  A[3][3] = (4.3678350970017640e+01*1.0/(D*D))*D;
  A[3][4] = (-2.7316192680776012e+01*1.0/(D*D))*D;
  A[3][5] = (6.3726300705467374e+00*1.0/(D*D))*D;
  A[4][0] = (1.8945656966490301e+00*1.0/(D*D))*D;
  A[4][1] = (-8.0777391975308639e+00*1.0/(D*D))*D;
  A[4][2] = (1.6775518077601411e+01*1.0/(D*D))*D;
  A[4][3] = (-2.7316192680776012e+01*1.0/(D*D))*D;
  A[4][4] = (2.7143959435626101e+01*1.0/(D*D))*D;
  A[4][5] = (-1.0420111331569665e+01*1.0/(D*D))*D;
  A[5][0] = (-3.9718364197530864e-01*1.0/(D*D))*D;
  A[5][1] = (1.8945656966490301e+00*1.0/(D*D))*D;
  A[5][2] = (-4.3058311287477951e+00*1.0/(D*D))*D;
  A[5][3] = (6.3726300705467374e+00*1.0/(D*D))*D;
  A[5][4] = (-1.0420111331569665e+01*1.0/(D*D))*D;
  A[5][5] = (6.8559303350970016e+00*1.0/(D*D))*D;


  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = idof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = idof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
