%module (directors="1") MatrixFactory1D
%feature("director");

%{
#include <MatrixFactory1D.h>
#include <Numeric/arrayobject.h>
#include <iostream>
#include <Dof_double.h>

#include <ml_config.h>
#ifdef HAVE_ML_EPETRA 
#ifdef HAVE_MPI
#include "mpi.h"
#include "Epetra_MpiComm.h"
#else
#include "Epetra_SerialComm.h"
#endif
#include <Epetra_Map.h>
#include <Epetra_FECrsMatrix.h>
#include <Epetra_ConfigDefs.h>
#endif // HAVE_ML_EPETRA 


PyObject* dof2numpy(Dof_double& dof) {
  int size = dof.size(); 

  PyArrayObject* array =  (PyArrayObject*) 
	  PyArray_FromDims(1, &size, PyArray_DOUBLE); 

  for (int i=0; i< size; i++) {
    *(double*)(array->data + array->strides[0]*(i)) = dof.glob_dof((int)i);  
  }
  return PyArray_Return(array);
}



vector<double>* numpy2vec (PyObject* array) {
  vector<double>* ret_vec = new vector<double>;
  if (!PyArray_Check(array)) {
    PyErr_SetString(PyExc_TypeError, "Not a NumPy array");
    return NULL; ;
  }
  PyArrayObject* pyarray; 
  pyarray = (PyArrayObject*)array; 
  int size = pyarray->dimensions[0];   
  cout <<"size "<<size<<endl; 
  double value; 
  for (int i=0; i< size; i++) {
    value = *(double*)(pyarray->data + pyarray->strides[0]*i); 
    ret_vec->push_back(value); 
  }
  return ret_vec;

 
}






%}

%init%{
import_array();
%}




%newobject  numpy2vec(PyObject*);
vector<double>* numpy2vec (PyObject* array); 
PyObject* dof2numpy (Dof_double& dof); 


%include "../MatrixFactory1D.h"


