
from Numeric import *
from MatSparse import * 
from MatrixFactory1D import *
from ConjGrad import *
from BlockMatrix import *
from scipy import linspace
import Gnuplot, Gnuplot.PlotItems, Gnuplot.funcutils

def rhs(a,b,c,d,x,t): 
    return -a*cos(x-t) + b*cos(x-t) - c*cos(x-t) + d*sin(x-t)  



mesh = linspace(0.0,1.0, 1000) 
#print mesh

matrix_factory = FastMatSparseMatrixFactory(numpy2vec(mesh))
matrix_factory.order = 2


M = matrix_factory.computeMassMatrix()
#printDofs(matrix_factory.dof)
mesh2 = dof2numpy(matrix_factory.dof)
#print mesh2


A = matrix_factory.computeStiffnessMatrix()
#printDofs(matrix_factory.dof)

n = matrix_factory.size()
print "n ", n

a = 1.0; b = 0.5; c = 0.1; d = 0.3; 

x = zeros(n,typecode='d')
bb = zeros(n,typecode='d')
f = zeros(n,typecode='d')

N = 200  
T = 1.0
dt = T/N

MA = (a + b*dt*dt)*M +  (c*dt*dt + d*dt)*A
MA.dumpToOctave("MA", "MA.m")

g = Gnuplot.Gnuplot(debug=1)

B = FastMatPrec(MA)

# set ic 
x_prev = zeros(n,typecode='d')
x_pprev = zeros(n,typecode='d')

for j in range(0,n): 
    x[j]= cos(mesh2[j]) 
    x_prev[j] = cos(mesh2[j]+dt) 


for i in range(0,N): 

    x_prev = x 
    x_pprev = x_prev 

    Tn = i*T/N 
    print Tn 
    for j in range(0,n): 
        f[j] = rhs(a,b,c,d,mesh2[j], Tn)

    bb = a*M*(2*x_prev - x_pprev) + (d*dt)*A*x_prev + dt*dt*M*f    
    print "max ", max(bb)

#    x = precondconjgrad(B, A, x, bb, 10E-6, True)
    x = conjgrad(A, x, bb, 10E-6, True,100)
    print "max ", max(x)
    g.replot(Gnuplot.Data(mesh2,x, with ='lines'))








