
from PyTrilinos import Epetra
from PyTrilinos import EpetraExt
from PyTrilinos import AztecOO
from PyTrilinos import Amesos

from Numeric import *
from MatrixFactory1D import *



mesh = arange(0.0,1.0, 0.5, typecode='d') 
print mesh
Comm = Epetra.PyComm()
matrix_factory = EpetraMatrixFactory(numpy2vec(mesh), Comm)
M = matrix_factory.computeMassMatrix()
print M 
A = matrix_factory.computeStiffnessMatrix()
print A 

EpetraExt.Add(M,False,1.0, A, 1.0)   

#print M 
Map = matrix_factory.Map
x = Epetra.Vector(Map) 
b = Epetra.Vector(Map) 
for i in range(0, len(b)):   
    
    b[i] = i


Problem = Epetra.LinearProblem(M, x, b)
AmesosList = {
    "PrintStatus": True,
    "PrintTiming": True
}
Solver = Amesos.Lapack(Problem)
Solver.SetParameters(AmesosList)
Solver.SymbolicFactorization()
Solver.NumericFactorization()
ierr = Solver.Solve()
print "Solver.Solve() return code = ", ierr
del Solver


print x 



  
 










