%module SyFi
%{
#include <SyFi.h>
#include <ginac/ginac.h>
using namespace GiNaC; 
%}

%feature("autodoc", "1");

%include std_string.i
%include stl.i 



namespace GiNaC{
%include ex.i
%include typemaps.i 	
} 

namespace GiNaC{ 
  class exvector{};
  typedef map<ex,ex, ex_is_less>  ex_ex_map;
}



%include tools.h
%include Polygon.h 
%include FE.h
%include LagrangeFE.h
%include Dof.h
%include CrouzeixRaviart.h
%include P0.h
%include RaviartThomas.h
%include DiscontinuousLagrangeFE.h
%include HermiteFE.h
%include Nedelec.h
%include Bubble.h
%include ElementComputations.h
%include ArnoldFalkWintherWeakSym.h





%extend GiNaC::exvector {
  void append(GiNaC::ex& e) {
    self->insert(self->end(), e); 
  }
  GiNaC::ex __getitem__(int i) { 
    cout <<(*self)[i]<<endl; 
    return (*self)[i]; 
  }
   
}; 

 

/*
%extend ex_ex_map {
  GiNaC::ex& __getitem__(GiNaC::ex& e) { 
    return (*self)[e]; 
  }

  void __settitem__(GiNaC::ex& key, GiNaC::ex& value) { 
    (*self)[key] = value; 
  }
   
}; 
*/


