#include <Polygon.h>

using namespace GiNaC; 

lst map2lst(ex_ex_map& map) { 
  lst equations; 
  ex_ex_it iter; 
  for (iter = map.begin(); iter != map.end(); iter++) {
    ex b; ex c; 
    b = (*iter).first; c = map[b]; 
    if ( c != 0 ) {
      // FIXME this is not actually a map2lst, I have added a == 0 below as well 
      equations.append(c == 0 ); 
    }
  }
  return equations; 

}


void check_line(ex p0, ex p1) { 
  Line line(p0,p1, "l"); 
  cout <<"Line: "<<line.str()<<endl; 

  int no_of_points = 5; 
  ex inc = (p1-p0)/no_of_points; 

  ex p = p0; 

  while(p != p1+inc) { 
    cout <<"p: "<<p<<endl; 
    p += inc; 
  }

  symbol t("t"); 
  cout <<"line.repr() "<<line.repr(t)<<endl; 

  ex l = line.repr(t); 


  ex f = x*x + y*y*y; 
  ex intf; 
  if ( l.nops() == 5 ) { // 2D
    intf = integral(l.op(2), l.op(3), l.op(4), f.subs(lst(l.op(0), l.op(1))));  
  } else if ( l.nops() == 6 ) { 
    intf = integral(l.op(3), l.op(4), l.op(5), f.subs(lst(l.op(0), l.op(1), l.op(2))));  
  }


  cout <<"intf "<<intf<<endl; 
  ex intfe = eval_integ(intf); 
  cout <<"intfe "<<intfe<<endl; 

}


void check_line2(ex p0, ex p1, int order) { 
  Line line(p0,p1,"l"); 
  cout <<"Line: "<<line.str()<<endl; 

  // FIXME need some nasty stuff for adding lst... 
  // Convert the lst to matrices to add 
  // then convert matrices to lst to use in lst_equals
  lst p0l = ex_to<lst>(p0); 
  lst p1l = ex_to<lst>(p1); 

  
  ex  p0m = lst_to_matrix2(p0l); 
  ex  p1m = lst_to_matrix2(p1l); 

  ex inc = (p1m-p0m)/order; 


  ex P = pol(order,3, "a"); 
  lst equations; 

  ex p = p0m; 
  ex pm = p.evalm(); 	
  int i = 0; 
  int j = 2; 

  /* FIXME Do not need to concretize the polynom 
   * such that it is 0 or 1 in various points 
   *
  while(pm != (p1m+inc).evalm()) { 
    i++; 
    lst pl = matrix_to_lst2(pm); 
    ex r= P.subs(lst_equals(pl, lst(x,y,z))); 
    equations.append(r == dirac(i,j) ); 
    p += inc; 
    pm = p.evalm(); 	
  }
  */

//  print(equations); 

  symbol t("t"); 
  ex line_repr = line.repr(t); 
  lst al = lst(line_repr.op(0).rhs().coeff(t), 
	       line_repr.op(1).rhs().coeff(t), 
	       line_repr.op(2).rhs().coeff(t)); 
  print(al); 

  lst n1 = lst(-al.op(1), al.op(0), 0); 
  lst n2 = cross(n1, al); 

  print(n1); 
  print(n2); 


  // FIXME nasty place to update a global variable
  nsd = 3; 
  ex gradP = grad(P); 
  cout <<"gradP "<<gradP<<endl; 
//  print(gradP); 

  ex dpdn1 = inner(gradP, n1); 
  ex dpdn2 = inner(gradP, n2); 

  cout <<"dpdn1 "<<dpdn1<<endl; 
  cout <<"dpdn2 "<<dpdn2<<endl; 

  ex_ex_map map = pol2basisandcoeff(dpdn1); 
  print(map); 
  lst eqns1 = map2lst(map); 
  // FIXME : instead of the nasty hack above I could do
  // something like 
  // lst_equals ( eqns1, 0 ) 
  map = pol2basisandcoeff(dpdn2); 
  lst eqns2 = map2lst(map); 

  equations = collapse(lst(equations, eqns1, eqns2)); 
  
  try {
    lst variables = coeffs(P); 
    cout <<"equations "<<endl; 
    cout <<"equations.nops() "<<equations.nops()<<endl; 
    print(equations); 
    cout <<"variables"<<endl; 
    cout <<"variables.nops() "<<variables.nops()<<endl; 
    print(variables); 
    ex ss = lsolve(equations, variables); 
    cout <<"ss"<<ss<<endl; 
    ex N = P.subs( ss) ; 
    cout <<"N "<<N<<endl; 

    ex gradN = grad(N); 
    ex dNdn1 = inner(gradN,n1);  
    cout <<"dNdn1 "<<dNdn1<<endl; 

    ex dNdn2 = inner(gradN,n2);  
    cout <<"dNdn2 "<<dNdn2<<endl; 

  } catch (exception &p) {
        cerr << p.what() << endl;
  }


}



int main() {
  symbol x0("x0"); symbol x1("x1"); 
  symbol y0("y0"); symbol y1("y1"); 
  symbol z0("z0"); symbol z1("z1"); 
 
  // 2D symbolic 
  ex p0 = lst(x0,y0); 
  ex p1 = lst(x1,y1); 
 
  check_line(p0, p1); 
 
  // 2D numerical
  ex q0 = lst (0,1); 
  ex q1 = lst (1,0); 
 
  check_line(q0, q1); 

  // 3D symbolic
  p0 = lst(x0,y0,z0); 
  p1 = lst(x1,y1,z1); 

  check_line(p0, p1); 

  // 3D numerical
  q0 = lst (0,1,0.5); 
  q1 = lst (1,0,0.3); 
 
  check_line(q0, q1); 

  // 3D symbolic
  
   try {
     ex p0 = lst(x0,y0,z0); 
     ex p1 = lst(x1,y1,z1); 

     check_line2(p0, p1, 1); 


     ex q0 = lst (0,0,0); 
     ex q1 = lst (1,1,0); 

     check_line2(q0, q1,2); 

    } catch (exception &p) {
        cerr << p.what() << endl;
        return 1;
    }
    return 0;



}



