#include <Polygon.h>


using namespace GiNaC; 

void check_tetrahedron(ex p0, ex p1, ex p2, ex p3) {
  Tetrahedron T(p0, p1, p2, p3, ""); 

  cout <<"Tetrahedron T "<<T.repr()<<endl; 

  symbol r("r"), s("s"), t("t"), u("u"), v("v"), w("w"); 
  lst variables = lst(r,s,t,u,v,w); 

  for (int i=1; i<= 4; i++) {
    Triangle t = T.triangle(i); 
    cout <<"Triangle "<<i <<" "<<t.repr()<<endl; 
  }
  for (int i=1; i<= 6; i++) {
    Line l = T.line(i); 
    cout <<"Line "<<i<<" "<<l.repr(variables.op(i-1))<<endl; 
  }

  ex f = x*x + y*y + z*z + x*y*z; 
//  ex f = 1; 
  ex intf = T.integrate(f); 
  cout <<"intf "<<intf<<endl; 

  /*
  ex line1; 
  ex l1_repr = T.line(1).repr(t);

  // FIXME check what happens with (x_0, y_0, z_0) also in 2D. 
  // It seems that it occur 3 times. Fix this at a later
  // point. For now it is 3*0.  
  lst new_coor; 
  for (int i=0; i<= 2; i++) { 
    new_coor.append(T.line(1).repr(variables.op(i)).op(i).lhs()
      == T.line(1).repr(variables.op(i)).op(i).rhs()   
       + T.line(2).repr(variables.op(i)).op(i).rhs()   
       + T.line(3).repr(variables.op(i)).op(i).rhs() );   
  }

  cout <<"New coor "<<endl; 
  print(new_coor); 

  // Find the vertices of the triangle parallel to the plane spanned
  // by the lines 2 and 3 as a function of r.   
  // FIXME: Need to explain this with a figure. 


  // first vertex, v1: 
  lst v1 = lst(T.line(1).repr(r).op(0).rhs(), T.line(1).repr(r).op(1).rhs(), T.line(1).repr(r).op(2).rhs());    
  cout <<"v1 "; 
  print(v1); 

  // second vertex, v2: 
 
  cout <<"Line 3 "<< T.line(3).repr(t)<<endl; 
  cout <<"Line 4 "<< T.line(4).repr(t)<<endl; 
  lst equations = lst(v1.op(0) + T.line(3).repr(t).op(0).rhs().coeff(t,1)*t == T.line(4).repr(u).op(0).rhs(),   
//                      v1.op(1) + T.line(3).repr(t).op(1).rhs().coeff(t,1)*t == T.line(4).repr(u).op(1).rhs(), 
                      v1.op(2) + T.line(3).repr(t).op(2).rhs().coeff(t,1)*t == T.line(4).repr(u).op(2).rhs()
                      );  


  cout <<"Equations "<<endl; 
  print(equations); 
  ex sol = lsolve(equations, lst(u,t));  
  lst lsol = ex_to<lst>(sol); 
  cout <<"sol "<<sol<<endl; 

  // FIXME: should be possible to send in a list of relationals to subs   

  lst v2 = lst(T.line(4).repr(u).op(0).subs(lsol.op(0)).rhs(), 
               T.line(4).repr(u).op(1).subs(lsol.op(0)).rhs(), 
               T.line(4).repr(u).op(2).subs(lsol.op(0)).rhs());  

  print(v2); 

  // third vertex, v3: 
  lst equations2 = lst(v1.op(0) + T.line(2).repr(t).op(0).rhs().coeff(t,1)*t == T.line(5).repr(u).op(0).rhs(),   
                       v1.op(1) + T.line(2).repr(t).op(1).rhs().coeff(t,1)*t == T.line(5).repr(u).op(1).rhs() 
//                      v1.op(2).rhs() + T.line(3).repr(t).op(2).rhs().coeff(t,1)*t == T.line(4).repr(u).op(2).rhs()
                      );  


  print(equations2); 
  ex sol2 = lsolve(equations2, lst(u,t));  
  lst lsol2 = ex_to<lst>(sol2); 
  cout <<"sol "<<sol2<<endl; 


  lst v3 = lst(T.line(5).repr(u).op(0).subs(sol2.op(0)).rhs(),  
               T.line(5).repr(u).op(1).subs(sol2.op(0)).rhs(),  
               T.line(5).repr(u).op(2).subs(sol2.op(0)).rhs());  

  print(v3); 

  Triangle TT = Triangle(v1, v2, v3); 
  cout <<"Triangle "<< TT.repr()<<endl; 

  ex f = x; 
  ex intf = TT.integrate(f); 
  cout <<"intf "<<intf<<endl; 

  cout <<"\n\n"; 

  for (int i=0; i<intf.nops(); i++) {
    cout <<intf.op(i)<<endl; 
  }

  / *
  ex intff = intf.op(0); 
  ex  intfff = intff; 
  for (int i=1; i<intf.nops(); i++) {
    intfff = intfff.subs(intf.op(i)); 
  }
  cout <<"intfff "<<intfff<<endl; 
  * /




//  Triangle repr is obviously not working properly (x1, x2, x3) should be added  
  */

}

int main() {
  symbol x0("x0"); symbol x1("x1"); symbol x2("x2"); symbol x3("x3");  
  symbol y0("y0"); symbol y1("y1"); symbol y2("y2"); symbol y3("y3");  
  symbol z0("z0"); symbol z1("z1"); symbol z2("z2"); symbol z3("z3");  

  ex p0 = lst(x0,y0,z0); 
  ex p1 = lst(x1,y1,z1); 
  ex p2 = lst(x2,y2,z2); 
  ex p3 = lst(x3,y3,z3); 

  check_tetrahedron(p0, p1, p2,p3); 

  ex q0 = lst (0,0,0); 
  ex q1 = lst (1,0,0); 
  ex q2 = lst (0,1,0); 
  ex q3 = lst (0,0,1); 

  check_tetrahedron(q0, q1, q2, q3); 
 
}
