#include <Polygon.h>


using namespace GiNaC; 

void check_triangle(ex p0, ex p1, ex p2) { 

  Triangle triangle(p0,p1,p2,"t"); 
  cout <<"Triangle:" <<triangle.str()<<endl; 

  symbol r("r"); symbol s("s"); symbol t("t"); 
  lst v = lst(r,s,t); 

  for (int i=1; i<= 3; i++) {
    Line line = triangle.line(i); 
    cout <<"\n Line"<<i<<": "<<line.str(); 
    cout <<" repr: "<<line.repr(v.op(i-1)); 
  }

  ex f = x*x + y*y*y + x*y; 
//  ex f = x*x;
  ex intf = triangle.integrate(f); 
  cout <<"intf "<<intf<<endl; 

  /*
  ex intff = intf.op(0); 
  ex  intfff = intff; 
  for (int i=1; i<intf.nops(); i++) {
    intfff = intfff.subs(intf.op(i)); 
  }
  cout <<"intfff "<<intfff<<endl; 
  */


  /*
  //run through the expression 
  ex_ex_map map; 
  ex_int_map intmap; 
  visitor_subst_pow(intff, map, intmap, "a");  
  cout <<"map"<<endl; 
  print(map); 
  cout <<"intmap"<<endl; 
  print(intmap); 
  lst l; 
  for(ex_ex_it i= map.begin(); i!=map.end(); i++) { 
    l.append( (*i).first == (*i).second);
  }
  print(l); 
  ex ss =  intf.subs(l); 
  cout <<"ss "<<ss<<endl; 
  */

}

int main() {
  symbol x0("x0"); symbol x1("x1"); symbol x2("x2"); 
  symbol y0("y0"); symbol y1("y1"); symbol y2("y2"); 
  symbol z0("z0"); symbol z1("z1"); symbol z2("z2"); 

  // symbolic 2D
  ex p0 = lst(x0,y0); 
  ex p1 = lst(x1,y1); 
  ex p2 = lst(x2,y2); 

  check_triangle(p0, p1, p2); 

  // numerical 2D
  ex q0 = lst (0,0); 
  ex q1 = lst (1,0); 
  ex q2 = lst (0,1); 

  check_triangle(q0, q1, q2); 
 
  // symbolic 3D
  p0 = lst(x0,y0,z0); 
  p1 = lst(x1,y1,z1); 
  p2 = lst(x2,y2,z2); 

  check_triangle(p0, p1, p2); 

  // numerical 3D
  q0 = lst (0,1,0); 
  q1 = lst (1,0,0.3); 
  q2 = lst (0,0,0.5); 

  check_triangle(q0, q1, q2); 
 



}
