#include <SimpleMesh.h>

Square:: Square(ex x0_, ex xn_, int nx_, int ny_) {
  x0 = x0_; 
  xn = xn_; 
  nx = nx_; 
  ny = ny_;
}

int Square::no_of_triangles() {
  return 2*(nx-1)*(ny-1);  
}

int Square:: no_of_boundary_nodes() {
  return 2*nx + 2*(ny-2);  
}

ex Square:: boundary_node( int i) {
  if (i>= 0 && i <= nx-1 ) {  
    ex dx = (xn.op(0) - x0.op(0))/(nx-1); 
    return lst(x0.op(0) + (i-1)*dx, x0.op(1));  
  } else if (i >= nx && i <= nx+ny-2) { 
    ex dy = (xn.op(1) - x0.op(1))/(ny-1); 
    return lst(xn.op(0), x0.op(1) + (i-nx)*dy);  
  } else if (i >= nx+ny-1 && i <= 2*nx+ny-3) { 
    ex dx = (xn.op(0) - x0.op(0))/(nx-1); 
    return lst(xn.op(0) - dx*(i-nx-ny+1) , xn.op(1));    
  } else if (i >= 2*nx+ny-2&& i <= no_of_boundary_nodes() ) {
    ex dy = (xn.op(1) - x0.op(1))/(ny-1); 
    return lst(x0.op(0), xn.op(1) - (i-2*nx-ny+2)*dy);  
  }
  return DUMMY; 
}

Triangle Square::triangle(int i) {
  ex dx = (xn.op(0) - x0.op(0))/(nx-1); 
  ex dy = (xn.op(1) - x0.op(1))/(ny-1); 

  int box = (i-1)/2+1; 

  ex p0,p1,p2,p3; 
  p0 = lst(x0.op(0) + ((box-1)%(nx-1))*dx, x0.op(1)     + ((box-1)/(ny-1))*dy);     
  p1 = lst(x0.op(0) + (((box-1)%(nx-1))+1)*dx, x0.op(1) + ((box-1)/(ny-1))*dy);     
  p2 = lst(x0.op(0) + ((box-1)%(nx-1))*dx, x0.op(1)     + (((box-1)/(ny-1))+1)*dy);     
  p3 = lst(x0.op(0) + (((box-1)%(nx-1))+1)*dx, x0.op(1) + (((box-1)/(ny-1))+1)*dy);     

  if (i%2 == 1) {
    return Triangle(p0,p1,p2); 
  } else if ( i%2 == 0) {
    return Triangle(p3,p1,p2); 
  }
  return Triangle(DUMMY,DUMMY,DUMMY); 
}


