#include "simplex.h"
#include <vector>

simplex:: simplex() {
}

simplex::~simplex() {
  ptvs.clear(); 
}

simplex:: simplex(const ptv& p0, const ptv& p1) {
  ptvs.push_back(p0); 
  ptvs.push_back(p1); 
}

simplex:: simplex(const ptv& p0, const ptv& p1, const ptv& p2) {
  ptvs.push_back(p0); 
  ptvs.push_back(p1); 
  ptvs.push_back(p2); 
}

simplex:: simplex(const ptv& p0, const ptv& p1, const ptv& p2, const ptv& p3) {
  ptvs.push_back(p0); 
  ptvs.push_back(p1); 
  ptvs.push_back(p2); 
  ptvs.push_back(p3); 
}

void simplex:: append(const ptv& p) {
  ptvs.push_back(p); 
}

int simplex:: size() const {
  return ptvs.size(); 
}




const ptv& simplex:: operator [] (int i) const {
  return ptvs[i]; 
}

ptv& simplex:: operator [] (int i) {
  return ptvs[i]; 
}

simplex& simplex::operator = (const simplex& p) {
  if ( this != &p) {
    ptvs.clear(); 
    for (int i=0; i<p.size(); i++) {
      ptvs.push_back(p[i]);  
    }
  }
  return *this; 
}

bool simplex:: is_less(const simplex& p) const {
  if ( ptvs.size() <  p.size() ) return true ; 
  if ( ptvs.size() > p.size() ) return false; 

  for (int i=ptvs.size()-1; i>= 0; i--) {
    if ( ptvs[i].is_less(p[i]) && p[i].is_less(ptvs[i])) {
    } else if ( ptvs[i].is_less(p[i]) ) {  
      return true; 
    } else if ( p[i].is_less(ptvs[i]) ) {
      return false;
    }
  }
  return false; 
}


std::ostream & operator<< ( std::ostream& os, const simplex& p) { 
  if (p.size() >= 1) {
    os <<"["; 
    for (int i=0; i< p.size()-1; i++) { 
      os <<p[i]<<","; 
    }
    os <<p[p.size()-1]<<"]"; 
  } else {
    os <<"ptv not created properly"<<std::endl; 
  }
}





