#ifndef SIMPLEX_IS_INCLUDED
#define SIMPLEX_IS_INCLUDED

#include <ptv.h>
#include <vector>
#include <iterator>
#include <iostream>

using namespace std; 

class simplex { 
    vector<ptv> ptvs; 
    public: 
    simplex();        
    simplex(const ptv& p0, const ptv& p1);
    simplex(const ptv& p0, const ptv& p1, const ptv& p2);
    simplex(const ptv& p0, const ptv& p1, const ptv& p2, const ptv& p3);

    virtual ~simplex(); 

    void append(const ptv& p); 
    int size() const; 

    const ptv& operator [] (int i) const;
    ptv& operator [] (int i); 
    simplex& operator = (const simplex& p);  



    bool is_less(const simplex& s) const; 
}; 

struct simplex_is_less : public std::binary_function<simplex, simplex, bool> {
bool operator() (const simplex &lh, const simplex &rh) const { return lh.is_less(rh);  }
};

std::ostream & operator<< ( std::ostream& os, const simplex& p); 



#endif 
