#ifndef __symb_transf_h__
#define __symb_transf_h__

#include <ginac/ginac.h>
#include <string>
#include <map>
#include <list>

using namespace std;
using namespace GiNaC;

/////////////////////////////////////////////////////////////////////////////

// a class that replaces symbols with same string, but
// different names with a set of symbols which have
// the same string

class symb_transf
{
 public:

  symb_transf( const ex & exzer__ ) : exzer( exzer__ ) {};

  symb_transf( const symb_transf & st ) { copy( st ); }

  symb_transf & operator =( const symb_transf & other );
 
  ex replaced();

 protected:

  void copy( const symb_transf & st );

  void create_lists( const ex & expre );
  void create_map();
  void create_replace_rules();
  string get_string( const ex & symb );

  ex exzer;

  lst symb_list;
  list<string> strg_list;
  map<string,lst> str_to_symb;


  lst repl_list;

};

/////////////////////////////////////////////////////////////////////////////

#endif

