#include "Bubble.h"

void Bubble:: compute_basis_functions() {

  if ( p == NULL ) {
    cout <<"You need to set a polygon before the basisfunctions can be computed"<<endl; 
    return; 
  }
 

  if (p->str() == "ReferenceLine")  { 
    Ns.insert(Ns.end(), x*(1-x)); 
  } else if (p->str() == "ReferenceTriangle" || p->str() == "Triangle" ) { 

    GiNaC::ex b = barycenter_triangle(p->vertex(0), p->vertex(1), p->vertex(2));   
    GiNaC::ex N = GiNaC::numeric(1); 
    for (int d=0; d< b.nops(); d++) { 
      N = N*b.op(d).rhs();  
    }
    cout <<"N "<<N<<endl; 
    Ns.insert(Ns.end(), N); 

  } else if (p->str() == "ReferenceTetrahedron" || p->str() == "Tetrahedron" ) { 
    GiNaC::ex b = barycenter_tetrahedron(p->vertex(0), p->vertex(1), 
		                       p->vertex(2), p->vertex(3));   
    GiNaC::ex N = GiNaC::numeric(1); 
    for (int d=0; d< b.nops(); d++) { 
      N = N*b.op(d).rhs();  
    }
    cout <<"N "<<N<<endl; 
    Ns.insert(Ns.end(), N); 
  }


  // create and insert dof
  GiNaC::lst midpoint = GiNaC::lst(); 
    for (int d=0; d< p->vertex(1).nops(); d++) { 	   
      midpoint.append(GiNaC::numeric(0)); 
    }
  for (int i=1; i<= p->no_vertices(); i++) {   
    for (int d=0; d< p->vertex(i-1).nops(); d++) { 	   
      midpoint.let_op(d)  += p->vertex(i-1).op(d);
    }
  }

  for (int d=0; d< p->vertex(1).nops(); d++) { 	   
    midpoint.let_op(d)  = midpoint.op(d)/p->no_vertices(); 
  }

  dofs.insert(dofs.end(), midpoint); 
}
