#ifndef CROUZEIXRAVIART_IS_INCLUDED
#define CROUZEIXRAVIART_IS_INCLUDED


#include "FE.h"


class CrouzeixRaviart : public StandardFE {
  public: 
  CrouzeixRaviart(); 
  virtual ~CrouzeixRaviart() {}

  void set(int order); 
  void set(Polygon& p);  
  void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 

class VectorCrouzeixRaviart : public StandardFE {
  protected: 
  int size; 
  public: 
  VectorCrouzeixRaviart(); 
  virtual ~VectorCrouzeixRaviart() {}

  virtual void set(int order); 
  virtual void set(Polygon& p);  
  virtual void set_size(int size_);  
  virtual void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 



#endif 
