#include "Dof.h"

void Dof::clear() {
  counter = -1; 
  loc2dof.clear(); 
  dof2index.clear(); 
  index2dof.clear(); 
  dof2loc.clear(); 
}

int Dof:: size() {
  return counter; 
}

int Dof:: insert_dof(int e, int i, GiNaC::ex Li){
  // first we update loc2dof, which always should be updated  
  pair<int,int> index; 
  index.first = e; 
  index.second = i; 
  loc2dof[index] = Li; 

  // check if the dof is new, if so
  // update counter, dof2index and create
  // a new vector in dof2loc  
  if (dof2index.find(Li) == dof2index.end() ) { 
    counter++; 
    dof2index[Li] = counter; 
    index2dof[counter] = Li; 
    vector<pair<int,int> > v; 
    dof2loc[Li] = v;  
  }
  
  // insert (e,i) in dof2loc[Li]  
  dof2loc[Li].insert(dof2loc[Li].end(), index); 
}

int Dof:: glob_dof(int e, int i) { 
  pair<int,int> index; 
  index.first = e; 
  index.second = i; 
  GiNaC::ex Li = loc2dof[index]; 
  return dof2index[Li]; 
}
int Dof:: glob_dof(GiNaC::ex Lj) {
  return dof2index[Lj]; 
}

GiNaC::ex Dof:: glob_dof(int j) {
  return index2dof[j];
}

vector<pair<int, int> > Dof:: glob2loc(int j){ 
  GiNaC::ex Lj = index2dof[j]; 
  return dof2loc[Lj]; 
}


//vector<pair<int, int> > glob2loc(GiNaC::ex global_dof); 





