#ifndef LAGRANGEFE_IS_INCLUDED
#define LAGRANGEFE_IS_INCLUDED 

#include "FE.h"

class LagrangeFE : public StandardFE {
  public: 
  LagrangeFE() {}
  virtual ~LagrangeFE() {}

  virtual void set(int order); 
  virtual void set(Polygon& p);  
  virtual void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 


// FIXME: would like to have this element also 
// in vector version since this it will give
// nice code in the element matrix e.g.: 
//       div(vfe.N(j))*pfe.N(i)

class VectorLagrangeFE : public StandardFE {
  protected: 
  int size; 
  public: 
  VectorLagrangeFE() {}
  ~VectorLagrangeFE() {}

  virtual void set(int order); 
  virtual void set(Polygon& p);  
  virtual void set_size(int size_);  
  virtual void compute_basis_functions();  
  virtual int nbf(); 
  virtual GiNaC::ex N(int i);  
  virtual GiNaC::ex dof(int i); 
}; 

#endif
