#include "P0.h"

void P0:: compute_basis_functions() {

  if ( p == NULL ) {
    cout <<"You need to set a polygon before the basisfunctions can be computed"<<endl; 
    return; 
  }
 
  // insert basis function
  Ns.insert(Ns.end(), GiNaC::numeric(1)); 

  // create and insert dof
  GiNaC::lst midpoint = GiNaC::lst(); 
    for (int d=0; d< p->vertex(1).nops(); d++) { 	   
      midpoint.append(GiNaC::numeric(0)); 
    }
  for (int i=1; i<= p->no_vertices(); i++) {   
    for (int d=0; d< p->vertex(i-1).nops(); d++) { 	   
      midpoint.let_op(d)  += p->vertex(i-1).op(d);
    }
  }

  for (int d=0; d< p->vertex(1).nops(); d++) { 	   
    midpoint.let_op(d)  = midpoint.op(d)/p->no_vertices(); 
  }

  dofs.insert(dofs.end(), midpoint); 
}
