#include "Polygon.h"


int Polygon::  no_vertices() {
  return p.size(); 
}

GiNaC::ex Polygon::vertex (int i) {
  return p[i];  
}

string Polygon:: str() {
  //NOTE could add all points here. 
  return "Polygon"; 
}


//---        Line ------------------------------------

Line:: Line(GiNaC::ex x0, GiNaC::ex x1, string subscript_){ 
   subscript = subscript_; 

  /* Lines on the form 
   * x = x_0 + a_1 t
   * y = y_0 + a_2 t
   * z = z_0 + a_3 t
  */




  //FIXME does not need to be a list in 1D. 
  if ( true /* (is_a<lst>(x0) && is_a<lst>(x1)) && (x0.nops() == x1.nops())*/ ) { 

    GiNaC::lst aa; 
    GiNaC::lst bb; 


    // compute aa and bb 
    for (int i=0; i<= x0.nops()-1; i++) {
      bb.append(x0.op(i)); 
      aa.append(x1.op(i) - x0.op(i)); 
    }


    //update internal structure
    p.insert(p.end(), x0); ; 
    p.insert(p.end(), x1); ; 
    a_ = aa; 
    b_ = bb; 

  } else {
    // FIXME: not decided on proper error handling yet. 
    // Could build upon GiNaC
    cout <<"THIS SHOULD NOT HAPPEN "<<endl; 
  }
}

int Line:: no_vertices() { return 2;  }

GiNaC::ex Line:: vertex(int i) {
  return p[i];  
}


 
GiNaC::ex Line:: repr(GiNaC::ex t, Repr_format format) {
  /* NOTE: use the same symbols in this 
   * description as in the actual symbols 
   * below and in the documentation. 
   *
   * Lines on the form 
   * x = x_0 + a_1 t,   
   * y = y_0 + a_2 t,
   * z = z_0 + a_3 t. 
   * for t in [0,1]
  */

  GiNaC::lst r; 
  // 2D

  if ( format == SUBS_PERFORMED ) { 
    if ( a_.nops() == 2) { 
      r = GiNaC::lst(  x == b_.op(0) +  a_.op(0)*t, 
                y == b_.op(1) +  a_.op(1)*t);   
    // 3D
    } else if ( a_.nops() == 3) {
      r = GiNaC::lst(  x == b_.op(0) +  a_.op(0)*t, 
                y == b_.op(1) +  a_.op(1)*t,   
                z == b_.op(2) +  a_.op(2)*t);   
    }
    r.append(GiNaC::lst(t,0,1));
  }
  else if ( format == SUBS_NOT_PERFORMED ) { 

    // NOTE: decide how the constant should be !!
    GiNaC::symbol a1("A"+subscript); 
    GiNaC::symbol a2("C"+subscript); 
    GiNaC::symbol a3("E"+subscript); 
    GiNaC::symbol b1("B"+subscript); 
    GiNaC::symbol b2("D"+subscript); 
    GiNaC::symbol b3("F"+subscript); 
  
  
    // 3D
    if ( a_.nops() == 2) { 
      r = GiNaC::lst(  x == b1 +  a1*t, 
                y == b2 +  a2*t);   
  
      r.append( a1 == a_.op(0));   
      r.append( b1 == b_.op(0));
      r.append( a2 == a_.op(1)); 
      r.append( b2 == b_.op(1)); 
    // 3D
    } else if ( a_.nops() == 3) {
      r = GiNaC::lst(  x == b1 +  a1*t, 
                y == b2 +  a2*t,   
                z == b3 +  a3*t);   
  
  
      r.append( a1 == a_.op(0));   
      r.append( b1 == b_.op(0));
      r.append( a2 == a_.op(1)); 
      r.append( b2 == b_.op(1)); 
      r.append( a3 == a_.op(2)); 
      r.append( b3 == b_.op(2)); 
  
  
    }
  
    r.append(GiNaC::lst(t,0,1));
  }

  return r; 
}

GiNaC::ex Line:: integrate(GiNaC::ex f, Repr_format format) {
  if ( format == SUBS_PERFORMED) {  
    GiNaC::symbol t("t"); 
    GiNaC::ex t_repr = repr(t); 
    GiNaC::lst sub; 
    int counter; 
    // perform substitution 
    if ( p[0].nops() == 3) {
      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
      counter = 3;  
    } else if ( p[0].nops() == 2) { 
      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1));  
      counter = 2;  
    }
  
  
    // compute D
    GiNaC::ex D; 
    if ( p[0].nops() == 3) {
      D = pow(t_repr.op(0).rhs().coeff(t), 2) +  
          pow(t_repr.op(1).rhs().coeff(t), 2) +   
          pow(t_repr.op(2).rhs().coeff(t), 2);  
    } else if ( p[0].nops() == 2) { 
      D = pow(t_repr.op(0).rhs().coeff(t), 2) +  
          pow(t_repr.op(1).rhs().coeff(t), 2);  
    }
  
    D = sqrt(D); 
  
    GiNaC::ex intf = f.subs(sub)*D; 
  
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 
  
    return intf; 
  } else if ( format == SUBS_NOT_PERFORMED ) { 
    GiNaC::symbol t("t"); 
    GiNaC::ex t_repr = repr(t); 
    GiNaC::lst sub; 
    GiNaC::symbol a("a"), b("b"), c("c"), D("D"); 
    int counter; 
    // perform substitution 
    
    if ( p[0].nops() == 3) {x ==  p[0].op(0) + a*t, 
//      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
      sub = GiNaC::lst( x ==  p[0].op(0) + a*t, 
                        y ==  p[0].op(1) + b*t, 
                        z ==  p[0].op(2) + c*t); 
      counter = 3;  
    } else if ( p[0].nops() == 2) { 
//      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1));  
      sub = GiNaC::lst( x ==  p[0].op(0) + a*t, 
                        y ==  p[0].op(1) + b*t); 
      counter = 2;  
    }
  
  
    // compute D
    GiNaC::ex DD; 
    if ( p[0].nops() == 3) {
      DD = pow(t_repr.op(0).rhs().coeff(t), 2) +  
          pow(t_repr.op(1).rhs().coeff(t), 2) +   
          pow(t_repr.op(2).rhs().coeff(t), 2);  
    } else if ( p[0].nops() == 2) { 
      DD = pow(t_repr.op(0).rhs().coeff(t), 2) +  
          pow(t_repr.op(1).rhs().coeff(t), 2);  
    }
  
    DD = sqrt(DD); 
  
    GiNaC::ex intf = f.subs(sub); 
  
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 


    intf = intf*D; 
  
    return intf; 
  }
  return DUMMY; 
}

string Line:: str(){
   std::ostringstream s; 
//   s <<"Line("<<p[0]<<","<<p[1]<<")"; 
   s <<"Line";
   return s.str(); 
}


//---        ReferenceLine --------------------------------

ReferenceLine:: ReferenceLine(string subscript_) {
  subscript = subscript_; 
  GiNaC::ex x0 = GiNaC::lst(0,0,0); 
  GiNaC::ex x1 = GiNaC::lst(1,0,0); 
  p.insert(p.end(),x0); 
  p.insert(p.end(),x1); 


}

int ReferenceLine:: no_vertices() { return 2; }

GiNaC::ex ReferenceLine:: vertex(int i) {
  return p[i]; 
}

GiNaC::ex ReferenceLine:: a() {
  return GiNaC::lst(1,0,0);  
}

GiNaC::ex ReferenceLine:: b() {
  return GiNaC::lst(0,0,0); 
}

GiNaC::ex ReferenceLine:: repr(GiNaC::ex t, Repr_format format) {
  GiNaC::lst r; 
  r = GiNaC::lst( x == t, y == 0, z == 0, t, 0, 1);  
  return r; 
}

string ReferenceLine:: str() {
   std::ostringstream s; 
//   s <<"ReferenceLine("<<p[0]<<","<<p[1]<<")"<<endl; 
   s <<"ReferenceLine"; // <<endl; 
   return s.str(); 
}

GiNaC::ex ReferenceLine:: integrate(GiNaC::ex f, Repr_format formt) {
  GiNaC::ex intf = GiNaC::integral(x,0,1,f);   
  intf =  eval_integ(intf); 
  return intf;  
}


//---        Triangle ------------------------------------

Triangle:: Triangle(GiNaC::ex x0, GiNaC::ex x1, GiNaC::ex x2, string subscript_) { 
  subscript = subscript_; 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 

}

int Triangle:: no_vertices() { return 3; }

GiNaC::ex Triangle:: vertex(int i) {
  return p[i]; 
}

/*
GiNaC::ex Triangle:: plane() {
  GiNaC::lst ret; 

  if ( p[1].nops() == 3 ) {
   
    GiNaC::lst x1x0; // = GiNaC::ex_to<lst>(p[1] - p[0]); 
    GiNaC::lst x2x0; // = GiNaC::ex_to<lst>(p[2] - p[0]); 
    for (int i=0; i<= p[0].nops()-1; i++) {
      x1x0.append(p[1].op(i)-p[0].op(i));  
      x2x0.append(p[2].op(i)-p[0].op(i));  
    }
   
    GiNaC::lst normal = cross(x1x0, x2x0); 
   
    cout <<endl; 
  
    symbol A("A"); symbol B("B"); symbol C("C"); 
    ret.append(normal.op(0)*(x- p[0].op(0)));
    ret.append(normal.op(1)*(y- p[0].op(1)));
    ret.append(normal.op(2)*(z- p[0].op(2)));
  } else {
    ret.append(z == 0 ); 
  }
 return ret; 
}
*/

Line Triangle:: line(int i) {
//  Line l = Line(p[(i-1)%3], p[i%3]); 
//  return l; 
  if      ( i == 1) return Line(p[0],p[1], istr(subscript,i));  
  else if ( i == 2) return Line(p[0],p[2], istr(subscript,i));  
  else if ( i == 3) return Line(p[1],p[2], istr(subscript,i));  
}

GiNaC::ex Triangle:: repr(Repr_format format) {
   GiNaC::symbol r("r"), s("s"); 
   GiNaC::symbol G("G"), H("H"); 
   GiNaC::ex l1_repr = line(1).repr(r); 
   GiNaC::ex l2_repr = line(2).repr(s); 
   GiNaC::lst ret; 
   //2D 
   if ( p[0].nops() == 2) {
     ret = GiNaC::lst( x == l1_repr.op(0).rhs().coeff(r,0) 
		         +  l1_repr.op(0).rhs().coeff(r,1)*r 
			 +  l2_repr.op(0).rhs().coeff(s,1)*s,  
                       y == l1_repr.op(1).rhs().coeff(r,0) 
		         +  l1_repr.op(1).rhs().coeff(r,1)*r 
			 +  l2_repr.op(1).rhs().coeff(s,1)*s);   


   }
   else if ( p[0].nops() == 3) {

     ret = GiNaC::lst( x == l1_repr.op(0).rhs().coeff(r,0) 
		          + l1_repr.op(0).rhs().coeff(r,1)*r 
			  + l2_repr.op(0).rhs().coeff(s,1)*s,  
                       y == l1_repr.op(1).rhs().coeff(r,0) 
		          + l1_repr.op(1).rhs().coeff(r,1)*r 
			  + l2_repr.op(1).rhs().coeff(s,1)*s,   
                       z == l1_repr.op(2).rhs().coeff(r,0) 
		          + l1_repr.op(2).rhs().coeff(r,1)*r 
			  + l2_repr.op(2).rhs().coeff(s,1)*s);   

   }

   ret.append(GiNaC::lst(r, 0, 1)); 
   ret.append(GiNaC::lst(s, 0, 1 - r)); 

   return ret; 

}


string Triangle:: str() {
   std::ostringstream s; 
//   s <<"Triangle("<<p[0]<<","<<p[1]<<","<<p[2]<<")"<<endl; 
   s <<"Triangle"; 
   return s.str(); 
}

GiNaC::ex Triangle:: integrate(GiNaC::ex func, Repr_format format) {

  if ( format == SUBS_PERFORMED ) {
    GiNaC::ex t_repr = repr(); 
    GiNaC::lst sub; 
    int counter; 
  
  
    // perform substitution
    if ( p[0].nops() == 3) {
      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
      counter = 3;  
    } else if ( p[0].nops() == 2) { 
      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1));  
      counter = 2;  
    }
    GiNaC::ex intf = func.subs(sub); 
  
    // compute D
    GiNaC::ex D; 
    if ( p[0].nops() == 3) {
      GiNaC::ex r = t_repr.op(3).op(0); 
      GiNaC::ex s = t_repr.op(4).op(0); 
      GiNaC::ex a = t_repr.op(0).rhs().coeff(r,1); 
      GiNaC::ex b = t_repr.op(0).rhs().coeff(s,1); 
      GiNaC::ex c = t_repr.op(1).rhs().coeff(r,1); 
      GiNaC::ex d = t_repr.op(1).rhs().coeff(s,1); 
      GiNaC::ex e = t_repr.op(2).rhs().coeff(r,1); 
      GiNaC::ex f = t_repr.op(2).rhs().coeff(s,1); 
      D = pow(c*f-d*e,2) + pow(a*f - b*e,2) + pow(a*d - b*c,2);   
      D = sqrt(D); 
    } else if ( p[0].nops() == 2) { 
      GiNaC::ex r = t_repr.op(2).op(0); 
      GiNaC::ex s = t_repr.op(3).op(0); 
      GiNaC::ex a = t_repr.op(0).rhs().coeff(r,1); 
      GiNaC::ex b = t_repr.op(0).rhs().coeff(s,1); 
      GiNaC::ex c = t_repr.op(1).rhs().coeff(r,1); 
      GiNaC::ex d = t_repr.op(1).rhs().coeff(s,1); 
      D = abs(a*d-b*c); 
    }
  
    intf = intf*D; 
  
  
    counter++; 
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 
  
    counter--; 
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 
    return intf; 
  } else if ( format == SUBS_NOT_PERFORMED ) {
    GiNaC::ex t_repr = repr(); 
    GiNaC::lst sub; 
    int counter; 
  
    GiNaC::symbol a("a"), b("b"), c("c"), d("d"), e("e"), f("f"), r("r"), s("s"), D("D");
  
    // perform substitution
    if ( p[0].nops() == 3) {
      sub = GiNaC::lst(x == p[0].op(0) + a*r + b*s,   
                       y == p[0].op(1) + c*r + d*s, 
                       z == p[0].op(2) + e*r + f*s);  
      counter = 3;  
    } else if ( p[0].nops() == 2) { 
      sub = GiNaC::lst(t_repr.op(0), t_repr.op(1));  
      sub = GiNaC::lst(x == p[0].op(0) + a*r + b*s,   
                       y == p[0].op(1) + c*r + d*s); 
      counter = 2;  
    }

    GiNaC::ex intf = func.subs(sub); 
  
    counter++; 
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 
  
    counter--; 
    intf = GiNaC::integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 

    intf = intf*D; 
    return intf; 

  }
  return DUMMY; 
  
}



//---        ReferenceTriangle ----------------------------


ReferenceTriangle:: ReferenceTriangle(string subscript_) { 
  subscript = subscript_; 
  GiNaC::ex x0 = GiNaC::lst(0,0,0); 
  GiNaC::ex x1 = GiNaC::lst(1,0,0); 
  GiNaC::ex x2 = GiNaC::lst(0,1,0); 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
}

int ReferenceTriangle:: no_vertices() { return 3; }

GiNaC::ex ReferenceTriangle:: vertex (int i) {
  return Triangle::vertex(i); 
}

//GiNaC::ex ReferenceTriangle:: plane() {
//  return Triangle:: plane(); 
//}

Line ReferenceTriangle:: line(int i) {
  return Triangle:: line(i); 
}

GiNaC::ex ReferenceTriangle:: repr(Repr_format format) {
  return Triangle:: repr(); 
}
  
string ReferenceTriangle:: str() {
   std::ostringstream s; 
//   s <<"ReferenceTriangle("<<p[0]<<","<<p[1]<<","<<p[2]<<")"; 
   s <<"ReferenceTriangle"; 
   return s.str(); 
}

GiNaC::ex ReferenceTriangle:: integrate(GiNaC::ex f) {
  GiNaC::ex ret = GiNaC::eval_integ(
		  GiNaC::integral(y,0,1, 
	          GiNaC::eval_integ(
		  GiNaC::integral(x,0,1-y,f))));   
  return ret;  
}

// ---------- Rectangle -------------------------------------- 

Rectangle:: Rectangle(GiNaC::ex p0, GiNaC::ex p1, string subscript_) { 
  subscript = subscript_; 

  GiNaC::ex x0; 
  GiNaC::ex x1; 
  GiNaC::ex x2; 
  GiNaC::ex x3; 

  if (p0.nops() == 2 && p1.nops() == 2) { 

    x0 = GiNaC::lst(p0.op(0), p0.op(1)); 
    x1 = GiNaC::lst(p1.op(0), p0.op(1)); 
    x2 = GiNaC::lst(p1.op(0), p1.op(1)); 
    x3 = GiNaC::lst(p0.op(0), p1.op(1)); 
  
  }
  else if (p0.nops() == 3 && p1.nops() == 3) { 
    if ( p0.op(0) == p1.op(0) ) { 

      x0 = GiNaC::lst(p0.op(0), p0.op(1), p0.op(2)); 
      x1 = GiNaC::lst(p0.op(0), p1.op(1), p0.op(2)); 
      x2 = GiNaC::lst(p0.op(0), p1.op(1), p1.op(2)); 
      x3 = GiNaC::lst(p0.op(0), p0.op(1), p1.op(2)); 
    
    } else if ( p0.op(1) == p1.op(1) ) { 

      x0 = GiNaC::lst(p0.op(0), p0.op(1), p0.op(2)); 
      x1 = GiNaC::lst(p1.op(0), p0.op(1), p0.op(2)); 
      x2 = GiNaC::lst(p1.op(0), p0.op(1), p1.op(2)); 
      x3 = GiNaC::lst(p0.op(0), p0.op(1), p1.op(2)); 
 
    } else if ( p0.op(2) == p1.op(2) ) {       

      x0 = GiNaC::lst(p0.op(0), p0.op(1), p0.op(2)); 
      x1 = GiNaC::lst(p1.op(0), p0.op(1), p0.op(2)); 
      x2 = GiNaC::lst(p1.op(0), p1.op(1), p0.op(2)); 
      x3 = GiNaC::lst(p0.op(0), p1.op(1), p0.op(2)); 

    }
  } else {
    throw(std::invalid_argument("The points p0 and p1 must be of dimention either 2 or 3."));
  }

  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 

}

int Rectangle:: no_vertices() { return 4; }

GiNaC::ex Rectangle:: vertex (int i) {
  return p[i]; 
}

Line Rectangle:: line(int i) {
  if      ( i == 1) return Line(p[0],p[1], istr(subscript,i));  
  else if ( i == 2) return Line(p[1],p[2], istr(subscript,i));  
  else if ( i == 3) return Line(p[2],p[3], istr(subscript,i));  
  else if ( i == 4) return Line(p[3],p[0], istr(subscript,i));  
}

GiNaC::ex Rectangle:: repr(Repr_format format) {
   GiNaC::lst ret;   
   GiNaC::symbol r("r"), s("s"), t("t"); 
   if ( p[0].nops() == 2) {
     ret.append( x == p[0].op(0) + r*( p[2].op(0) - p[0].op(0))); 
     ret.append( y == p[0].op(1) + s*( p[2].op(1) - p[0].op(1))); 
     ret.append( GiNaC::lst(r,0,1)); 
     ret.append( GiNaC::lst(s,0,1)); 
   } else if ( p[0].nops() == 3) {
     ret.append( x == p[0].op(0) + r*( p[2].op(0) - p[0].op(0))); 
     ret.append( y == p[0].op(1) + s*( p[2].op(1) - p[0].op(1))); 
     ret.append( z == p[0].op(1) + t*( p[2].op(2) - p[0].op(2))); 
     ret.append( GiNaC::lst(r,0,1)); 
     ret.append( GiNaC::lst(s,0,1)); 
     ret.append( GiNaC::lst(t,0,1)); 
   }
   return ret; 
}

string Rectangle :: str() {
  return "Rectangle"; 
}
 
GiNaC::ex Rectangle:: integrate(GiNaC::ex func) {

    int counter; 
    GiNaC::ex s_repr = repr(); 

    GiNaC::lst sub; 
    // perform substitution
    if ( p[0].nops() == 3) {
      sub = GiNaC::lst(s_repr.op(0), s_repr.op(1), s_repr.op(2));  
      counter = 3;  
    } else if ( p[0].nops() == 2) { 
      sub = GiNaC::lst(s_repr.op(0), s_repr.op(1));  
      counter = 2;  
    }

    GiNaC::ex D; 
    if (p[0].nops() == 2) { 
      D =  ( p[2].op(0) - p[0].op(0)) 
          *( p[2].op(1) - p[0].op(1)); 
    } else if (p[0].nops() == 3) { 

      if ( p[2].op(0) == p[0].op(0) ) {   
        D =  ( p[2].op(1) - p[0].op(1)) 
            *( p[2].op(2) - p[0].op(2)); 
      } 
      else if ( p[2].op(1) == p[0].op(1) ) {   
        D =  ( p[2].op(0) - p[0].op(0)) 
            *( p[2].op(2) - p[0].op(2)); 
      }
      else if ( p[2].op(2) == p[0].op(2) ) {   
        D =  ( p[2].op(0) - p[0].op(0)) 
            *( p[2].op(1) - p[0].op(1)); 
      }
    }

    GiNaC::ex intf = func.subs(sub); 
     
    intf = intf*D; 

    intf = GiNaC::integral(s_repr.op(counter).op(0), s_repr.op(counter).op(1), s_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 
  
    counter++; 
    intf = GiNaC::integral(s_repr.op(counter).op(0), s_repr.op(counter).op(1), s_repr.op(counter).op(2), intf);  
    intf = eval_integ(intf); 

    counter++; 
    if ( counter <  s_repr.nops() ) { 
      intf = GiNaC::integral(s_repr.op(counter).op(0), s_repr.op(counter).op(1), s_repr.op(counter).op(2), intf);  
      intf = eval_integ(intf); 
    }
   
    return intf; 


}






// ---------- ReferenceRectangle -------------------------------------- 

ReferenceRectangle:: ReferenceRectangle(string subscript_) { 
  subscript = subscript_; 
  GiNaC::ex x0 = GiNaC::lst(0,0,0); 
  GiNaC::ex x1 = GiNaC::lst(1,0,0); 
  GiNaC::ex x2 = GiNaC::lst(1,1,0); 
  GiNaC::ex x3 = GiNaC::lst(0,1,0); 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 
}

int ReferenceRectangle:: no_vertices() { return 4; }

GiNaC::ex ReferenceRectangle:: vertex (int i) {
  return p[i]; 
}

Line ReferenceRectangle:: line(int i) {
  return Rectangle::line(i); 
}

GiNaC::ex ReferenceRectangle:: repr(Repr_format format) {
  return Rectangle::repr(format); 
}

string ReferenceRectangle :: str() {
  return "ReferenceRectangle"; 
}
 
GiNaC::ex ReferenceRectangle:: integrate(GiNaC::ex func) {
  return Rectangle::integrate(func); 
}





//---        Tetrahedron ------------------------------------


Tetrahedron:: Tetrahedron(GiNaC::ex x0, GiNaC::ex x1, GiNaC::ex x2, GiNaC::ex x3, string subscript_) { 
  subscript = subscript_; 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 

}

int Tetrahedron:: no_vertices() {return 4; }

GiNaC::ex Tetrahedron:: vertex(int i) {
  return p[i]; 
}

Line Tetrahedron:: line(int i) {
  int i0, i1; 
  if ( i == 1 ) {
    i0 = 0; i1 = 1;  
  } else if ( i == 2 ) { 
    i0 = 0; i1 = 2;  
  } else if ( i == 3 )  { 
    i0 = 0; i1 = 3;  
  } else if ( i == 4 )  { 
    i0 = 1; i1 = 2;  
  } else if ( i == 5 )  { 
    i0 = 1; i1 = 3;  
  } else if ( i == 6 )  { 
    i0 = 2; i1 = 3;  
  }
  Line l = Line(p[i0], p[i1], istr(subscript,i)); 
  return l; 
}

Triangle Tetrahedron :: triangle(int i) {
  Triangle t = Triangle(p[i%4], p[(i+1)%4], p[(i+2)%4], istr(subscript,i)); 
  return t; 
}

string Tetrahedron:: str() {
   std::ostringstream s; 
//   s <<"Tetrahedron("<<p[0]<<","<<p[1]<<","<<p[2]<<","<<p[3]<<")"; 
   s <<"Tetrahedron";
   return s.str(); 
}


GiNaC::ex Tetrahedron:: repr(Repr_format format) {
   GiNaC::symbol r("r"), s("s"), t("t"); 
   GiNaC::ex l1_repr = line(1).repr(r); 
   GiNaC::ex l2_repr = line(2).repr(s); 
   GiNaC::ex l3_repr = line(3).repr(t); 
   GiNaC::lst ret; 


   ret = GiNaC::lst( 
       x == l1_repr.op(0).rhs().coeff(r,0)   + l1_repr.op(0).rhs().coeff(r,1)*r 
         +  l2_repr.op(0).rhs().coeff(s,1)*s + l3_repr.op(0).rhs().coeff(t,1)*t,  
       y == l1_repr.op(1).rhs().coeff(r,0)   + l1_repr.op(1).rhs().coeff(r,1)*r 
         +  l2_repr.op(1).rhs().coeff(s,1)*s + l3_repr.op(1).rhs().coeff(t,1)*t,  
       z == l1_repr.op(2).rhs().coeff(r,0)   + l1_repr.op(1).rhs().coeff(r,1)*r  
         +  l2_repr.op(2).rhs().coeff(s,1)*s + l3_repr.op(2).rhs().coeff(t,1)*t);   


   ret.append(GiNaC::lst(r, 0, 1)); 
   ret.append(GiNaC::lst(s, 0, 1 - r)); 
   ret.append(GiNaC::lst(t, 0, 1 - r - s)); 

   return ret; 
}

GiNaC::ex Tetrahedron:: integrate(GiNaC::ex func, Repr_format format) {
  if ( format == SUBS_PERFORMED ) {
    GiNaC::ex t_repr = repr(); 
  
    //perform substitution
    GiNaC::lst sub = GiNaC::lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
    GiNaC::ex intf = func.subs(sub); 
  
    // compute D 
    GiNaC::ex D; 
    GiNaC::ex r = t_repr.op(3).op(0); 
    GiNaC::ex s = t_repr.op(4).op(0); 
    GiNaC::ex t = t_repr.op(5).op(0); 
    GiNaC::ex a = t_repr.op(0).rhs().coeff(r,1); 
    GiNaC::ex b = t_repr.op(0).rhs().coeff(s,1); 
    GiNaC::ex c = t_repr.op(0).rhs().coeff(t,1); 
    GiNaC::ex d = t_repr.op(1).rhs().coeff(r,1); 
    GiNaC::ex e = t_repr.op(1).rhs().coeff(s,1); 
    GiNaC::ex f = t_repr.op(1).rhs().coeff(t,1); 
    GiNaC::ex g = t_repr.op(2).rhs().coeff(r,1); 
    GiNaC::ex h = t_repr.op(2).rhs().coeff(s,1); 
    GiNaC::ex k = t_repr.op(2).rhs().coeff(t,1); 
  
    D = a*(e*k-f*h) - b*(d*k-f*g) + c*(d*h - g*e); 
  
    intf = intf*D; 
  
    intf = GiNaC::integral(t_repr.op(5).op(0), t_repr.op(5).op(1), t_repr.op(5).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    intf = GiNaC::integral(t_repr.op(4).op(0), t_repr.op(4).op(1), t_repr.op(4).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    intf = GiNaC::integral(t_repr.op(3).op(0), t_repr.op(3).op(1), t_repr.op(3).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    return intf; 
  } else if ( format == SUBS_NOT_PERFORMED ) {
    GiNaC::ex t_repr = repr(); 
  
    GiNaC::symbol a("a"), b("b"), c("c"), d("d"), e("e"), f("f"), g("g"), h("h"), k("k"), D("D");
    GiNaC::ex r = t_repr.op(3).op(0); 
    GiNaC::ex s = t_repr.op(4).op(0); 
    GiNaC::ex t = t_repr.op(5).op(0); 

    //perform substitution
//    GiNaC::lst sub = GiNaC::lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
    GiNaC::ex sub = GiNaC::lst(x == p[0].op(0) + a*r + b*s + c*t,   
                     y == p[0].op(1) + d*r + e*s + f*t, 
                     z == p[0].op(2) + g*r + h*s + k*t);  

    GiNaC::ex intf = func.subs(sub); 

    intf = GiNaC::integral(t_repr.op(5).op(0), t_repr.op(5).op(1), t_repr.op(5).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    intf = GiNaC::integral(t_repr.op(4).op(0), t_repr.op(4).op(1), t_repr.op(4).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    intf = GiNaC::integral(t_repr.op(3).op(0), t_repr.op(3).op(1), t_repr.op(3).op(2), intf);  
    intf = GiNaC::eval_integ(intf); 
  
    intf = intf*D; 

    return intf; 

  }
  return DUMMY; 
}

//---        ReferenceTetrahedron ---------------------------

ReferenceTetrahedron:: ReferenceTetrahedron(string subscript_) : Tetrahedron(subscript_) {
  subscript = subscript_;  
  GiNaC::ex x0 = GiNaC::lst(0, 0, 0); 
  GiNaC::ex x1 = GiNaC::lst(1, 0, 0); 
  GiNaC::ex x2 = GiNaC::lst(0, 1, 0); 
  GiNaC::ex x3 = GiNaC::lst(0, 0, 1); 

  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 
}

int ReferenceTetrahedron:: no_vertices () {
   return 4; 
}

GiNaC::ex ReferenceTetrahedron:: vertex(int i) {
   return Tetrahedron:: vertex(i); 
}

Line ReferenceTetrahedron:: line(int i) {
   return Tetrahedron:: line(i); 
}

Triangle ReferenceTetrahedron :: triangle(int i) {
   return Tetrahedron:: triangle(i); 
}

string ReferenceTetrahedron:: str() {
   std::ostringstream s; 
//   s <<"ReferenceTetrahedron("<<p[0]<<","<<p[1]<<","<<p[2]<<","<<p[3]<<")"<<endl; 
   s <<"ReferenceTetrahedron"; 
   return s.str(); 
}

GiNaC::ex ReferenceTetrahedron:: integrate(GiNaC::ex f, Repr_format format) {
  
  GiNaC::ex intf = GiNaC::integral(x,0,1-y-z,f); 
  intf = GiNaC::eval_integ(intf); 

  intf = GiNaC::integral(y,0,1-z, intf); 
  intf = GiNaC::eval_integ(intf); 

  intf = GiNaC::integral(z,0,1, intf);  
  intf = GiNaC::eval_integ(intf); 

  return intf;  
}


//--  tools for Polygons ------------------------------------------------------ 

GiNaC::lst bezier_ordinates(Tetrahedron& tetrahedra, int d) {

  //FIXME: ugly conversion to matrix 

  GiNaC::lst ret; 
  GiNaC::ex V1 = tetrahedra.vertex(0); 
  GiNaC::ex V2 = tetrahedra.vertex(1); 
  GiNaC::ex V3 = tetrahedra.vertex(2); 
  GiNaC::ex V4 = tetrahedra.vertex(3); 

  GiNaC::lst V1l = GiNaC::ex_to<GiNaC::lst>(V1); 
  GiNaC::lst V2l = GiNaC::ex_to<GiNaC::lst>(V2); 
  GiNaC::lst V3l = GiNaC::ex_to<GiNaC::lst>(V3); 
  GiNaC::lst V4l = GiNaC::ex_to<GiNaC::lst>(V4); 


  GiNaC::ex V1m  = lst_to_matrix2(V1l); 
  GiNaC::ex V2m  = lst_to_matrix2(V2l); 
  GiNaC::ex V3m  = lst_to_matrix2(V3l); 
  GiNaC::ex V4m  = lst_to_matrix2(V4l); 

  int l; 
  for (int i=0; i<= d; i++) {
    for (int j=0; j<= d; j++) {
      for (int k=0; k<= d; k++) {
	if ( d - i - j -k  >= 0 ) { 
          l= d - i - j -k; 
          GiNaC::ex sum = (l*V1m + k*V2m + j*V3m + i*V4m)/d;  
          ret.append(matrix_to_lst2(sum.evalm())); 
	}
      }
    }
  }
  // FIXME how should these be sorted ?????  
//  ret = ret.sort(); 
  return ret; 
}



GiNaC::lst bezier_ordinates(Triangle& triangle, int d) {

  //FIXME: ugly conversion to matrix 

  GiNaC::lst ret; 
  GiNaC::ex V1 = triangle.vertex(0); 
  GiNaC::ex V2 = triangle.vertex(1); 
  GiNaC::ex V3 = triangle.vertex(2); 

  GiNaC::lst V1l = GiNaC::ex_to<GiNaC::lst>(V1); 
  GiNaC::lst V2l = GiNaC::ex_to<GiNaC::lst>(V2); 
  GiNaC::lst V3l = GiNaC::ex_to<GiNaC::lst>(V3); 

  GiNaC::ex V1m  = lst_to_matrix2(V1l); 
  GiNaC::ex V2m  = lst_to_matrix2(V2l); 
  GiNaC::ex V3m  = lst_to_matrix2(V3l); 


  int k; 
  for (int i=0; i <= d; i++) {
    for (int j=0; j <= d; j++) {
      if ( d - i - j >= 0  ) { 
        k = d - i - j; 
        GiNaC::ex sum = (k*V1m + j*V2m + i*V3m)/d;  
        ret.append(matrix_to_lst2(sum.evalm())); 
      }
    }
  }
  // FIXME how should these be sorted ?????  
  // ret = ret.sort(); 
  return ret; 
}

// FIXME barycenter_line, barycenter_triangle, barycenter_tetrahedron
// all needs to determine which equations to use in a proper way 

GiNaC::ex barycenter_line(GiNaC::ex p0, GiNaC::ex p1) {
 GiNaC::ex sol = DUMMY;  

 // 1D
 if ( p0.nops() == 1 && p1.nops() == 1 ) {
   GiNaC::symbol b0("b0"), b1("b1");
   GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0); 
   GiNaC::ex eq2 = 1 == b0 + b1; 
   sol = lsolve(GiNaC::lst(eq1, eq2), GiNaC::lst(b0, b1)); 
   if ( sol == 0 ) {
     GiNaC::ex eq1 = y == b0*p0.op(1) + b1*p1.op(1); 
     sol = lsolve(GiNaC::lst(eq1, eq2), GiNaC::lst(b0, b1)); 
   }
   if ( sol == 0 ) {
     GiNaC::ex eq1 = z == b0*p0.op(2) + b1*p1.op(2); 
     sol = lsolve(GiNaC::lst(eq1, eq2), GiNaC::lst(b0, b1)); 
   }
 }
 //2D 
 else if ( p0.nops() == 2 && p1.nops() == 2 ) {
   GiNaC::symbol b0("b0"), b1("b1");
   GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0); 
   GiNaC::ex eq3 = 1 == b0 + b1; 
   sol = lsolve(GiNaC::lst(eq1, eq3), GiNaC::lst(b0, b1)); 
   if (sol.nops() == 0) {  
     GiNaC::ex eq2 = y == b0*p0.op(1) + b1*p1.op(1); 
     sol = lsolve(GiNaC::lst(eq2, eq3), GiNaC::lst(b0, b1)); 
   }
 }
 //3D 
 else if ( p0.nops() == 3 && p1.nops() == 3 ) {
   GiNaC::symbol b0("b0"), b1("b1");
   GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0); 
   GiNaC::ex eq4 = 1 == b0 + b1; 
   sol = lsolve(GiNaC::lst(eq1, eq4), GiNaC::lst(b0, b1)); 
   if (sol.nops() == 0) {  
     GiNaC::ex eq2 = y == b0*p0.op(1) + b1*p1.op(1); 
     sol = lsolve(GiNaC::lst(eq2, eq4), GiNaC::lst(b0, b1)); 
   }
   if (sol.nops() == 0) {  
     GiNaC::ex eq3 = z == b0*p0.op(2) + b1*p1.op(2); 
     sol = lsolve(GiNaC::lst(eq3, eq4), GiNaC::lst(b0, b1)); 
   }
 } 
 else {
   cout <<"Could not compute the barycentric coordinates."<<endl; 
   cout <<"Check the coordinates."<<endl;
 }
 return sol; 
}



GiNaC::ex barycenter_triangle(GiNaC::ex p0, GiNaC::ex p1, GiNaC::ex p2) {
 GiNaC::ex sol; 
 sol = DUMMY; 

 // 2D 
 if ( p0.nops() == 2 && p1.nops() == 2 && p2.nops() == 2) {
   GiNaC::symbol b0("b0"), b1("b1"), b2("b2");
   GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0) + b2*p2.op(0); 
   GiNaC::ex eq2 = y == b0*p0.op(1) + b1*p1.op(1) + b2*p2.op(1); 
   GiNaC::ex eq3 = 1 == b0 + b1 + b2; 
  
   sol = lsolve(GiNaC::lst(eq1, eq2, eq3), GiNaC::lst(b0, b1, b2)); 
 } 
 // 3D 
 else if ( p0.nops() == 3 && p1.nops() == 3 && p2.nops() == 3) {
   GiNaC::symbol b0("b0"), b1("b1"), b2("b2");
   GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0) + b2*p2.op(0); 
   GiNaC::ex eq2 = y == b0*p0.op(1) + b1*p1.op(1) + b2*p2.op(1); 
   GiNaC::ex eq3 = z == b0*p0.op(2) + b1*p1.op(2) + b2*p2.op(2); 
   GiNaC::ex eq4 = 1 == b0 + b1 + b2; 
  
   sol = lsolve(GiNaC::lst(eq1, eq2, eq4), GiNaC::lst(b0, b1, b2)); 
   if ( sol.nops() == 0 ) {
     sol = lsolve(GiNaC::lst(eq1, eq3, eq4), GiNaC::lst(b0, b1, b2)); 
   }
   if ( sol.nops() == 0 ) {
     sol = lsolve(GiNaC::lst(eq2, eq3, eq4), GiNaC::lst(b0, b1, b2)); 
   }
 }
  
  

 return sol; 
}

GiNaC::ex barycenter_tetrahedron(GiNaC::ex p0, GiNaC::ex p1, GiNaC::ex p2, GiNaC::ex p3) {
 GiNaC::symbol b0("b0"), b1("b1"), b2("b2"), b3("b3");

 // 3D 
 GiNaC::ex eq1 = x == b0*p0.op(0) + b1*p1.op(0) + b2*p2.op(0) + b3*p3.op(0); 
 GiNaC::ex eq2 = y == b0*p0.op(1) + b1*p1.op(1) + b2*p2.op(1) + b3*p3.op(1); 
 GiNaC::ex eq3 = z == b0*p0.op(2) + b1*p1.op(2) + b2*p2.op(2) + b3*p3.op(2); 
 GiNaC::ex eq4 = 1 == b0 + b1 + b2 +b3; 

 GiNaC::ex sol = lsolve(GiNaC::lst(eq1, eq2, eq3, eq4), GiNaC::lst(b0, b1, b2, b3)); 

 return sol; 

}

GiNaC::ex bernstein(int order, Polygon& p, const string a) {

  if ( order < 0 ) {
    cout <<"Can not create polynomials of order less than 0!"<<endl; 
    return DUMMY; 
  }

  GiNaC::ex ret; // GiNaC::ex to return   
  int dof;       // degrees of freedom  
  GiNaC::ex A;   // GiNaC::ex holding the coefficients a_0 .. a_dof  
  GiNaC::lst basis; 

  if ( p.str() == "Line" || p.str() == "ReferenceLine" ) {
    GiNaC::ex bary = barycenter_line(p.vertex(0), p.vertex(1)); 
    GiNaC::ex b0= bary.op(0).rhs(); 
    GiNaC::ex b1= bary.op(1).rhs(); 
    dof = order+1; 
    A = GiNaC::symbolic_matrix(1,dof, a); 
    int o=0; 
    for (GiNaC::const_iterator i = A.begin(); i != A.end(); ++i)  {  
      ret += (*i)*GiNaC::binomial(order,o)*pow(b0,o)*pow(b1,order-o);  
      basis.append(pow(b0,o)*pow(b1,order-o));  
      o++; 
    }
  }
  else if ( p.str() == "Triangle" || p.str() == "ReferenceTriangle" )  {

    dof = (order+1)*(order+2)/2; 
    A = GiNaC::symbolic_matrix(1, dof , a); 

    GiNaC::ex bary = barycenter_triangle(p.vertex(0), p.vertex(1), p.vertex(2)); 
    GiNaC::ex b0= bary.op(0).rhs(); 
    GiNaC::ex b1= bary.op(1).rhs(); 
    GiNaC::ex b2= bary.op(2).rhs(); 

    size_t i=0; 
    for (int o1 = 0; o1 <= order; o1++) {
      for (int o2 = 0; o2 <= order; o2++) {
        for (int o3 = 0; o3 <= order; o3++) {
          if ( o1 + o2 + o3 == order ) { 
	    ret += A.op(i)*(GiNaC::factorial(order)/(GiNaC::factorial(o1)*GiNaC::factorial(o2)*GiNaC::factorial(o3)))
		   *pow(b0,o1)*pow(b1,o2)*pow(b2,o3);  

            basis.append(pow(b0,o1)*pow(b1,o2)*pow(b2,o3));  
	    i++; 
	  }
	}
      }
    }
  }
  else if (p.str() == "Tetrahedron" || p.str() == "ReferenceTetrahedron") {


    dof = 0; 
    for (int j=0; j<= order; j++) { 
      dof += (j+1)*(j+2)/2; 
    }
    A = GiNaC::symbolic_matrix(1, dof , a); 


    GiNaC::ex bary = barycenter_tetrahedron(p.vertex(0), p.vertex(1), p.vertex(2), p.vertex(3)); 
    GiNaC::ex b0= bary.op(0).rhs(); 
    GiNaC::ex b1= bary.op(1).rhs(); 
    GiNaC::ex b2= bary.op(2).rhs(); 
    GiNaC::ex b3= bary.op(3).rhs(); 


    size_t i=0; 
    for (int o1 = 0; o1 <= order; o1++) {
      for (int o2 = 0; o2 <= order; o2++) {
        for (int o3 = 0; o3 <= order; o3++) {
          for (int o4 = 0; o4 <= order; o4++) {
            if ( o1 + o2 + o3 + o4 == order ) { 
  	      ret += A.op(i)*(GiNaC::factorial(order)/(GiNaC::factorial(o1)*GiNaC::factorial(o2)*GiNaC::factorial(o3)*GiNaC::factorial(o4)))
		   *pow(b0,o1)*pow(b1,o2)*pow(b2,o3)*pow(b3,o4);  
              basis.append(pow(b0,o1)*pow(b1,o2)*pow(b2,o3)*pow(b3,o4));
	      i++; 
	    }
	  }
	}
      }
    }
  }
  return GiNaC::lst(ret,matrix_to_lst2(A),basis); 
}

GiNaC::lst bernsteinv(int no_fields, int order, Polygon& p, const string a) {

  if ( order < 0 ) {
    cout <<"Can not create polynomials of order less than 0!"<<endl; 
    return GiNaC::lst(DUMMY); 
  }

  GiNaC::lst ret1;  // contains the polynom  
  GiNaC::lst ret2;  // contains the coefficients   
  GiNaC::lst ret3;  // constains the basis functions  
  GiNaC::lst basis_tmp; 
  for (int i=1; i<= no_fields; i++) { 
    GiNaC::lst basis; 
    std::ostringstream s; 
    s <<a<<""<<i<<"_"; 
    GiNaC::ex pol = bernstein(order, p, s.str()); 
    ret1.append(pol.op(0)); 
    ret2.append(pol.op(1)); 
    basis_tmp = GiNaC::ex_to<GiNaC::lst>(pol.op(2)); 
    for (GiNaC::lst::const_iterator basis_iterator = basis_tmp.begin(); 
	 basis_iterator != basis_tmp.end(); ++basis_iterator) {
      GiNaC::lst tmp_lst; 
      for (int d=1; d<=no_fields; d++) tmp_lst.append(0);   
      tmp_lst.let_op(i-1) = (*basis_iterator);  
      ret3.append(tmp_lst); 
    }
  }
  return GiNaC::lst(ret1,ret2,ret3); 

}

GiNaC::lst normal(Tetrahedron& tetrahedron, int i){
  Triangle triangle = tetrahedron.triangle(i); 

  GiNaC::symbol t("t"); 
  GiNaC::ex line1_repr = triangle.line(1).repr(t); 
  GiNaC::ex n11 = line1_repr.op(0).rhs().coeff(t,1); 
  GiNaC::ex n12 = line1_repr.op(1).rhs().coeff(t,1); 
  GiNaC::ex n13 = line1_repr.op(2).rhs().coeff(t,1); 

  GiNaC::ex line2_repr = triangle.line(2).repr(t); 
  GiNaC::ex n21 = line2_repr.op(0).rhs().coeff(t,1); 
  GiNaC::ex n22 = line2_repr.op(1).rhs().coeff(t,1); 
  GiNaC::ex n23 = line2_repr.op(2).rhs().coeff(t,1); 

  GiNaC::lst n1 = GiNaC::lst(n11,n12,n13); 
  GiNaC::lst n2 = GiNaC::lst(n21,n22,n23); 
  GiNaC::lst n3 = cross(n1,n2);  

  GiNaC::ex norm = sqrt(pow(n3.op(0),2) 
		      + pow(n3.op(1),2) 
		      + pow(n3.op(2),2));

  n3.let_op(0) = n3.op(0)/norm;
  n3.let_op(1) = n3.op(1)/norm;
  n3.let_op(2) = n3.op(2)/norm;

  return n3; 
}


GiNaC::lst normal(Triangle& triangle, int i){
  Line line = triangle.line(i); 
  //FIXME: 5 lines to compute the normal vector, these should
  // be put somewhere else.   
  GiNaC::symbol t("t"); 
  GiNaC::ex line_repr = line.repr(t); 
  GiNaC::ex n1 = line_repr.op(0).rhs().coeff(t,1); 
  GiNaC::ex n2 = line_repr.op(1).rhs().coeff(t,1); 
  GiNaC::ex norm = sqrt(pow(n1,2) + pow(n2,2));
  GiNaC::lst normal = GiNaC::lst(n2/norm,-n1/norm);  
return normal; 
}

GiNaC::lst tangent(Triangle& triangle, int i){
  Line line = triangle.line(i); 
  //FIXME: 5 lines to compute the tangent vector, these should
  // be put somewhere else.   
  GiNaC::symbol t("t"); 
  GiNaC::ex line_repr = line.repr(t); 
  GiNaC::ex t1 = line_repr.op(0).rhs().coeff(t,1); 
  GiNaC::ex t2 = line_repr.op(1).rhs().coeff(t,1); 
  GiNaC::ex norm = sqrt(pow(t1,2) + pow(t2,2));
  GiNaC::lst tangent = GiNaC::lst(t1/norm,t2/norm);  
return tangent; 
}


// ---------- Box -------------------------------------- 

Box:: Box(GiNaC::ex p0, GiNaC::ex p1, string subscript_) { 
  subscript = subscript_; 
  GiNaC::ex x0 = GiNaC::lst(p0.op(0),p0.op(1),p0.op(2)); 
  GiNaC::ex x1 = GiNaC::lst(p1.op(0),p0.op(1),p0.op(2)); 
  GiNaC::ex x2 = GiNaC::lst(p1.op(0),p1.op(1),p0.op(2)); 
  GiNaC::ex x3 = GiNaC::lst(p0.op(0),p1.op(1),p0.op(2)); 

  GiNaC::ex x4 = GiNaC::lst(p0.op(0),p0.op(1),p1.op(2)); 
  GiNaC::ex x5 = GiNaC::lst(p1.op(0),p0.op(1),p1.op(2)); 
  GiNaC::ex x6 = GiNaC::lst(p1.op(0),p1.op(1),p1.op(2)); 
  GiNaC::ex x7 = GiNaC::lst(p0.op(0),p1.op(1),p1.op(2)); 

  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 

  p.insert(p.end(), x4); 
  p.insert(p.end(), x5); 
  p.insert(p.end(), x6); 
  p.insert(p.end(), x7); 

}

int Box:: no_vertices() { return 8; }

GiNaC::ex Box:: vertex (int i) {
  return p[i]; 
}

Line Box:: line(int i) {
  if      ( i == 1) return Line(p[0],p[1], istr(subscript,i));  
  else if ( i == 2) return Line(p[1],p[2], istr(subscript,i));  
  else if ( i == 3) return Line(p[2],p[3], istr(subscript,i));  
  else if ( i == 4) return Line(p[3],p[0], istr(subscript,i));  

  else if ( i == 5) return Line(p[4],p[5], istr(subscript,i));  
  else if ( i == 6) return Line(p[5],p[6], istr(subscript,i));  
  else if ( i == 7) return Line(p[6],p[7], istr(subscript,i));  
  else if ( i == 8) return Line(p[7],p[4], istr(subscript,i));  

  else if ( i == 9)  return Line(p[0],p[4], istr(subscript,i));  
  else if ( i == 10) return Line(p[1],p[5], istr(subscript,i));  
  else if ( i == 11) return Line(p[2],p[6], istr(subscript,i));  
  else if ( i == 12) return Line(p[3],p[7], istr(subscript,i));  
}

GiNaC::ex Box:: repr(Repr_format format) {
   GiNaC::lst ret;   
   GiNaC::symbol r("r"), s("s"), t("t"); 
   ret.append( x == p[0].op(0) + r*( p[6].op(0) - p[0].op(0))); 
   ret.append( y == p[0].op(1) + s*( p[6].op(1) - p[0].op(1))); 
   ret.append( z == p[0].op(1) + t*( p[6].op(2) - p[0].op(2))); 
   ret.append( GiNaC::lst(r,0,1)); 
   ret.append( GiNaC::lst(s,0,1)); 
   ret.append( GiNaC::lst(t,0,1)); 
   return ret; 
}

string Box :: str() {
  return "Box"; 
}
 
GiNaC::ex Box:: integrate(GiNaC::ex func) {

    GiNaC::ex b_repr = repr(); 

    GiNaC::lst sub; 
    sub = GiNaC::lst(b_repr.op(0), b_repr.op(1), b_repr.op(2));  
    GiNaC::ex intf = func.subs(sub); 

    GiNaC::ex D =  ( p[6].op(0) - p[0].op(0))
	          *( p[6].op(1) - p[0].op(1)) 
                  *( p[6].op(2) - p[0].op(2)); 
     

    

    
    intf = intf*D; 

    intf = GiNaC::integral(b_repr.op(3).op(0), b_repr.op(3).op(1), b_repr.op(3).op(2), intf);  
    intf = eval_integ(intf); 
  
    intf = GiNaC::integral(b_repr.op(4).op(0), b_repr.op(4).op(1), b_repr.op(4).op(2), intf);  
    intf = eval_integ(intf); 

    intf = GiNaC::integral(b_repr.op(5).op(0), b_repr.op(5).op(1), b_repr.op(5).op(2), intf);  
    intf = eval_integ(intf); 
   
    return intf; 


}

// ---------- ReferenceBox -------------------------------------- 

ReferenceBox:: ReferenceBox(string subscript_) { 
  subscript = subscript_; 
  GiNaC::ex x0 = GiNaC::lst(0,0,0); 
  GiNaC::ex x1 = GiNaC::lst(1,0,0); 
  GiNaC::ex x2 = GiNaC::lst(1,1,0); 
  GiNaC::ex x3 = GiNaC::lst(0,1,0); 

  GiNaC::ex x4 = GiNaC::lst(0,0,1); 
  GiNaC::ex x5 = GiNaC::lst(1,0,1); 
  GiNaC::ex x6 = GiNaC::lst(1,1,1); 
  GiNaC::ex x7 = GiNaC::lst(0,1,1); 

  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 

  p.insert(p.end(), x4); 
  p.insert(p.end(), x5); 
  p.insert(p.end(), x6); 
  p.insert(p.end(), x7); 

}

int ReferenceBox:: no_vertices() { return 8; }

GiNaC::ex ReferenceBox:: vertex (int i) {
  return Box::vertex(i); 
}

Line ReferenceBox:: line(int i) {
  return Box::line(i); 
}

GiNaC::ex ReferenceBox:: repr(Repr_format format) {
  return Box::repr(format); 
}

string ReferenceBox :: str() {
  return "ReferenceBox"; 
}
 
GiNaC::ex ReferenceBox:: integrate(GiNaC::ex func) {
  return Box::integrate(func); 
}




