#include "FE.h"


// could have several versions of this example 
// 1. Std example using the reference element
// 2. Example using globale element
// 3. Simple code generation, just printing out a element matrix
// 4. Code generation towards a backend FFC
// 5. With Diffpack
// 6. With ML 



void poisson() {
  std::map<std::pair<int,int>,double> A;
  std::map<int, double> b; 
  std::pair<int,int> index;

  LagrangeFE fe;
  Dof           dof;
  int t=0; 

  Triangle triangle; Mesh mesh;  
  int ig, jg; 
  for ( triangle = mesh.iter.begin(); triangle != mesh.iter.end(); triangle++) { 
    t++; 
    fe.set(triangle); 
    fe.compute_basis_functions(); 
    for (int i=1; i <= fe.nbf(); i++) {  
      ig = dof.glob_dof(t, i, fe.dof(i)); 
      index.first = ig; 
      for (int j=1; j <= fe.nbf(); j++) {  
        jg = dof.glob_dof(t,j fe.dof(j)); 
	index.second = jg; 
	A[index] += integral(triangle,grad(fe.N(i)*grad(fe.N(j)))); 
      }
      b[ig] += integral(triangle,f*fe.N(i));  
    }
  }



}


