#include <SyFi.h>

using namespace GiNaC; 

int main() {
  Dof dof; 
  // create two triangles
  Triangle t1(lst(0,0), lst(1,0), lst(0,1)); 
  Triangle t2(lst(1,1), lst(1,0), lst(0,1)); 

  int order = 2; 

  DiscontinuousLagrangeFE fe; 
  fe.set(order); 
  fe.set(t1); 
  fe.set_element_number(1); 
  fe.compute_basis_functions(); 
  usage(fe); 
  for (int i=0; i< fe.nbf(); i++) {
    dof.insert_dof(1,i,fe.dof(i)); 
  }

  fe.set(t2); 
  fe.set_element_number(2); 
  fe.compute_basis_functions(); 
  usage(fe); 
  for (int i=0; i< fe.nbf(); i++) {
    dof.insert_dof(2,i,fe.dof(i)); 
  }

  // Print out the global degrees of freedom an their 
  // corresponding local degrees of freedom 
  vector<pair<int,int> > vec; 
  pair<int,int> index; 
  ex exdof; 
  for (int i=0; i< dof.size(); i++) {
    exdof = dof.glob_dof(i); 
    vec = dof.glob2loc(i);
    cout <<"global dof " <<i<<" dof "<<exdof<<endl; 
    for (int j=0; j<vec.size(); j++) { 
      index = vec[j]; 
      cout <<"  element "<<index.first<<" local dof "<<index.second<<endl; 
    }
  }










}
