#include <SyFi.h>
#include <ptv.h>

//double ptv::tolerance = 0.0001; 

int main() {

  DofT<ptv,ptv_is_less> dof; 

  // initialization of ptv used as dof 

  // first triangle 
  double x[2];
  x[0] = 0.0; x[1] = 0.0;  
  ptv p(2,x); 
  dof.insert_dof(1,1,p); 

  p[0] = 1.0; p[1] = 0.0;  
  dof.insert_dof(1,2,p); 

  p[0] = 0.0; p[1] = 1.0;  
  dof.insert_dof(1,3,p); 

  // second triangle 
  p[0] = 1.0; p[1] = 1.0;  
  dof.insert_dof(2,1,p); 

  p[0] = 1.0; p[1] = 0.0;  
  dof.insert_dof(2,2,p); 

  p[0] = 0.0; p[1] = 1.0;  
  dof.insert_dof(2,3,p); 



  // print out the global dofs
  // and their corresponding local dofs

  vector<pair<int,int> > vec; 
  pair<int,int> index; 
  ptv exdof; 
  for (int i=0; i< dof.size(); i++) {
    exdof = dof.glob_dof(i); 
    cout <<"global dof " <<i<<" dof "<<exdof<<endl; 
    vec = dof.glob2loc(i);
    for (int j=0; j<vec.size(); j++) { 
      index = vec[j]; 
      cout <<"  element "<<index.first<<" local dof "<<index.second<<endl; 
    }
  }
}



