#include <SyFi.h>

using namespace GiNaC; 

void usage(FE& fe) { 
  ex Ni; 
  ex gradNi; 
  ex dofi; 
  for (int i=0; i< fe.nbf() ; i++) { 
    Ni = fe.N(i); 
    gradNi = grad(Ni); 
    dofi = fe.dof(i); 
    cout <<"The basis function, N("<<i<<")="<<Ni<<endl; 
    cout <<"The gradient of N("<<i<<")="<<gradNi<<endl; 
    cout <<"The corresponding dof, L("<<i<<")="<<dofi<<endl; 
  }
}



int main(){ 
  int order = 1; 
  Triangle triangle(lst(0,0), lst(1,0), lst(0,1));   
  LagrangeFE fe; 
  fe.set(order); 
  fe.set(triangle); 
  fe.compute_basis_functions(); 

  usage(fe); 

}


