#include <SyFi.h>

using namespace GiNaC; 





int main(){ 
  //matrix in terms of rational numbers 
  int order = 1; 
  Triangle triangle(lst(0,0), lst(1,0), lst(0,1));   
  LagrangeFE fe; 
  fe.set(order); 
  fe.set(triangle); 
  fe.compute_basis_functions(); 

  Dof dof; 
  std::map<std::pair<int,int>, ex> A; 
  compute_Poisson_element_matrix(fe, dof, A); 
  print(A); 

  //matrix in terms of symbols 
  symbol x0("x0", "x_0"), x1("x1", "x_1"), x2("x2", "x_2");  
  symbol y0("y0", "y_0"), y1("y1", "y_1"), y2("y2", "y_2");  
  Triangle triangle2(lst(x0,y0), lst(x1,y1), lst(x2,y2));   

  LagrangeFE fe2; 
  fe2.set(order); 
  fe2.set(triangle2); 
  fe2.compute_basis_functions(); 

  Dof dof2; 
  std::map<std::pair<int,int>, ex> A2; 
  compute_Poisson_element_matrix(fe2, dof2, A2); 

  cout <<"standard format on output"<<endl; 
  print(A2); 
  cout <<"LaTeX format on output "<<endl; 
  cout <<latex; 
  print(A2); 
  cout <<"C code format on output "<<endl; 
  cout <<csrc; 
  print(A2); 


}


