#include <SyFi.h>

using namespace GiNaC; 

int main(){ 
  //---          2D Hermite element
  Triangle triangle(lst(0,0), lst(1,0), lst(0,1));   
  HermiteFE fe; 
  fe.set(triangle); 
  fe.compute_basis_functions(); 

  usage(fe); 

  Dof dof; 
  std::map<std::pair<int,int>, ex> A; 
  compute_Poisson_element_matrix(fe, dof, A); 
  print(A); 

  //---          3D Hermite element

  Tetrahedron tetrahedron(lst(0,0,0), lst(1,0,0), lst(0,1,0), lst(0,0,1));   
  HermiteFE fe2; 
  fe2.set(tetrahedron); 
  fe2.compute_basis_functions(); 

  usage(fe2); 

  Dof dof2; 
  std::map<std::pair<int,int>, ex> A2; 
  compute_Poisson_element_matrix(fe2, dof2, A2); 
  print(A2); 




}

