#include <SyFi.h>

using namespace GiNaC; 

int main() {

  
  ex p0 = lst(0.0,0.0,0.0);
  ex p1 = lst(1.0,1.0,1.0);
  
  Line line(p0,p1);
  
  // show usage of repr 
  symbol t("t"); 
  ex l_repr = line.repr(t);
  cout <<"l.repr "<<l_repr<<endl; 
  EQUAL_OR_DIE(l_repr, "{x==t,y==t,z==t,{t,0,1}}"); 

  for (int i=0; i< l_repr.nops(); i++) {
    cout <<"l_repr.op(" <<i<<"):  "<<l_repr.op(i)<<endl; 
  }
  
  // compute the integral of a function along the line 
  ex f = x*x + y*y*y + z;
  ex intf = line.integrate(f); 
  cout <<"intf "<<intf<<endl; 
  EQUAL_OR_DIE(intf, "13/12*sqrt(3)"); 



  return 0; 

}

