#include <SyFi.h>

using namespace GiNaC; 

int main() {

  ReferenceTriangle domain; 

  // First the lowest order. 
  // The lowest order is special, because we must use P0 
  RaviartThomas v_fe;
  v_fe.set(1);
  v_fe.set(domain);
  v_fe.compute_basis_functions();

  P0 p_fe; 
  p_fe.set(domain);
  p_fe.compute_basis_functions();

  usage(v_fe, p_fe); 

  Dof dof; 
  std::map<std::pair<int,int>, ex> A; 
  compute_mixed_Poisson_element_matrix(v_fe, p_fe, dof, A);  
  print(A); 


  // Then for instance order 3
  int order = 3; 
  RaviartThomas v_fe2;
  v_fe2.set(order);
  v_fe2.set(domain);
  v_fe2.compute_basis_functions();

  DiscontinuousLagrangeFE p_fe2; 
  p_fe2.set(order); 
  p_fe2.set(domain);
  p_fe2.compute_basis_functions();

  usage(v_fe2, p_fe2); 

  Dof dof2; 
  std::map<std::pair<int,int>, ex> A2; 
  compute_mixed_Poisson_element_matrix(v_fe2, p_fe2, dof2, A2);  
  print(A2); 



}

