#include <ptv.h>


double ptv::tol = 10e-6;  

ptv::ptv() { 
  dim = 0; 
  v = 0; 
}


ptv::ptv(int size_, double* v_) {
  dim = size_; 
  v = new double[dim]; 
  for (int i=0; i< dim; i++) { 
    v[i] = v_[i];
  }
}

ptv::ptv(const ptv& p){
  dim = p.size(); 
  v = new double[dim]; 
  for (int i=0; i< dim; i++) { 
    v[i] = p[i]; 
  }

}

ptv::~ptv() { 
  if (dim > 0) delete [] v; 
}

const int ptv::size() const { return dim;}

const double& ptv::operator [] (int i) const { 
  return v[i];   
}

double& ptv::operator [] (int i) { 
  return v[i];   
}

ptv& ptv::operator = (const ptv& p) { 
  dim = p.size(); 
  v = new double[dim]; 
  for (int i=0; i< dim; i++) { 
    v[i] = p[i]; 
  }
  return *this; 
}



bool ptv::is_less(const ptv& p) const {
//  cout <<"inside is_less "<<endl; 
  double tmp = 0; 
  double tol = 0.0001; 

  if ( dim <  p.size() ) return true ; 
  if ( dim >  p.size() ) return false; 


  for (int i=0; i< dim; i++) {
    if ( v[i] + tol >= p[i] && v[i] - tol <= p[i] ) {   
    } else if ( v[i] - tol < p[i] ) { 
	return true; 
    } else if ( v[i] + tol > p[i] ) { 
	return false ; 
    }
  }
  return false; 
}
  



std::ostream & operator<< ( std::ostream& os, const ptv& p) { 
  if (p.size() >= 1) {
    os <<"["; 
    for (int i=0; i< p.size()-1; i++) { 
      os <<p[i]<<","; 
    }
    os <<p[p.size()-1]<<"]"; 
  } else {
    os <<"ptv not created properly"<<endl; 
  }
}





