#ifndef PTV_INCLUDED
#define PTV_INCLUDED

#include <SyFi.h>


class ptv {
private: 
  int dim; 
  double* v; 
  static double tol;

public: 
  ptv();   
  ptv(int size_, double* v_); 
  ptv(const ptv& p);

  ~ptv(); 

  const int size() const; 

  const double& operator [] (int i) const;
  double& operator [] (int i); 
  ptv& operator = (const ptv& p);  

  bool is_less(const ptv& p) const; 
};

struct ptv_is_less : public std::binary_function<ptv, ptv, bool> {
bool operator() (const ptv &lh, const ptv &rh) const { return lh.is_less(rh);  }
};

std::ostream & operator<< ( std::ostream& os, const ptv& p); 


#endif

