#include <SyFi.h>

using namespace GiNaC; 

int main() {
  
  ex p0 = lst(0.0,0.0,0.0);
  ex p1 = lst(1.0,0.0,0.0);
  ex p2 = lst(0.0,1.0,0.0);
  ex p3 = lst(0.0,0.0,1.0);
  
  Tetrahedron tetrahedron(p0,p1,p2,p3);
  
  ex repr = tetrahedron.repr();
  cout <<"t.repr "<<repr<<endl; 
  EQUAL_OR_DIE(repr, "{x==r,y==s,z==t,{r,0,1},{s,0,1-r},{t,0,1-s-r}}");  
  
  ex f = x*y*z;
  ex intf = tetrahedron.integrate(f); 
  cout <<"intf "<<intf<<endl; 
  EQUAL_OR_DIE(intf, "1/720"); 
 
  return 0; 
}

