#include <SyFi.h> 

using namespace GiNaC; 

int main() {

  symbol x0("x0"), x1("x1"), y0("y0"), y1("y1"), z0("z0"), z1("z1"); 
  
  ex p0 = lst(x0,y0,z0);
  ex p1 = lst(x1,y0,z0);
  ex p2 = lst(x0,y1,z0);
  ex p3 = lst(x0,y0,z1);

  Tetrahedron tetrahedron(p0,p1,p2,p3);
  
  ex repr = tetrahedron.repr();
  cout <<"t.repr "<<repr<<endl; 
  EQUAL_OR_DIE(repr, "{x==r*(x1-x0)+x0,y==y0+s*(-y0+y1),z==(z1-z0)*t+z0,{r,0,1},{s,0,1-r},{t,0,1-s-r}}"); 
  
  ex f = x*y*z;
  ex intf = tetrahedron.integrate(f); 
  cout <<"intf "<<intf<<endl; 
  EQUAL_OR_DIE(intf, "19/720*y0*x1*z0+1/144*z1*x0*y1+19/720*x0*z0*y1+1/144*y0*x1*z1+1/720*x1*z1*y1+19/720*y0*z1*x0+1/144*x1*z0*y1+47/720*y0*x0*z0");   

  
  return 0; 
}

