
#include <math.h>
#include <utility>
#include <map>
#include <ptv.h>
#include <DofT.h>
#include <ScalarFunction.h>

using namespace std; 



/* ------------- order 1 ---------------*/


  
void matrix_factory_vector_mass_3D_order1 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& dof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    iidof[12];
  double idof0[4];
  idof0[0]=x0;  idof0[1]=y0;  idof0[2]=z0;
  idof0[3] = 0.0;
  ptv ipdof0(4,idof0);
  iidof[0] = dof.insert_dof(element,0,ipdof0);

  double idof1[4];
  idof1[0]=x0;  idof1[1]=y0;  idof1[2]=z0;
  idof1[3] = 1.0;
  ptv ipdof1(4,idof1);
  iidof[1] = dof.insert_dof(element,1,ipdof1);

  double idof2[4];
  idof2[0]=x0;  idof2[1]=y0;  idof2[2]=z0;
  idof2[3] = 2.0;
  ptv ipdof2(4,idof2);
  iidof[2] = dof.insert_dof(element,2,ipdof2);

  double idof3[4];
  idof3[0]=G00+x0;  idof3[1]=y0+G10;  idof3[2]=z0+G20;
  idof3[3] = 0.0;
  ptv ipdof3(4,idof3);
  iidof[3] = dof.insert_dof(element,3,ipdof3);

  double idof4[4];
  idof4[0]=G00+x0;  idof4[1]=y0+G10;  idof4[2]=z0+G20;
  idof4[3] = 1.0;
  ptv ipdof4(4,idof4);
  iidof[4] = dof.insert_dof(element,4,ipdof4);

  double idof5[4];
  idof5[0]=G00+x0;  idof5[1]=y0+G10;  idof5[2]=z0+G20;
  idof5[3] = 2.0;
  ptv ipdof5(4,idof5);
  iidof[5] = dof.insert_dof(element,5,ipdof5);

  double idof6[4];
  idof6[0]=G01+x0;  idof6[1]=y0+G11;  idof6[2]=G21+z0;
  idof6[3] = 0.0;
  ptv ipdof6(4,idof6);
  iidof[6] = dof.insert_dof(element,6,ipdof6);

  double idof7[4];
  idof7[0]=G01+x0;  idof7[1]=y0+G11;  idof7[2]=G21+z0;
  idof7[3] = 1.0;
  ptv ipdof7(4,idof7);
  iidof[7] = dof.insert_dof(element,7,ipdof7);

  double idof8[4];
  idof8[0]=G01+x0;  idof8[1]=y0+G11;  idof8[2]=G21+z0;
  idof8[3] = 2.0;
  ptv ipdof8(4,idof8);
  iidof[8] = dof.insert_dof(element,8,ipdof8);

  double idof9[4];
  idof9[0]=G02+x0;  idof9[1]=G12+y0;  idof9[2]=G22+z0;
  idof9[3] = 0.0;
  ptv ipdof9(4,idof9);
  iidof[9] = dof.insert_dof(element,9,ipdof9);

  double idof10[4];
  idof10[0]=G02+x0;  idof10[1]=G12+y0;  idof10[2]=G22+z0;
  idof10[3] = 1.0;
  ptv ipdof10(4,idof10);
  iidof[10] = dof.insert_dof(element,10,ipdof10);

  double idof11[4];
  idof11[0]=G02+x0;  idof11[1]=G12+y0;  idof11[2]=G22+z0;
  idof11[3] = 2.0;
  ptv ipdof11(4,idof11);
  iidof[11] = dof.insert_dof(element,11,ipdof11);

 
  double A[12][12];
  A[0][0]=(1.6666666666666666e-02)*D;
  A[0][1]=(0.0)*D;
  A[0][2]=(0.0)*D;
  A[0][3]=(8.3333333333333332e-03)*D;
  A[0][4]=(0.0)*D;
  A[0][5]=(0.0)*D;
  A[0][6]=(8.3333333333333332e-03)*D;
  A[0][7]=(0.0)*D;
  A[0][8]=(0.0)*D;
  A[0][9]=(8.3333333333333332e-03)*D;
  A[0][10]=(0.0)*D;
  A[0][11]=(0.0)*D;
  A[1][0]=(0.0)*D;
  A[1][1]=(1.6666666666666666e-02)*D;
  A[1][2]=(0.0)*D;
  A[1][3]=(0.0)*D;
  A[1][4]=(8.3333333333333332e-03)*D;
  A[1][5]=(0.0)*D;
  A[1][6]=(0.0)*D;
  A[1][7]=(8.3333333333333332e-03)*D;
  A[1][8]=(0.0)*D;
  A[1][9]=(0.0)*D;
  A[1][10]=(8.3333333333333332e-03)*D;
  A[1][11]=(0.0)*D;
  A[2][0]=(0.0)*D;
  A[2][1]=(0.0)*D;
  A[2][2]=(1.6666666666666666e-02)*D;
  A[2][3]=(0.0)*D;
  A[2][4]=(0.0)*D;
  A[2][5]=(8.3333333333333332e-03)*D;
  A[2][6]=(0.0)*D;
  A[2][7]=(0.0)*D;
  A[2][8]=(8.3333333333333332e-03)*D;
  A[2][9]=(0.0)*D;
  A[2][10]=(0.0)*D;
  A[2][11]=(8.3333333333333332e-03)*D;
  A[3][0]=(8.3333333333333332e-03)*D;
  A[3][1]=(0.0)*D;
  A[3][2]=(0.0)*D;
  A[3][3]=(1.6666666666666666e-02)*D;
  A[3][4]=(0.0)*D;
  A[3][5]=(0.0)*D;
  A[3][6]=(8.3333333333333332e-03)*D;
  A[3][7]=(0.0)*D;
  A[3][8]=(0.0)*D;
  A[3][9]=(8.3333333333333332e-03)*D;
  A[3][10]=(0.0)*D;
  A[3][11]=(0.0)*D;
  A[4][0]=(0.0)*D;
  A[4][1]=(8.3333333333333332e-03)*D;
  A[4][2]=(0.0)*D;
  A[4][3]=(0.0)*D;
  A[4][4]=(1.6666666666666666e-02)*D;
  A[4][5]=(0.0)*D;
  A[4][6]=(0.0)*D;
  A[4][7]=(8.3333333333333332e-03)*D;
  A[4][8]=(0.0)*D;
  A[4][9]=(0.0)*D;
  A[4][10]=(8.3333333333333332e-03)*D;
  A[4][11]=(0.0)*D;
  A[5][0]=(0.0)*D;
  A[5][1]=(0.0)*D;
  A[5][2]=(8.3333333333333332e-03)*D;
  A[5][3]=(0.0)*D;
  A[5][4]=(0.0)*D;
  A[5][5]=(1.6666666666666666e-02)*D;
  A[5][6]=(0.0)*D;
  A[5][7]=(0.0)*D;
  A[5][8]=(8.3333333333333332e-03)*D;
  A[5][9]=(0.0)*D;
  A[5][10]=(0.0)*D;
  A[5][11]=(8.3333333333333332e-03)*D;
  A[6][0]=(8.3333333333333332e-03)*D;
  A[6][1]=(0.0)*D;
  A[6][2]=(0.0)*D;
  A[6][3]=(8.3333333333333332e-03)*D;
  A[6][4]=(0.0)*D;
  A[6][5]=(0.0)*D;
  A[6][6]=(1.6666666666666666e-02)*D;
  A[6][7]=(0.0)*D;
  A[6][8]=(0.0)*D;
  A[6][9]=(8.3333333333333332e-03)*D;
  A[6][10]=(0.0)*D;
  A[6][11]=(0.0)*D;
  A[7][0]=(0.0)*D;
  A[7][1]=(8.3333333333333332e-03)*D;
  A[7][2]=(0.0)*D;
  A[7][3]=(0.0)*D;
  A[7][4]=(8.3333333333333332e-03)*D;
  A[7][5]=(0.0)*D;
  A[7][6]=(0.0)*D;
  A[7][7]=(1.6666666666666666e-02)*D;
  A[7][8]=(0.0)*D;
  A[7][9]=(0.0)*D;
  A[7][10]=(8.3333333333333332e-03)*D;
  A[7][11]=(0.0)*D;
  A[8][0]=(0.0)*D;
  A[8][1]=(0.0)*D;
  A[8][2]=(8.3333333333333332e-03)*D;
  A[8][3]=(0.0)*D;
  A[8][4]=(0.0)*D;
  A[8][5]=(8.3333333333333332e-03)*D;
  A[8][6]=(0.0)*D;
  A[8][7]=(0.0)*D;
  A[8][8]=(1.6666666666666666e-02)*D;
  A[8][9]=(0.0)*D;
  A[8][10]=(0.0)*D;
  A[8][11]=(8.3333333333333332e-03)*D;
  A[9][0]=(8.3333333333333332e-03)*D;
  A[9][1]=(0.0)*D;
  A[9][2]=(0.0)*D;
  A[9][3]=(8.3333333333333332e-03)*D;
  A[9][4]=(0.0)*D;
  A[9][5]=(0.0)*D;
  A[9][6]=(8.3333333333333332e-03)*D;
  A[9][7]=(0.0)*D;
  A[9][8]=(0.0)*D;
  A[9][9]=(1.6666666666666666e-02)*D;
  A[9][10]=(0.0)*D;
  A[9][11]=(0.0)*D;
  A[10][0]=(0.0)*D;
  A[10][1]=(8.3333333333333332e-03)*D;
  A[10][2]=(0.0)*D;
  A[10][3]=(0.0)*D;
  A[10][4]=(8.3333333333333332e-03)*D;
  A[10][5]=(0.0)*D;
  A[10][6]=(0.0)*D;
  A[10][7]=(8.3333333333333332e-03)*D;
  A[10][8]=(0.0)*D;
  A[10][9]=(0.0)*D;
  A[10][10]=(1.6666666666666666e-02)*D;
  A[10][11]=(0.0)*D;
  A[11][0]=(0.0)*D;
  A[11][1]=(0.0)*D;
  A[11][2]=(8.3333333333333332e-03)*D;
  A[11][3]=(0.0)*D;
  A[11][4]=(0.0)*D;
  A[11][5]=(8.3333333333333332e-03)*D;
  A[11][6]=(0.0)*D;
  A[11][7]=(0.0)*D;
  A[11][8]=(8.3333333333333332e-03)*D;
  A[11][9]=(0.0)*D;
  A[11][10]=(0.0)*D;
  A[11][11]=(1.6666666666666666e-02)*D;
  int nbf = 12;  

  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = iidof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = iidof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}


/* ------------- order 2 ---------------*/


  
void matrix_factory_vector_mass_3D_order2 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& dof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    iidof[30];
  double idof0[4];
  idof0[0]=x0;  idof0[1]=y0;  idof0[2]=z0;
  idof0[3] = 0.0;
  ptv ipdof0(4,idof0);
  iidof[0] = dof.insert_dof(element,0,ipdof0);

  double idof1[4];
  idof1[0]=x0;  idof1[1]=y0;  idof1[2]=z0;
  idof1[3] = 1.0;
  ptv ipdof1(4,idof1);
  iidof[1] = dof.insert_dof(element,1,ipdof1);

  double idof2[4];
  idof2[0]=x0;  idof2[1]=y0;  idof2[2]=z0;
  idof2[3] = 2.0;
  ptv ipdof2(4,idof2);
  iidof[2] = dof.insert_dof(element,2,ipdof2);

  double idof3[4];
  idof3[0]=G00/2.0+x0;  idof3[1]=y0+G10/2.0;  idof3[2]=z0+G20/2.0;
  idof3[3] = 0.0;
  ptv ipdof3(4,idof3);
  iidof[3] = dof.insert_dof(element,3,ipdof3);

  double idof4[4];
  idof4[0]=G00/2.0+x0;  idof4[1]=y0+G10/2.0;  idof4[2]=z0+G20/2.0;
  idof4[3] = 1.0;
  ptv ipdof4(4,idof4);
  iidof[4] = dof.insert_dof(element,4,ipdof4);

  double idof5[4];
  idof5[0]=G00/2.0+x0;  idof5[1]=y0+G10/2.0;  idof5[2]=z0+G20/2.0;
  idof5[3] = 2.0;
  ptv ipdof5(4,idof5);
  iidof[5] = dof.insert_dof(element,5,ipdof5);

  double idof6[4];
  idof6[0]=G00+x0;  idof6[1]=y0+G10;  idof6[2]=z0+G20;
  idof6[3] = 0.0;
  ptv ipdof6(4,idof6);
  iidof[6] = dof.insert_dof(element,6,ipdof6);

  double idof7[4];
  idof7[0]=G00+x0;  idof7[1]=y0+G10;  idof7[2]=z0+G20;
  idof7[3] = 1.0;
  ptv ipdof7(4,idof7);
  iidof[7] = dof.insert_dof(element,7,ipdof7);

  double idof8[4];
  idof8[0]=G00+x0;  idof8[1]=y0+G10;  idof8[2]=z0+G20;
  idof8[3] = 2.0;
  ptv ipdof8(4,idof8);
  iidof[8] = dof.insert_dof(element,8,ipdof8);

  double idof9[4];
  idof9[0]=G01/2.0+x0;  idof9[1]=y0+G11/2.0;  idof9[2]=G21/2.0+z0;
  idof9[3] = 0.0;
  ptv ipdof9(4,idof9);
  iidof[9] = dof.insert_dof(element,9,ipdof9);

  double idof10[4];
  idof10[0]=G01/2.0+x0;  idof10[1]=y0+G11/2.0;  idof10[2]=G21/2.0+z0;
  idof10[3] = 1.0;
  ptv ipdof10(4,idof10);
  iidof[10] = dof.insert_dof(element,10,ipdof10);

  double idof11[4];
  idof11[0]=G01/2.0+x0;  idof11[1]=y0+G11/2.0;  idof11[2]=G21/2.0+z0;
  idof11[3] = 2.0;
  ptv ipdof11(4,idof11);
  iidof[11] = dof.insert_dof(element,11,ipdof11);

  double idof12[4];
  idof12[0]=G01/2.0+G00/2.0+x0;  idof12[1]=y0+G11/2.0+G10/2.0;  idof12[2]=G21/2.0+z0+G20/2.0;
  idof12[3] = 0.0;
  ptv ipdof12(4,idof12);
  iidof[12] = dof.insert_dof(element,12,ipdof12);

  double idof13[4];
  idof13[0]=G01/2.0+G00/2.0+x0;  idof13[1]=y0+G11/2.0+G10/2.0;  idof13[2]=G21/2.0+z0+G20/2.0;
  idof13[3] = 1.0;
  ptv ipdof13(4,idof13);
  iidof[13] = dof.insert_dof(element,13,ipdof13);

  double idof14[4];
  idof14[0]=G01/2.0+G00/2.0+x0;  idof14[1]=y0+G11/2.0+G10/2.0;  idof14[2]=G21/2.0+z0+G20/2.0;
  idof14[3] = 2.0;
  ptv ipdof14(4,idof14);
  iidof[14] = dof.insert_dof(element,14,ipdof14);

  double idof15[4];
  idof15[0]=G01+x0;  idof15[1]=y0+G11;  idof15[2]=G21+z0;
  idof15[3] = 0.0;
  ptv ipdof15(4,idof15);
  iidof[15] = dof.insert_dof(element,15,ipdof15);

  double idof16[4];
  idof16[0]=G01+x0;  idof16[1]=y0+G11;  idof16[2]=G21+z0;
  idof16[3] = 1.0;
  ptv ipdof16(4,idof16);
  iidof[16] = dof.insert_dof(element,16,ipdof16);

  double idof17[4];
  idof17[0]=G01+x0;  idof17[1]=y0+G11;  idof17[2]=G21+z0;
  idof17[3] = 2.0;
  ptv ipdof17(4,idof17);
  iidof[17] = dof.insert_dof(element,17,ipdof17);

  double idof18[4];
  idof18[0]=G02/2.0+x0;  idof18[1]=G12/2.0+y0;  idof18[2]=G22/2.0+z0;
  idof18[3] = 0.0;
  ptv ipdof18(4,idof18);
  iidof[18] = dof.insert_dof(element,18,ipdof18);

  double idof19[4];
  idof19[0]=G02/2.0+x0;  idof19[1]=G12/2.0+y0;  idof19[2]=G22/2.0+z0;
  idof19[3] = 1.0;
  ptv ipdof19(4,idof19);
  iidof[19] = dof.insert_dof(element,19,ipdof19);

  double idof20[4];
  idof20[0]=G02/2.0+x0;  idof20[1]=G12/2.0+y0;  idof20[2]=G22/2.0+z0;
  idof20[3] = 2.0;
  ptv ipdof20(4,idof20);
  iidof[20] = dof.insert_dof(element,20,ipdof20);

  double idof21[4];
  idof21[0]=G02/2.0+G00/2.0+x0;  idof21[1]=G12/2.0+y0+G10/2.0;  idof21[2]=G22/2.0+z0+G20/2.0;
  idof21[3] = 0.0;
  ptv ipdof21(4,idof21);
  iidof[21] = dof.insert_dof(element,21,ipdof21);

  double idof22[4];
  idof22[0]=G02/2.0+G00/2.0+x0;  idof22[1]=G12/2.0+y0+G10/2.0;  idof22[2]=G22/2.0+z0+G20/2.0;
  idof22[3] = 1.0;
  ptv ipdof22(4,idof22);
  iidof[22] = dof.insert_dof(element,22,ipdof22);

  double idof23[4];
  idof23[0]=G02/2.0+G00/2.0+x0;  idof23[1]=G12/2.0+y0+G10/2.0;  idof23[2]=G22/2.0+z0+G20/2.0;
  idof23[3] = 2.0;
  ptv ipdof23(4,idof23);
  iidof[23] = dof.insert_dof(element,23,ipdof23);

  double idof24[4];
  idof24[0]=G02/2.0+G01/2.0+x0;  idof24[1]=G12/2.0+y0+G11/2.0;  idof24[2]=G22/2.0+G21/2.0+z0;
  idof24[3] = 0.0;
  ptv ipdof24(4,idof24);
  iidof[24] = dof.insert_dof(element,24,ipdof24);

  double idof25[4];
  idof25[0]=G02/2.0+G01/2.0+x0;  idof25[1]=G12/2.0+y0+G11/2.0;  idof25[2]=G22/2.0+G21/2.0+z0;
  idof25[3] = 1.0;
  ptv ipdof25(4,idof25);
  iidof[25] = dof.insert_dof(element,25,ipdof25);

  double idof26[4];
  idof26[0]=G02/2.0+G01/2.0+x0;  idof26[1]=G12/2.0+y0+G11/2.0;  idof26[2]=G22/2.0+G21/2.0+z0;
  idof26[3] = 2.0;
  ptv ipdof26(4,idof26);
  iidof[26] = dof.insert_dof(element,26,ipdof26);

  double idof27[4];
  idof27[0]=G02+x0;  idof27[1]=G12+y0;  idof27[2]=G22+z0;
  idof27[3] = 0.0;
  ptv ipdof27(4,idof27);
  iidof[27] = dof.insert_dof(element,27,ipdof27);

  double idof28[4];
  idof28[0]=G02+x0;  idof28[1]=G12+y0;  idof28[2]=G22+z0;
  idof28[3] = 1.0;
  ptv ipdof28(4,idof28);
  iidof[28] = dof.insert_dof(element,28,ipdof28);

  double idof29[4];
  idof29[0]=G02+x0;  idof29[1]=G12+y0;  idof29[2]=G22+z0;
  idof29[3] = 2.0;
  ptv ipdof29(4,idof29);
  iidof[29] = dof.insert_dof(element,29,ipdof29);

 
  double A[30][30];
  A[0][0]=(2.3809523809523812e-03)*D;
  A[0][1]=(0.0)*D;
  A[0][2]=(0.0)*D;
  A[0][3]=(-1.5873015873015873e-03)*D;
  A[0][4]=(0.0)*D;
  A[0][5]=(0.0)*D;
  A[0][6]=(3.9682539682539683e-04)*D;
  A[0][7]=(0.0)*D;
  A[0][8]=(0.0)*D;
  A[0][9]=(-1.5873015873015873e-03)*D;
  A[0][10]=(0.0)*D;
  A[0][11]=(0.0)*D;
  A[0][12]=(-2.3809523809523812e-03)*D;
  A[0][13]=(0.0)*D;
  A[0][14]=(0.0)*D;
  A[0][15]=(3.9682539682539683e-04)*D;
  A[0][16]=(0.0)*D;
  A[0][17]=(0.0)*D;
  A[0][18]=(-1.5873015873015873e-03)*D;
  A[0][19]=(0.0)*D;
  A[0][20]=(0.0)*D;
  A[0][21]=(-2.3809523809523812e-03)*D;
  A[0][22]=(0.0)*D;
  A[0][23]=(0.0)*D;
  A[0][24]=(-2.3809523809523812e-03)*D;
  A[0][25]=(0.0)*D;
  A[0][26]=(0.0)*D;
  A[0][27]=(3.9682539682539683e-04)*D;
  A[0][28]=(0.0)*D;
  A[0][29]=(0.0)*D;
  A[1][0]=(0.0)*D;
  A[1][1]=(2.3809523809523812e-03)*D;
  A[1][2]=(0.0)*D;
  A[1][3]=(0.0)*D;
  A[1][4]=(-1.5873015873015873e-03)*D;
  A[1][5]=(0.0)*D;
  A[1][6]=(0.0)*D;
  A[1][7]=(3.9682539682539683e-04)*D;
  A[1][8]=(0.0)*D;
  A[1][9]=(0.0)*D;
  A[1][10]=(-1.5873015873015873e-03)*D;
  A[1][11]=(0.0)*D;
  A[1][12]=(0.0)*D;
  A[1][13]=(-2.3809523809523812e-03)*D;
  A[1][14]=(0.0)*D;
  A[1][15]=(0.0)*D;
  A[1][16]=(3.9682539682539683e-04)*D;
  A[1][17]=(0.0)*D;
  A[1][18]=(0.0)*D;
  A[1][19]=(-1.5873015873015873e-03)*D;
  A[1][20]=(0.0)*D;
  A[1][21]=(0.0)*D;
  A[1][22]=(-2.3809523809523812e-03)*D;
  A[1][23]=(0.0)*D;
  A[1][24]=(0.0)*D;
  A[1][25]=(-2.3809523809523812e-03)*D;
  A[1][26]=(0.0)*D;
  A[1][27]=(0.0)*D;
  A[1][28]=(3.9682539682539683e-04)*D;
  A[1][29]=(0.0)*D;
  A[2][0]=(0.0)*D;
  A[2][1]=(0.0)*D;
  A[2][2]=(2.3809523809523812e-03)*D;
  A[2][3]=(0.0)*D;
  A[2][4]=(0.0)*D;
  A[2][5]=(-1.5873015873015873e-03)*D;
  A[2][6]=(0.0)*D;
  A[2][7]=(0.0)*D;
  A[2][8]=(3.9682539682539683e-04)*D;
  A[2][9]=(0.0)*D;
  A[2][10]=(0.0)*D;
  A[2][11]=(-1.5873015873015873e-03)*D;
  A[2][12]=(0.0)*D;
  A[2][13]=(0.0)*D;
  A[2][14]=(-2.3809523809523812e-03)*D;
  A[2][15]=(0.0)*D;
  A[2][16]=(0.0)*D;
  A[2][17]=(3.9682539682539683e-04)*D;
  A[2][18]=(0.0)*D;
  A[2][19]=(0.0)*D;
  A[2][20]=(-1.5873015873015873e-03)*D;
  A[2][21]=(0.0)*D;
  A[2][22]=(0.0)*D;
  A[2][23]=(-2.3809523809523812e-03)*D;
  A[2][24]=(0.0)*D;
  A[2][25]=(0.0)*D;
  A[2][26]=(-2.3809523809523812e-03)*D;
  A[2][27]=(0.0)*D;
  A[2][28]=(0.0)*D;
  A[2][29]=(3.9682539682539683e-04)*D;
  A[3][0]=(-1.5873015873015873e-03)*D;
  A[3][1]=(0.0)*D;
  A[3][2]=(0.0)*D;
  A[3][3]=(1.2698412698412698e-02)*D;
  A[3][4]=(0.0)*D;
  A[3][5]=(0.0)*D;
  A[3][6]=(-1.5873015873015873e-03)*D;
  A[3][7]=(0.0)*D;
  A[3][8]=(0.0)*D;
  A[3][9]=(6.3492063492063492e-03)*D;
  A[3][10]=(0.0)*D;
  A[3][11]=(0.0)*D;
  A[3][12]=(6.3492063492063492e-03)*D;
  A[3][13]=(0.0)*D;
  A[3][14]=(0.0)*D;
  A[3][15]=(-2.3809523809523812e-03)*D;
  A[3][16]=(0.0)*D;
  A[3][17]=(0.0)*D;
  A[3][18]=(6.3492063492063492e-03)*D;
  A[3][19]=(0.0)*D;
  A[3][20]=(0.0)*D;
  A[3][21]=(6.3492063492063492e-03)*D;
  A[3][22]=(0.0)*D;
  A[3][23]=(0.0)*D;
  A[3][24]=(3.1746031746031746e-03)*D;
  A[3][25]=(0.0)*D;
  A[3][26]=(0.0)*D;
  A[3][27]=(-2.3809523809523812e-03)*D;
  A[3][28]=(0.0)*D;
  A[3][29]=(0.0)*D;
  A[4][0]=(0.0)*D;
  A[4][1]=(-1.5873015873015873e-03)*D;
  A[4][2]=(0.0)*D;
  A[4][3]=(0.0)*D;
  A[4][4]=(1.2698412698412698e-02)*D;
  A[4][5]=(0.0)*D;
  A[4][6]=(0.0)*D;
  A[4][7]=(-1.5873015873015873e-03)*D;
  A[4][8]=(0.0)*D;
  A[4][9]=(0.0)*D;
  A[4][10]=(6.3492063492063492e-03)*D;
  A[4][11]=(0.0)*D;
  A[4][12]=(0.0)*D;
  A[4][13]=(6.3492063492063492e-03)*D;
  A[4][14]=(0.0)*D;
  A[4][15]=(0.0)*D;
  A[4][16]=(-2.3809523809523812e-03)*D;
  A[4][17]=(0.0)*D;
  A[4][18]=(0.0)*D;
  A[4][19]=(6.3492063492063492e-03)*D;
  A[4][20]=(0.0)*D;
  A[4][21]=(0.0)*D;
  A[4][22]=(6.3492063492063492e-03)*D;
  A[4][23]=(0.0)*D;
  A[4][24]=(0.0)*D;
  A[4][25]=(3.1746031746031746e-03)*D;
  A[4][26]=(0.0)*D;
  A[4][27]=(0.0)*D;
  A[4][28]=(-2.3809523809523812e-03)*D;
  A[4][29]=(0.0)*D;
  A[5][0]=(0.0)*D;
  A[5][1]=(0.0)*D;
  A[5][2]=(-1.5873015873015873e-03)*D;
  A[5][3]=(0.0)*D;
  A[5][4]=(0.0)*D;
  A[5][5]=(1.2698412698412698e-02)*D;
  A[5][6]=(0.0)*D;
  A[5][7]=(0.0)*D;
  A[5][8]=(-1.5873015873015873e-03)*D;
  A[5][9]=(0.0)*D;
  A[5][10]=(0.0)*D;
  A[5][11]=(6.3492063492063492e-03)*D;
  A[5][12]=(0.0)*D;
  A[5][13]=(0.0)*D;
  A[5][14]=(6.3492063492063492e-03)*D;
  A[5][15]=(0.0)*D;
  A[5][16]=(0.0)*D;
  A[5][17]=(-2.3809523809523812e-03)*D;
  A[5][18]=(0.0)*D;
  A[5][19]=(0.0)*D;
  A[5][20]=(6.3492063492063492e-03)*D;
  A[5][21]=(0.0)*D;
  A[5][22]=(0.0)*D;
  A[5][23]=(6.3492063492063492e-03)*D;
  A[5][24]=(0.0)*D;
  A[5][25]=(0.0)*D;
  A[5][26]=(3.1746031746031746e-03)*D;
  A[5][27]=(0.0)*D;
  A[5][28]=(0.0)*D;
  A[5][29]=(-2.3809523809523812e-03)*D;
  A[6][0]=(3.9682539682539683e-04)*D;
  A[6][1]=(0.0)*D;
  A[6][2]=(0.0)*D;
  A[6][3]=(-1.5873015873015873e-03)*D;
  A[6][4]=(0.0)*D;
  A[6][5]=(0.0)*D;
  A[6][6]=(2.3809523809523812e-03)*D;
  A[6][7]=(0.0)*D;
  A[6][8]=(0.0)*D;
  A[6][9]=(-2.3809523809523812e-03)*D;
  A[6][10]=(0.0)*D;
  A[6][11]=(0.0)*D;
  A[6][12]=(-1.5873015873015873e-03)*D;
  A[6][13]=(0.0)*D;
  A[6][14]=(0.0)*D;
  A[6][15]=(3.9682539682539683e-04)*D;
  A[6][16]=(0.0)*D;
  A[6][17]=(0.0)*D;
  A[6][18]=(-2.3809523809523812e-03)*D;
  A[6][19]=(0.0)*D;
  A[6][20]=(0.0)*D;
  A[6][21]=(-1.5873015873015873e-03)*D;
  A[6][22]=(0.0)*D;
  A[6][23]=(0.0)*D;
  A[6][24]=(-2.3809523809523812e-03)*D;
  A[6][25]=(0.0)*D;
  A[6][26]=(0.0)*D;
  A[6][27]=(3.9682539682539683e-04)*D;
  A[6][28]=(0.0)*D;
  A[6][29]=(0.0)*D;
  A[7][0]=(0.0)*D;
  A[7][1]=(3.9682539682539683e-04)*D;
  A[7][2]=(0.0)*D;
  A[7][3]=(0.0)*D;
  A[7][4]=(-1.5873015873015873e-03)*D;
  A[7][5]=(0.0)*D;
  A[7][6]=(0.0)*D;
  A[7][7]=(2.3809523809523812e-03)*D;
  A[7][8]=(0.0)*D;
  A[7][9]=(0.0)*D;
  A[7][10]=(-2.3809523809523812e-03)*D;
  A[7][11]=(0.0)*D;
  A[7][12]=(0.0)*D;
  A[7][13]=(-1.5873015873015873e-03)*D;
  A[7][14]=(0.0)*D;
  A[7][15]=(0.0)*D;
  A[7][16]=(3.9682539682539683e-04)*D;
  A[7][17]=(0.0)*D;
  A[7][18]=(0.0)*D;
  A[7][19]=(-2.3809523809523812e-03)*D;
  A[7][20]=(0.0)*D;
  A[7][21]=(0.0)*D;
  A[7][22]=(-1.5873015873015873e-03)*D;
  A[7][23]=(0.0)*D;
  A[7][24]=(0.0)*D;
  A[7][25]=(-2.3809523809523812e-03)*D;
  A[7][26]=(0.0)*D;
  A[7][27]=(0.0)*D;
  A[7][28]=(3.9682539682539683e-04)*D;
  A[7][29]=(0.0)*D;
  A[8][0]=(0.0)*D;
  A[8][1]=(0.0)*D;
  A[8][2]=(3.9682539682539683e-04)*D;
  A[8][3]=(0.0)*D;
  A[8][4]=(0.0)*D;
  A[8][5]=(-1.5873015873015873e-03)*D;
  A[8][6]=(0.0)*D;
  A[8][7]=(0.0)*D;
  A[8][8]=(2.3809523809523812e-03)*D;
  A[8][9]=(0.0)*D;
  A[8][10]=(0.0)*D;
  A[8][11]=(-2.3809523809523812e-03)*D;
  A[8][12]=(0.0)*D;
  A[8][13]=(0.0)*D;
  A[8][14]=(-1.5873015873015873e-03)*D;
  A[8][15]=(0.0)*D;
  A[8][16]=(0.0)*D;
  A[8][17]=(3.9682539682539683e-04)*D;
  A[8][18]=(0.0)*D;
  A[8][19]=(0.0)*D;
  A[8][20]=(-2.3809523809523812e-03)*D;
  A[8][21]=(0.0)*D;
  A[8][22]=(0.0)*D;
  A[8][23]=(-1.5873015873015873e-03)*D;
  A[8][24]=(0.0)*D;
  A[8][25]=(0.0)*D;
  A[8][26]=(-2.3809523809523812e-03)*D;
  A[8][27]=(0.0)*D;
  A[8][28]=(0.0)*D;
  A[8][29]=(3.9682539682539683e-04)*D;
  A[9][0]=(-1.5873015873015873e-03)*D;
  A[9][1]=(0.0)*D;
  A[9][2]=(0.0)*D;
  A[9][3]=(6.3492063492063492e-03)*D;
  A[9][4]=(0.0)*D;
  A[9][5]=(0.0)*D;
  A[9][6]=(-2.3809523809523812e-03)*D;
  A[9][7]=(0.0)*D;
  A[9][8]=(0.0)*D;
  A[9][9]=(1.2698412698412698e-02)*D;
  A[9][10]=(0.0)*D;
  A[9][11]=(0.0)*D;
  A[9][12]=(6.3492063492063492e-03)*D;
  A[9][13]=(0.0)*D;
  A[9][14]=(0.0)*D;
  A[9][15]=(-1.5873015873015873e-03)*D;
  A[9][16]=(0.0)*D;
  A[9][17]=(0.0)*D;
  A[9][18]=(6.3492063492063492e-03)*D;
  A[9][19]=(0.0)*D;
  A[9][20]=(0.0)*D;
  A[9][21]=(3.1746031746031746e-03)*D;
  A[9][22]=(0.0)*D;
  A[9][23]=(0.0)*D;
  A[9][24]=(6.3492063492063492e-03)*D;
  A[9][25]=(0.0)*D;
  A[9][26]=(0.0)*D;
  A[9][27]=(-2.3809523809523812e-03)*D;
  A[9][28]=(0.0)*D;
  A[9][29]=(0.0)*D;
  A[10][0]=(0.0)*D;
  A[10][1]=(-1.5873015873015873e-03)*D;
  A[10][2]=(0.0)*D;
  A[10][3]=(0.0)*D;
  A[10][4]=(6.3492063492063492e-03)*D;
  A[10][5]=(0.0)*D;
  A[10][6]=(0.0)*D;
  A[10][7]=(-2.3809523809523812e-03)*D;
  A[10][8]=(0.0)*D;
  A[10][9]=(0.0)*D;
  A[10][10]=(1.2698412698412698e-02)*D;
  A[10][11]=(0.0)*D;
  A[10][12]=(0.0)*D;
  A[10][13]=(6.3492063492063492e-03)*D;
  A[10][14]=(0.0)*D;
  A[10][15]=(0.0)*D;
  A[10][16]=(-1.5873015873015873e-03)*D;
  A[10][17]=(0.0)*D;
  A[10][18]=(0.0)*D;
  A[10][19]=(6.3492063492063492e-03)*D;
  A[10][20]=(0.0)*D;
  A[10][21]=(0.0)*D;
  A[10][22]=(3.1746031746031746e-03)*D;
  A[10][23]=(0.0)*D;
  A[10][24]=(0.0)*D;
  A[10][25]=(6.3492063492063492e-03)*D;
  A[10][26]=(0.0)*D;
  A[10][27]=(0.0)*D;
  A[10][28]=(-2.3809523809523812e-03)*D;
  A[10][29]=(0.0)*D;
  A[11][0]=(0.0)*D;
  A[11][1]=(0.0)*D;
  A[11][2]=(-1.5873015873015873e-03)*D;
  A[11][3]=(0.0)*D;
  A[11][4]=(0.0)*D;
  A[11][5]=(6.3492063492063492e-03)*D;
  A[11][6]=(0.0)*D;
  A[11][7]=(0.0)*D;
  A[11][8]=(-2.3809523809523812e-03)*D;
  A[11][9]=(0.0)*D;
  A[11][10]=(0.0)*D;
  A[11][11]=(1.2698412698412698e-02)*D;
  A[11][12]=(0.0)*D;
  A[11][13]=(0.0)*D;
  A[11][14]=(6.3492063492063492e-03)*D;
  A[11][15]=(0.0)*D;
  A[11][16]=(0.0)*D;
  A[11][17]=(-1.5873015873015873e-03)*D;
  A[11][18]=(0.0)*D;
  A[11][19]=(0.0)*D;
  A[11][20]=(6.3492063492063492e-03)*D;
  A[11][21]=(0.0)*D;
  A[11][22]=(0.0)*D;
  A[11][23]=(3.1746031746031746e-03)*D;
  A[11][24]=(0.0)*D;
  A[11][25]=(0.0)*D;
  A[11][26]=(6.3492063492063492e-03)*D;
  A[11][27]=(0.0)*D;
  A[11][28]=(0.0)*D;
  A[11][29]=(-2.3809523809523812e-03)*D;
  A[12][0]=(-2.3809523809523812e-03)*D;
  A[12][1]=(0.0)*D;
  A[12][2]=(0.0)*D;
  A[12][3]=(6.3492063492063492e-03)*D;
  A[12][4]=(0.0)*D;
  A[12][5]=(0.0)*D;
  A[12][6]=(-1.5873015873015873e-03)*D;
  A[12][7]=(0.0)*D;
  A[12][8]=(0.0)*D;
  A[12][9]=(6.3492063492063492e-03)*D;
  A[12][10]=(0.0)*D;
  A[12][11]=(0.0)*D;
  A[12][12]=(1.2698412698412698e-02)*D;
  A[12][13]=(0.0)*D;
  A[12][14]=(0.0)*D;
  A[12][15]=(-1.5873015873015873e-03)*D;
  A[12][16]=(0.0)*D;
  A[12][17]=(0.0)*D;
  A[12][18]=(3.1746031746031746e-03)*D;
  A[12][19]=(0.0)*D;
  A[12][20]=(0.0)*D;
  A[12][21]=(6.3492063492063492e-03)*D;
  A[12][22]=(0.0)*D;
  A[12][23]=(0.0)*D;
  A[12][24]=(6.3492063492063492e-03)*D;
  A[12][25]=(0.0)*D;
  A[12][26]=(0.0)*D;
  A[12][27]=(-2.3809523809523812e-03)*D;
  A[12][28]=(0.0)*D;
  A[12][29]=(0.0)*D;
  A[13][0]=(0.0)*D;
  A[13][1]=(-2.3809523809523812e-03)*D;
  A[13][2]=(0.0)*D;
  A[13][3]=(0.0)*D;
  A[13][4]=(6.3492063492063492e-03)*D;
  A[13][5]=(0.0)*D;
  A[13][6]=(0.0)*D;
  A[13][7]=(-1.5873015873015873e-03)*D;
  A[13][8]=(0.0)*D;
  A[13][9]=(0.0)*D;
  A[13][10]=(6.3492063492063492e-03)*D;
  A[13][11]=(0.0)*D;
  A[13][12]=(0.0)*D;
  A[13][13]=(1.2698412698412698e-02)*D;
  A[13][14]=(0.0)*D;
  A[13][15]=(0.0)*D;
  A[13][16]=(-1.5873015873015873e-03)*D;
  A[13][17]=(0.0)*D;
  A[13][18]=(0.0)*D;
  A[13][19]=(3.1746031746031746e-03)*D;
  A[13][20]=(0.0)*D;
  A[13][21]=(0.0)*D;
  A[13][22]=(6.3492063492063492e-03)*D;
  A[13][23]=(0.0)*D;
  A[13][24]=(0.0)*D;
  A[13][25]=(6.3492063492063492e-03)*D;
  A[13][26]=(0.0)*D;
  A[13][27]=(0.0)*D;
  A[13][28]=(-2.3809523809523812e-03)*D;
  A[13][29]=(0.0)*D;
  A[14][0]=(0.0)*D;
  A[14][1]=(0.0)*D;
  A[14][2]=(-2.3809523809523812e-03)*D;
  A[14][3]=(0.0)*D;
  A[14][4]=(0.0)*D;
  A[14][5]=(6.3492063492063492e-03)*D;
  A[14][6]=(0.0)*D;
  A[14][7]=(0.0)*D;
  A[14][8]=(-1.5873015873015873e-03)*D;
  A[14][9]=(0.0)*D;
  A[14][10]=(0.0)*D;
  A[14][11]=(6.3492063492063492e-03)*D;
  A[14][12]=(0.0)*D;
  A[14][13]=(0.0)*D;
  A[14][14]=(1.2698412698412698e-02)*D;
  A[14][15]=(0.0)*D;
  A[14][16]=(0.0)*D;
  A[14][17]=(-1.5873015873015873e-03)*D;
  A[14][18]=(0.0)*D;
  A[14][19]=(0.0)*D;
  A[14][20]=(3.1746031746031746e-03)*D;
  A[14][21]=(0.0)*D;
  A[14][22]=(0.0)*D;
  A[14][23]=(6.3492063492063492e-03)*D;
  A[14][24]=(0.0)*D;
  A[14][25]=(0.0)*D;
  A[14][26]=(6.3492063492063492e-03)*D;
  A[14][27]=(0.0)*D;
  A[14][28]=(0.0)*D;
  A[14][29]=(-2.3809523809523812e-03)*D;
  A[15][0]=(3.9682539682539683e-04)*D;
  A[15][1]=(0.0)*D;
  A[15][2]=(0.0)*D;
  A[15][3]=(-2.3809523809523812e-03)*D;
  A[15][4]=(0.0)*D;
  A[15][5]=(0.0)*D;
  A[15][6]=(3.9682539682539683e-04)*D;
  A[15][7]=(0.0)*D;
  A[15][8]=(0.0)*D;
  A[15][9]=(-1.5873015873015873e-03)*D;
  A[15][10]=(0.0)*D;
  A[15][11]=(0.0)*D;
  A[15][12]=(-1.5873015873015873e-03)*D;
  A[15][13]=(0.0)*D;
  A[15][14]=(0.0)*D;
  A[15][15]=(2.3809523809523812e-03)*D;
  A[15][16]=(0.0)*D;
  A[15][17]=(0.0)*D;
  A[15][18]=(-2.3809523809523812e-03)*D;
  A[15][19]=(0.0)*D;
  A[15][20]=(0.0)*D;
  A[15][21]=(-2.3809523809523812e-03)*D;
  A[15][22]=(0.0)*D;
  A[15][23]=(0.0)*D;
  A[15][24]=(-1.5873015873015873e-03)*D;
  A[15][25]=(0.0)*D;
  A[15][26]=(0.0)*D;
  A[15][27]=(3.9682539682539683e-04)*D;
  A[15][28]=(0.0)*D;
  A[15][29]=(0.0)*D;
  A[16][0]=(0.0)*D;
  A[16][1]=(3.9682539682539683e-04)*D;
  A[16][2]=(0.0)*D;
  A[16][3]=(0.0)*D;
  A[16][4]=(-2.3809523809523812e-03)*D;
  A[16][5]=(0.0)*D;
  A[16][6]=(0.0)*D;
  A[16][7]=(3.9682539682539683e-04)*D;
  A[16][8]=(0.0)*D;
  A[16][9]=(0.0)*D;
  A[16][10]=(-1.5873015873015873e-03)*D;
  A[16][11]=(0.0)*D;
  A[16][12]=(0.0)*D;
  A[16][13]=(-1.5873015873015873e-03)*D;
  A[16][14]=(0.0)*D;
  A[16][15]=(0.0)*D;
  A[16][16]=(2.3809523809523812e-03)*D;
  A[16][17]=(0.0)*D;
  A[16][18]=(0.0)*D;
  A[16][19]=(-2.3809523809523812e-03)*D;
  A[16][20]=(0.0)*D;
  A[16][21]=(0.0)*D;
  A[16][22]=(-2.3809523809523812e-03)*D;
  A[16][23]=(0.0)*D;
  A[16][24]=(0.0)*D;
  A[16][25]=(-1.5873015873015873e-03)*D;
  A[16][26]=(0.0)*D;
  A[16][27]=(0.0)*D;
  A[16][28]=(3.9682539682539683e-04)*D;
  A[16][29]=(0.0)*D;
  A[17][0]=(0.0)*D;
  A[17][1]=(0.0)*D;
  A[17][2]=(3.9682539682539683e-04)*D;
  A[17][3]=(0.0)*D;
  A[17][4]=(0.0)*D;
  A[17][5]=(-2.3809523809523812e-03)*D;
  A[17][6]=(0.0)*D;
  A[17][7]=(0.0)*D;
  A[17][8]=(3.9682539682539683e-04)*D;
  A[17][9]=(0.0)*D;
  A[17][10]=(0.0)*D;
  A[17][11]=(-1.5873015873015873e-03)*D;
  A[17][12]=(0.0)*D;
  A[17][13]=(0.0)*D;
  A[17][14]=(-1.5873015873015873e-03)*D;
  A[17][15]=(0.0)*D;
  A[17][16]=(0.0)*D;
  A[17][17]=(2.3809523809523812e-03)*D;
  A[17][18]=(0.0)*D;
  A[17][19]=(0.0)*D;
  A[17][20]=(-2.3809523809523812e-03)*D;
  A[17][21]=(0.0)*D;
  A[17][22]=(0.0)*D;
  A[17][23]=(-2.3809523809523812e-03)*D;
  A[17][24]=(0.0)*D;
  A[17][25]=(0.0)*D;
  A[17][26]=(-1.5873015873015873e-03)*D;
  A[17][27]=(0.0)*D;
  A[17][28]=(0.0)*D;
  A[17][29]=(3.9682539682539683e-04)*D;
  A[18][0]=(-1.5873015873015873e-03)*D;
  A[18][1]=(0.0)*D;
  A[18][2]=(0.0)*D;
  A[18][3]=(6.3492063492063492e-03)*D;
  A[18][4]=(0.0)*D;
  A[18][5]=(0.0)*D;
  A[18][6]=(-2.3809523809523812e-03)*D;
  A[18][7]=(0.0)*D;
  A[18][8]=(0.0)*D;
  A[18][9]=(6.3492063492063492e-03)*D;
  A[18][10]=(0.0)*D;
  A[18][11]=(0.0)*D;
  A[18][12]=(3.1746031746031746e-03)*D;
  A[18][13]=(0.0)*D;
  A[18][14]=(0.0)*D;
  A[18][15]=(-2.3809523809523812e-03)*D;
  A[18][16]=(0.0)*D;
  A[18][17]=(0.0)*D;
  A[18][18]=(1.2698412698412698e-02)*D;
  A[18][19]=(0.0)*D;
  A[18][20]=(0.0)*D;
  A[18][21]=(6.3492063492063492e-03)*D;
  A[18][22]=(0.0)*D;
  A[18][23]=(0.0)*D;
  A[18][24]=(6.3492063492063492e-03)*D;
  A[18][25]=(0.0)*D;
  A[18][26]=(0.0)*D;
  A[18][27]=(-1.5873015873015873e-03)*D;
  A[18][28]=(0.0)*D;
  A[18][29]=(0.0)*D;
  A[19][0]=(0.0)*D;
  A[19][1]=(-1.5873015873015873e-03)*D;
  A[19][2]=(0.0)*D;
  A[19][3]=(0.0)*D;
  A[19][4]=(6.3492063492063492e-03)*D;
  A[19][5]=(0.0)*D;
  A[19][6]=(0.0)*D;
  A[19][7]=(-2.3809523809523812e-03)*D;
  A[19][8]=(0.0)*D;
  A[19][9]=(0.0)*D;
  A[19][10]=(6.3492063492063492e-03)*D;
  A[19][11]=(0.0)*D;
  A[19][12]=(0.0)*D;
  A[19][13]=(3.1746031746031746e-03)*D;
  A[19][14]=(0.0)*D;
  A[19][15]=(0.0)*D;
  A[19][16]=(-2.3809523809523812e-03)*D;
  A[19][17]=(0.0)*D;
  A[19][18]=(0.0)*D;
  A[19][19]=(1.2698412698412698e-02)*D;
  A[19][20]=(0.0)*D;
  A[19][21]=(0.0)*D;
  A[19][22]=(6.3492063492063492e-03)*D;
  A[19][23]=(0.0)*D;
  A[19][24]=(0.0)*D;
  A[19][25]=(6.3492063492063492e-03)*D;
  A[19][26]=(0.0)*D;
  A[19][27]=(0.0)*D;
  A[19][28]=(-1.5873015873015873e-03)*D;
  A[19][29]=(0.0)*D;
  A[20][0]=(0.0)*D;
  A[20][1]=(0.0)*D;
  A[20][2]=(-1.5873015873015873e-03)*D;
  A[20][3]=(0.0)*D;
  A[20][4]=(0.0)*D;
  A[20][5]=(6.3492063492063492e-03)*D;
  A[20][6]=(0.0)*D;
  A[20][7]=(0.0)*D;
  A[20][8]=(-2.3809523809523812e-03)*D;
  A[20][9]=(0.0)*D;
  A[20][10]=(0.0)*D;
  A[20][11]=(6.3492063492063492e-03)*D;
  A[20][12]=(0.0)*D;
  A[20][13]=(0.0)*D;
  A[20][14]=(3.1746031746031746e-03)*D;
  A[20][15]=(0.0)*D;
  A[20][16]=(0.0)*D;
  A[20][17]=(-2.3809523809523812e-03)*D;
  A[20][18]=(0.0)*D;
  A[20][19]=(0.0)*D;
  A[20][20]=(1.2698412698412698e-02)*D;
  A[20][21]=(0.0)*D;
  A[20][22]=(0.0)*D;
  A[20][23]=(6.3492063492063492e-03)*D;
  A[20][24]=(0.0)*D;
  A[20][25]=(0.0)*D;
  A[20][26]=(6.3492063492063492e-03)*D;
  A[20][27]=(0.0)*D;
  A[20][28]=(0.0)*D;
  A[20][29]=(-1.5873015873015873e-03)*D;
  A[21][0]=(-2.3809523809523812e-03)*D;
  A[21][1]=(0.0)*D;
  A[21][2]=(0.0)*D;
  A[21][3]=(6.3492063492063492e-03)*D;
  A[21][4]=(0.0)*D;
  A[21][5]=(0.0)*D;
  A[21][6]=(-1.5873015873015873e-03)*D;
  A[21][7]=(0.0)*D;
  A[21][8]=(0.0)*D;
  A[21][9]=(3.1746031746031746e-03)*D;
  A[21][10]=(0.0)*D;
  A[21][11]=(0.0)*D;
  A[21][12]=(6.3492063492063492e-03)*D;
  A[21][13]=(0.0)*D;
  A[21][14]=(0.0)*D;
  A[21][15]=(-2.3809523809523812e-03)*D;
  A[21][16]=(0.0)*D;
  A[21][17]=(0.0)*D;
  A[21][18]=(6.3492063492063492e-03)*D;
  A[21][19]=(0.0)*D;
  A[21][20]=(0.0)*D;
  A[21][21]=(1.2698412698412698e-02)*D;
  A[21][22]=(0.0)*D;
  A[21][23]=(0.0)*D;
  A[21][24]=(6.3492063492063492e-03)*D;
  A[21][25]=(0.0)*D;
  A[21][26]=(0.0)*D;
  A[21][27]=(-1.5873015873015873e-03)*D;
  A[21][28]=(0.0)*D;
  A[21][29]=(0.0)*D;
  A[22][0]=(0.0)*D;
  A[22][1]=(-2.3809523809523812e-03)*D;
  A[22][2]=(0.0)*D;
  A[22][3]=(0.0)*D;
  A[22][4]=(6.3492063492063492e-03)*D;
  A[22][5]=(0.0)*D;
  A[22][6]=(0.0)*D;
  A[22][7]=(-1.5873015873015873e-03)*D;
  A[22][8]=(0.0)*D;
  A[22][9]=(0.0)*D;
  A[22][10]=(3.1746031746031746e-03)*D;
  A[22][11]=(0.0)*D;
  A[22][12]=(0.0)*D;
  A[22][13]=(6.3492063492063492e-03)*D;
  A[22][14]=(0.0)*D;
  A[22][15]=(0.0)*D;
  A[22][16]=(-2.3809523809523812e-03)*D;
  A[22][17]=(0.0)*D;
  A[22][18]=(0.0)*D;
  A[22][19]=(6.3492063492063492e-03)*D;
  A[22][20]=(0.0)*D;
  A[22][21]=(0.0)*D;
  A[22][22]=(1.2698412698412698e-02)*D;
  A[22][23]=(0.0)*D;
  A[22][24]=(0.0)*D;
  A[22][25]=(6.3492063492063492e-03)*D;
  A[22][26]=(0.0)*D;
  A[22][27]=(0.0)*D;
  A[22][28]=(-1.5873015873015873e-03)*D;
  A[22][29]=(0.0)*D;
  A[23][0]=(0.0)*D;
  A[23][1]=(0.0)*D;
  A[23][2]=(-2.3809523809523812e-03)*D;
  A[23][3]=(0.0)*D;
  A[23][4]=(0.0)*D;
  A[23][5]=(6.3492063492063492e-03)*D;
  A[23][6]=(0.0)*D;
  A[23][7]=(0.0)*D;
  A[23][8]=(-1.5873015873015873e-03)*D;
  A[23][9]=(0.0)*D;
  A[23][10]=(0.0)*D;
  A[23][11]=(3.1746031746031746e-03)*D;
  A[23][12]=(0.0)*D;
  A[23][13]=(0.0)*D;
  A[23][14]=(6.3492063492063492e-03)*D;
  A[23][15]=(0.0)*D;
  A[23][16]=(0.0)*D;
  A[23][17]=(-2.3809523809523812e-03)*D;
  A[23][18]=(0.0)*D;
  A[23][19]=(0.0)*D;
  A[23][20]=(6.3492063492063492e-03)*D;
  A[23][21]=(0.0)*D;
  A[23][22]=(0.0)*D;
  A[23][23]=(1.2698412698412698e-02)*D;
  A[23][24]=(0.0)*D;
  A[23][25]=(0.0)*D;
  A[23][26]=(6.3492063492063492e-03)*D;
  A[23][27]=(0.0)*D;
  A[23][28]=(0.0)*D;
  A[23][29]=(-1.5873015873015873e-03)*D;
  A[24][0]=(-2.3809523809523812e-03)*D;
  A[24][1]=(0.0)*D;
  A[24][2]=(0.0)*D;
  A[24][3]=(3.1746031746031746e-03)*D;
  A[24][4]=(0.0)*D;
  A[24][5]=(0.0)*D;
  A[24][6]=(-2.3809523809523812e-03)*D;
  A[24][7]=(0.0)*D;
  A[24][8]=(0.0)*D;
  A[24][9]=(6.3492063492063492e-03)*D;
  A[24][10]=(0.0)*D;
  A[24][11]=(0.0)*D;
  A[24][12]=(6.3492063492063492e-03)*D;
  A[24][13]=(0.0)*D;
  A[24][14]=(0.0)*D;
  A[24][15]=(-1.5873015873015873e-03)*D;
  A[24][16]=(0.0)*D;
  A[24][17]=(0.0)*D;
  A[24][18]=(6.3492063492063492e-03)*D;
  A[24][19]=(0.0)*D;
  A[24][20]=(0.0)*D;
  A[24][21]=(6.3492063492063492e-03)*D;
  A[24][22]=(0.0)*D;
  A[24][23]=(0.0)*D;
  A[24][24]=(1.2698412698412698e-02)*D;
  A[24][25]=(0.0)*D;
  A[24][26]=(0.0)*D;
  A[24][27]=(-1.5873015873015873e-03)*D;
  A[24][28]=(0.0)*D;
  A[24][29]=(0.0)*D;
  A[25][0]=(0.0)*D;
  A[25][1]=(-2.3809523809523812e-03)*D;
  A[25][2]=(0.0)*D;
  A[25][3]=(0.0)*D;
  A[25][4]=(3.1746031746031746e-03)*D;
  A[25][5]=(0.0)*D;
  A[25][6]=(0.0)*D;
  A[25][7]=(-2.3809523809523812e-03)*D;
  A[25][8]=(0.0)*D;
  A[25][9]=(0.0)*D;
  A[25][10]=(6.3492063492063492e-03)*D;
  A[25][11]=(0.0)*D;
  A[25][12]=(0.0)*D;
  A[25][13]=(6.3492063492063492e-03)*D;
  A[25][14]=(0.0)*D;
  A[25][15]=(0.0)*D;
  A[25][16]=(-1.5873015873015873e-03)*D;
  A[25][17]=(0.0)*D;
  A[25][18]=(0.0)*D;
  A[25][19]=(6.3492063492063492e-03)*D;
  A[25][20]=(0.0)*D;
  A[25][21]=(0.0)*D;
  A[25][22]=(6.3492063492063492e-03)*D;
  A[25][23]=(0.0)*D;
  A[25][24]=(0.0)*D;
  A[25][25]=(1.2698412698412698e-02)*D;
  A[25][26]=(0.0)*D;
  A[25][27]=(0.0)*D;
  A[25][28]=(-1.5873015873015873e-03)*D;
  A[25][29]=(0.0)*D;
  A[26][0]=(0.0)*D;
  A[26][1]=(0.0)*D;
  A[26][2]=(-2.3809523809523812e-03)*D;
  A[26][3]=(0.0)*D;
  A[26][4]=(0.0)*D;
  A[26][5]=(3.1746031746031746e-03)*D;
  A[26][6]=(0.0)*D;
  A[26][7]=(0.0)*D;
  A[26][8]=(-2.3809523809523812e-03)*D;
  A[26][9]=(0.0)*D;
  A[26][10]=(0.0)*D;
  A[26][11]=(6.3492063492063492e-03)*D;
  A[26][12]=(0.0)*D;
  A[26][13]=(0.0)*D;
  A[26][14]=(6.3492063492063492e-03)*D;
  A[26][15]=(0.0)*D;
  A[26][16]=(0.0)*D;
  A[26][17]=(-1.5873015873015873e-03)*D;
  A[26][18]=(0.0)*D;
  A[26][19]=(0.0)*D;
  A[26][20]=(6.3492063492063492e-03)*D;
  A[26][21]=(0.0)*D;
  A[26][22]=(0.0)*D;
  A[26][23]=(6.3492063492063492e-03)*D;
  A[26][24]=(0.0)*D;
  A[26][25]=(0.0)*D;
  A[26][26]=(1.2698412698412698e-02)*D;
  A[26][27]=(0.0)*D;
  A[26][28]=(0.0)*D;
  A[26][29]=(-1.5873015873015873e-03)*D;
  A[27][0]=(3.9682539682539683e-04)*D;
  A[27][1]=(0.0)*D;
  A[27][2]=(0.0)*D;
  A[27][3]=(-2.3809523809523812e-03)*D;
  A[27][4]=(0.0)*D;
  A[27][5]=(0.0)*D;
  A[27][6]=(3.9682539682539683e-04)*D;
  A[27][7]=(0.0)*D;
  A[27][8]=(0.0)*D;
  A[27][9]=(-2.3809523809523812e-03)*D;
  A[27][10]=(0.0)*D;
  A[27][11]=(0.0)*D;
  A[27][12]=(-2.3809523809523812e-03)*D;
  A[27][13]=(0.0)*D;
  A[27][14]=(0.0)*D;
  A[27][15]=(3.9682539682539683e-04)*D;
  A[27][16]=(0.0)*D;
  A[27][17]=(0.0)*D;
  A[27][18]=(-1.5873015873015873e-03)*D;
  A[27][19]=(0.0)*D;
  A[27][20]=(0.0)*D;
  A[27][21]=(-1.5873015873015873e-03)*D;
  A[27][22]=(0.0)*D;
  A[27][23]=(0.0)*D;
  A[27][24]=(-1.5873015873015873e-03)*D;
  A[27][25]=(0.0)*D;
  A[27][26]=(0.0)*D;
  A[27][27]=(2.3809523809523812e-03)*D;
  A[27][28]=(0.0)*D;
  A[27][29]=(0.0)*D;
  A[28][0]=(0.0)*D;
  A[28][1]=(3.9682539682539683e-04)*D;
  A[28][2]=(0.0)*D;
  A[28][3]=(0.0)*D;
  A[28][4]=(-2.3809523809523812e-03)*D;
  A[28][5]=(0.0)*D;
  A[28][6]=(0.0)*D;
  A[28][7]=(3.9682539682539683e-04)*D;
  A[28][8]=(0.0)*D;
  A[28][9]=(0.0)*D;
  A[28][10]=(-2.3809523809523812e-03)*D;
  A[28][11]=(0.0)*D;
  A[28][12]=(0.0)*D;
  A[28][13]=(-2.3809523809523812e-03)*D;
  A[28][14]=(0.0)*D;
  A[28][15]=(0.0)*D;
  A[28][16]=(3.9682539682539683e-04)*D;
  A[28][17]=(0.0)*D;
  A[28][18]=(0.0)*D;
  A[28][19]=(-1.5873015873015873e-03)*D;
  A[28][20]=(0.0)*D;
  A[28][21]=(0.0)*D;
  A[28][22]=(-1.5873015873015873e-03)*D;
  A[28][23]=(0.0)*D;
  A[28][24]=(0.0)*D;
  A[28][25]=(-1.5873015873015873e-03)*D;
  A[28][26]=(0.0)*D;
  A[28][27]=(0.0)*D;
  A[28][28]=(2.3809523809523812e-03)*D;
  A[28][29]=(0.0)*D;
  A[29][0]=(0.0)*D;
  A[29][1]=(0.0)*D;
  A[29][2]=(3.9682539682539683e-04)*D;
  A[29][3]=(0.0)*D;
  A[29][4]=(0.0)*D;
  A[29][5]=(-2.3809523809523812e-03)*D;
  A[29][6]=(0.0)*D;
  A[29][7]=(0.0)*D;
  A[29][8]=(3.9682539682539683e-04)*D;
  A[29][9]=(0.0)*D;
  A[29][10]=(0.0)*D;
  A[29][11]=(-2.3809523809523812e-03)*D;
  A[29][12]=(0.0)*D;
  A[29][13]=(0.0)*D;
  A[29][14]=(-2.3809523809523812e-03)*D;
  A[29][15]=(0.0)*D;
  A[29][16]=(0.0)*D;
  A[29][17]=(3.9682539682539683e-04)*D;
  A[29][18]=(0.0)*D;
  A[29][19]=(0.0)*D;
  A[29][20]=(-1.5873015873015873e-03)*D;
  A[29][21]=(0.0)*D;
  A[29][22]=(0.0)*D;
  A[29][23]=(-1.5873015873015873e-03)*D;
  A[29][24]=(0.0)*D;
  A[29][25]=(0.0)*D;
  A[29][26]=(-1.5873015873015873e-03)*D;
  A[29][27]=(0.0)*D;
  A[29][28]=(0.0)*D;
  A[29][29]=(2.3809523809523812e-03)*D;
  int nbf = 30;  

  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = iidof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = iidof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}


/* ------------- order 3 ---------------*/


  
void matrix_factory_vector_mass_3D_order3 (map<pair<int,int>,double>& matrix, 
         DofT<ptv,ptv_is_less>& dof, 
         int element, double pp0[3], double pp1[3], double pp2[3], double pp3[3]){
  
   //variables

  double x0 = pp0[0]; double y0 = pp0[1]; double z0 = pp0[2];  
  double x1 = pp1[0]; double y1 = pp1[1]; double z1 = pp1[2];  
  double x2 = pp2[0]; double y2 = pp2[1]; double z2 = pp2[2];  
  double x3 = pp3[0]; double y3 = pp3[1]; double z3 = pp3[2];  

  double G00 = x1 - x0; 
  double G10 = y1 - y0;  
  double G20 = z1 - z0;  

  double G01 = x2 - x0; 
  double G11 = y2 - y0; 
  double G21 = z2 - z0; 

  double G02 = x3 - x0; 
  double G12 = y3 - y0; 
  double G22 = z3 - z0; 
 
  double D =  G00*(G11*G22-G21*G12) 
            - G01*(G10*G22-G20*G12) 
            + G02*(G10*G21-G20*G11);

 

 
  int    iidof[60];
  double idof0[4];
  idof0[0]=x0;  idof0[1]=y0;  idof0[2]=z0;
  idof0[3] = 0.0;
  ptv ipdof0(4,idof0);
  iidof[0] = dof.insert_dof(element,0,ipdof0);

  double idof1[4];
  idof1[0]=x0;  idof1[1]=y0;  idof1[2]=z0;
  idof1[3] = 1.0;
  ptv ipdof1(4,idof1);
  iidof[1] = dof.insert_dof(element,1,ipdof1);

  double idof2[4];
  idof2[0]=x0;  idof2[1]=y0;  idof2[2]=z0;
  idof2[3] = 2.0;
  ptv ipdof2(4,idof2);
  iidof[2] = dof.insert_dof(element,2,ipdof2);

  double idof3[4];
  idof3[0]=G00/3.0+x0;  idof3[1]=y0+G10/3.0;  idof3[2]=z0+G20/3.0;
  idof3[3] = 0.0;
  ptv ipdof3(4,idof3);
  iidof[3] = dof.insert_dof(element,3,ipdof3);

  double idof4[4];
  idof4[0]=G00/3.0+x0;  idof4[1]=y0+G10/3.0;  idof4[2]=z0+G20/3.0;
  idof4[3] = 1.0;
  ptv ipdof4(4,idof4);
  iidof[4] = dof.insert_dof(element,4,ipdof4);

  double idof5[4];
  idof5[0]=G00/3.0+x0;  idof5[1]=y0+G10/3.0;  idof5[2]=z0+G20/3.0;
  idof5[3] = 2.0;
  ptv ipdof5(4,idof5);
  iidof[5] = dof.insert_dof(element,5,ipdof5);

  double idof6[4];
  idof6[0]=(2.0/3.0)*G00+x0;  idof6[1]=y0+(2.0/3.0)*G10;  idof6[2]=z0+(2.0/3.0)*G20;
  idof6[3] = 0.0;
  ptv ipdof6(4,idof6);
  iidof[6] = dof.insert_dof(element,6,ipdof6);

  double idof7[4];
  idof7[0]=(2.0/3.0)*G00+x0;  idof7[1]=y0+(2.0/3.0)*G10;  idof7[2]=z0+(2.0/3.0)*G20;
  idof7[3] = 1.0;
  ptv ipdof7(4,idof7);
  iidof[7] = dof.insert_dof(element,7,ipdof7);

  double idof8[4];
  idof8[0]=(2.0/3.0)*G00+x0;  idof8[1]=y0+(2.0/3.0)*G10;  idof8[2]=z0+(2.0/3.0)*G20;
  idof8[3] = 2.0;
  ptv ipdof8(4,idof8);
  iidof[8] = dof.insert_dof(element,8,ipdof8);

  double idof9[4];
  idof9[0]=G00+x0;  idof9[1]=y0+G10;  idof9[2]=z0+G20;
  idof9[3] = 0.0;
  ptv ipdof9(4,idof9);
  iidof[9] = dof.insert_dof(element,9,ipdof9);

  double idof10[4];
  idof10[0]=G00+x0;  idof10[1]=y0+G10;  idof10[2]=z0+G20;
  idof10[3] = 1.0;
  ptv ipdof10(4,idof10);
  iidof[10] = dof.insert_dof(element,10,ipdof10);

  double idof11[4];
  idof11[0]=G00+x0;  idof11[1]=y0+G10;  idof11[2]=z0+G20;
  idof11[3] = 2.0;
  ptv ipdof11(4,idof11);
  iidof[11] = dof.insert_dof(element,11,ipdof11);

  double idof12[4];
  idof12[0]=G01/3.0+x0;  idof12[1]=y0+G11/3.0;  idof12[2]=G21/3.0+z0;
  idof12[3] = 0.0;
  ptv ipdof12(4,idof12);
  iidof[12] = dof.insert_dof(element,12,ipdof12);

  double idof13[4];
  idof13[0]=G01/3.0+x0;  idof13[1]=y0+G11/3.0;  idof13[2]=G21/3.0+z0;
  idof13[3] = 1.0;
  ptv ipdof13(4,idof13);
  iidof[13] = dof.insert_dof(element,13,ipdof13);

  double idof14[4];
  idof14[0]=G01/3.0+x0;  idof14[1]=y0+G11/3.0;  idof14[2]=G21/3.0+z0;
  idof14[3] = 2.0;
  ptv ipdof14(4,idof14);
  iidof[14] = dof.insert_dof(element,14,ipdof14);

  double idof15[4];
  idof15[0]=G01/3.0+G00/3.0+x0;  idof15[1]=y0+G11/3.0+G10/3.0;  idof15[2]=G21/3.0+z0+G20/3.0;
  idof15[3] = 0.0;
  ptv ipdof15(4,idof15);
  iidof[15] = dof.insert_dof(element,15,ipdof15);

  double idof16[4];
  idof16[0]=G01/3.0+G00/3.0+x0;  idof16[1]=y0+G11/3.0+G10/3.0;  idof16[2]=G21/3.0+z0+G20/3.0;
  idof16[3] = 1.0;
  ptv ipdof16(4,idof16);
  iidof[16] = dof.insert_dof(element,16,ipdof16);

  double idof17[4];
  idof17[0]=G01/3.0+G00/3.0+x0;  idof17[1]=y0+G11/3.0+G10/3.0;  idof17[2]=G21/3.0+z0+G20/3.0;
  idof17[3] = 2.0;
  ptv ipdof17(4,idof17);
  iidof[17] = dof.insert_dof(element,17,ipdof17);

  double idof18[4];
  idof18[0]=G01/3.0+(2.0/3.0)*G00+x0;  idof18[1]=y0+G11/3.0+(2.0/3.0)*G10;  idof18[2]=G21/3.0+z0+(2.0/3.0)*G20;
  idof18[3] = 0.0;
  ptv ipdof18(4,idof18);
  iidof[18] = dof.insert_dof(element,18,ipdof18);

  double idof19[4];
  idof19[0]=G01/3.0+(2.0/3.0)*G00+x0;  idof19[1]=y0+G11/3.0+(2.0/3.0)*G10;  idof19[2]=G21/3.0+z0+(2.0/3.0)*G20;
  idof19[3] = 1.0;
  ptv ipdof19(4,idof19);
  iidof[19] = dof.insert_dof(element,19,ipdof19);

  double idof20[4];
  idof20[0]=G01/3.0+(2.0/3.0)*G00+x0;  idof20[1]=y0+G11/3.0+(2.0/3.0)*G10;  idof20[2]=G21/3.0+z0+(2.0/3.0)*G20;
  idof20[3] = 2.0;
  ptv ipdof20(4,idof20);
  iidof[20] = dof.insert_dof(element,20,ipdof20);

  double idof21[4];
  idof21[0]=(2.0/3.0)*G01+x0;  idof21[1]=y0+(2.0/3.0)*G11;  idof21[2]=(2.0/3.0)*G21+z0;
  idof21[3] = 0.0;
  ptv ipdof21(4,idof21);
  iidof[21] = dof.insert_dof(element,21,ipdof21);

  double idof22[4];
  idof22[0]=(2.0/3.0)*G01+x0;  idof22[1]=y0+(2.0/3.0)*G11;  idof22[2]=(2.0/3.0)*G21+z0;
  idof22[3] = 1.0;
  ptv ipdof22(4,idof22);
  iidof[22] = dof.insert_dof(element,22,ipdof22);

  double idof23[4];
  idof23[0]=(2.0/3.0)*G01+x0;  idof23[1]=y0+(2.0/3.0)*G11;  idof23[2]=(2.0/3.0)*G21+z0;
  idof23[3] = 2.0;
  ptv ipdof23(4,idof23);
  iidof[23] = dof.insert_dof(element,23,ipdof23);

  double idof24[4];
  idof24[0]=(2.0/3.0)*G01+G00/3.0+x0;  idof24[1]=y0+(2.0/3.0)*G11+G10/3.0;  idof24[2]=(2.0/3.0)*G21+z0+G20/3.0;
  idof24[3] = 0.0;
  ptv ipdof24(4,idof24);
  iidof[24] = dof.insert_dof(element,24,ipdof24);

  double idof25[4];
  idof25[0]=(2.0/3.0)*G01+G00/3.0+x0;  idof25[1]=y0+(2.0/3.0)*G11+G10/3.0;  idof25[2]=(2.0/3.0)*G21+z0+G20/3.0;
  idof25[3] = 1.0;
  ptv ipdof25(4,idof25);
  iidof[25] = dof.insert_dof(element,25,ipdof25);

  double idof26[4];
  idof26[0]=(2.0/3.0)*G01+G00/3.0+x0;  idof26[1]=y0+(2.0/3.0)*G11+G10/3.0;  idof26[2]=(2.0/3.0)*G21+z0+G20/3.0;
  idof26[3] = 2.0;
  ptv ipdof26(4,idof26);
  iidof[26] = dof.insert_dof(element,26,ipdof26);

  double idof27[4];
  idof27[0]=G01+x0;  idof27[1]=y0+G11;  idof27[2]=G21+z0;
  idof27[3] = 0.0;
  ptv ipdof27(4,idof27);
  iidof[27] = dof.insert_dof(element,27,ipdof27);

  double idof28[4];
  idof28[0]=G01+x0;  idof28[1]=y0+G11;  idof28[2]=G21+z0;
  idof28[3] = 1.0;
  ptv ipdof28(4,idof28);
  iidof[28] = dof.insert_dof(element,28,ipdof28);

  double idof29[4];
  idof29[0]=G01+x0;  idof29[1]=y0+G11;  idof29[2]=G21+z0;
  idof29[3] = 2.0;
  ptv ipdof29(4,idof29);
  iidof[29] = dof.insert_dof(element,29,ipdof29);

  double idof30[4];
  idof30[0]=G02/3.0+x0;  idof30[1]=G12/3.0+y0;  idof30[2]=G22/3.0+z0;
  idof30[3] = 0.0;
  ptv ipdof30(4,idof30);
  iidof[30] = dof.insert_dof(element,30,ipdof30);

  double idof31[4];
  idof31[0]=G02/3.0+x0;  idof31[1]=G12/3.0+y0;  idof31[2]=G22/3.0+z0;
  idof31[3] = 1.0;
  ptv ipdof31(4,idof31);
  iidof[31] = dof.insert_dof(element,31,ipdof31);

  double idof32[4];
  idof32[0]=G02/3.0+x0;  idof32[1]=G12/3.0+y0;  idof32[2]=G22/3.0+z0;
  idof32[3] = 2.0;
  ptv ipdof32(4,idof32);
  iidof[32] = dof.insert_dof(element,32,ipdof32);

  double idof33[4];
  idof33[0]=G02/3.0+G00/3.0+x0;  idof33[1]=G12/3.0+y0+G10/3.0;  idof33[2]=G22/3.0+z0+G20/3.0;
  idof33[3] = 0.0;
  ptv ipdof33(4,idof33);
  iidof[33] = dof.insert_dof(element,33,ipdof33);

  double idof34[4];
  idof34[0]=G02/3.0+G00/3.0+x0;  idof34[1]=G12/3.0+y0+G10/3.0;  idof34[2]=G22/3.0+z0+G20/3.0;
  idof34[3] = 1.0;
  ptv ipdof34(4,idof34);
  iidof[34] = dof.insert_dof(element,34,ipdof34);

  double idof35[4];
  idof35[0]=G02/3.0+G00/3.0+x0;  idof35[1]=G12/3.0+y0+G10/3.0;  idof35[2]=G22/3.0+z0+G20/3.0;
  idof35[3] = 2.0;
  ptv ipdof35(4,idof35);
  iidof[35] = dof.insert_dof(element,35,ipdof35);

  double idof36[4];
  idof36[0]=G02/3.0+(2.0/3.0)*G00+x0;  idof36[1]=G12/3.0+y0+(2.0/3.0)*G10;  idof36[2]=G22/3.0+z0+(2.0/3.0)*G20;
  idof36[3] = 0.0;
  ptv ipdof36(4,idof36);
  iidof[36] = dof.insert_dof(element,36,ipdof36);

  double idof37[4];
  idof37[0]=G02/3.0+(2.0/3.0)*G00+x0;  idof37[1]=G12/3.0+y0+(2.0/3.0)*G10;  idof37[2]=G22/3.0+z0+(2.0/3.0)*G20;
  idof37[3] = 1.0;
  ptv ipdof37(4,idof37);
  iidof[37] = dof.insert_dof(element,37,ipdof37);

  double idof38[4];
  idof38[0]=G02/3.0+(2.0/3.0)*G00+x0;  idof38[1]=G12/3.0+y0+(2.0/3.0)*G10;  idof38[2]=G22/3.0+z0+(2.0/3.0)*G20;
  idof38[3] = 2.0;
  ptv ipdof38(4,idof38);
  iidof[38] = dof.insert_dof(element,38,ipdof38);

  double idof39[4];
  idof39[0]=G02/3.0+G01/3.0+x0;  idof39[1]=G12/3.0+y0+G11/3.0;  idof39[2]=G22/3.0+G21/3.0+z0;
  idof39[3] = 0.0;
  ptv ipdof39(4,idof39);
  iidof[39] = dof.insert_dof(element,39,ipdof39);

  double idof40[4];
  idof40[0]=G02/3.0+G01/3.0+x0;  idof40[1]=G12/3.0+y0+G11/3.0;  idof40[2]=G22/3.0+G21/3.0+z0;
  idof40[3] = 1.0;
  ptv ipdof40(4,idof40);
  iidof[40] = dof.insert_dof(element,40,ipdof40);

  double idof41[4];
  idof41[0]=G02/3.0+G01/3.0+x0;  idof41[1]=G12/3.0+y0+G11/3.0;  idof41[2]=G22/3.0+G21/3.0+z0;
  idof41[3] = 2.0;
  ptv ipdof41(4,idof41);
  iidof[41] = dof.insert_dof(element,41,ipdof41);

  double idof42[4];
  idof42[0]=G02/3.0+G01/3.0+G00/3.0+x0;  idof42[1]=G12/3.0+y0+G11/3.0+G10/3.0;  idof42[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  idof42[3] = 0.0;
  ptv ipdof42(4,idof42);
  iidof[42] = dof.insert_dof(element,42,ipdof42);

  double idof43[4];
  idof43[0]=G02/3.0+G01/3.0+G00/3.0+x0;  idof43[1]=G12/3.0+y0+G11/3.0+G10/3.0;  idof43[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  idof43[3] = 1.0;
  ptv ipdof43(4,idof43);
  iidof[43] = dof.insert_dof(element,43,ipdof43);

  double idof44[4];
  idof44[0]=G02/3.0+G01/3.0+G00/3.0+x0;  idof44[1]=G12/3.0+y0+G11/3.0+G10/3.0;  idof44[2]=G22/3.0+G21/3.0+z0+G20/3.0;
  idof44[3] = 2.0;
  ptv ipdof44(4,idof44);
  iidof[44] = dof.insert_dof(element,44,ipdof44);

  double idof45[4];
  idof45[0]=G02/3.0+(2.0/3.0)*G01+x0;  idof45[1]=G12/3.0+y0+(2.0/3.0)*G11;  idof45[2]=G22/3.0+(2.0/3.0)*G21+z0;
  idof45[3] = 0.0;
  ptv ipdof45(4,idof45);
  iidof[45] = dof.insert_dof(element,45,ipdof45);

  double idof46[4];
  idof46[0]=G02/3.0+(2.0/3.0)*G01+x0;  idof46[1]=G12/3.0+y0+(2.0/3.0)*G11;  idof46[2]=G22/3.0+(2.0/3.0)*G21+z0;
  idof46[3] = 1.0;
  ptv ipdof46(4,idof46);
  iidof[46] = dof.insert_dof(element,46,ipdof46);

  double idof47[4];
  idof47[0]=G02/3.0+(2.0/3.0)*G01+x0;  idof47[1]=G12/3.0+y0+(2.0/3.0)*G11;  idof47[2]=G22/3.0+(2.0/3.0)*G21+z0;
  idof47[3] = 2.0;
  ptv ipdof47(4,idof47);
  iidof[47] = dof.insert_dof(element,47,ipdof47);

  double idof48[4];
  idof48[0]=(2.0/3.0)*G02+x0;  idof48[1]=(2.0/3.0)*G12+y0;  idof48[2]=(2.0/3.0)*G22+z0;
  idof48[3] = 0.0;
  ptv ipdof48(4,idof48);
  iidof[48] = dof.insert_dof(element,48,ipdof48);

  double idof49[4];
  idof49[0]=(2.0/3.0)*G02+x0;  idof49[1]=(2.0/3.0)*G12+y0;  idof49[2]=(2.0/3.0)*G22+z0;
  idof49[3] = 1.0;
  ptv ipdof49(4,idof49);
  iidof[49] = dof.insert_dof(element,49,ipdof49);

  double idof50[4];
  idof50[0]=(2.0/3.0)*G02+x0;  idof50[1]=(2.0/3.0)*G12+y0;  idof50[2]=(2.0/3.0)*G22+z0;
  idof50[3] = 2.0;
  ptv ipdof50(4,idof50);
  iidof[50] = dof.insert_dof(element,50,ipdof50);

  double idof51[4];
  idof51[0]=(2.0/3.0)*G02+G00/3.0+x0;  idof51[1]=(2.0/3.0)*G12+y0+G10/3.0;  idof51[2]=(2.0/3.0)*G22+z0+G20/3.0;
  idof51[3] = 0.0;
  ptv ipdof51(4,idof51);
  iidof[51] = dof.insert_dof(element,51,ipdof51);

  double idof52[4];
  idof52[0]=(2.0/3.0)*G02+G00/3.0+x0;  idof52[1]=(2.0/3.0)*G12+y0+G10/3.0;  idof52[2]=(2.0/3.0)*G22+z0+G20/3.0;
  idof52[3] = 1.0;
  ptv ipdof52(4,idof52);
  iidof[52] = dof.insert_dof(element,52,ipdof52);

  double idof53[4];
  idof53[0]=(2.0/3.0)*G02+G00/3.0+x0;  idof53[1]=(2.0/3.0)*G12+y0+G10/3.0;  idof53[2]=(2.0/3.0)*G22+z0+G20/3.0;
  idof53[3] = 2.0;
  ptv ipdof53(4,idof53);
  iidof[53] = dof.insert_dof(element,53,ipdof53);

  double idof54[4];
  idof54[0]=(2.0/3.0)*G02+G01/3.0+x0;  idof54[1]=(2.0/3.0)*G12+y0+G11/3.0;  idof54[2]=(2.0/3.0)*G22+G21/3.0+z0;
  idof54[3] = 0.0;
  ptv ipdof54(4,idof54);
  iidof[54] = dof.insert_dof(element,54,ipdof54);

  double idof55[4];
  idof55[0]=(2.0/3.0)*G02+G01/3.0+x0;  idof55[1]=(2.0/3.0)*G12+y0+G11/3.0;  idof55[2]=(2.0/3.0)*G22+G21/3.0+z0;
  idof55[3] = 1.0;
  ptv ipdof55(4,idof55);
  iidof[55] = dof.insert_dof(element,55,ipdof55);

  double idof56[4];
  idof56[0]=(2.0/3.0)*G02+G01/3.0+x0;  idof56[1]=(2.0/3.0)*G12+y0+G11/3.0;  idof56[2]=(2.0/3.0)*G22+G21/3.0+z0;
  idof56[3] = 2.0;
  ptv ipdof56(4,idof56);
  iidof[56] = dof.insert_dof(element,56,ipdof56);

  double idof57[4];
  idof57[0]=G02+x0;  idof57[1]=G12+y0;  idof57[2]=G22+z0;
  idof57[3] = 0.0;
  ptv ipdof57(4,idof57);
  iidof[57] = dof.insert_dof(element,57,ipdof57);

  double idof58[4];
  idof58[0]=G02+x0;  idof58[1]=G12+y0;  idof58[2]=G22+z0;
  idof58[3] = 1.0;
  ptv ipdof58(4,idof58);
  iidof[58] = dof.insert_dof(element,58,ipdof58);

  double idof59[4];
  idof59[0]=G02+x0;  idof59[1]=G12+y0;  idof59[2]=G22+z0;
  idof59[3] = 2.0;
  ptv ipdof59(4,idof59);
  iidof[59] = dof.insert_dof(element,59,ipdof59);

 
  double A[60][60];
  A[0][0]=(5.9523809523809529e-04)*D;
  A[0][1]=(0.0)*D;
  A[0][2]=(0.0)*D;
  A[0][3]=(-4.4642857142857141e-04)*D;
  A[0][4]=(0.0)*D;
  A[0][5]=(0.0)*D;
  A[0][6]=(2.2321428571428571e-04)*D;
  A[0][7]=(0.0)*D;
  A[0][8]=(0.0)*D;
  A[0][9]=(7.4404761904761911e-05)*D;
  A[0][10]=(0.0)*D;
  A[0][11]=(0.0)*D;
  A[0][12]=(-4.4642857142857141e-04)*D;
  A[0][13]=(0.0)*D;
  A[0][14]=(0.0)*D;
  A[0][15]=(6.6964285714285715e-04)*D;
  A[0][16]=(0.0)*D;
  A[0][17]=(0.0)*D;
  A[0][18]=(1.1160714285714285e-04)*D;
  A[0][19]=(0.0)*D;
  A[0][20]=(0.0)*D;
  A[0][21]=(2.2321428571428571e-04)*D;
  A[0][22]=(0.0)*D;
  A[0][23]=(0.0)*D;
  A[0][24]=(1.1160714285714285e-04)*D;
  A[0][25]=(0.0)*D;
  A[0][26]=(0.0)*D;
  A[0][27]=(7.4404761904761911e-05)*D;
  A[0][28]=(0.0)*D;
  A[0][29]=(0.0)*D;
  A[0][30]=(-4.4642857142857141e-04)*D;
  A[0][31]=(0.0)*D;
  A[0][32]=(0.0)*D;
  A[0][33]=(6.6964285714285715e-04)*D;
  A[0][34]=(0.0)*D;
  A[0][35]=(0.0)*D;
  A[0][36]=(1.1160714285714285e-04)*D;
  A[0][37]=(0.0)*D;
  A[0][38]=(0.0)*D;
  A[0][39]=(6.6964285714285715e-04)*D;
  A[0][40]=(0.0)*D;
  A[0][41]=(0.0)*D;
  A[0][42]=(1.3392857142857143e-03)*D;
  A[0][43]=(0.0)*D;
  A[0][44]=(0.0)*D;
  A[0][45]=(1.1160714285714285e-04)*D;
  A[0][46]=(0.0)*D;
  A[0][47]=(0.0)*D;
  A[0][48]=(2.2321428571428571e-04)*D;
  A[0][49]=(0.0)*D;
  A[0][50]=(0.0)*D;
  A[0][51]=(1.1160714285714285e-04)*D;
  A[0][52]=(0.0)*D;
  A[0][53]=(0.0)*D;
  A[0][54]=(1.1160714285714285e-04)*D;
  A[0][55]=(0.0)*D;
  A[0][56]=(0.0)*D;
  A[0][57]=(7.4404761904761911e-05)*D;
  A[0][58]=(0.0)*D;
  A[0][59]=(0.0)*D;
  A[1][0]=(0.0)*D;
  A[1][1]=(5.9523809523809529e-04)*D;
  A[1][2]=(0.0)*D;
  A[1][3]=(0.0)*D;
  A[1][4]=(-4.4642857142857141e-04)*D;
  A[1][5]=(0.0)*D;
  A[1][6]=(0.0)*D;
  A[1][7]=(2.2321428571428571e-04)*D;
  A[1][8]=(0.0)*D;
  A[1][9]=(0.0)*D;
  A[1][10]=(7.4404761904761911e-05)*D;
  A[1][11]=(0.0)*D;
  A[1][12]=(0.0)*D;
  A[1][13]=(-4.4642857142857141e-04)*D;
  A[1][14]=(0.0)*D;
  A[1][15]=(0.0)*D;
  A[1][16]=(6.6964285714285715e-04)*D;
  A[1][17]=(0.0)*D;
  A[1][18]=(0.0)*D;
  A[1][19]=(1.1160714285714285e-04)*D;
  A[1][20]=(0.0)*D;
  A[1][21]=(0.0)*D;
  A[1][22]=(2.2321428571428571e-04)*D;
  A[1][23]=(0.0)*D;
  A[1][24]=(0.0)*D;
  A[1][25]=(1.1160714285714285e-04)*D;
  A[1][26]=(0.0)*D;
  A[1][27]=(0.0)*D;
  A[1][28]=(7.4404761904761911e-05)*D;
  A[1][29]=(0.0)*D;
  A[1][30]=(0.0)*D;
  A[1][31]=(-4.4642857142857141e-04)*D;
  A[1][32]=(0.0)*D;
  A[1][33]=(0.0)*D;
  A[1][34]=(6.6964285714285715e-04)*D;
  A[1][35]=(0.0)*D;
  A[1][36]=(0.0)*D;
  A[1][37]=(1.1160714285714285e-04)*D;
  A[1][38]=(0.0)*D;
  A[1][39]=(0.0)*D;
  A[1][40]=(6.6964285714285715e-04)*D;
  A[1][41]=(0.0)*D;
  A[1][42]=(0.0)*D;
  A[1][43]=(1.3392857142857143e-03)*D;
  A[1][44]=(0.0)*D;
  A[1][45]=(0.0)*D;
  A[1][46]=(1.1160714285714285e-04)*D;
  A[1][47]=(0.0)*D;
  A[1][48]=(0.0)*D;
  A[1][49]=(2.2321428571428571e-04)*D;
  A[1][50]=(0.0)*D;
  A[1][51]=(0.0)*D;
  A[1][52]=(1.1160714285714285e-04)*D;
  A[1][53]=(0.0)*D;
  A[1][54]=(0.0)*D;
  A[1][55]=(1.1160714285714285e-04)*D;
  A[1][56]=(0.0)*D;
  A[1][57]=(0.0)*D;
  A[1][58]=(7.4404761904761911e-05)*D;
  A[1][59]=(0.0)*D;
  A[2][0]=(0.0)*D;
  A[2][1]=(0.0)*D;
  A[2][2]=(5.9523809523809529e-04)*D;
  A[2][3]=(0.0)*D;
  A[2][4]=(0.0)*D;
  A[2][5]=(-4.4642857142857141e-04)*D;
  A[2][6]=(0.0)*D;
  A[2][7]=(0.0)*D;
  A[2][8]=(2.2321428571428571e-04)*D;
  A[2][9]=(0.0)*D;
  A[2][10]=(0.0)*D;
  A[2][11]=(7.4404761904761911e-05)*D;
  A[2][12]=(0.0)*D;
  A[2][13]=(0.0)*D;
  A[2][14]=(-4.4642857142857141e-04)*D;
  A[2][15]=(0.0)*D;
  A[2][16]=(0.0)*D;
  A[2][17]=(6.6964285714285715e-04)*D;
  A[2][18]=(0.0)*D;
  A[2][19]=(0.0)*D;
  A[2][20]=(1.1160714285714285e-04)*D;
  A[2][21]=(0.0)*D;
  A[2][22]=(0.0)*D;
  A[2][23]=(2.2321428571428571e-04)*D;
  A[2][24]=(0.0)*D;
  A[2][25]=(0.0)*D;
  A[2][26]=(1.1160714285714285e-04)*D;
  A[2][27]=(0.0)*D;
  A[2][28]=(0.0)*D;
  A[2][29]=(7.4404761904761911e-05)*D;
  A[2][30]=(0.0)*D;
  A[2][31]=(0.0)*D;
  A[2][32]=(-4.4642857142857141e-04)*D;
  A[2][33]=(0.0)*D;
  A[2][34]=(0.0)*D;
  A[2][35]=(6.6964285714285715e-04)*D;
  A[2][36]=(0.0)*D;
  A[2][37]=(0.0)*D;
  A[2][38]=(1.1160714285714285e-04)*D;
  A[2][39]=(0.0)*D;
  A[2][40]=(0.0)*D;
  A[2][41]=(6.6964285714285715e-04)*D;
  A[2][42]=(0.0)*D;
  A[2][43]=(0.0)*D;
  A[2][44]=(1.3392857142857143e-03)*D;
  A[2][45]=(0.0)*D;
  A[2][46]=(0.0)*D;
  A[2][47]=(1.1160714285714285e-04)*D;
  A[2][48]=(0.0)*D;
  A[2][49]=(0.0)*D;
  A[2][50]=(2.2321428571428571e-04)*D;
  A[2][51]=(0.0)*D;
  A[2][52]=(0.0)*D;
  A[2][53]=(1.1160714285714285e-04)*D;
  A[2][54]=(0.0)*D;
  A[2][55]=(0.0)*D;
  A[2][56]=(1.1160714285714285e-04)*D;
  A[2][57]=(0.0)*D;
  A[2][58]=(0.0)*D;
  A[2][59]=(7.4404761904761911e-05)*D;
  A[3][0]=(-4.4642857142857141e-04)*D;
  A[3][1]=(0.0)*D;
  A[3][2]=(0.0)*D;
  A[3][3]=(4.0178571428571425e-03)*D;
  A[3][4]=(0.0)*D;
  A[3][5]=(0.0)*D;
  A[3][6]=(-2.0089285714285712e-03)*D;
  A[3][7]=(0.0)*D;
  A[3][8]=(0.0)*D;
  A[3][9]=(2.2321428571428571e-04)*D;
  A[3][10]=(0.0)*D;
  A[3][11]=(0.0)*D;
  A[3][12]=(2.0089285714285712e-03)*D;
  A[3][13]=(0.0)*D;
  A[3][14]=(0.0)*D;
  A[3][15]=(0.0)*D;
  A[3][16]=(0.0)*D;
  A[3][17]=(0.0)*D;
  A[3][18]=(-1.0044642857142856e-03)*D;
  A[3][19]=(0.0)*D;
  A[3][20]=(0.0)*D;
  A[3][21]=(-1.0044642857142856e-03)*D;
  A[3][22]=(0.0)*D;
  A[3][23]=(0.0)*D;
  A[3][24]=(0.0)*D;
  A[3][25]=(0.0)*D;
  A[3][26]=(0.0)*D;
  A[3][27]=(1.1160714285714285e-04)*D;
  A[3][28]=(0.0)*D;
  A[3][29]=(0.0)*D;
  A[3][30]=(2.0089285714285712e-03)*D;
  A[3][31]=(0.0)*D;
  A[3][32]=(0.0)*D;
  A[3][33]=(0.0)*D;
  A[3][34]=(0.0)*D;
  A[3][35]=(0.0)*D;
  A[3][36]=(-1.0044642857142856e-03)*D;
  A[3][37]=(0.0)*D;
  A[3][38]=(0.0)*D;
  A[3][39]=(0.0)*D;
  A[3][40]=(0.0)*D;
  A[3][41]=(0.0)*D;
  A[3][42]=(-2.0089285714285712e-03)*D;
  A[3][43]=(0.0)*D;
  A[3][44]=(0.0)*D;
  A[3][45]=(0.0)*D;
  A[3][46]=(0.0)*D;
  A[3][47]=(0.0)*D;
  A[3][48]=(-1.0044642857142856e-03)*D;
  A[3][49]=(0.0)*D;
  A[3][50]=(0.0)*D;
  A[3][51]=(0.0)*D;
  A[3][52]=(0.0)*D;
  A[3][53]=(0.0)*D;
  A[3][54]=(0.0)*D;
  A[3][55]=(0.0)*D;
  A[3][56]=(0.0)*D;
  A[3][57]=(1.1160714285714285e-04)*D;
  A[3][58]=(0.0)*D;
  A[3][59]=(0.0)*D;
  A[4][0]=(0.0)*D;
  A[4][1]=(-4.4642857142857141e-04)*D;
  A[4][2]=(0.0)*D;
  A[4][3]=(0.0)*D;
  A[4][4]=(4.0178571428571425e-03)*D;
  A[4][5]=(0.0)*D;
  A[4][6]=(0.0)*D;
  A[4][7]=(-2.0089285714285712e-03)*D;
  A[4][8]=(0.0)*D;
  A[4][9]=(0.0)*D;
  A[4][10]=(2.2321428571428571e-04)*D;
  A[4][11]=(0.0)*D;
  A[4][12]=(0.0)*D;
  A[4][13]=(2.0089285714285712e-03)*D;
  A[4][14]=(0.0)*D;
  A[4][15]=(0.0)*D;
  A[4][16]=(0.0)*D;
  A[4][17]=(0.0)*D;
  A[4][18]=(0.0)*D;
  A[4][19]=(-1.0044642857142856e-03)*D;
  A[4][20]=(0.0)*D;
  A[4][21]=(0.0)*D;
  A[4][22]=(-1.0044642857142856e-03)*D;
  A[4][23]=(0.0)*D;
  A[4][24]=(0.0)*D;
  A[4][25]=(0.0)*D;
  A[4][26]=(0.0)*D;
  A[4][27]=(0.0)*D;
  A[4][28]=(1.1160714285714285e-04)*D;
  A[4][29]=(0.0)*D;
  A[4][30]=(0.0)*D;
  A[4][31]=(2.0089285714285712e-03)*D;
  A[4][32]=(0.0)*D;
  A[4][33]=(0.0)*D;
  A[4][34]=(0.0)*D;
  A[4][35]=(0.0)*D;
  A[4][36]=(0.0)*D;
  A[4][37]=(-1.0044642857142856e-03)*D;
  A[4][38]=(0.0)*D;
  A[4][39]=(0.0)*D;
  A[4][40]=(0.0)*D;
  A[4][41]=(0.0)*D;
  A[4][42]=(0.0)*D;
  A[4][43]=(-2.0089285714285712e-03)*D;
  A[4][44]=(0.0)*D;
  A[4][45]=(0.0)*D;
  A[4][46]=(0.0)*D;
  A[4][47]=(0.0)*D;
  A[4][48]=(0.0)*D;
  A[4][49]=(-1.0044642857142856e-03)*D;
  A[4][50]=(0.0)*D;
  A[4][51]=(0.0)*D;
  A[4][52]=(0.0)*D;
  A[4][53]=(0.0)*D;
  A[4][54]=(0.0)*D;
  A[4][55]=(0.0)*D;
  A[4][56]=(0.0)*D;
  A[4][57]=(0.0)*D;
  A[4][58]=(1.1160714285714285e-04)*D;
  A[4][59]=(0.0)*D;
  A[5][0]=(0.0)*D;
  A[5][1]=(0.0)*D;
  A[5][2]=(-4.4642857142857141e-04)*D;
  A[5][3]=(0.0)*D;
  A[5][4]=(0.0)*D;
  A[5][5]=(4.0178571428571425e-03)*D;
  A[5][6]=(0.0)*D;
  A[5][7]=(0.0)*D;
  A[5][8]=(-2.0089285714285712e-03)*D;
  A[5][9]=(0.0)*D;
  A[5][10]=(0.0)*D;
  A[5][11]=(2.2321428571428571e-04)*D;
  A[5][12]=(0.0)*D;
  A[5][13]=(0.0)*D;
  A[5][14]=(2.0089285714285712e-03)*D;
  A[5][15]=(0.0)*D;
  A[5][16]=(0.0)*D;
  A[5][17]=(0.0)*D;
  A[5][18]=(0.0)*D;
  A[5][19]=(0.0)*D;
  A[5][20]=(-1.0044642857142856e-03)*D;
  A[5][21]=(0.0)*D;
  A[5][22]=(0.0)*D;
  A[5][23]=(-1.0044642857142856e-03)*D;
  A[5][24]=(0.0)*D;
  A[5][25]=(0.0)*D;
  A[5][26]=(0.0)*D;
  A[5][27]=(0.0)*D;
  A[5][28]=(0.0)*D;
  A[5][29]=(1.1160714285714285e-04)*D;
  A[5][30]=(0.0)*D;
  A[5][31]=(0.0)*D;
  A[5][32]=(2.0089285714285712e-03)*D;
  A[5][33]=(0.0)*D;
  A[5][34]=(0.0)*D;
  A[5][35]=(0.0)*D;
  A[5][36]=(0.0)*D;
  A[5][37]=(0.0)*D;
  A[5][38]=(-1.0044642857142856e-03)*D;
  A[5][39]=(0.0)*D;
  A[5][40]=(0.0)*D;
  A[5][41]=(0.0)*D;
  A[5][42]=(0.0)*D;
  A[5][43]=(0.0)*D;
  A[5][44]=(-2.0089285714285712e-03)*D;
  A[5][45]=(0.0)*D;
  A[5][46]=(0.0)*D;
  A[5][47]=(0.0)*D;
  A[5][48]=(0.0)*D;
  A[5][49]=(0.0)*D;
  A[5][50]=(-1.0044642857142856e-03)*D;
  A[5][51]=(0.0)*D;
  A[5][52]=(0.0)*D;
  A[5][53]=(0.0)*D;
  A[5][54]=(0.0)*D;
  A[5][55]=(0.0)*D;
  A[5][56]=(0.0)*D;
  A[5][57]=(0.0)*D;
  A[5][58]=(0.0)*D;
  A[5][59]=(1.1160714285714285e-04)*D;
  A[6][0]=(2.2321428571428571e-04)*D;
  A[6][1]=(0.0)*D;
  A[6][2]=(0.0)*D;
  A[6][3]=(-2.0089285714285712e-03)*D;
  A[6][4]=(0.0)*D;
  A[6][5]=(0.0)*D;
  A[6][6]=(4.0178571428571425e-03)*D;
  A[6][7]=(0.0)*D;
  A[6][8]=(0.0)*D;
  A[6][9]=(-4.4642857142857141e-04)*D;
  A[6][10]=(0.0)*D;
  A[6][11]=(0.0)*D;
  A[6][12]=(-1.0044642857142856e-03)*D;
  A[6][13]=(0.0)*D;
  A[6][14]=(0.0)*D;
  A[6][15]=(0.0)*D;
  A[6][16]=(0.0)*D;
  A[6][17]=(0.0)*D;
  A[6][18]=(2.0089285714285712e-03)*D;
  A[6][19]=(0.0)*D;
  A[6][20]=(0.0)*D;
  A[6][21]=(0.0)*D;
  A[6][22]=(0.0)*D;
  A[6][23]=(0.0)*D;
  A[6][24]=(-1.0044642857142856e-03)*D;
  A[6][25]=(0.0)*D;
  A[6][26]=(0.0)*D;
  A[6][27]=(1.1160714285714285e-04)*D;
  A[6][28]=(0.0)*D;
  A[6][29]=(0.0)*D;
  A[6][30]=(-1.0044642857142856e-03)*D;
  A[6][31]=(0.0)*D;
  A[6][32]=(0.0)*D;
  A[6][33]=(0.0)*D;
  A[6][34]=(0.0)*D;
  A[6][35]=(0.0)*D;
  A[6][36]=(2.0089285714285712e-03)*D;
  A[6][37]=(0.0)*D;
  A[6][38]=(0.0)*D;
  A[6][39]=(-2.0089285714285712e-03)*D;
  A[6][40]=(0.0)*D;
  A[6][41]=(0.0)*D;
  A[6][42]=(0.0)*D;
  A[6][43]=(0.0)*D;
  A[6][44]=(0.0)*D;
  A[6][45]=(0.0)*D;
  A[6][46]=(0.0)*D;
  A[6][47]=(0.0)*D;
  A[6][48]=(0.0)*D;
  A[6][49]=(0.0)*D;
  A[6][50]=(0.0)*D;
  A[6][51]=(-1.0044642857142856e-03)*D;
  A[6][52]=(0.0)*D;
  A[6][53]=(0.0)*D;
  A[6][54]=(0.0)*D;
  A[6][55]=(0.0)*D;
  A[6][56]=(0.0)*D;
  A[6][57]=(1.1160714285714285e-04)*D;
  A[6][58]=(0.0)*D;
  A[6][59]=(0.0)*D;
  A[7][0]=(0.0)*D;
  A[7][1]=(2.2321428571428571e-04)*D;
  A[7][2]=(0.0)*D;
  A[7][3]=(0.0)*D;
  A[7][4]=(-2.0089285714285712e-03)*D;
  A[7][5]=(0.0)*D;
  A[7][6]=(0.0)*D;
  A[7][7]=(4.0178571428571425e-03)*D;
  A[7][8]=(0.0)*D;
  A[7][9]=(0.0)*D;
  A[7][10]=(-4.4642857142857141e-04)*D;
  A[7][11]=(0.0)*D;
  A[7][12]=(0.0)*D;
  A[7][13]=(-1.0044642857142856e-03)*D;
  A[7][14]=(0.0)*D;
  A[7][15]=(0.0)*D;
  A[7][16]=(0.0)*D;
  A[7][17]=(0.0)*D;
  A[7][18]=(0.0)*D;
  A[7][19]=(2.0089285714285712e-03)*D;
  A[7][20]=(0.0)*D;
  A[7][21]=(0.0)*D;
  A[7][22]=(0.0)*D;
  A[7][23]=(0.0)*D;
  A[7][24]=(0.0)*D;
  A[7][25]=(-1.0044642857142856e-03)*D;
  A[7][26]=(0.0)*D;
  A[7][27]=(0.0)*D;
  A[7][28]=(1.1160714285714285e-04)*D;
  A[7][29]=(0.0)*D;
  A[7][30]=(0.0)*D;
  A[7][31]=(-1.0044642857142856e-03)*D;
  A[7][32]=(0.0)*D;
  A[7][33]=(0.0)*D;
  A[7][34]=(0.0)*D;
  A[7][35]=(0.0)*D;
  A[7][36]=(0.0)*D;
  A[7][37]=(2.0089285714285712e-03)*D;
  A[7][38]=(0.0)*D;
  A[7][39]=(0.0)*D;
  A[7][40]=(-2.0089285714285712e-03)*D;
  A[7][41]=(0.0)*D;
  A[7][42]=(0.0)*D;
  A[7][43]=(0.0)*D;
  A[7][44]=(0.0)*D;
  A[7][45]=(0.0)*D;
  A[7][46]=(0.0)*D;
  A[7][47]=(0.0)*D;
  A[7][48]=(0.0)*D;
  A[7][49]=(0.0)*D;
  A[7][50]=(0.0)*D;
  A[7][51]=(0.0)*D;
  A[7][52]=(-1.0044642857142856e-03)*D;
  A[7][53]=(0.0)*D;
  A[7][54]=(0.0)*D;
  A[7][55]=(0.0)*D;
  A[7][56]=(0.0)*D;
  A[7][57]=(0.0)*D;
  A[7][58]=(1.1160714285714285e-04)*D;
  A[7][59]=(0.0)*D;
  A[8][0]=(0.0)*D;
  A[8][1]=(0.0)*D;
  A[8][2]=(2.2321428571428571e-04)*D;
  A[8][3]=(0.0)*D;
  A[8][4]=(0.0)*D;
  A[8][5]=(-2.0089285714285712e-03)*D;
  A[8][6]=(0.0)*D;
  A[8][7]=(0.0)*D;
  A[8][8]=(4.0178571428571425e-03)*D;
  A[8][9]=(0.0)*D;
  A[8][10]=(0.0)*D;
  A[8][11]=(-4.4642857142857141e-04)*D;
  A[8][12]=(0.0)*D;
  A[8][13]=(0.0)*D;
  A[8][14]=(-1.0044642857142856e-03)*D;
  A[8][15]=(0.0)*D;
  A[8][16]=(0.0)*D;
  A[8][17]=(0.0)*D;
  A[8][18]=(0.0)*D;
  A[8][19]=(0.0)*D;
  A[8][20]=(2.0089285714285712e-03)*D;
  A[8][21]=(0.0)*D;
  A[8][22]=(0.0)*D;
  A[8][23]=(0.0)*D;
  A[8][24]=(0.0)*D;
  A[8][25]=(0.0)*D;
  A[8][26]=(-1.0044642857142856e-03)*D;
  A[8][27]=(0.0)*D;
  A[8][28]=(0.0)*D;
  A[8][29]=(1.1160714285714285e-04)*D;
  A[8][30]=(0.0)*D;
  A[8][31]=(0.0)*D;
  A[8][32]=(-1.0044642857142856e-03)*D;
  A[8][33]=(0.0)*D;
  A[8][34]=(0.0)*D;
  A[8][35]=(0.0)*D;
  A[8][36]=(0.0)*D;
  A[8][37]=(0.0)*D;
  A[8][38]=(2.0089285714285712e-03)*D;
  A[8][39]=(0.0)*D;
  A[8][40]=(0.0)*D;
  A[8][41]=(-2.0089285714285712e-03)*D;
  A[8][42]=(0.0)*D;
  A[8][43]=(0.0)*D;
  A[8][44]=(0.0)*D;
  A[8][45]=(0.0)*D;
  A[8][46]=(0.0)*D;
  A[8][47]=(0.0)*D;
  A[8][48]=(0.0)*D;
  A[8][49]=(0.0)*D;
  A[8][50]=(0.0)*D;
  A[8][51]=(0.0)*D;
  A[8][52]=(0.0)*D;
  A[8][53]=(-1.0044642857142856e-03)*D;
  A[8][54]=(0.0)*D;
  A[8][55]=(0.0)*D;
  A[8][56]=(0.0)*D;
  A[8][57]=(0.0)*D;
  A[8][58]=(0.0)*D;
  A[8][59]=(1.1160714285714285e-04)*D;
  A[9][0]=(7.4404761904761911e-05)*D;
  A[9][1]=(0.0)*D;
  A[9][2]=(0.0)*D;
  A[9][3]=(2.2321428571428571e-04)*D;
  A[9][4]=(0.0)*D;
  A[9][5]=(0.0)*D;
  A[9][6]=(-4.4642857142857141e-04)*D;
  A[9][7]=(0.0)*D;
  A[9][8]=(0.0)*D;
  A[9][9]=(5.9523809523809529e-04)*D;
  A[9][10]=(0.0)*D;
  A[9][11]=(0.0)*D;
  A[9][12]=(1.1160714285714285e-04)*D;
  A[9][13]=(0.0)*D;
  A[9][14]=(0.0)*D;
  A[9][15]=(6.6964285714285715e-04)*D;
  A[9][16]=(0.0)*D;
  A[9][17]=(0.0)*D;
  A[9][18]=(-4.4642857142857141e-04)*D;
  A[9][19]=(0.0)*D;
  A[9][20]=(0.0)*D;
  A[9][21]=(1.1160714285714285e-04)*D;
  A[9][22]=(0.0)*D;
  A[9][23]=(0.0)*D;
  A[9][24]=(2.2321428571428571e-04)*D;
  A[9][25]=(0.0)*D;
  A[9][26]=(0.0)*D;
  A[9][27]=(7.4404761904761911e-05)*D;
  A[9][28]=(0.0)*D;
  A[9][29]=(0.0)*D;
  A[9][30]=(1.1160714285714285e-04)*D;
  A[9][31]=(0.0)*D;
  A[9][32]=(0.0)*D;
  A[9][33]=(6.6964285714285715e-04)*D;
  A[9][34]=(0.0)*D;
  A[9][35]=(0.0)*D;
  A[9][36]=(-4.4642857142857141e-04)*D;
  A[9][37]=(0.0)*D;
  A[9][38]=(0.0)*D;
  A[9][39]=(1.3392857142857143e-03)*D;
  A[9][40]=(0.0)*D;
  A[9][41]=(0.0)*D;
  A[9][42]=(6.6964285714285715e-04)*D;
  A[9][43]=(0.0)*D;
  A[9][44]=(0.0)*D;
  A[9][45]=(1.1160714285714285e-04)*D;
  A[9][46]=(0.0)*D;
  A[9][47]=(0.0)*D;
  A[9][48]=(1.1160714285714285e-04)*D;
  A[9][49]=(0.0)*D;
  A[9][50]=(0.0)*D;
  A[9][51]=(2.2321428571428571e-04)*D;
  A[9][52]=(0.0)*D;
  A[9][53]=(0.0)*D;
  A[9][54]=(1.1160714285714285e-04)*D;
  A[9][55]=(0.0)*D;
  A[9][56]=(0.0)*D;
  A[9][57]=(7.4404761904761911e-05)*D;
  A[9][58]=(0.0)*D;
  A[9][59]=(0.0)*D;
  A[10][0]=(0.0)*D;
  A[10][1]=(7.4404761904761911e-05)*D;
  A[10][2]=(0.0)*D;
  A[10][3]=(0.0)*D;
  A[10][4]=(2.2321428571428571e-04)*D;
  A[10][5]=(0.0)*D;
  A[10][6]=(0.0)*D;
  A[10][7]=(-4.4642857142857141e-04)*D;
  A[10][8]=(0.0)*D;
  A[10][9]=(0.0)*D;
  A[10][10]=(5.9523809523809529e-04)*D;
  A[10][11]=(0.0)*D;
  A[10][12]=(0.0)*D;
  A[10][13]=(1.1160714285714285e-04)*D;
  A[10][14]=(0.0)*D;
  A[10][15]=(0.0)*D;
  A[10][16]=(6.6964285714285715e-04)*D;
  A[10][17]=(0.0)*D;
  A[10][18]=(0.0)*D;
  A[10][19]=(-4.4642857142857141e-04)*D;
  A[10][20]=(0.0)*D;
  A[10][21]=(0.0)*D;
  A[10][22]=(1.1160714285714285e-04)*D;
  A[10][23]=(0.0)*D;
  A[10][24]=(0.0)*D;
  A[10][25]=(2.2321428571428571e-04)*D;
  A[10][26]=(0.0)*D;
  A[10][27]=(0.0)*D;
  A[10][28]=(7.4404761904761911e-05)*D;
  A[10][29]=(0.0)*D;
  A[10][30]=(0.0)*D;
  A[10][31]=(1.1160714285714285e-04)*D;
  A[10][32]=(0.0)*D;
  A[10][33]=(0.0)*D;
  A[10][34]=(6.6964285714285715e-04)*D;
  A[10][35]=(0.0)*D;
  A[10][36]=(0.0)*D;
  A[10][37]=(-4.4642857142857141e-04)*D;
  A[10][38]=(0.0)*D;
  A[10][39]=(0.0)*D;
  A[10][40]=(1.3392857142857143e-03)*D;
  A[10][41]=(0.0)*D;
  A[10][42]=(0.0)*D;
  A[10][43]=(6.6964285714285715e-04)*D;
  A[10][44]=(0.0)*D;
  A[10][45]=(0.0)*D;
  A[10][46]=(1.1160714285714285e-04)*D;
  A[10][47]=(0.0)*D;
  A[10][48]=(0.0)*D;
  A[10][49]=(1.1160714285714285e-04)*D;
  A[10][50]=(0.0)*D;
  A[10][51]=(0.0)*D;
  A[10][52]=(2.2321428571428571e-04)*D;
  A[10][53]=(0.0)*D;
  A[10][54]=(0.0)*D;
  A[10][55]=(1.1160714285714285e-04)*D;
  A[10][56]=(0.0)*D;
  A[10][57]=(0.0)*D;
  A[10][58]=(7.4404761904761911e-05)*D;
  A[10][59]=(0.0)*D;
  A[11][0]=(0.0)*D;
  A[11][1]=(0.0)*D;
  A[11][2]=(7.4404761904761911e-05)*D;
  A[11][3]=(0.0)*D;
  A[11][4]=(0.0)*D;
  A[11][5]=(2.2321428571428571e-04)*D;
  A[11][6]=(0.0)*D;
  A[11][7]=(0.0)*D;
  A[11][8]=(-4.4642857142857141e-04)*D;
  A[11][9]=(0.0)*D;
  A[11][10]=(0.0)*D;
  A[11][11]=(5.9523809523809529e-04)*D;
  A[11][12]=(0.0)*D;
  A[11][13]=(0.0)*D;
  A[11][14]=(1.1160714285714285e-04)*D;
  A[11][15]=(0.0)*D;
  A[11][16]=(0.0)*D;
  A[11][17]=(6.6964285714285715e-04)*D;
  A[11][18]=(0.0)*D;
  A[11][19]=(0.0)*D;
  A[11][20]=(-4.4642857142857141e-04)*D;
  A[11][21]=(0.0)*D;
  A[11][22]=(0.0)*D;
  A[11][23]=(1.1160714285714285e-04)*D;
  A[11][24]=(0.0)*D;
  A[11][25]=(0.0)*D;
  A[11][26]=(2.2321428571428571e-04)*D;
  A[11][27]=(0.0)*D;
  A[11][28]=(0.0)*D;
  A[11][29]=(7.4404761904761911e-05)*D;
  A[11][30]=(0.0)*D;
  A[11][31]=(0.0)*D;
  A[11][32]=(1.1160714285714285e-04)*D;
  A[11][33]=(0.0)*D;
  A[11][34]=(0.0)*D;
  A[11][35]=(6.6964285714285715e-04)*D;
  A[11][36]=(0.0)*D;
  A[11][37]=(0.0)*D;
  A[11][38]=(-4.4642857142857141e-04)*D;
  A[11][39]=(0.0)*D;
  A[11][40]=(0.0)*D;
  A[11][41]=(1.3392857142857143e-03)*D;
  A[11][42]=(0.0)*D;
  A[11][43]=(0.0)*D;
  A[11][44]=(6.6964285714285715e-04)*D;
  A[11][45]=(0.0)*D;
  A[11][46]=(0.0)*D;
  A[11][47]=(1.1160714285714285e-04)*D;
  A[11][48]=(0.0)*D;
  A[11][49]=(0.0)*D;
  A[11][50]=(1.1160714285714285e-04)*D;
  A[11][51]=(0.0)*D;
  A[11][52]=(0.0)*D;
  A[11][53]=(2.2321428571428571e-04)*D;
  A[11][54]=(0.0)*D;
  A[11][55]=(0.0)*D;
  A[11][56]=(1.1160714285714285e-04)*D;
  A[11][57]=(0.0)*D;
  A[11][58]=(0.0)*D;
  A[11][59]=(7.4404761904761911e-05)*D;
  A[12][0]=(-4.4642857142857141e-04)*D;
  A[12][1]=(0.0)*D;
  A[12][2]=(0.0)*D;
  A[12][3]=(2.0089285714285712e-03)*D;
  A[12][4]=(0.0)*D;
  A[12][5]=(0.0)*D;
  A[12][6]=(-1.0044642857142856e-03)*D;
  A[12][7]=(0.0)*D;
  A[12][8]=(0.0)*D;
  A[12][9]=(1.1160714285714285e-04)*D;
  A[12][10]=(0.0)*D;
  A[12][11]=(0.0)*D;
  A[12][12]=(4.0178571428571425e-03)*D;
  A[12][13]=(0.0)*D;
  A[12][14]=(0.0)*D;
  A[12][15]=(0.0)*D;
  A[12][16]=(0.0)*D;
  A[12][17]=(0.0)*D;
  A[12][18]=(0.0)*D;
  A[12][19]=(0.0)*D;
  A[12][20]=(0.0)*D;
  A[12][21]=(-2.0089285714285712e-03)*D;
  A[12][22]=(0.0)*D;
  A[12][23]=(0.0)*D;
  A[12][24]=(-1.0044642857142856e-03)*D;
  A[12][25]=(0.0)*D;
  A[12][26]=(0.0)*D;
  A[12][27]=(2.2321428571428571e-04)*D;
  A[12][28]=(0.0)*D;
  A[12][29]=(0.0)*D;
  A[12][30]=(2.0089285714285712e-03)*D;
  A[12][31]=(0.0)*D;
  A[12][32]=(0.0)*D;
  A[12][33]=(0.0)*D;
  A[12][34]=(0.0)*D;
  A[12][35]=(0.0)*D;
  A[12][36]=(0.0)*D;
  A[12][37]=(0.0)*D;
  A[12][38]=(0.0)*D;
  A[12][39]=(0.0)*D;
  A[12][40]=(0.0)*D;
  A[12][41]=(0.0)*D;
  A[12][42]=(-2.0089285714285712e-03)*D;
  A[12][43]=(0.0)*D;
  A[12][44]=(0.0)*D;
  A[12][45]=(-1.0044642857142856e-03)*D;
  A[12][46]=(0.0)*D;
  A[12][47]=(0.0)*D;
  A[12][48]=(-1.0044642857142856e-03)*D;
  A[12][49]=(0.0)*D;
  A[12][50]=(0.0)*D;
  A[12][51]=(0.0)*D;
  A[12][52]=(0.0)*D;
  A[12][53]=(0.0)*D;
  A[12][54]=(0.0)*D;
  A[12][55]=(0.0)*D;
  A[12][56]=(0.0)*D;
  A[12][57]=(1.1160714285714285e-04)*D;
  A[12][58]=(0.0)*D;
  A[12][59]=(0.0)*D;
  A[13][0]=(0.0)*D;
  A[13][1]=(-4.4642857142857141e-04)*D;
  A[13][2]=(0.0)*D;
  A[13][3]=(0.0)*D;
  A[13][4]=(2.0089285714285712e-03)*D;
  A[13][5]=(0.0)*D;
  A[13][6]=(0.0)*D;
  A[13][7]=(-1.0044642857142856e-03)*D;
  A[13][8]=(0.0)*D;
  A[13][9]=(0.0)*D;
  A[13][10]=(1.1160714285714285e-04)*D;
  A[13][11]=(0.0)*D;
  A[13][12]=(0.0)*D;
  A[13][13]=(4.0178571428571425e-03)*D;
  A[13][14]=(0.0)*D;
  A[13][15]=(0.0)*D;
  A[13][16]=(0.0)*D;
  A[13][17]=(0.0)*D;
  A[13][18]=(0.0)*D;
  A[13][19]=(0.0)*D;
  A[13][20]=(0.0)*D;
  A[13][21]=(0.0)*D;
  A[13][22]=(-2.0089285714285712e-03)*D;
  A[13][23]=(0.0)*D;
  A[13][24]=(0.0)*D;
  A[13][25]=(-1.0044642857142856e-03)*D;
  A[13][26]=(0.0)*D;
  A[13][27]=(0.0)*D;
  A[13][28]=(2.2321428571428571e-04)*D;
  A[13][29]=(0.0)*D;
  A[13][30]=(0.0)*D;
  A[13][31]=(2.0089285714285712e-03)*D;
  A[13][32]=(0.0)*D;
  A[13][33]=(0.0)*D;
  A[13][34]=(0.0)*D;
  A[13][35]=(0.0)*D;
  A[13][36]=(0.0)*D;
  A[13][37]=(0.0)*D;
  A[13][38]=(0.0)*D;
  A[13][39]=(0.0)*D;
  A[13][40]=(0.0)*D;
  A[13][41]=(0.0)*D;
  A[13][42]=(0.0)*D;
  A[13][43]=(-2.0089285714285712e-03)*D;
  A[13][44]=(0.0)*D;
  A[13][45]=(0.0)*D;
  A[13][46]=(-1.0044642857142856e-03)*D;
  A[13][47]=(0.0)*D;
  A[13][48]=(0.0)*D;
  A[13][49]=(-1.0044642857142856e-03)*D;
  A[13][50]=(0.0)*D;
  A[13][51]=(0.0)*D;
  A[13][52]=(0.0)*D;
  A[13][53]=(0.0)*D;
  A[13][54]=(0.0)*D;
  A[13][55]=(0.0)*D;
  A[13][56]=(0.0)*D;
  A[13][57]=(0.0)*D;
  A[13][58]=(1.1160714285714285e-04)*D;
  A[13][59]=(0.0)*D;
  A[14][0]=(0.0)*D;
  A[14][1]=(0.0)*D;
  A[14][2]=(-4.4642857142857141e-04)*D;
  A[14][3]=(0.0)*D;
  A[14][4]=(0.0)*D;
  A[14][5]=(2.0089285714285712e-03)*D;
  A[14][6]=(0.0)*D;
  A[14][7]=(0.0)*D;
  A[14][8]=(-1.0044642857142856e-03)*D;
  A[14][9]=(0.0)*D;
  A[14][10]=(0.0)*D;
  A[14][11]=(1.1160714285714285e-04)*D;
  A[14][12]=(0.0)*D;
  A[14][13]=(0.0)*D;
  A[14][14]=(4.0178571428571425e-03)*D;
  A[14][15]=(0.0)*D;
  A[14][16]=(0.0)*D;
  A[14][17]=(0.0)*D;
  A[14][18]=(0.0)*D;
  A[14][19]=(0.0)*D;
  A[14][20]=(0.0)*D;
  A[14][21]=(0.0)*D;
  A[14][22]=(0.0)*D;
  A[14][23]=(-2.0089285714285712e-03)*D;
  A[14][24]=(0.0)*D;
  A[14][25]=(0.0)*D;
  A[14][26]=(-1.0044642857142856e-03)*D;
  A[14][27]=(0.0)*D;
  A[14][28]=(0.0)*D;
  A[14][29]=(2.2321428571428571e-04)*D;
  A[14][30]=(0.0)*D;
  A[14][31]=(0.0)*D;
  A[14][32]=(2.0089285714285712e-03)*D;
  A[14][33]=(0.0)*D;
  A[14][34]=(0.0)*D;
  A[14][35]=(0.0)*D;
  A[14][36]=(0.0)*D;
  A[14][37]=(0.0)*D;
  A[14][38]=(0.0)*D;
  A[14][39]=(0.0)*D;
  A[14][40]=(0.0)*D;
  A[14][41]=(0.0)*D;
  A[14][42]=(0.0)*D;
  A[14][43]=(0.0)*D;
  A[14][44]=(-2.0089285714285712e-03)*D;
  A[14][45]=(0.0)*D;
  A[14][46]=(0.0)*D;
  A[14][47]=(-1.0044642857142856e-03)*D;
  A[14][48]=(0.0)*D;
  A[14][49]=(0.0)*D;
  A[14][50]=(-1.0044642857142856e-03)*D;
  A[14][51]=(0.0)*D;
  A[14][52]=(0.0)*D;
  A[14][53]=(0.0)*D;
  A[14][54]=(0.0)*D;
  A[14][55]=(0.0)*D;
  A[14][56]=(0.0)*D;
  A[14][57]=(0.0)*D;
  A[14][58]=(0.0)*D;
  A[14][59]=(1.1160714285714285e-04)*D;
  A[15][0]=(6.6964285714285715e-04)*D;
  A[15][1]=(0.0)*D;
  A[15][2]=(0.0)*D;
  A[15][3]=(0.0)*D;
  A[15][4]=(0.0)*D;
  A[15][5]=(0.0)*D;
  A[15][6]=(0.0)*D;
  A[15][7]=(0.0)*D;
  A[15][8]=(0.0)*D;
  A[15][9]=(6.6964285714285715e-04)*D;
  A[15][10]=(0.0)*D;
  A[15][11]=(0.0)*D;
  A[15][12]=(0.0)*D;
  A[15][13]=(0.0)*D;
  A[15][14]=(0.0)*D;
  A[15][15]=(1.6071428571428570e-02)*D;
  A[15][16]=(0.0)*D;
  A[15][17]=(0.0)*D;
  A[15][18]=(0.0)*D;
  A[15][19]=(0.0)*D;
  A[15][20]=(0.0)*D;
  A[15][21]=(0.0)*D;
  A[15][22]=(0.0)*D;
  A[15][23]=(0.0)*D;
  A[15][24]=(0.0)*D;
  A[15][25]=(0.0)*D;
  A[15][26]=(0.0)*D;
  A[15][27]=(6.6964285714285715e-04)*D;
  A[15][28]=(0.0)*D;
  A[15][29]=(0.0)*D;
  A[15][30]=(0.0)*D;
  A[15][31]=(0.0)*D;
  A[15][32]=(0.0)*D;
  A[15][33]=(8.0357142857142849e-03)*D;
  A[15][34]=(0.0)*D;
  A[15][35]=(0.0)*D;
  A[15][36]=(0.0)*D;
  A[15][37]=(0.0)*D;
  A[15][38]=(0.0)*D;
  A[15][39]=(8.0357142857142849e-03)*D;
  A[15][40]=(0.0)*D;
  A[15][41]=(0.0)*D;
  A[15][42]=(8.0357142857142849e-03)*D;
  A[15][43]=(0.0)*D;
  A[15][44]=(0.0)*D;
  A[15][45]=(0.0)*D;
  A[15][46]=(0.0)*D;
  A[15][47]=(0.0)*D;
  A[15][48]=(-2.0089285714285712e-03)*D;
  A[15][49]=(0.0)*D;
  A[15][50]=(0.0)*D;
  A[15][51]=(-2.0089285714285712e-03)*D;
  A[15][52]=(0.0)*D;
  A[15][53]=(0.0)*D;
  A[15][54]=(-2.0089285714285712e-03)*D;
  A[15][55]=(0.0)*D;
  A[15][56]=(0.0)*D;
  A[15][57]=(1.3392857142857143e-03)*D;
  A[15][58]=(0.0)*D;
  A[15][59]=(0.0)*D;
  A[16][0]=(0.0)*D;
  A[16][1]=(6.6964285714285715e-04)*D;
  A[16][2]=(0.0)*D;
  A[16][3]=(0.0)*D;
  A[16][4]=(0.0)*D;
  A[16][5]=(0.0)*D;
  A[16][6]=(0.0)*D;
  A[16][7]=(0.0)*D;
  A[16][8]=(0.0)*D;
  A[16][9]=(0.0)*D;
  A[16][10]=(6.6964285714285715e-04)*D;
  A[16][11]=(0.0)*D;
  A[16][12]=(0.0)*D;
  A[16][13]=(0.0)*D;
  A[16][14]=(0.0)*D;
  A[16][15]=(0.0)*D;
  A[16][16]=(1.6071428571428570e-02)*D;
  A[16][17]=(0.0)*D;
  A[16][18]=(0.0)*D;
  A[16][19]=(0.0)*D;
  A[16][20]=(0.0)*D;
  A[16][21]=(0.0)*D;
  A[16][22]=(0.0)*D;
  A[16][23]=(0.0)*D;
  A[16][24]=(0.0)*D;
  A[16][25]=(0.0)*D;
  A[16][26]=(0.0)*D;
  A[16][27]=(0.0)*D;
  A[16][28]=(6.6964285714285715e-04)*D;
  A[16][29]=(0.0)*D;
  A[16][30]=(0.0)*D;
  A[16][31]=(0.0)*D;
  A[16][32]=(0.0)*D;
  A[16][33]=(0.0)*D;
  A[16][34]=(8.0357142857142849e-03)*D;
  A[16][35]=(0.0)*D;
  A[16][36]=(0.0)*D;
  A[16][37]=(0.0)*D;
  A[16][38]=(0.0)*D;
  A[16][39]=(0.0)*D;
  A[16][40]=(8.0357142857142849e-03)*D;
  A[16][41]=(0.0)*D;
  A[16][42]=(0.0)*D;
  A[16][43]=(8.0357142857142849e-03)*D;
  A[16][44]=(0.0)*D;
  A[16][45]=(0.0)*D;
  A[16][46]=(0.0)*D;
  A[16][47]=(0.0)*D;
  A[16][48]=(0.0)*D;
  A[16][49]=(-2.0089285714285712e-03)*D;
  A[16][50]=(0.0)*D;
  A[16][51]=(0.0)*D;
  A[16][52]=(-2.0089285714285712e-03)*D;
  A[16][53]=(0.0)*D;
  A[16][54]=(0.0)*D;
  A[16][55]=(-2.0089285714285712e-03)*D;
  A[16][56]=(0.0)*D;
  A[16][57]=(0.0)*D;
  A[16][58]=(1.3392857142857143e-03)*D;
  A[16][59]=(0.0)*D;
  A[17][0]=(0.0)*D;
  A[17][1]=(0.0)*D;
  A[17][2]=(6.6964285714285715e-04)*D;
  A[17][3]=(0.0)*D;
  A[17][4]=(0.0)*D;
  A[17][5]=(0.0)*D;
  A[17][6]=(0.0)*D;
  A[17][7]=(0.0)*D;
  A[17][8]=(0.0)*D;
  A[17][9]=(0.0)*D;
  A[17][10]=(0.0)*D;
  A[17][11]=(6.6964285714285715e-04)*D;
  A[17][12]=(0.0)*D;
  A[17][13]=(0.0)*D;
  A[17][14]=(0.0)*D;
  A[17][15]=(0.0)*D;
  A[17][16]=(0.0)*D;
  A[17][17]=(1.6071428571428570e-02)*D;
  A[17][18]=(0.0)*D;
  A[17][19]=(0.0)*D;
  A[17][20]=(0.0)*D;
  A[17][21]=(0.0)*D;
  A[17][22]=(0.0)*D;
  A[17][23]=(0.0)*D;
  A[17][24]=(0.0)*D;
  A[17][25]=(0.0)*D;
  A[17][26]=(0.0)*D;
  A[17][27]=(0.0)*D;
  A[17][28]=(0.0)*D;
  A[17][29]=(6.6964285714285715e-04)*D;
  A[17][30]=(0.0)*D;
  A[17][31]=(0.0)*D;
  A[17][32]=(0.0)*D;
  A[17][33]=(0.0)*D;
  A[17][34]=(0.0)*D;
  A[17][35]=(8.0357142857142849e-03)*D;
  A[17][36]=(0.0)*D;
  A[17][37]=(0.0)*D;
  A[17][38]=(0.0)*D;
  A[17][39]=(0.0)*D;
  A[17][40]=(0.0)*D;
  A[17][41]=(8.0357142857142849e-03)*D;
  A[17][42]=(0.0)*D;
  A[17][43]=(0.0)*D;
  A[17][44]=(8.0357142857142849e-03)*D;
  A[17][45]=(0.0)*D;
  A[17][46]=(0.0)*D;
  A[17][47]=(0.0)*D;
  A[17][48]=(0.0)*D;
  A[17][49]=(0.0)*D;
  A[17][50]=(-2.0089285714285712e-03)*D;
  A[17][51]=(0.0)*D;
  A[17][52]=(0.0)*D;
  A[17][53]=(-2.0089285714285712e-03)*D;
  A[17][54]=(0.0)*D;
  A[17][55]=(0.0)*D;
  A[17][56]=(-2.0089285714285712e-03)*D;
  A[17][57]=(0.0)*D;
  A[17][58]=(0.0)*D;
  A[17][59]=(1.3392857142857143e-03)*D;
  A[18][0]=(1.1160714285714285e-04)*D;
  A[18][1]=(0.0)*D;
  A[18][2]=(0.0)*D;
  A[18][3]=(-1.0044642857142856e-03)*D;
  A[18][4]=(0.0)*D;
  A[18][5]=(0.0)*D;
  A[18][6]=(2.0089285714285712e-03)*D;
  A[18][7]=(0.0)*D;
  A[18][8]=(0.0)*D;
  A[18][9]=(-4.4642857142857141e-04)*D;
  A[18][10]=(0.0)*D;
  A[18][11]=(0.0)*D;
  A[18][12]=(0.0)*D;
  A[18][13]=(0.0)*D;
  A[18][14]=(0.0)*D;
  A[18][15]=(0.0)*D;
  A[18][16]=(0.0)*D;
  A[18][17]=(0.0)*D;
  A[18][18]=(4.0178571428571425e-03)*D;
  A[18][19]=(0.0)*D;
  A[18][20]=(0.0)*D;
  A[18][21]=(-1.0044642857142856e-03)*D;
  A[18][22]=(0.0)*D;
  A[18][23]=(0.0)*D;
  A[18][24]=(-2.0089285714285712e-03)*D;
  A[18][25]=(0.0)*D;
  A[18][26]=(0.0)*D;
  A[18][27]=(2.2321428571428571e-04)*D;
  A[18][28]=(0.0)*D;
  A[18][29]=(0.0)*D;
  A[18][30]=(0.0)*D;
  A[18][31]=(0.0)*D;
  A[18][32]=(0.0)*D;
  A[18][33]=(0.0)*D;
  A[18][34]=(0.0)*D;
  A[18][35]=(0.0)*D;
  A[18][36]=(2.0089285714285712e-03)*D;
  A[18][37]=(0.0)*D;
  A[18][38]=(0.0)*D;
  A[18][39]=(-2.0089285714285712e-03)*D;
  A[18][40]=(0.0)*D;
  A[18][41]=(0.0)*D;
  A[18][42]=(0.0)*D;
  A[18][43]=(0.0)*D;
  A[18][44]=(0.0)*D;
  A[18][45]=(-1.0044642857142856e-03)*D;
  A[18][46]=(0.0)*D;
  A[18][47]=(0.0)*D;
  A[18][48]=(0.0)*D;
  A[18][49]=(0.0)*D;
  A[18][50]=(0.0)*D;
  A[18][51]=(-1.0044642857142856e-03)*D;
  A[18][52]=(0.0)*D;
  A[18][53]=(0.0)*D;
  A[18][54]=(0.0)*D;
  A[18][55]=(0.0)*D;
  A[18][56]=(0.0)*D;
  A[18][57]=(1.1160714285714285e-04)*D;
  A[18][58]=(0.0)*D;
  A[18][59]=(0.0)*D;
  A[19][0]=(0.0)*D;
  A[19][1]=(1.1160714285714285e-04)*D;
  A[19][2]=(0.0)*D;
  A[19][3]=(0.0)*D;
  A[19][4]=(-1.0044642857142856e-03)*D;
  A[19][5]=(0.0)*D;
  A[19][6]=(0.0)*D;
  A[19][7]=(2.0089285714285712e-03)*D;
  A[19][8]=(0.0)*D;
  A[19][9]=(0.0)*D;
  A[19][10]=(-4.4642857142857141e-04)*D;
  A[19][11]=(0.0)*D;
  A[19][12]=(0.0)*D;
  A[19][13]=(0.0)*D;
  A[19][14]=(0.0)*D;
  A[19][15]=(0.0)*D;
  A[19][16]=(0.0)*D;
  A[19][17]=(0.0)*D;
  A[19][18]=(0.0)*D;
  A[19][19]=(4.0178571428571425e-03)*D;
  A[19][20]=(0.0)*D;
  A[19][21]=(0.0)*D;
  A[19][22]=(-1.0044642857142856e-03)*D;
  A[19][23]=(0.0)*D;
  A[19][24]=(0.0)*D;
  A[19][25]=(-2.0089285714285712e-03)*D;
  A[19][26]=(0.0)*D;
  A[19][27]=(0.0)*D;
  A[19][28]=(2.2321428571428571e-04)*D;
  A[19][29]=(0.0)*D;
  A[19][30]=(0.0)*D;
  A[19][31]=(0.0)*D;
  A[19][32]=(0.0)*D;
  A[19][33]=(0.0)*D;
  A[19][34]=(0.0)*D;
  A[19][35]=(0.0)*D;
  A[19][36]=(0.0)*D;
  A[19][37]=(2.0089285714285712e-03)*D;
  A[19][38]=(0.0)*D;
  A[19][39]=(0.0)*D;
  A[19][40]=(-2.0089285714285712e-03)*D;
  A[19][41]=(0.0)*D;
  A[19][42]=(0.0)*D;
  A[19][43]=(0.0)*D;
  A[19][44]=(0.0)*D;
  A[19][45]=(0.0)*D;
  A[19][46]=(-1.0044642857142856e-03)*D;
  A[19][47]=(0.0)*D;
  A[19][48]=(0.0)*D;
  A[19][49]=(0.0)*D;
  A[19][50]=(0.0)*D;
  A[19][51]=(0.0)*D;
  A[19][52]=(-1.0044642857142856e-03)*D;
  A[19][53]=(0.0)*D;
  A[19][54]=(0.0)*D;
  A[19][55]=(0.0)*D;
  A[19][56]=(0.0)*D;
  A[19][57]=(0.0)*D;
  A[19][58]=(1.1160714285714285e-04)*D;
  A[19][59]=(0.0)*D;
  A[20][0]=(0.0)*D;
  A[20][1]=(0.0)*D;
  A[20][2]=(1.1160714285714285e-04)*D;
  A[20][3]=(0.0)*D;
  A[20][4]=(0.0)*D;
  A[20][5]=(-1.0044642857142856e-03)*D;
  A[20][6]=(0.0)*D;
  A[20][7]=(0.0)*D;
  A[20][8]=(2.0089285714285712e-03)*D;
  A[20][9]=(0.0)*D;
  A[20][10]=(0.0)*D;
  A[20][11]=(-4.4642857142857141e-04)*D;
  A[20][12]=(0.0)*D;
  A[20][13]=(0.0)*D;
  A[20][14]=(0.0)*D;
  A[20][15]=(0.0)*D;
  A[20][16]=(0.0)*D;
  A[20][17]=(0.0)*D;
  A[20][18]=(0.0)*D;
  A[20][19]=(0.0)*D;
  A[20][20]=(4.0178571428571425e-03)*D;
  A[20][21]=(0.0)*D;
  A[20][22]=(0.0)*D;
  A[20][23]=(-1.0044642857142856e-03)*D;
  A[20][24]=(0.0)*D;
  A[20][25]=(0.0)*D;
  A[20][26]=(-2.0089285714285712e-03)*D;
  A[20][27]=(0.0)*D;
  A[20][28]=(0.0)*D;
  A[20][29]=(2.2321428571428571e-04)*D;
  A[20][30]=(0.0)*D;
  A[20][31]=(0.0)*D;
  A[20][32]=(0.0)*D;
  A[20][33]=(0.0)*D;
  A[20][34]=(0.0)*D;
  A[20][35]=(0.0)*D;
  A[20][36]=(0.0)*D;
  A[20][37]=(0.0)*D;
  A[20][38]=(2.0089285714285712e-03)*D;
  A[20][39]=(0.0)*D;
  A[20][40]=(0.0)*D;
  A[20][41]=(-2.0089285714285712e-03)*D;
  A[20][42]=(0.0)*D;
  A[20][43]=(0.0)*D;
  A[20][44]=(0.0)*D;
  A[20][45]=(0.0)*D;
  A[20][46]=(0.0)*D;
  A[20][47]=(-1.0044642857142856e-03)*D;
  A[20][48]=(0.0)*D;
  A[20][49]=(0.0)*D;
  A[20][50]=(0.0)*D;
  A[20][51]=(0.0)*D;
  A[20][52]=(0.0)*D;
  A[20][53]=(-1.0044642857142856e-03)*D;
  A[20][54]=(0.0)*D;
  A[20][55]=(0.0)*D;
  A[20][56]=(0.0)*D;
  A[20][57]=(0.0)*D;
  A[20][58]=(0.0)*D;
  A[20][59]=(1.1160714285714285e-04)*D;
  A[21][0]=(2.2321428571428571e-04)*D;
  A[21][1]=(0.0)*D;
  A[21][2]=(0.0)*D;
  A[21][3]=(-1.0044642857142856e-03)*D;
  A[21][4]=(0.0)*D;
  A[21][5]=(0.0)*D;
  A[21][6]=(0.0)*D;
  A[21][7]=(0.0)*D;
  A[21][8]=(0.0)*D;
  A[21][9]=(1.1160714285714285e-04)*D;
  A[21][10]=(0.0)*D;
  A[21][11]=(0.0)*D;
  A[21][12]=(-2.0089285714285712e-03)*D;
  A[21][13]=(0.0)*D;
  A[21][14]=(0.0)*D;
  A[21][15]=(0.0)*D;
  A[21][16]=(0.0)*D;
  A[21][17]=(0.0)*D;
  A[21][18]=(-1.0044642857142856e-03)*D;
  A[21][19]=(0.0)*D;
  A[21][20]=(0.0)*D;
  A[21][21]=(4.0178571428571425e-03)*D;
  A[21][22]=(0.0)*D;
  A[21][23]=(0.0)*D;
  A[21][24]=(2.0089285714285712e-03)*D;
  A[21][25]=(0.0)*D;
  A[21][26]=(0.0)*D;
  A[21][27]=(-4.4642857142857141e-04)*D;
  A[21][28]=(0.0)*D;
  A[21][29]=(0.0)*D;
  A[21][30]=(-1.0044642857142856e-03)*D;
  A[21][31]=(0.0)*D;
  A[21][32]=(0.0)*D;
  A[21][33]=(-2.0089285714285712e-03)*D;
  A[21][34]=(0.0)*D;
  A[21][35]=(0.0)*D;
  A[21][36]=(0.0)*D;
  A[21][37]=(0.0)*D;
  A[21][38]=(0.0)*D;
  A[21][39]=(0.0)*D;
  A[21][40]=(0.0)*D;
  A[21][41]=(0.0)*D;
  A[21][42]=(0.0)*D;
  A[21][43]=(0.0)*D;
  A[21][44]=(0.0)*D;
  A[21][45]=(2.0089285714285712e-03)*D;
  A[21][46]=(0.0)*D;
  A[21][47]=(0.0)*D;
  A[21][48]=(0.0)*D;
  A[21][49]=(0.0)*D;
  A[21][50]=(0.0)*D;
  A[21][51]=(0.0)*D;
  A[21][52]=(0.0)*D;
  A[21][53]=(0.0)*D;
  A[21][54]=(-1.0044642857142856e-03)*D;
  A[21][55]=(0.0)*D;
  A[21][56]=(0.0)*D;
  A[21][57]=(1.1160714285714285e-04)*D;
  A[21][58]=(0.0)*D;
  A[21][59]=(0.0)*D;
  A[22][0]=(0.0)*D;
  A[22][1]=(2.2321428571428571e-04)*D;
  A[22][2]=(0.0)*D;
  A[22][3]=(0.0)*D;
  A[22][4]=(-1.0044642857142856e-03)*D;
  A[22][5]=(0.0)*D;
  A[22][6]=(0.0)*D;
  A[22][7]=(0.0)*D;
  A[22][8]=(0.0)*D;
  A[22][9]=(0.0)*D;
  A[22][10]=(1.1160714285714285e-04)*D;
  A[22][11]=(0.0)*D;
  A[22][12]=(0.0)*D;
  A[22][13]=(-2.0089285714285712e-03)*D;
  A[22][14]=(0.0)*D;
  A[22][15]=(0.0)*D;
  A[22][16]=(0.0)*D;
  A[22][17]=(0.0)*D;
  A[22][18]=(0.0)*D;
  A[22][19]=(-1.0044642857142856e-03)*D;
  A[22][20]=(0.0)*D;
  A[22][21]=(0.0)*D;
  A[22][22]=(4.0178571428571425e-03)*D;
  A[22][23]=(0.0)*D;
  A[22][24]=(0.0)*D;
  A[22][25]=(2.0089285714285712e-03)*D;
  A[22][26]=(0.0)*D;
  A[22][27]=(0.0)*D;
  A[22][28]=(-4.4642857142857141e-04)*D;
  A[22][29]=(0.0)*D;
  A[22][30]=(0.0)*D;
  A[22][31]=(-1.0044642857142856e-03)*D;
  A[22][32]=(0.0)*D;
  A[22][33]=(0.0)*D;
  A[22][34]=(-2.0089285714285712e-03)*D;
  A[22][35]=(0.0)*D;
  A[22][36]=(0.0)*D;
  A[22][37]=(0.0)*D;
  A[22][38]=(0.0)*D;
  A[22][39]=(0.0)*D;
  A[22][40]=(0.0)*D;
  A[22][41]=(0.0)*D;
  A[22][42]=(0.0)*D;
  A[22][43]=(0.0)*D;
  A[22][44]=(0.0)*D;
  A[22][45]=(0.0)*D;
  A[22][46]=(2.0089285714285712e-03)*D;
  A[22][47]=(0.0)*D;
  A[22][48]=(0.0)*D;
  A[22][49]=(0.0)*D;
  A[22][50]=(0.0)*D;
  A[22][51]=(0.0)*D;
  A[22][52]=(0.0)*D;
  A[22][53]=(0.0)*D;
  A[22][54]=(0.0)*D;
  A[22][55]=(-1.0044642857142856e-03)*D;
  A[22][56]=(0.0)*D;
  A[22][57]=(0.0)*D;
  A[22][58]=(1.1160714285714285e-04)*D;
  A[22][59]=(0.0)*D;
  A[23][0]=(0.0)*D;
  A[23][1]=(0.0)*D;
  A[23][2]=(2.2321428571428571e-04)*D;
  A[23][3]=(0.0)*D;
  A[23][4]=(0.0)*D;
  A[23][5]=(-1.0044642857142856e-03)*D;
  A[23][6]=(0.0)*D;
  A[23][7]=(0.0)*D;
  A[23][8]=(0.0)*D;
  A[23][9]=(0.0)*D;
  A[23][10]=(0.0)*D;
  A[23][11]=(1.1160714285714285e-04)*D;
  A[23][12]=(0.0)*D;
  A[23][13]=(0.0)*D;
  A[23][14]=(-2.0089285714285712e-03)*D;
  A[23][15]=(0.0)*D;
  A[23][16]=(0.0)*D;
  A[23][17]=(0.0)*D;
  A[23][18]=(0.0)*D;
  A[23][19]=(0.0)*D;
  A[23][20]=(-1.0044642857142856e-03)*D;
  A[23][21]=(0.0)*D;
  A[23][22]=(0.0)*D;
  A[23][23]=(4.0178571428571425e-03)*D;
  A[23][24]=(0.0)*D;
  A[23][25]=(0.0)*D;
  A[23][26]=(2.0089285714285712e-03)*D;
  A[23][27]=(0.0)*D;
  A[23][28]=(0.0)*D;
  A[23][29]=(-4.4642857142857141e-04)*D;
  A[23][30]=(0.0)*D;
  A[23][31]=(0.0)*D;
  A[23][32]=(-1.0044642857142856e-03)*D;
  A[23][33]=(0.0)*D;
  A[23][34]=(0.0)*D;
  A[23][35]=(-2.0089285714285712e-03)*D;
  A[23][36]=(0.0)*D;
  A[23][37]=(0.0)*D;
  A[23][38]=(0.0)*D;
  A[23][39]=(0.0)*D;
  A[23][40]=(0.0)*D;
  A[23][41]=(0.0)*D;
  A[23][42]=(0.0)*D;
  A[23][43]=(0.0)*D;
  A[23][44]=(0.0)*D;
  A[23][45]=(0.0)*D;
  A[23][46]=(0.0)*D;
  A[23][47]=(2.0089285714285712e-03)*D;
  A[23][48]=(0.0)*D;
  A[23][49]=(0.0)*D;
  A[23][50]=(0.0)*D;
  A[23][51]=(0.0)*D;
  A[23][52]=(0.0)*D;
  A[23][53]=(0.0)*D;
  A[23][54]=(0.0)*D;
  A[23][55]=(0.0)*D;
  A[23][56]=(-1.0044642857142856e-03)*D;
  A[23][57]=(0.0)*D;
  A[23][58]=(0.0)*D;
  A[23][59]=(1.1160714285714285e-04)*D;
  A[24][0]=(1.1160714285714285e-04)*D;
  A[24][1]=(0.0)*D;
  A[24][2]=(0.0)*D;
  A[24][3]=(0.0)*D;
  A[24][4]=(0.0)*D;
  A[24][5]=(0.0)*D;
  A[24][6]=(-1.0044642857142856e-03)*D;
  A[24][7]=(0.0)*D;
  A[24][8]=(0.0)*D;
  A[24][9]=(2.2321428571428571e-04)*D;
  A[24][10]=(0.0)*D;
  A[24][11]=(0.0)*D;
  A[24][12]=(-1.0044642857142856e-03)*D;
  A[24][13]=(0.0)*D;
  A[24][14]=(0.0)*D;
  A[24][15]=(0.0)*D;
  A[24][16]=(0.0)*D;
  A[24][17]=(0.0)*D;
  A[24][18]=(-2.0089285714285712e-03)*D;
  A[24][19]=(0.0)*D;
  A[24][20]=(0.0)*D;
  A[24][21]=(2.0089285714285712e-03)*D;
  A[24][22]=(0.0)*D;
  A[24][23]=(0.0)*D;
  A[24][24]=(4.0178571428571425e-03)*D;
  A[24][25]=(0.0)*D;
  A[24][26]=(0.0)*D;
  A[24][27]=(-4.4642857142857141e-04)*D;
  A[24][28]=(0.0)*D;
  A[24][29]=(0.0)*D;
  A[24][30]=(0.0)*D;
  A[24][31]=(0.0)*D;
  A[24][32]=(0.0)*D;
  A[24][33]=(-2.0089285714285712e-03)*D;
  A[24][34]=(0.0)*D;
  A[24][35]=(0.0)*D;
  A[24][36]=(-1.0044642857142856e-03)*D;
  A[24][37]=(0.0)*D;
  A[24][38]=(0.0)*D;
  A[24][39]=(0.0)*D;
  A[24][40]=(0.0)*D;
  A[24][41]=(0.0)*D;
  A[24][42]=(0.0)*D;
  A[24][43]=(0.0)*D;
  A[24][44]=(0.0)*D;
  A[24][45]=(2.0089285714285712e-03)*D;
  A[24][46]=(0.0)*D;
  A[24][47]=(0.0)*D;
  A[24][48]=(0.0)*D;
  A[24][49]=(0.0)*D;
  A[24][50]=(0.0)*D;
  A[24][51]=(0.0)*D;
  A[24][52]=(0.0)*D;
  A[24][53]=(0.0)*D;
  A[24][54]=(-1.0044642857142856e-03)*D;
  A[24][55]=(0.0)*D;
  A[24][56]=(0.0)*D;
  A[24][57]=(1.1160714285714285e-04)*D;
  A[24][58]=(0.0)*D;
  A[24][59]=(0.0)*D;
  A[25][0]=(0.0)*D;
  A[25][1]=(1.1160714285714285e-04)*D;
  A[25][2]=(0.0)*D;
  A[25][3]=(0.0)*D;
  A[25][4]=(0.0)*D;
  A[25][5]=(0.0)*D;
  A[25][6]=(0.0)*D;
  A[25][7]=(-1.0044642857142856e-03)*D;
  A[25][8]=(0.0)*D;
  A[25][9]=(0.0)*D;
  A[25][10]=(2.2321428571428571e-04)*D;
  A[25][11]=(0.0)*D;
  A[25][12]=(0.0)*D;
  A[25][13]=(-1.0044642857142856e-03)*D;
  A[25][14]=(0.0)*D;
  A[25][15]=(0.0)*D;
  A[25][16]=(0.0)*D;
  A[25][17]=(0.0)*D;
  A[25][18]=(0.0)*D;
  A[25][19]=(-2.0089285714285712e-03)*D;
  A[25][20]=(0.0)*D;
  A[25][21]=(0.0)*D;
  A[25][22]=(2.0089285714285712e-03)*D;
  A[25][23]=(0.0)*D;
  A[25][24]=(0.0)*D;
  A[25][25]=(4.0178571428571425e-03)*D;
  A[25][26]=(0.0)*D;
  A[25][27]=(0.0)*D;
  A[25][28]=(-4.4642857142857141e-04)*D;
  A[25][29]=(0.0)*D;
  A[25][30]=(0.0)*D;
  A[25][31]=(0.0)*D;
  A[25][32]=(0.0)*D;
  A[25][33]=(0.0)*D;
  A[25][34]=(-2.0089285714285712e-03)*D;
  A[25][35]=(0.0)*D;
  A[25][36]=(0.0)*D;
  A[25][37]=(-1.0044642857142856e-03)*D;
  A[25][38]=(0.0)*D;
  A[25][39]=(0.0)*D;
  A[25][40]=(0.0)*D;
  A[25][41]=(0.0)*D;
  A[25][42]=(0.0)*D;
  A[25][43]=(0.0)*D;
  A[25][44]=(0.0)*D;
  A[25][45]=(0.0)*D;
  A[25][46]=(2.0089285714285712e-03)*D;
  A[25][47]=(0.0)*D;
  A[25][48]=(0.0)*D;
  A[25][49]=(0.0)*D;
  A[25][50]=(0.0)*D;
  A[25][51]=(0.0)*D;
  A[25][52]=(0.0)*D;
  A[25][53]=(0.0)*D;
  A[25][54]=(0.0)*D;
  A[25][55]=(-1.0044642857142856e-03)*D;
  A[25][56]=(0.0)*D;
  A[25][57]=(0.0)*D;
  A[25][58]=(1.1160714285714285e-04)*D;
  A[25][59]=(0.0)*D;
  A[26][0]=(0.0)*D;
  A[26][1]=(0.0)*D;
  A[26][2]=(1.1160714285714285e-04)*D;
  A[26][3]=(0.0)*D;
  A[26][4]=(0.0)*D;
  A[26][5]=(0.0)*D;
  A[26][6]=(0.0)*D;
  A[26][7]=(0.0)*D;
  A[26][8]=(-1.0044642857142856e-03)*D;
  A[26][9]=(0.0)*D;
  A[26][10]=(0.0)*D;
  A[26][11]=(2.2321428571428571e-04)*D;
  A[26][12]=(0.0)*D;
  A[26][13]=(0.0)*D;
  A[26][14]=(-1.0044642857142856e-03)*D;
  A[26][15]=(0.0)*D;
  A[26][16]=(0.0)*D;
  A[26][17]=(0.0)*D;
  A[26][18]=(0.0)*D;
  A[26][19]=(0.0)*D;
  A[26][20]=(-2.0089285714285712e-03)*D;
  A[26][21]=(0.0)*D;
  A[26][22]=(0.0)*D;
  A[26][23]=(2.0089285714285712e-03)*D;
  A[26][24]=(0.0)*D;
  A[26][25]=(0.0)*D;
  A[26][26]=(4.0178571428571425e-03)*D;
  A[26][27]=(0.0)*D;
  A[26][28]=(0.0)*D;
  A[26][29]=(-4.4642857142857141e-04)*D;
  A[26][30]=(0.0)*D;
  A[26][31]=(0.0)*D;
  A[26][32]=(0.0)*D;
  A[26][33]=(0.0)*D;
  A[26][34]=(0.0)*D;
  A[26][35]=(-2.0089285714285712e-03)*D;
  A[26][36]=(0.0)*D;
  A[26][37]=(0.0)*D;
  A[26][38]=(-1.0044642857142856e-03)*D;
  A[26][39]=(0.0)*D;
  A[26][40]=(0.0)*D;
  A[26][41]=(0.0)*D;
  A[26][42]=(0.0)*D;
  A[26][43]=(0.0)*D;
  A[26][44]=(0.0)*D;
  A[26][45]=(0.0)*D;
  A[26][46]=(0.0)*D;
  A[26][47]=(2.0089285714285712e-03)*D;
  A[26][48]=(0.0)*D;
  A[26][49]=(0.0)*D;
  A[26][50]=(0.0)*D;
  A[26][51]=(0.0)*D;
  A[26][52]=(0.0)*D;
  A[26][53]=(0.0)*D;
  A[26][54]=(0.0)*D;
  A[26][55]=(0.0)*D;
  A[26][56]=(-1.0044642857142856e-03)*D;
  A[26][57]=(0.0)*D;
  A[26][58]=(0.0)*D;
  A[26][59]=(1.1160714285714285e-04)*D;
  A[27][0]=(7.4404761904761911e-05)*D;
  A[27][1]=(0.0)*D;
  A[27][2]=(0.0)*D;
  A[27][3]=(1.1160714285714285e-04)*D;
  A[27][4]=(0.0)*D;
  A[27][5]=(0.0)*D;
  A[27][6]=(1.1160714285714285e-04)*D;
  A[27][7]=(0.0)*D;
  A[27][8]=(0.0)*D;
  A[27][9]=(7.4404761904761911e-05)*D;
  A[27][10]=(0.0)*D;
  A[27][11]=(0.0)*D;
  A[27][12]=(2.2321428571428571e-04)*D;
  A[27][13]=(0.0)*D;
  A[27][14]=(0.0)*D;
  A[27][15]=(6.6964285714285715e-04)*D;
  A[27][16]=(0.0)*D;
  A[27][17]=(0.0)*D;
  A[27][18]=(2.2321428571428571e-04)*D;
  A[27][19]=(0.0)*D;
  A[27][20]=(0.0)*D;
  A[27][21]=(-4.4642857142857141e-04)*D;
  A[27][22]=(0.0)*D;
  A[27][23]=(0.0)*D;
  A[27][24]=(-4.4642857142857141e-04)*D;
  A[27][25]=(0.0)*D;
  A[27][26]=(0.0)*D;
  A[27][27]=(5.9523809523809529e-04)*D;
  A[27][28]=(0.0)*D;
  A[27][29]=(0.0)*D;
  A[27][30]=(1.1160714285714285e-04)*D;
  A[27][31]=(0.0)*D;
  A[27][32]=(0.0)*D;
  A[27][33]=(1.3392857142857143e-03)*D;
  A[27][34]=(0.0)*D;
  A[27][35]=(0.0)*D;
  A[27][36]=(1.1160714285714285e-04)*D;
  A[27][37]=(0.0)*D;
  A[27][38]=(0.0)*D;
  A[27][39]=(6.6964285714285715e-04)*D;
  A[27][40]=(0.0)*D;
  A[27][41]=(0.0)*D;
  A[27][42]=(6.6964285714285715e-04)*D;
  A[27][43]=(0.0)*D;
  A[27][44]=(0.0)*D;
  A[27][45]=(-4.4642857142857141e-04)*D;
  A[27][46]=(0.0)*D;
  A[27][47]=(0.0)*D;
  A[27][48]=(1.1160714285714285e-04)*D;
  A[27][49]=(0.0)*D;
  A[27][50]=(0.0)*D;
  A[27][51]=(1.1160714285714285e-04)*D;
  A[27][52]=(0.0)*D;
  A[27][53]=(0.0)*D;
  A[27][54]=(2.2321428571428571e-04)*D;
  A[27][55]=(0.0)*D;
  A[27][56]=(0.0)*D;
  A[27][57]=(7.4404761904761911e-05)*D;
  A[27][58]=(0.0)*D;
  A[27][59]=(0.0)*D;
  A[28][0]=(0.0)*D;
  A[28][1]=(7.4404761904761911e-05)*D;
  A[28][2]=(0.0)*D;
  A[28][3]=(0.0)*D;
  A[28][4]=(1.1160714285714285e-04)*D;
  A[28][5]=(0.0)*D;
  A[28][6]=(0.0)*D;
  A[28][7]=(1.1160714285714285e-04)*D;
  A[28][8]=(0.0)*D;
  A[28][9]=(0.0)*D;
  A[28][10]=(7.4404761904761911e-05)*D;
  A[28][11]=(0.0)*D;
  A[28][12]=(0.0)*D;
  A[28][13]=(2.2321428571428571e-04)*D;
  A[28][14]=(0.0)*D;
  A[28][15]=(0.0)*D;
  A[28][16]=(6.6964285714285715e-04)*D;
  A[28][17]=(0.0)*D;
  A[28][18]=(0.0)*D;
  A[28][19]=(2.2321428571428571e-04)*D;
  A[28][20]=(0.0)*D;
  A[28][21]=(0.0)*D;
  A[28][22]=(-4.4642857142857141e-04)*D;
  A[28][23]=(0.0)*D;
  A[28][24]=(0.0)*D;
  A[28][25]=(-4.4642857142857141e-04)*D;
  A[28][26]=(0.0)*D;
  A[28][27]=(0.0)*D;
  A[28][28]=(5.9523809523809529e-04)*D;
  A[28][29]=(0.0)*D;
  A[28][30]=(0.0)*D;
  A[28][31]=(1.1160714285714285e-04)*D;
  A[28][32]=(0.0)*D;
  A[28][33]=(0.0)*D;
  A[28][34]=(1.3392857142857143e-03)*D;
  A[28][35]=(0.0)*D;
  A[28][36]=(0.0)*D;
  A[28][37]=(1.1160714285714285e-04)*D;
  A[28][38]=(0.0)*D;
  A[28][39]=(0.0)*D;
  A[28][40]=(6.6964285714285715e-04)*D;
  A[28][41]=(0.0)*D;
  A[28][42]=(0.0)*D;
  A[28][43]=(6.6964285714285715e-04)*D;
  A[28][44]=(0.0)*D;
  A[28][45]=(0.0)*D;
  A[28][46]=(-4.4642857142857141e-04)*D;
  A[28][47]=(0.0)*D;
  A[28][48]=(0.0)*D;
  A[28][49]=(1.1160714285714285e-04)*D;
  A[28][50]=(0.0)*D;
  A[28][51]=(0.0)*D;
  A[28][52]=(1.1160714285714285e-04)*D;
  A[28][53]=(0.0)*D;
  A[28][54]=(0.0)*D;
  A[28][55]=(2.2321428571428571e-04)*D;
  A[28][56]=(0.0)*D;
  A[28][57]=(0.0)*D;
  A[28][58]=(7.4404761904761911e-05)*D;
  A[28][59]=(0.0)*D;
  A[29][0]=(0.0)*D;
  A[29][1]=(0.0)*D;
  A[29][2]=(7.4404761904761911e-05)*D;
  A[29][3]=(0.0)*D;
  A[29][4]=(0.0)*D;
  A[29][5]=(1.1160714285714285e-04)*D;
  A[29][6]=(0.0)*D;
  A[29][7]=(0.0)*D;
  A[29][8]=(1.1160714285714285e-04)*D;
  A[29][9]=(0.0)*D;
  A[29][10]=(0.0)*D;
  A[29][11]=(7.4404761904761911e-05)*D;
  A[29][12]=(0.0)*D;
  A[29][13]=(0.0)*D;
  A[29][14]=(2.2321428571428571e-04)*D;
  A[29][15]=(0.0)*D;
  A[29][16]=(0.0)*D;
  A[29][17]=(6.6964285714285715e-04)*D;
  A[29][18]=(0.0)*D;
  A[29][19]=(0.0)*D;
  A[29][20]=(2.2321428571428571e-04)*D;
  A[29][21]=(0.0)*D;
  A[29][22]=(0.0)*D;
  A[29][23]=(-4.4642857142857141e-04)*D;
  A[29][24]=(0.0)*D;
  A[29][25]=(0.0)*D;
  A[29][26]=(-4.4642857142857141e-04)*D;
  A[29][27]=(0.0)*D;
  A[29][28]=(0.0)*D;
  A[29][29]=(5.9523809523809529e-04)*D;
  A[29][30]=(0.0)*D;
  A[29][31]=(0.0)*D;
  A[29][32]=(1.1160714285714285e-04)*D;
  A[29][33]=(0.0)*D;
  A[29][34]=(0.0)*D;
  A[29][35]=(1.3392857142857143e-03)*D;
  A[29][36]=(0.0)*D;
  A[29][37]=(0.0)*D;
  A[29][38]=(1.1160714285714285e-04)*D;
  A[29][39]=(0.0)*D;
  A[29][40]=(0.0)*D;
  A[29][41]=(6.6964285714285715e-04)*D;
  A[29][42]=(0.0)*D;
  A[29][43]=(0.0)*D;
  A[29][44]=(6.6964285714285715e-04)*D;
  A[29][45]=(0.0)*D;
  A[29][46]=(0.0)*D;
  A[29][47]=(-4.4642857142857141e-04)*D;
  A[29][48]=(0.0)*D;
  A[29][49]=(0.0)*D;
  A[29][50]=(1.1160714285714285e-04)*D;
  A[29][51]=(0.0)*D;
  A[29][52]=(0.0)*D;
  A[29][53]=(1.1160714285714285e-04)*D;
  A[29][54]=(0.0)*D;
  A[29][55]=(0.0)*D;
  A[29][56]=(2.2321428571428571e-04)*D;
  A[29][57]=(0.0)*D;
  A[29][58]=(0.0)*D;
  A[29][59]=(7.4404761904761911e-05)*D;
  A[30][0]=(-4.4642857142857141e-04)*D;
  A[30][1]=(0.0)*D;
  A[30][2]=(0.0)*D;
  A[30][3]=(2.0089285714285712e-03)*D;
  A[30][4]=(0.0)*D;
  A[30][5]=(0.0)*D;
  A[30][6]=(-1.0044642857142856e-03)*D;
  A[30][7]=(0.0)*D;
  A[30][8]=(0.0)*D;
  A[30][9]=(1.1160714285714285e-04)*D;
  A[30][10]=(0.0)*D;
  A[30][11]=(0.0)*D;
  A[30][12]=(2.0089285714285712e-03)*D;
  A[30][13]=(0.0)*D;
  A[30][14]=(0.0)*D;
  A[30][15]=(0.0)*D;
  A[30][16]=(0.0)*D;
  A[30][17]=(0.0)*D;
  A[30][18]=(0.0)*D;
  A[30][19]=(0.0)*D;
  A[30][20]=(0.0)*D;
  A[30][21]=(-1.0044642857142856e-03)*D;
  A[30][22]=(0.0)*D;
  A[30][23]=(0.0)*D;
  A[30][24]=(0.0)*D;
  A[30][25]=(0.0)*D;
  A[30][26]=(0.0)*D;
  A[30][27]=(1.1160714285714285e-04)*D;
  A[30][28]=(0.0)*D;
  A[30][29]=(0.0)*D;
  A[30][30]=(4.0178571428571425e-03)*D;
  A[30][31]=(0.0)*D;
  A[30][32]=(0.0)*D;
  A[30][33]=(0.0)*D;
  A[30][34]=(0.0)*D;
  A[30][35]=(0.0)*D;
  A[30][36]=(0.0)*D;
  A[30][37]=(0.0)*D;
  A[30][38]=(0.0)*D;
  A[30][39]=(0.0)*D;
  A[30][40]=(0.0)*D;
  A[30][41]=(0.0)*D;
  A[30][42]=(-2.0089285714285712e-03)*D;
  A[30][43]=(0.0)*D;
  A[30][44]=(0.0)*D;
  A[30][45]=(0.0)*D;
  A[30][46]=(0.0)*D;
  A[30][47]=(0.0)*D;
  A[30][48]=(-2.0089285714285712e-03)*D;
  A[30][49]=(0.0)*D;
  A[30][50]=(0.0)*D;
  A[30][51]=(-1.0044642857142856e-03)*D;
  A[30][52]=(0.0)*D;
  A[30][53]=(0.0)*D;
  A[30][54]=(-1.0044642857142856e-03)*D;
  A[30][55]=(0.0)*D;
  A[30][56]=(0.0)*D;
  A[30][57]=(2.2321428571428571e-04)*D;
  A[30][58]=(0.0)*D;
  A[30][59]=(0.0)*D;
  A[31][0]=(0.0)*D;
  A[31][1]=(-4.4642857142857141e-04)*D;
  A[31][2]=(0.0)*D;
  A[31][3]=(0.0)*D;
  A[31][4]=(2.0089285714285712e-03)*D;
  A[31][5]=(0.0)*D;
  A[31][6]=(0.0)*D;
  A[31][7]=(-1.0044642857142856e-03)*D;
  A[31][8]=(0.0)*D;
  A[31][9]=(0.0)*D;
  A[31][10]=(1.1160714285714285e-04)*D;
  A[31][11]=(0.0)*D;
  A[31][12]=(0.0)*D;
  A[31][13]=(2.0089285714285712e-03)*D;
  A[31][14]=(0.0)*D;
  A[31][15]=(0.0)*D;
  A[31][16]=(0.0)*D;
  A[31][17]=(0.0)*D;
  A[31][18]=(0.0)*D;
  A[31][19]=(0.0)*D;
  A[31][20]=(0.0)*D;
  A[31][21]=(0.0)*D;
  A[31][22]=(-1.0044642857142856e-03)*D;
  A[31][23]=(0.0)*D;
  A[31][24]=(0.0)*D;
  A[31][25]=(0.0)*D;
  A[31][26]=(0.0)*D;
  A[31][27]=(0.0)*D;
  A[31][28]=(1.1160714285714285e-04)*D;
  A[31][29]=(0.0)*D;
  A[31][30]=(0.0)*D;
  A[31][31]=(4.0178571428571425e-03)*D;
  A[31][32]=(0.0)*D;
  A[31][33]=(0.0)*D;
  A[31][34]=(0.0)*D;
  A[31][35]=(0.0)*D;
  A[31][36]=(0.0)*D;
  A[31][37]=(0.0)*D;
  A[31][38]=(0.0)*D;
  A[31][39]=(0.0)*D;
  A[31][40]=(0.0)*D;
  A[31][41]=(0.0)*D;
  A[31][42]=(0.0)*D;
  A[31][43]=(-2.0089285714285712e-03)*D;
  A[31][44]=(0.0)*D;
  A[31][45]=(0.0)*D;
  A[31][46]=(0.0)*D;
  A[31][47]=(0.0)*D;
  A[31][48]=(0.0)*D;
  A[31][49]=(-2.0089285714285712e-03)*D;
  A[31][50]=(0.0)*D;
  A[31][51]=(0.0)*D;
  A[31][52]=(-1.0044642857142856e-03)*D;
  A[31][53]=(0.0)*D;
  A[31][54]=(0.0)*D;
  A[31][55]=(-1.0044642857142856e-03)*D;
  A[31][56]=(0.0)*D;
  A[31][57]=(0.0)*D;
  A[31][58]=(2.2321428571428571e-04)*D;
  A[31][59]=(0.0)*D;
  A[32][0]=(0.0)*D;
  A[32][1]=(0.0)*D;
  A[32][2]=(-4.4642857142857141e-04)*D;
  A[32][3]=(0.0)*D;
  A[32][4]=(0.0)*D;
  A[32][5]=(2.0089285714285712e-03)*D;
  A[32][6]=(0.0)*D;
  A[32][7]=(0.0)*D;
  A[32][8]=(-1.0044642857142856e-03)*D;
  A[32][9]=(0.0)*D;
  A[32][10]=(0.0)*D;
  A[32][11]=(1.1160714285714285e-04)*D;
  A[32][12]=(0.0)*D;
  A[32][13]=(0.0)*D;
  A[32][14]=(2.0089285714285712e-03)*D;
  A[32][15]=(0.0)*D;
  A[32][16]=(0.0)*D;
  A[32][17]=(0.0)*D;
  A[32][18]=(0.0)*D;
  A[32][19]=(0.0)*D;
  A[32][20]=(0.0)*D;
  A[32][21]=(0.0)*D;
  A[32][22]=(0.0)*D;
  A[32][23]=(-1.0044642857142856e-03)*D;
  A[32][24]=(0.0)*D;
  A[32][25]=(0.0)*D;
  A[32][26]=(0.0)*D;
  A[32][27]=(0.0)*D;
  A[32][28]=(0.0)*D;
  A[32][29]=(1.1160714285714285e-04)*D;
  A[32][30]=(0.0)*D;
  A[32][31]=(0.0)*D;
  A[32][32]=(4.0178571428571425e-03)*D;
  A[32][33]=(0.0)*D;
  A[32][34]=(0.0)*D;
  A[32][35]=(0.0)*D;
  A[32][36]=(0.0)*D;
  A[32][37]=(0.0)*D;
  A[32][38]=(0.0)*D;
  A[32][39]=(0.0)*D;
  A[32][40]=(0.0)*D;
  A[32][41]=(0.0)*D;
  A[32][42]=(0.0)*D;
  A[32][43]=(0.0)*D;
  A[32][44]=(-2.0089285714285712e-03)*D;
  A[32][45]=(0.0)*D;
  A[32][46]=(0.0)*D;
  A[32][47]=(0.0)*D;
  A[32][48]=(0.0)*D;
  A[32][49]=(0.0)*D;
  A[32][50]=(-2.0089285714285712e-03)*D;
  A[32][51]=(0.0)*D;
  A[32][52]=(0.0)*D;
  A[32][53]=(-1.0044642857142856e-03)*D;
  A[32][54]=(0.0)*D;
  A[32][55]=(0.0)*D;
  A[32][56]=(-1.0044642857142856e-03)*D;
  A[32][57]=(0.0)*D;
  A[32][58]=(0.0)*D;
  A[32][59]=(2.2321428571428571e-04)*D;
  A[33][0]=(6.6964285714285715e-04)*D;
  A[33][1]=(0.0)*D;
  A[33][2]=(0.0)*D;
  A[33][3]=(0.0)*D;
  A[33][4]=(0.0)*D;
  A[33][5]=(0.0)*D;
  A[33][6]=(0.0)*D;
  A[33][7]=(0.0)*D;
  A[33][8]=(0.0)*D;
  A[33][9]=(6.6964285714285715e-04)*D;
  A[33][10]=(0.0)*D;
  A[33][11]=(0.0)*D;
  A[33][12]=(0.0)*D;
  A[33][13]=(0.0)*D;
  A[33][14]=(0.0)*D;
  A[33][15]=(8.0357142857142849e-03)*D;
  A[33][16]=(0.0)*D;
  A[33][17]=(0.0)*D;
  A[33][18]=(0.0)*D;
  A[33][19]=(0.0)*D;
  A[33][20]=(0.0)*D;
  A[33][21]=(-2.0089285714285712e-03)*D;
  A[33][22]=(0.0)*D;
  A[33][23]=(0.0)*D;
  A[33][24]=(-2.0089285714285712e-03)*D;
  A[33][25]=(0.0)*D;
  A[33][26]=(0.0)*D;
  A[33][27]=(1.3392857142857143e-03)*D;
  A[33][28]=(0.0)*D;
  A[33][29]=(0.0)*D;
  A[33][30]=(0.0)*D;
  A[33][31]=(0.0)*D;
  A[33][32]=(0.0)*D;
  A[33][33]=(1.6071428571428570e-02)*D;
  A[33][34]=(0.0)*D;
  A[33][35]=(0.0)*D;
  A[33][36]=(0.0)*D;
  A[33][37]=(0.0)*D;
  A[33][38]=(0.0)*D;
  A[33][39]=(8.0357142857142849e-03)*D;
  A[33][40]=(0.0)*D;
  A[33][41]=(0.0)*D;
  A[33][42]=(8.0357142857142849e-03)*D;
  A[33][43]=(0.0)*D;
  A[33][44]=(0.0)*D;
  A[33][45]=(-2.0089285714285712e-03)*D;
  A[33][46]=(0.0)*D;
  A[33][47]=(0.0)*D;
  A[33][48]=(0.0)*D;
  A[33][49]=(0.0)*D;
  A[33][50]=(0.0)*D;
  A[33][51]=(0.0)*D;
  A[33][52]=(0.0)*D;
  A[33][53]=(0.0)*D;
  A[33][54]=(0.0)*D;
  A[33][55]=(0.0)*D;
  A[33][56]=(0.0)*D;
  A[33][57]=(6.6964285714285715e-04)*D;
  A[33][58]=(0.0)*D;
  A[33][59]=(0.0)*D;
  A[34][0]=(0.0)*D;
  A[34][1]=(6.6964285714285715e-04)*D;
  A[34][2]=(0.0)*D;
  A[34][3]=(0.0)*D;
  A[34][4]=(0.0)*D;
  A[34][5]=(0.0)*D;
  A[34][6]=(0.0)*D;
  A[34][7]=(0.0)*D;
  A[34][8]=(0.0)*D;
  A[34][9]=(0.0)*D;
  A[34][10]=(6.6964285714285715e-04)*D;
  A[34][11]=(0.0)*D;
  A[34][12]=(0.0)*D;
  A[34][13]=(0.0)*D;
  A[34][14]=(0.0)*D;
  A[34][15]=(0.0)*D;
  A[34][16]=(8.0357142857142849e-03)*D;
  A[34][17]=(0.0)*D;
  A[34][18]=(0.0)*D;
  A[34][19]=(0.0)*D;
  A[34][20]=(0.0)*D;
  A[34][21]=(0.0)*D;
  A[34][22]=(-2.0089285714285712e-03)*D;
  A[34][23]=(0.0)*D;
  A[34][24]=(0.0)*D;
  A[34][25]=(-2.0089285714285712e-03)*D;
  A[34][26]=(0.0)*D;
  A[34][27]=(0.0)*D;
  A[34][28]=(1.3392857142857143e-03)*D;
  A[34][29]=(0.0)*D;
  A[34][30]=(0.0)*D;
  A[34][31]=(0.0)*D;
  A[34][32]=(0.0)*D;
  A[34][33]=(0.0)*D;
  A[34][34]=(1.6071428571428570e-02)*D;
  A[34][35]=(0.0)*D;
  A[34][36]=(0.0)*D;
  A[34][37]=(0.0)*D;
  A[34][38]=(0.0)*D;
  A[34][39]=(0.0)*D;
  A[34][40]=(8.0357142857142849e-03)*D;
  A[34][41]=(0.0)*D;
  A[34][42]=(0.0)*D;
  A[34][43]=(8.0357142857142849e-03)*D;
  A[34][44]=(0.0)*D;
  A[34][45]=(0.0)*D;
  A[34][46]=(-2.0089285714285712e-03)*D;
  A[34][47]=(0.0)*D;
  A[34][48]=(0.0)*D;
  A[34][49]=(0.0)*D;
  A[34][50]=(0.0)*D;
  A[34][51]=(0.0)*D;
  A[34][52]=(0.0)*D;
  A[34][53]=(0.0)*D;
  A[34][54]=(0.0)*D;
  A[34][55]=(0.0)*D;
  A[34][56]=(0.0)*D;
  A[34][57]=(0.0)*D;
  A[34][58]=(6.6964285714285715e-04)*D;
  A[34][59]=(0.0)*D;
  A[35][0]=(0.0)*D;
  A[35][1]=(0.0)*D;
  A[35][2]=(6.6964285714285715e-04)*D;
  A[35][3]=(0.0)*D;
  A[35][4]=(0.0)*D;
  A[35][5]=(0.0)*D;
  A[35][6]=(0.0)*D;
  A[35][7]=(0.0)*D;
  A[35][8]=(0.0)*D;
  A[35][9]=(0.0)*D;
  A[35][10]=(0.0)*D;
  A[35][11]=(6.6964285714285715e-04)*D;
  A[35][12]=(0.0)*D;
  A[35][13]=(0.0)*D;
  A[35][14]=(0.0)*D;
  A[35][15]=(0.0)*D;
  A[35][16]=(0.0)*D;
  A[35][17]=(8.0357142857142849e-03)*D;
  A[35][18]=(0.0)*D;
  A[35][19]=(0.0)*D;
  A[35][20]=(0.0)*D;
  A[35][21]=(0.0)*D;
  A[35][22]=(0.0)*D;
  A[35][23]=(-2.0089285714285712e-03)*D;
  A[35][24]=(0.0)*D;
  A[35][25]=(0.0)*D;
  A[35][26]=(-2.0089285714285712e-03)*D;
  A[35][27]=(0.0)*D;
  A[35][28]=(0.0)*D;
  A[35][29]=(1.3392857142857143e-03)*D;
  A[35][30]=(0.0)*D;
  A[35][31]=(0.0)*D;
  A[35][32]=(0.0)*D;
  A[35][33]=(0.0)*D;
  A[35][34]=(0.0)*D;
  A[35][35]=(1.6071428571428570e-02)*D;
  A[35][36]=(0.0)*D;
  A[35][37]=(0.0)*D;
  A[35][38]=(0.0)*D;
  A[35][39]=(0.0)*D;
  A[35][40]=(0.0)*D;
  A[35][41]=(8.0357142857142849e-03)*D;
  A[35][42]=(0.0)*D;
  A[35][43]=(0.0)*D;
  A[35][44]=(8.0357142857142849e-03)*D;
  A[35][45]=(0.0)*D;
  A[35][46]=(0.0)*D;
  A[35][47]=(-2.0089285714285712e-03)*D;
  A[35][48]=(0.0)*D;
  A[35][49]=(0.0)*D;
  A[35][50]=(0.0)*D;
  A[35][51]=(0.0)*D;
  A[35][52]=(0.0)*D;
  A[35][53]=(0.0)*D;
  A[35][54]=(0.0)*D;
  A[35][55]=(0.0)*D;
  A[35][56]=(0.0)*D;
  A[35][57]=(0.0)*D;
  A[35][58]=(0.0)*D;
  A[35][59]=(6.6964285714285715e-04)*D;
  A[36][0]=(1.1160714285714285e-04)*D;
  A[36][1]=(0.0)*D;
  A[36][2]=(0.0)*D;
  A[36][3]=(-1.0044642857142856e-03)*D;
  A[36][4]=(0.0)*D;
  A[36][5]=(0.0)*D;
  A[36][6]=(2.0089285714285712e-03)*D;
  A[36][7]=(0.0)*D;
  A[36][8]=(0.0)*D;
  A[36][9]=(-4.4642857142857141e-04)*D;
  A[36][10]=(0.0)*D;
  A[36][11]=(0.0)*D;
  A[36][12]=(0.0)*D;
  A[36][13]=(0.0)*D;
  A[36][14]=(0.0)*D;
  A[36][15]=(0.0)*D;
  A[36][16]=(0.0)*D;
  A[36][17]=(0.0)*D;
  A[36][18]=(2.0089285714285712e-03)*D;
  A[36][19]=(0.0)*D;
  A[36][20]=(0.0)*D;
  A[36][21]=(0.0)*D;
  A[36][22]=(0.0)*D;
  A[36][23]=(0.0)*D;
  A[36][24]=(-1.0044642857142856e-03)*D;
  A[36][25]=(0.0)*D;
  A[36][26]=(0.0)*D;
  A[36][27]=(1.1160714285714285e-04)*D;
  A[36][28]=(0.0)*D;
  A[36][29]=(0.0)*D;
  A[36][30]=(0.0)*D;
  A[36][31]=(0.0)*D;
  A[36][32]=(0.0)*D;
  A[36][33]=(0.0)*D;
  A[36][34]=(0.0)*D;
  A[36][35]=(0.0)*D;
  A[36][36]=(4.0178571428571425e-03)*D;
  A[36][37]=(0.0)*D;
  A[36][38]=(0.0)*D;
  A[36][39]=(-2.0089285714285712e-03)*D;
  A[36][40]=(0.0)*D;
  A[36][41]=(0.0)*D;
  A[36][42]=(0.0)*D;
  A[36][43]=(0.0)*D;
  A[36][44]=(0.0)*D;
  A[36][45]=(0.0)*D;
  A[36][46]=(0.0)*D;
  A[36][47]=(0.0)*D;
  A[36][48]=(-1.0044642857142856e-03)*D;
  A[36][49]=(0.0)*D;
  A[36][50]=(0.0)*D;
  A[36][51]=(-2.0089285714285712e-03)*D;
  A[36][52]=(0.0)*D;
  A[36][53]=(0.0)*D;
  A[36][54]=(-1.0044642857142856e-03)*D;
  A[36][55]=(0.0)*D;
  A[36][56]=(0.0)*D;
  A[36][57]=(2.2321428571428571e-04)*D;
  A[36][58]=(0.0)*D;
  A[36][59]=(0.0)*D;
  A[37][0]=(0.0)*D;
  A[37][1]=(1.1160714285714285e-04)*D;
  A[37][2]=(0.0)*D;
  A[37][3]=(0.0)*D;
  A[37][4]=(-1.0044642857142856e-03)*D;
  A[37][5]=(0.0)*D;
  A[37][6]=(0.0)*D;
  A[37][7]=(2.0089285714285712e-03)*D;
  A[37][8]=(0.0)*D;
  A[37][9]=(0.0)*D;
  A[37][10]=(-4.4642857142857141e-04)*D;
  A[37][11]=(0.0)*D;
  A[37][12]=(0.0)*D;
  A[37][13]=(0.0)*D;
  A[37][14]=(0.0)*D;
  A[37][15]=(0.0)*D;
  A[37][16]=(0.0)*D;
  A[37][17]=(0.0)*D;
  A[37][18]=(0.0)*D;
  A[37][19]=(2.0089285714285712e-03)*D;
  A[37][20]=(0.0)*D;
  A[37][21]=(0.0)*D;
  A[37][22]=(0.0)*D;
  A[37][23]=(0.0)*D;
  A[37][24]=(0.0)*D;
  A[37][25]=(-1.0044642857142856e-03)*D;
  A[37][26]=(0.0)*D;
  A[37][27]=(0.0)*D;
  A[37][28]=(1.1160714285714285e-04)*D;
  A[37][29]=(0.0)*D;
  A[37][30]=(0.0)*D;
  A[37][31]=(0.0)*D;
  A[37][32]=(0.0)*D;
  A[37][33]=(0.0)*D;
  A[37][34]=(0.0)*D;
  A[37][35]=(0.0)*D;
  A[37][36]=(0.0)*D;
  A[37][37]=(4.0178571428571425e-03)*D;
  A[37][38]=(0.0)*D;
  A[37][39]=(0.0)*D;
  A[37][40]=(-2.0089285714285712e-03)*D;
  A[37][41]=(0.0)*D;
  A[37][42]=(0.0)*D;
  A[37][43]=(0.0)*D;
  A[37][44]=(0.0)*D;
  A[37][45]=(0.0)*D;
  A[37][46]=(0.0)*D;
  A[37][47]=(0.0)*D;
  A[37][48]=(0.0)*D;
  A[37][49]=(-1.0044642857142856e-03)*D;
  A[37][50]=(0.0)*D;
  A[37][51]=(0.0)*D;
  A[37][52]=(-2.0089285714285712e-03)*D;
  A[37][53]=(0.0)*D;
  A[37][54]=(0.0)*D;
  A[37][55]=(-1.0044642857142856e-03)*D;
  A[37][56]=(0.0)*D;
  A[37][57]=(0.0)*D;
  A[37][58]=(2.2321428571428571e-04)*D;
  A[37][59]=(0.0)*D;
  A[38][0]=(0.0)*D;
  A[38][1]=(0.0)*D;
  A[38][2]=(1.1160714285714285e-04)*D;
  A[38][3]=(0.0)*D;
  A[38][4]=(0.0)*D;
  A[38][5]=(-1.0044642857142856e-03)*D;
  A[38][6]=(0.0)*D;
  A[38][7]=(0.0)*D;
  A[38][8]=(2.0089285714285712e-03)*D;
  A[38][9]=(0.0)*D;
  A[38][10]=(0.0)*D;
  A[38][11]=(-4.4642857142857141e-04)*D;
  A[38][12]=(0.0)*D;
  A[38][13]=(0.0)*D;
  A[38][14]=(0.0)*D;
  A[38][15]=(0.0)*D;
  A[38][16]=(0.0)*D;
  A[38][17]=(0.0)*D;
  A[38][18]=(0.0)*D;
  A[38][19]=(0.0)*D;
  A[38][20]=(2.0089285714285712e-03)*D;
  A[38][21]=(0.0)*D;
  A[38][22]=(0.0)*D;
  A[38][23]=(0.0)*D;
  A[38][24]=(0.0)*D;
  A[38][25]=(0.0)*D;
  A[38][26]=(-1.0044642857142856e-03)*D;
  A[38][27]=(0.0)*D;
  A[38][28]=(0.0)*D;
  A[38][29]=(1.1160714285714285e-04)*D;
  A[38][30]=(0.0)*D;
  A[38][31]=(0.0)*D;
  A[38][32]=(0.0)*D;
  A[38][33]=(0.0)*D;
  A[38][34]=(0.0)*D;
  A[38][35]=(0.0)*D;
  A[38][36]=(0.0)*D;
  A[38][37]=(0.0)*D;
  A[38][38]=(4.0178571428571425e-03)*D;
  A[38][39]=(0.0)*D;
  A[38][40]=(0.0)*D;
  A[38][41]=(-2.0089285714285712e-03)*D;
  A[38][42]=(0.0)*D;
  A[38][43]=(0.0)*D;
  A[38][44]=(0.0)*D;
  A[38][45]=(0.0)*D;
  A[38][46]=(0.0)*D;
  A[38][47]=(0.0)*D;
  A[38][48]=(0.0)*D;
  A[38][49]=(0.0)*D;
  A[38][50]=(-1.0044642857142856e-03)*D;
  A[38][51]=(0.0)*D;
  A[38][52]=(0.0)*D;
  A[38][53]=(-2.0089285714285712e-03)*D;
  A[38][54]=(0.0)*D;
  A[38][55]=(0.0)*D;
  A[38][56]=(-1.0044642857142856e-03)*D;
  A[38][57]=(0.0)*D;
  A[38][58]=(0.0)*D;
  A[38][59]=(2.2321428571428571e-04)*D;
  A[39][0]=(6.6964285714285715e-04)*D;
  A[39][1]=(0.0)*D;
  A[39][2]=(0.0)*D;
  A[39][3]=(0.0)*D;
  A[39][4]=(0.0)*D;
  A[39][5]=(0.0)*D;
  A[39][6]=(-2.0089285714285712e-03)*D;
  A[39][7]=(0.0)*D;
  A[39][8]=(0.0)*D;
  A[39][9]=(1.3392857142857143e-03)*D;
  A[39][10]=(0.0)*D;
  A[39][11]=(0.0)*D;
  A[39][12]=(0.0)*D;
  A[39][13]=(0.0)*D;
  A[39][14]=(0.0)*D;
  A[39][15]=(8.0357142857142849e-03)*D;
  A[39][16]=(0.0)*D;
  A[39][17]=(0.0)*D;
  A[39][18]=(-2.0089285714285712e-03)*D;
  A[39][19]=(0.0)*D;
  A[39][20]=(0.0)*D;
  A[39][21]=(0.0)*D;
  A[39][22]=(0.0)*D;
  A[39][23]=(0.0)*D;
  A[39][24]=(0.0)*D;
  A[39][25]=(0.0)*D;
  A[39][26]=(0.0)*D;
  A[39][27]=(6.6964285714285715e-04)*D;
  A[39][28]=(0.0)*D;
  A[39][29]=(0.0)*D;
  A[39][30]=(0.0)*D;
  A[39][31]=(0.0)*D;
  A[39][32]=(0.0)*D;
  A[39][33]=(8.0357142857142849e-03)*D;
  A[39][34]=(0.0)*D;
  A[39][35]=(0.0)*D;
  A[39][36]=(-2.0089285714285712e-03)*D;
  A[39][37]=(0.0)*D;
  A[39][38]=(0.0)*D;
  A[39][39]=(1.6071428571428570e-02)*D;
  A[39][40]=(0.0)*D;
  A[39][41]=(0.0)*D;
  A[39][42]=(8.0357142857142849e-03)*D;
  A[39][43]=(0.0)*D;
  A[39][44]=(0.0)*D;
  A[39][45]=(0.0)*D;
  A[39][46]=(0.0)*D;
  A[39][47]=(0.0)*D;
  A[39][48]=(0.0)*D;
  A[39][49]=(0.0)*D;
  A[39][50]=(0.0)*D;
  A[39][51]=(0.0)*D;
  A[39][52]=(0.0)*D;
  A[39][53]=(0.0)*D;
  A[39][54]=(0.0)*D;
  A[39][55]=(0.0)*D;
  A[39][56]=(0.0)*D;
  A[39][57]=(6.6964285714285715e-04)*D;
  A[39][58]=(0.0)*D;
  A[39][59]=(0.0)*D;
  A[40][0]=(0.0)*D;
  A[40][1]=(6.6964285714285715e-04)*D;
  A[40][2]=(0.0)*D;
  A[40][3]=(0.0)*D;
  A[40][4]=(0.0)*D;
  A[40][5]=(0.0)*D;
  A[40][6]=(0.0)*D;
  A[40][7]=(-2.0089285714285712e-03)*D;
  A[40][8]=(0.0)*D;
  A[40][9]=(0.0)*D;
  A[40][10]=(1.3392857142857143e-03)*D;
  A[40][11]=(0.0)*D;
  A[40][12]=(0.0)*D;
  A[40][13]=(0.0)*D;
  A[40][14]=(0.0)*D;
  A[40][15]=(0.0)*D;
  A[40][16]=(8.0357142857142849e-03)*D;
  A[40][17]=(0.0)*D;
  A[40][18]=(0.0)*D;
  A[40][19]=(-2.0089285714285712e-03)*D;
  A[40][20]=(0.0)*D;
  A[40][21]=(0.0)*D;
  A[40][22]=(0.0)*D;
  A[40][23]=(0.0)*D;
  A[40][24]=(0.0)*D;
  A[40][25]=(0.0)*D;
  A[40][26]=(0.0)*D;
  A[40][27]=(0.0)*D;
  A[40][28]=(6.6964285714285715e-04)*D;
  A[40][29]=(0.0)*D;
  A[40][30]=(0.0)*D;
  A[40][31]=(0.0)*D;
  A[40][32]=(0.0)*D;
  A[40][33]=(0.0)*D;
  A[40][34]=(8.0357142857142849e-03)*D;
  A[40][35]=(0.0)*D;
  A[40][36]=(0.0)*D;
  A[40][37]=(-2.0089285714285712e-03)*D;
  A[40][38]=(0.0)*D;
  A[40][39]=(0.0)*D;
  A[40][40]=(1.6071428571428570e-02)*D;
  A[40][41]=(0.0)*D;
  A[40][42]=(0.0)*D;
  A[40][43]=(8.0357142857142849e-03)*D;
  A[40][44]=(0.0)*D;
  A[40][45]=(0.0)*D;
  A[40][46]=(0.0)*D;
  A[40][47]=(0.0)*D;
  A[40][48]=(0.0)*D;
  A[40][49]=(0.0)*D;
  A[40][50]=(0.0)*D;
  A[40][51]=(0.0)*D;
  A[40][52]=(0.0)*D;
  A[40][53]=(0.0)*D;
  A[40][54]=(0.0)*D;
  A[40][55]=(0.0)*D;
  A[40][56]=(0.0)*D;
  A[40][57]=(0.0)*D;
  A[40][58]=(6.6964285714285715e-04)*D;
  A[40][59]=(0.0)*D;
  A[41][0]=(0.0)*D;
  A[41][1]=(0.0)*D;
  A[41][2]=(6.6964285714285715e-04)*D;
  A[41][3]=(0.0)*D;
  A[41][4]=(0.0)*D;
  A[41][5]=(0.0)*D;
  A[41][6]=(0.0)*D;
  A[41][7]=(0.0)*D;
  A[41][8]=(-2.0089285714285712e-03)*D;
  A[41][9]=(0.0)*D;
  A[41][10]=(0.0)*D;
  A[41][11]=(1.3392857142857143e-03)*D;
  A[41][12]=(0.0)*D;
  A[41][13]=(0.0)*D;
  A[41][14]=(0.0)*D;
  A[41][15]=(0.0)*D;
  A[41][16]=(0.0)*D;
  A[41][17]=(8.0357142857142849e-03)*D;
  A[41][18]=(0.0)*D;
  A[41][19]=(0.0)*D;
  A[41][20]=(-2.0089285714285712e-03)*D;
  A[41][21]=(0.0)*D;
  A[41][22]=(0.0)*D;
  A[41][23]=(0.0)*D;
  A[41][24]=(0.0)*D;
  A[41][25]=(0.0)*D;
  A[41][26]=(0.0)*D;
  A[41][27]=(0.0)*D;
  A[41][28]=(0.0)*D;
  A[41][29]=(6.6964285714285715e-04)*D;
  A[41][30]=(0.0)*D;
  A[41][31]=(0.0)*D;
  A[41][32]=(0.0)*D;
  A[41][33]=(0.0)*D;
  A[41][34]=(0.0)*D;
  A[41][35]=(8.0357142857142849e-03)*D;
  A[41][36]=(0.0)*D;
  A[41][37]=(0.0)*D;
  A[41][38]=(-2.0089285714285712e-03)*D;
  A[41][39]=(0.0)*D;
  A[41][40]=(0.0)*D;
  A[41][41]=(1.6071428571428570e-02)*D;
  A[41][42]=(0.0)*D;
  A[41][43]=(0.0)*D;
  A[41][44]=(8.0357142857142849e-03)*D;
  A[41][45]=(0.0)*D;
  A[41][46]=(0.0)*D;
  A[41][47]=(0.0)*D;
  A[41][48]=(0.0)*D;
  A[41][49]=(0.0)*D;
  A[41][50]=(0.0)*D;
  A[41][51]=(0.0)*D;
  A[41][52]=(0.0)*D;
  A[41][53]=(0.0)*D;
  A[41][54]=(0.0)*D;
  A[41][55]=(0.0)*D;
  A[41][56]=(0.0)*D;
  A[41][57]=(0.0)*D;
  A[41][58]=(0.0)*D;
  A[41][59]=(6.6964285714285715e-04)*D;
  A[42][0]=(1.3392857142857143e-03)*D;
  A[42][1]=(0.0)*D;
  A[42][2]=(0.0)*D;
  A[42][3]=(-2.0089285714285712e-03)*D;
  A[42][4]=(0.0)*D;
  A[42][5]=(0.0)*D;
  A[42][6]=(0.0)*D;
  A[42][7]=(0.0)*D;
  A[42][8]=(0.0)*D;
  A[42][9]=(6.6964285714285715e-04)*D;
  A[42][10]=(0.0)*D;
  A[42][11]=(0.0)*D;
  A[42][12]=(-2.0089285714285712e-03)*D;
  A[42][13]=(0.0)*D;
  A[42][14]=(0.0)*D;
  A[42][15]=(8.0357142857142849e-03)*D;
  A[42][16]=(0.0)*D;
  A[42][17]=(0.0)*D;
  A[42][18]=(0.0)*D;
  A[42][19]=(0.0)*D;
  A[42][20]=(0.0)*D;
  A[42][21]=(0.0)*D;
  A[42][22]=(0.0)*D;
  A[42][23]=(0.0)*D;
  A[42][24]=(0.0)*D;
  A[42][25]=(0.0)*D;
  A[42][26]=(0.0)*D;
  A[42][27]=(6.6964285714285715e-04)*D;
  A[42][28]=(0.0)*D;
  A[42][29]=(0.0)*D;
  A[42][30]=(-2.0089285714285712e-03)*D;
  A[42][31]=(0.0)*D;
  A[42][32]=(0.0)*D;
  A[42][33]=(8.0357142857142849e-03)*D;
  A[42][34]=(0.0)*D;
  A[42][35]=(0.0)*D;
  A[42][36]=(0.0)*D;
  A[42][37]=(0.0)*D;
  A[42][38]=(0.0)*D;
  A[42][39]=(8.0357142857142849e-03)*D;
  A[42][40]=(0.0)*D;
  A[42][41]=(0.0)*D;
  A[42][42]=(1.6071428571428570e-02)*D;
  A[42][43]=(0.0)*D;
  A[42][44]=(0.0)*D;
  A[42][45]=(0.0)*D;
  A[42][46]=(0.0)*D;
  A[42][47]=(0.0)*D;
  A[42][48]=(0.0)*D;
  A[42][49]=(0.0)*D;
  A[42][50]=(0.0)*D;
  A[42][51]=(0.0)*D;
  A[42][52]=(0.0)*D;
  A[42][53]=(0.0)*D;
  A[42][54]=(0.0)*D;
  A[42][55]=(0.0)*D;
  A[42][56]=(0.0)*D;
  A[42][57]=(6.6964285714285715e-04)*D;
  A[42][58]=(0.0)*D;
  A[42][59]=(0.0)*D;
  A[43][0]=(0.0)*D;
  A[43][1]=(1.3392857142857143e-03)*D;
  A[43][2]=(0.0)*D;
  A[43][3]=(0.0)*D;
  A[43][4]=(-2.0089285714285712e-03)*D;
  A[43][5]=(0.0)*D;
  A[43][6]=(0.0)*D;
  A[43][7]=(0.0)*D;
  A[43][8]=(0.0)*D;
  A[43][9]=(0.0)*D;
  A[43][10]=(6.6964285714285715e-04)*D;
  A[43][11]=(0.0)*D;
  A[43][12]=(0.0)*D;
  A[43][13]=(-2.0089285714285712e-03)*D;
  A[43][14]=(0.0)*D;
  A[43][15]=(0.0)*D;
  A[43][16]=(8.0357142857142849e-03)*D;
  A[43][17]=(0.0)*D;
  A[43][18]=(0.0)*D;
  A[43][19]=(0.0)*D;
  A[43][20]=(0.0)*D;
  A[43][21]=(0.0)*D;
  A[43][22]=(0.0)*D;
  A[43][23]=(0.0)*D;
  A[43][24]=(0.0)*D;
  A[43][25]=(0.0)*D;
  A[43][26]=(0.0)*D;
  A[43][27]=(0.0)*D;
  A[43][28]=(6.6964285714285715e-04)*D;
  A[43][29]=(0.0)*D;
  A[43][30]=(0.0)*D;
  A[43][31]=(-2.0089285714285712e-03)*D;
  A[43][32]=(0.0)*D;
  A[43][33]=(0.0)*D;
  A[43][34]=(8.0357142857142849e-03)*D;
  A[43][35]=(0.0)*D;
  A[43][36]=(0.0)*D;
  A[43][37]=(0.0)*D;
  A[43][38]=(0.0)*D;
  A[43][39]=(0.0)*D;
  A[43][40]=(8.0357142857142849e-03)*D;
  A[43][41]=(0.0)*D;
  A[43][42]=(0.0)*D;
  A[43][43]=(1.6071428571428570e-02)*D;
  A[43][44]=(0.0)*D;
  A[43][45]=(0.0)*D;
  A[43][46]=(0.0)*D;
  A[43][47]=(0.0)*D;
  A[43][48]=(0.0)*D;
  A[43][49]=(0.0)*D;
  A[43][50]=(0.0)*D;
  A[43][51]=(0.0)*D;
  A[43][52]=(0.0)*D;
  A[43][53]=(0.0)*D;
  A[43][54]=(0.0)*D;
  A[43][55]=(0.0)*D;
  A[43][56]=(0.0)*D;
  A[43][57]=(0.0)*D;
  A[43][58]=(6.6964285714285715e-04)*D;
  A[43][59]=(0.0)*D;
  A[44][0]=(0.0)*D;
  A[44][1]=(0.0)*D;
  A[44][2]=(1.3392857142857143e-03)*D;
  A[44][3]=(0.0)*D;
  A[44][4]=(0.0)*D;
  A[44][5]=(-2.0089285714285712e-03)*D;
  A[44][6]=(0.0)*D;
  A[44][7]=(0.0)*D;
  A[44][8]=(0.0)*D;
  A[44][9]=(0.0)*D;
  A[44][10]=(0.0)*D;
  A[44][11]=(6.6964285714285715e-04)*D;
  A[44][12]=(0.0)*D;
  A[44][13]=(0.0)*D;
  A[44][14]=(-2.0089285714285712e-03)*D;
  A[44][15]=(0.0)*D;
  A[44][16]=(0.0)*D;
  A[44][17]=(8.0357142857142849e-03)*D;
  A[44][18]=(0.0)*D;
  A[44][19]=(0.0)*D;
  A[44][20]=(0.0)*D;
  A[44][21]=(0.0)*D;
  A[44][22]=(0.0)*D;
  A[44][23]=(0.0)*D;
  A[44][24]=(0.0)*D;
  A[44][25]=(0.0)*D;
  A[44][26]=(0.0)*D;
  A[44][27]=(0.0)*D;
  A[44][28]=(0.0)*D;
  A[44][29]=(6.6964285714285715e-04)*D;
  A[44][30]=(0.0)*D;
  A[44][31]=(0.0)*D;
  A[44][32]=(-2.0089285714285712e-03)*D;
  A[44][33]=(0.0)*D;
  A[44][34]=(0.0)*D;
  A[44][35]=(8.0357142857142849e-03)*D;
  A[44][36]=(0.0)*D;
  A[44][37]=(0.0)*D;
  A[44][38]=(0.0)*D;
  A[44][39]=(0.0)*D;
  A[44][40]=(0.0)*D;
  A[44][41]=(8.0357142857142849e-03)*D;
  A[44][42]=(0.0)*D;
  A[44][43]=(0.0)*D;
  A[44][44]=(1.6071428571428570e-02)*D;
  A[44][45]=(0.0)*D;
  A[44][46]=(0.0)*D;
  A[44][47]=(0.0)*D;
  A[44][48]=(0.0)*D;
  A[44][49]=(0.0)*D;
  A[44][50]=(0.0)*D;
  A[44][51]=(0.0)*D;
  A[44][52]=(0.0)*D;
  A[44][53]=(0.0)*D;
  A[44][54]=(0.0)*D;
  A[44][55]=(0.0)*D;
  A[44][56]=(0.0)*D;
  A[44][57]=(0.0)*D;
  A[44][58]=(0.0)*D;
  A[44][59]=(6.6964285714285715e-04)*D;
  A[45][0]=(1.1160714285714285e-04)*D;
  A[45][1]=(0.0)*D;
  A[45][2]=(0.0)*D;
  A[45][3]=(0.0)*D;
  A[45][4]=(0.0)*D;
  A[45][5]=(0.0)*D;
  A[45][6]=(0.0)*D;
  A[45][7]=(0.0)*D;
  A[45][8]=(0.0)*D;
  A[45][9]=(1.1160714285714285e-04)*D;
  A[45][10]=(0.0)*D;
  A[45][11]=(0.0)*D;
  A[45][12]=(-1.0044642857142856e-03)*D;
  A[45][13]=(0.0)*D;
  A[45][14]=(0.0)*D;
  A[45][15]=(0.0)*D;
  A[45][16]=(0.0)*D;
  A[45][17]=(0.0)*D;
  A[45][18]=(-1.0044642857142856e-03)*D;
  A[45][19]=(0.0)*D;
  A[45][20]=(0.0)*D;
  A[45][21]=(2.0089285714285712e-03)*D;
  A[45][22]=(0.0)*D;
  A[45][23]=(0.0)*D;
  A[45][24]=(2.0089285714285712e-03)*D;
  A[45][25]=(0.0)*D;
  A[45][26]=(0.0)*D;
  A[45][27]=(-4.4642857142857141e-04)*D;
  A[45][28]=(0.0)*D;
  A[45][29]=(0.0)*D;
  A[45][30]=(0.0)*D;
  A[45][31]=(0.0)*D;
  A[45][32]=(0.0)*D;
  A[45][33]=(-2.0089285714285712e-03)*D;
  A[45][34]=(0.0)*D;
  A[45][35]=(0.0)*D;
  A[45][36]=(0.0)*D;
  A[45][37]=(0.0)*D;
  A[45][38]=(0.0)*D;
  A[45][39]=(0.0)*D;
  A[45][40]=(0.0)*D;
  A[45][41]=(0.0)*D;
  A[45][42]=(0.0)*D;
  A[45][43]=(0.0)*D;
  A[45][44]=(0.0)*D;
  A[45][45]=(4.0178571428571425e-03)*D;
  A[45][46]=(0.0)*D;
  A[45][47]=(0.0)*D;
  A[45][48]=(-1.0044642857142856e-03)*D;
  A[45][49]=(0.0)*D;
  A[45][50]=(0.0)*D;
  A[45][51]=(-1.0044642857142856e-03)*D;
  A[45][52]=(0.0)*D;
  A[45][53]=(0.0)*D;
  A[45][54]=(-2.0089285714285712e-03)*D;
  A[45][55]=(0.0)*D;
  A[45][56]=(0.0)*D;
  A[45][57]=(2.2321428571428571e-04)*D;
  A[45][58]=(0.0)*D;
  A[45][59]=(0.0)*D;
  A[46][0]=(0.0)*D;
  A[46][1]=(1.1160714285714285e-04)*D;
  A[46][2]=(0.0)*D;
  A[46][3]=(0.0)*D;
  A[46][4]=(0.0)*D;
  A[46][5]=(0.0)*D;
  A[46][6]=(0.0)*D;
  A[46][7]=(0.0)*D;
  A[46][8]=(0.0)*D;
  A[46][9]=(0.0)*D;
  A[46][10]=(1.1160714285714285e-04)*D;
  A[46][11]=(0.0)*D;
  A[46][12]=(0.0)*D;
  A[46][13]=(-1.0044642857142856e-03)*D;
  A[46][14]=(0.0)*D;
  A[46][15]=(0.0)*D;
  A[46][16]=(0.0)*D;
  A[46][17]=(0.0)*D;
  A[46][18]=(0.0)*D;
  A[46][19]=(-1.0044642857142856e-03)*D;
  A[46][20]=(0.0)*D;
  A[46][21]=(0.0)*D;
  A[46][22]=(2.0089285714285712e-03)*D;
  A[46][23]=(0.0)*D;
  A[46][24]=(0.0)*D;
  A[46][25]=(2.0089285714285712e-03)*D;
  A[46][26]=(0.0)*D;
  A[46][27]=(0.0)*D;
  A[46][28]=(-4.4642857142857141e-04)*D;
  A[46][29]=(0.0)*D;
  A[46][30]=(0.0)*D;
  A[46][31]=(0.0)*D;
  A[46][32]=(0.0)*D;
  A[46][33]=(0.0)*D;
  A[46][34]=(-2.0089285714285712e-03)*D;
  A[46][35]=(0.0)*D;
  A[46][36]=(0.0)*D;
  A[46][37]=(0.0)*D;
  A[46][38]=(0.0)*D;
  A[46][39]=(0.0)*D;
  A[46][40]=(0.0)*D;
  A[46][41]=(0.0)*D;
  A[46][42]=(0.0)*D;
  A[46][43]=(0.0)*D;
  A[46][44]=(0.0)*D;
  A[46][45]=(0.0)*D;
  A[46][46]=(4.0178571428571425e-03)*D;
  A[46][47]=(0.0)*D;
  A[46][48]=(0.0)*D;
  A[46][49]=(-1.0044642857142856e-03)*D;
  A[46][50]=(0.0)*D;
  A[46][51]=(0.0)*D;
  A[46][52]=(-1.0044642857142856e-03)*D;
  A[46][53]=(0.0)*D;
  A[46][54]=(0.0)*D;
  A[46][55]=(-2.0089285714285712e-03)*D;
  A[46][56]=(0.0)*D;
  A[46][57]=(0.0)*D;
  A[46][58]=(2.2321428571428571e-04)*D;
  A[46][59]=(0.0)*D;
  A[47][0]=(0.0)*D;
  A[47][1]=(0.0)*D;
  A[47][2]=(1.1160714285714285e-04)*D;
  A[47][3]=(0.0)*D;
  A[47][4]=(0.0)*D;
  A[47][5]=(0.0)*D;
  A[47][6]=(0.0)*D;
  A[47][7]=(0.0)*D;
  A[47][8]=(0.0)*D;
  A[47][9]=(0.0)*D;
  A[47][10]=(0.0)*D;
  A[47][11]=(1.1160714285714285e-04)*D;
  A[47][12]=(0.0)*D;
  A[47][13]=(0.0)*D;
  A[47][14]=(-1.0044642857142856e-03)*D;
  A[47][15]=(0.0)*D;
  A[47][16]=(0.0)*D;
  A[47][17]=(0.0)*D;
  A[47][18]=(0.0)*D;
  A[47][19]=(0.0)*D;
  A[47][20]=(-1.0044642857142856e-03)*D;
  A[47][21]=(0.0)*D;
  A[47][22]=(0.0)*D;
  A[47][23]=(2.0089285714285712e-03)*D;
  A[47][24]=(0.0)*D;
  A[47][25]=(0.0)*D;
  A[47][26]=(2.0089285714285712e-03)*D;
  A[47][27]=(0.0)*D;
  A[47][28]=(0.0)*D;
  A[47][29]=(-4.4642857142857141e-04)*D;
  A[47][30]=(0.0)*D;
  A[47][31]=(0.0)*D;
  A[47][32]=(0.0)*D;
  A[47][33]=(0.0)*D;
  A[47][34]=(0.0)*D;
  A[47][35]=(-2.0089285714285712e-03)*D;
  A[47][36]=(0.0)*D;
  A[47][37]=(0.0)*D;
  A[47][38]=(0.0)*D;
  A[47][39]=(0.0)*D;
  A[47][40]=(0.0)*D;
  A[47][41]=(0.0)*D;
  A[47][42]=(0.0)*D;
  A[47][43]=(0.0)*D;
  A[47][44]=(0.0)*D;
  A[47][45]=(0.0)*D;
  A[47][46]=(0.0)*D;
  A[47][47]=(4.0178571428571425e-03)*D;
  A[47][48]=(0.0)*D;
  A[47][49]=(0.0)*D;
  A[47][50]=(-1.0044642857142856e-03)*D;
  A[47][51]=(0.0)*D;
  A[47][52]=(0.0)*D;
  A[47][53]=(-1.0044642857142856e-03)*D;
  A[47][54]=(0.0)*D;
  A[47][55]=(0.0)*D;
  A[47][56]=(-2.0089285714285712e-03)*D;
  A[47][57]=(0.0)*D;
  A[47][58]=(0.0)*D;
  A[47][59]=(2.2321428571428571e-04)*D;
  A[48][0]=(2.2321428571428571e-04)*D;
  A[48][1]=(0.0)*D;
  A[48][2]=(0.0)*D;
  A[48][3]=(-1.0044642857142856e-03)*D;
  A[48][4]=(0.0)*D;
  A[48][5]=(0.0)*D;
  A[48][6]=(0.0)*D;
  A[48][7]=(0.0)*D;
  A[48][8]=(0.0)*D;
  A[48][9]=(1.1160714285714285e-04)*D;
  A[48][10]=(0.0)*D;
  A[48][11]=(0.0)*D;
  A[48][12]=(-1.0044642857142856e-03)*D;
  A[48][13]=(0.0)*D;
  A[48][14]=(0.0)*D;
  A[48][15]=(-2.0089285714285712e-03)*D;
  A[48][16]=(0.0)*D;
  A[48][17]=(0.0)*D;
  A[48][18]=(0.0)*D;
  A[48][19]=(0.0)*D;
  A[48][20]=(0.0)*D;
  A[48][21]=(0.0)*D;
  A[48][22]=(0.0)*D;
  A[48][23]=(0.0)*D;
  A[48][24]=(0.0)*D;
  A[48][25]=(0.0)*D;
  A[48][26]=(0.0)*D;
  A[48][27]=(1.1160714285714285e-04)*D;
  A[48][28]=(0.0)*D;
  A[48][29]=(0.0)*D;
  A[48][30]=(-2.0089285714285712e-03)*D;
  A[48][31]=(0.0)*D;
  A[48][32]=(0.0)*D;
  A[48][33]=(0.0)*D;
  A[48][34]=(0.0)*D;
  A[48][35]=(0.0)*D;
  A[48][36]=(-1.0044642857142856e-03)*D;
  A[48][37]=(0.0)*D;
  A[48][38]=(0.0)*D;
  A[48][39]=(0.0)*D;
  A[48][40]=(0.0)*D;
  A[48][41]=(0.0)*D;
  A[48][42]=(0.0)*D;
  A[48][43]=(0.0)*D;
  A[48][44]=(0.0)*D;
  A[48][45]=(-1.0044642857142856e-03)*D;
  A[48][46]=(0.0)*D;
  A[48][47]=(0.0)*D;
  A[48][48]=(4.0178571428571425e-03)*D;
  A[48][49]=(0.0)*D;
  A[48][50]=(0.0)*D;
  A[48][51]=(2.0089285714285712e-03)*D;
  A[48][52]=(0.0)*D;
  A[48][53]=(0.0)*D;
  A[48][54]=(2.0089285714285712e-03)*D;
  A[48][55]=(0.0)*D;
  A[48][56]=(0.0)*D;
  A[48][57]=(-4.4642857142857141e-04)*D;
  A[48][58]=(0.0)*D;
  A[48][59]=(0.0)*D;
  A[49][0]=(0.0)*D;
  A[49][1]=(2.2321428571428571e-04)*D;
  A[49][2]=(0.0)*D;
  A[49][3]=(0.0)*D;
  A[49][4]=(-1.0044642857142856e-03)*D;
  A[49][5]=(0.0)*D;
  A[49][6]=(0.0)*D;
  A[49][7]=(0.0)*D;
  A[49][8]=(0.0)*D;
  A[49][9]=(0.0)*D;
  A[49][10]=(1.1160714285714285e-04)*D;
  A[49][11]=(0.0)*D;
  A[49][12]=(0.0)*D;
  A[49][13]=(-1.0044642857142856e-03)*D;
  A[49][14]=(0.0)*D;
  A[49][15]=(0.0)*D;
  A[49][16]=(-2.0089285714285712e-03)*D;
  A[49][17]=(0.0)*D;
  A[49][18]=(0.0)*D;
  A[49][19]=(0.0)*D;
  A[49][20]=(0.0)*D;
  A[49][21]=(0.0)*D;
  A[49][22]=(0.0)*D;
  A[49][23]=(0.0)*D;
  A[49][24]=(0.0)*D;
  A[49][25]=(0.0)*D;
  A[49][26]=(0.0)*D;
  A[49][27]=(0.0)*D;
  A[49][28]=(1.1160714285714285e-04)*D;
  A[49][29]=(0.0)*D;
  A[49][30]=(0.0)*D;
  A[49][31]=(-2.0089285714285712e-03)*D;
  A[49][32]=(0.0)*D;
  A[49][33]=(0.0)*D;
  A[49][34]=(0.0)*D;
  A[49][35]=(0.0)*D;
  A[49][36]=(0.0)*D;
  A[49][37]=(-1.0044642857142856e-03)*D;
  A[49][38]=(0.0)*D;
  A[49][39]=(0.0)*D;
  A[49][40]=(0.0)*D;
  A[49][41]=(0.0)*D;
  A[49][42]=(0.0)*D;
  A[49][43]=(0.0)*D;
  A[49][44]=(0.0)*D;
  A[49][45]=(0.0)*D;
  A[49][46]=(-1.0044642857142856e-03)*D;
  A[49][47]=(0.0)*D;
  A[49][48]=(0.0)*D;
  A[49][49]=(4.0178571428571425e-03)*D;
  A[49][50]=(0.0)*D;
  A[49][51]=(0.0)*D;
  A[49][52]=(2.0089285714285712e-03)*D;
  A[49][53]=(0.0)*D;
  A[49][54]=(0.0)*D;
  A[49][55]=(2.0089285714285712e-03)*D;
  A[49][56]=(0.0)*D;
  A[49][57]=(0.0)*D;
  A[49][58]=(-4.4642857142857141e-04)*D;
  A[49][59]=(0.0)*D;
  A[50][0]=(0.0)*D;
  A[50][1]=(0.0)*D;
  A[50][2]=(2.2321428571428571e-04)*D;
  A[50][3]=(0.0)*D;
  A[50][4]=(0.0)*D;
  A[50][5]=(-1.0044642857142856e-03)*D;
  A[50][6]=(0.0)*D;
  A[50][7]=(0.0)*D;
  A[50][8]=(0.0)*D;
  A[50][9]=(0.0)*D;
  A[50][10]=(0.0)*D;
  A[50][11]=(1.1160714285714285e-04)*D;
  A[50][12]=(0.0)*D;
  A[50][13]=(0.0)*D;
  A[50][14]=(-1.0044642857142856e-03)*D;
  A[50][15]=(0.0)*D;
  A[50][16]=(0.0)*D;
  A[50][17]=(-2.0089285714285712e-03)*D;
  A[50][18]=(0.0)*D;
  A[50][19]=(0.0)*D;
  A[50][20]=(0.0)*D;
  A[50][21]=(0.0)*D;
  A[50][22]=(0.0)*D;
  A[50][23]=(0.0)*D;
  A[50][24]=(0.0)*D;
  A[50][25]=(0.0)*D;
  A[50][26]=(0.0)*D;
  A[50][27]=(0.0)*D;
  A[50][28]=(0.0)*D;
  A[50][29]=(1.1160714285714285e-04)*D;
  A[50][30]=(0.0)*D;
  A[50][31]=(0.0)*D;
  A[50][32]=(-2.0089285714285712e-03)*D;
  A[50][33]=(0.0)*D;
  A[50][34]=(0.0)*D;
  A[50][35]=(0.0)*D;
  A[50][36]=(0.0)*D;
  A[50][37]=(0.0)*D;
  A[50][38]=(-1.0044642857142856e-03)*D;
  A[50][39]=(0.0)*D;
  A[50][40]=(0.0)*D;
  A[50][41]=(0.0)*D;
  A[50][42]=(0.0)*D;
  A[50][43]=(0.0)*D;
  A[50][44]=(0.0)*D;
  A[50][45]=(0.0)*D;
  A[50][46]=(0.0)*D;
  A[50][47]=(-1.0044642857142856e-03)*D;
  A[50][48]=(0.0)*D;
  A[50][49]=(0.0)*D;
  A[50][50]=(4.0178571428571425e-03)*D;
  A[50][51]=(0.0)*D;
  A[50][52]=(0.0)*D;
  A[50][53]=(2.0089285714285712e-03)*D;
  A[50][54]=(0.0)*D;
  A[50][55]=(0.0)*D;
  A[50][56]=(2.0089285714285712e-03)*D;
  A[50][57]=(0.0)*D;
  A[50][58]=(0.0)*D;
  A[50][59]=(-4.4642857142857141e-04)*D;
  A[51][0]=(1.1160714285714285e-04)*D;
  A[51][1]=(0.0)*D;
  A[51][2]=(0.0)*D;
  A[51][3]=(0.0)*D;
  A[51][4]=(0.0)*D;
  A[51][5]=(0.0)*D;
  A[51][6]=(-1.0044642857142856e-03)*D;
  A[51][7]=(0.0)*D;
  A[51][8]=(0.0)*D;
  A[51][9]=(2.2321428571428571e-04)*D;
  A[51][10]=(0.0)*D;
  A[51][11]=(0.0)*D;
  A[51][12]=(0.0)*D;
  A[51][13]=(0.0)*D;
  A[51][14]=(0.0)*D;
  A[51][15]=(-2.0089285714285712e-03)*D;
  A[51][16]=(0.0)*D;
  A[51][17]=(0.0)*D;
  A[51][18]=(-1.0044642857142856e-03)*D;
  A[51][19]=(0.0)*D;
  A[51][20]=(0.0)*D;
  A[51][21]=(0.0)*D;
  A[51][22]=(0.0)*D;
  A[51][23]=(0.0)*D;
  A[51][24]=(0.0)*D;
  A[51][25]=(0.0)*D;
  A[51][26]=(0.0)*D;
  A[51][27]=(1.1160714285714285e-04)*D;
  A[51][28]=(0.0)*D;
  A[51][29]=(0.0)*D;
  A[51][30]=(-1.0044642857142856e-03)*D;
  A[51][31]=(0.0)*D;
  A[51][32]=(0.0)*D;
  A[51][33]=(0.0)*D;
  A[51][34]=(0.0)*D;
  A[51][35]=(0.0)*D;
  A[51][36]=(-2.0089285714285712e-03)*D;
  A[51][37]=(0.0)*D;
  A[51][38]=(0.0)*D;
  A[51][39]=(0.0)*D;
  A[51][40]=(0.0)*D;
  A[51][41]=(0.0)*D;
  A[51][42]=(0.0)*D;
  A[51][43]=(0.0)*D;
  A[51][44]=(0.0)*D;
  A[51][45]=(-1.0044642857142856e-03)*D;
  A[51][46]=(0.0)*D;
  A[51][47]=(0.0)*D;
  A[51][48]=(2.0089285714285712e-03)*D;
  A[51][49]=(0.0)*D;
  A[51][50]=(0.0)*D;
  A[51][51]=(4.0178571428571425e-03)*D;
  A[51][52]=(0.0)*D;
  A[51][53]=(0.0)*D;
  A[51][54]=(2.0089285714285712e-03)*D;
  A[51][55]=(0.0)*D;
  A[51][56]=(0.0)*D;
  A[51][57]=(-4.4642857142857141e-04)*D;
  A[51][58]=(0.0)*D;
  A[51][59]=(0.0)*D;
  A[52][0]=(0.0)*D;
  A[52][1]=(1.1160714285714285e-04)*D;
  A[52][2]=(0.0)*D;
  A[52][3]=(0.0)*D;
  A[52][4]=(0.0)*D;
  A[52][5]=(0.0)*D;
  A[52][6]=(0.0)*D;
  A[52][7]=(-1.0044642857142856e-03)*D;
  A[52][8]=(0.0)*D;
  A[52][9]=(0.0)*D;
  A[52][10]=(2.2321428571428571e-04)*D;
  A[52][11]=(0.0)*D;
  A[52][12]=(0.0)*D;
  A[52][13]=(0.0)*D;
  A[52][14]=(0.0)*D;
  A[52][15]=(0.0)*D;
  A[52][16]=(-2.0089285714285712e-03)*D;
  A[52][17]=(0.0)*D;
  A[52][18]=(0.0)*D;
  A[52][19]=(-1.0044642857142856e-03)*D;
  A[52][20]=(0.0)*D;
  A[52][21]=(0.0)*D;
  A[52][22]=(0.0)*D;
  A[52][23]=(0.0)*D;
  A[52][24]=(0.0)*D;
  A[52][25]=(0.0)*D;
  A[52][26]=(0.0)*D;
  A[52][27]=(0.0)*D;
  A[52][28]=(1.1160714285714285e-04)*D;
  A[52][29]=(0.0)*D;
  A[52][30]=(0.0)*D;
  A[52][31]=(-1.0044642857142856e-03)*D;
  A[52][32]=(0.0)*D;
  A[52][33]=(0.0)*D;
  A[52][34]=(0.0)*D;
  A[52][35]=(0.0)*D;
  A[52][36]=(0.0)*D;
  A[52][37]=(-2.0089285714285712e-03)*D;
  A[52][38]=(0.0)*D;
  A[52][39]=(0.0)*D;
  A[52][40]=(0.0)*D;
  A[52][41]=(0.0)*D;
  A[52][42]=(0.0)*D;
  A[52][43]=(0.0)*D;
  A[52][44]=(0.0)*D;
  A[52][45]=(0.0)*D;
  A[52][46]=(-1.0044642857142856e-03)*D;
  A[52][47]=(0.0)*D;
  A[52][48]=(0.0)*D;
  A[52][49]=(2.0089285714285712e-03)*D;
  A[52][50]=(0.0)*D;
  A[52][51]=(0.0)*D;
  A[52][52]=(4.0178571428571425e-03)*D;
  A[52][53]=(0.0)*D;
  A[52][54]=(0.0)*D;
  A[52][55]=(2.0089285714285712e-03)*D;
  A[52][56]=(0.0)*D;
  A[52][57]=(0.0)*D;
  A[52][58]=(-4.4642857142857141e-04)*D;
  A[52][59]=(0.0)*D;
  A[53][0]=(0.0)*D;
  A[53][1]=(0.0)*D;
  A[53][2]=(1.1160714285714285e-04)*D;
  A[53][3]=(0.0)*D;
  A[53][4]=(0.0)*D;
  A[53][5]=(0.0)*D;
  A[53][6]=(0.0)*D;
  A[53][7]=(0.0)*D;
  A[53][8]=(-1.0044642857142856e-03)*D;
  A[53][9]=(0.0)*D;
  A[53][10]=(0.0)*D;
  A[53][11]=(2.2321428571428571e-04)*D;
  A[53][12]=(0.0)*D;
  A[53][13]=(0.0)*D;
  A[53][14]=(0.0)*D;
  A[53][15]=(0.0)*D;
  A[53][16]=(0.0)*D;
  A[53][17]=(-2.0089285714285712e-03)*D;
  A[53][18]=(0.0)*D;
  A[53][19]=(0.0)*D;
  A[53][20]=(-1.0044642857142856e-03)*D;
  A[53][21]=(0.0)*D;
  A[53][22]=(0.0)*D;
  A[53][23]=(0.0)*D;
  A[53][24]=(0.0)*D;
  A[53][25]=(0.0)*D;
  A[53][26]=(0.0)*D;
  A[53][27]=(0.0)*D;
  A[53][28]=(0.0)*D;
  A[53][29]=(1.1160714285714285e-04)*D;
  A[53][30]=(0.0)*D;
  A[53][31]=(0.0)*D;
  A[53][32]=(-1.0044642857142856e-03)*D;
  A[53][33]=(0.0)*D;
  A[53][34]=(0.0)*D;
  A[53][35]=(0.0)*D;
  A[53][36]=(0.0)*D;
  A[53][37]=(0.0)*D;
  A[53][38]=(-2.0089285714285712e-03)*D;
  A[53][39]=(0.0)*D;
  A[53][40]=(0.0)*D;
  A[53][41]=(0.0)*D;
  A[53][42]=(0.0)*D;
  A[53][43]=(0.0)*D;
  A[53][44]=(0.0)*D;
  A[53][45]=(0.0)*D;
  A[53][46]=(0.0)*D;
  A[53][47]=(-1.0044642857142856e-03)*D;
  A[53][48]=(0.0)*D;
  A[53][49]=(0.0)*D;
  A[53][50]=(2.0089285714285712e-03)*D;
  A[53][51]=(0.0)*D;
  A[53][52]=(0.0)*D;
  A[53][53]=(4.0178571428571425e-03)*D;
  A[53][54]=(0.0)*D;
  A[53][55]=(0.0)*D;
  A[53][56]=(2.0089285714285712e-03)*D;
  A[53][57]=(0.0)*D;
  A[53][58]=(0.0)*D;
  A[53][59]=(-4.4642857142857141e-04)*D;
  A[54][0]=(1.1160714285714285e-04)*D;
  A[54][1]=(0.0)*D;
  A[54][2]=(0.0)*D;
  A[54][3]=(0.0)*D;
  A[54][4]=(0.0)*D;
  A[54][5]=(0.0)*D;
  A[54][6]=(0.0)*D;
  A[54][7]=(0.0)*D;
  A[54][8]=(0.0)*D;
  A[54][9]=(1.1160714285714285e-04)*D;
  A[54][10]=(0.0)*D;
  A[54][11]=(0.0)*D;
  A[54][12]=(0.0)*D;
  A[54][13]=(0.0)*D;
  A[54][14]=(0.0)*D;
  A[54][15]=(-2.0089285714285712e-03)*D;
  A[54][16]=(0.0)*D;
  A[54][17]=(0.0)*D;
  A[54][18]=(0.0)*D;
  A[54][19]=(0.0)*D;
  A[54][20]=(0.0)*D;
  A[54][21]=(-1.0044642857142856e-03)*D;
  A[54][22]=(0.0)*D;
  A[54][23]=(0.0)*D;
  A[54][24]=(-1.0044642857142856e-03)*D;
  A[54][25]=(0.0)*D;
  A[54][26]=(0.0)*D;
  A[54][27]=(2.2321428571428571e-04)*D;
  A[54][28]=(0.0)*D;
  A[54][29]=(0.0)*D;
  A[54][30]=(-1.0044642857142856e-03)*D;
  A[54][31]=(0.0)*D;
  A[54][32]=(0.0)*D;
  A[54][33]=(0.0)*D;
  A[54][34]=(0.0)*D;
  A[54][35]=(0.0)*D;
  A[54][36]=(-1.0044642857142856e-03)*D;
  A[54][37]=(0.0)*D;
  A[54][38]=(0.0)*D;
  A[54][39]=(0.0)*D;
  A[54][40]=(0.0)*D;
  A[54][41]=(0.0)*D;
  A[54][42]=(0.0)*D;
  A[54][43]=(0.0)*D;
  A[54][44]=(0.0)*D;
  A[54][45]=(-2.0089285714285712e-03)*D;
  A[54][46]=(0.0)*D;
  A[54][47]=(0.0)*D;
  A[54][48]=(2.0089285714285712e-03)*D;
  A[54][49]=(0.0)*D;
  A[54][50]=(0.0)*D;
  A[54][51]=(2.0089285714285712e-03)*D;
  A[54][52]=(0.0)*D;
  A[54][53]=(0.0)*D;
  A[54][54]=(4.0178571428571425e-03)*D;
  A[54][55]=(0.0)*D;
  A[54][56]=(0.0)*D;
  A[54][57]=(-4.4642857142857141e-04)*D;
  A[54][58]=(0.0)*D;
  A[54][59]=(0.0)*D;
  A[55][0]=(0.0)*D;
  A[55][1]=(1.1160714285714285e-04)*D;
  A[55][2]=(0.0)*D;
  A[55][3]=(0.0)*D;
  A[55][4]=(0.0)*D;
  A[55][5]=(0.0)*D;
  A[55][6]=(0.0)*D;
  A[55][7]=(0.0)*D;
  A[55][8]=(0.0)*D;
  A[55][9]=(0.0)*D;
  A[55][10]=(1.1160714285714285e-04)*D;
  A[55][11]=(0.0)*D;
  A[55][12]=(0.0)*D;
  A[55][13]=(0.0)*D;
  A[55][14]=(0.0)*D;
  A[55][15]=(0.0)*D;
  A[55][16]=(-2.0089285714285712e-03)*D;
  A[55][17]=(0.0)*D;
  A[55][18]=(0.0)*D;
  A[55][19]=(0.0)*D;
  A[55][20]=(0.0)*D;
  A[55][21]=(0.0)*D;
  A[55][22]=(-1.0044642857142856e-03)*D;
  A[55][23]=(0.0)*D;
  A[55][24]=(0.0)*D;
  A[55][25]=(-1.0044642857142856e-03)*D;
  A[55][26]=(0.0)*D;
  A[55][27]=(0.0)*D;
  A[55][28]=(2.2321428571428571e-04)*D;
  A[55][29]=(0.0)*D;
  A[55][30]=(0.0)*D;
  A[55][31]=(-1.0044642857142856e-03)*D;
  A[55][32]=(0.0)*D;
  A[55][33]=(0.0)*D;
  A[55][34]=(0.0)*D;
  A[55][35]=(0.0)*D;
  A[55][36]=(0.0)*D;
  A[55][37]=(-1.0044642857142856e-03)*D;
  A[55][38]=(0.0)*D;
  A[55][39]=(0.0)*D;
  A[55][40]=(0.0)*D;
  A[55][41]=(0.0)*D;
  A[55][42]=(0.0)*D;
  A[55][43]=(0.0)*D;
  A[55][44]=(0.0)*D;
  A[55][45]=(0.0)*D;
  A[55][46]=(-2.0089285714285712e-03)*D;
  A[55][47]=(0.0)*D;
  A[55][48]=(0.0)*D;
  A[55][49]=(2.0089285714285712e-03)*D;
  A[55][50]=(0.0)*D;
  A[55][51]=(0.0)*D;
  A[55][52]=(2.0089285714285712e-03)*D;
  A[55][53]=(0.0)*D;
  A[55][54]=(0.0)*D;
  A[55][55]=(4.0178571428571425e-03)*D;
  A[55][56]=(0.0)*D;
  A[55][57]=(0.0)*D;
  A[55][58]=(-4.4642857142857141e-04)*D;
  A[55][59]=(0.0)*D;
  A[56][0]=(0.0)*D;
  A[56][1]=(0.0)*D;
  A[56][2]=(1.1160714285714285e-04)*D;
  A[56][3]=(0.0)*D;
  A[56][4]=(0.0)*D;
  A[56][5]=(0.0)*D;
  A[56][6]=(0.0)*D;
  A[56][7]=(0.0)*D;
  A[56][8]=(0.0)*D;
  A[56][9]=(0.0)*D;
  A[56][10]=(0.0)*D;
  A[56][11]=(1.1160714285714285e-04)*D;
  A[56][12]=(0.0)*D;
  A[56][13]=(0.0)*D;
  A[56][14]=(0.0)*D;
  A[56][15]=(0.0)*D;
  A[56][16]=(0.0)*D;
  A[56][17]=(-2.0089285714285712e-03)*D;
  A[56][18]=(0.0)*D;
  A[56][19]=(0.0)*D;
  A[56][20]=(0.0)*D;
  A[56][21]=(0.0)*D;
  A[56][22]=(0.0)*D;
  A[56][23]=(-1.0044642857142856e-03)*D;
  A[56][24]=(0.0)*D;
  A[56][25]=(0.0)*D;
  A[56][26]=(-1.0044642857142856e-03)*D;
  A[56][27]=(0.0)*D;
  A[56][28]=(0.0)*D;
  A[56][29]=(2.2321428571428571e-04)*D;
  A[56][30]=(0.0)*D;
  A[56][31]=(0.0)*D;
  A[56][32]=(-1.0044642857142856e-03)*D;
  A[56][33]=(0.0)*D;
  A[56][34]=(0.0)*D;
  A[56][35]=(0.0)*D;
  A[56][36]=(0.0)*D;
  A[56][37]=(0.0)*D;
  A[56][38]=(-1.0044642857142856e-03)*D;
  A[56][39]=(0.0)*D;
  A[56][40]=(0.0)*D;
  A[56][41]=(0.0)*D;
  A[56][42]=(0.0)*D;
  A[56][43]=(0.0)*D;
  A[56][44]=(0.0)*D;
  A[56][45]=(0.0)*D;
  A[56][46]=(0.0)*D;
  A[56][47]=(-2.0089285714285712e-03)*D;
  A[56][48]=(0.0)*D;
  A[56][49]=(0.0)*D;
  A[56][50]=(2.0089285714285712e-03)*D;
  A[56][51]=(0.0)*D;
  A[56][52]=(0.0)*D;
  A[56][53]=(2.0089285714285712e-03)*D;
  A[56][54]=(0.0)*D;
  A[56][55]=(0.0)*D;
  A[56][56]=(4.0178571428571425e-03)*D;
  A[56][57]=(0.0)*D;
  A[56][58]=(0.0)*D;
  A[56][59]=(-4.4642857142857141e-04)*D;
  A[57][0]=(7.4404761904761911e-05)*D;
  A[57][1]=(0.0)*D;
  A[57][2]=(0.0)*D;
  A[57][3]=(1.1160714285714285e-04)*D;
  A[57][4]=(0.0)*D;
  A[57][5]=(0.0)*D;
  A[57][6]=(1.1160714285714285e-04)*D;
  A[57][7]=(0.0)*D;
  A[57][8]=(0.0)*D;
  A[57][9]=(7.4404761904761911e-05)*D;
  A[57][10]=(0.0)*D;
  A[57][11]=(0.0)*D;
  A[57][12]=(1.1160714285714285e-04)*D;
  A[57][13]=(0.0)*D;
  A[57][14]=(0.0)*D;
  A[57][15]=(1.3392857142857143e-03)*D;
  A[57][16]=(0.0)*D;
  A[57][17]=(0.0)*D;
  A[57][18]=(1.1160714285714285e-04)*D;
  A[57][19]=(0.0)*D;
  A[57][20]=(0.0)*D;
  A[57][21]=(1.1160714285714285e-04)*D;
  A[57][22]=(0.0)*D;
  A[57][23]=(0.0)*D;
  A[57][24]=(1.1160714285714285e-04)*D;
  A[57][25]=(0.0)*D;
  A[57][26]=(0.0)*D;
  A[57][27]=(7.4404761904761911e-05)*D;
  A[57][28]=(0.0)*D;
  A[57][29]=(0.0)*D;
  A[57][30]=(2.2321428571428571e-04)*D;
  A[57][31]=(0.0)*D;
  A[57][32]=(0.0)*D;
  A[57][33]=(6.6964285714285715e-04)*D;
  A[57][34]=(0.0)*D;
  A[57][35]=(0.0)*D;
  A[57][36]=(2.2321428571428571e-04)*D;
  A[57][37]=(0.0)*D;
  A[57][38]=(0.0)*D;
  A[57][39]=(6.6964285714285715e-04)*D;
  A[57][40]=(0.0)*D;
  A[57][41]=(0.0)*D;
  A[57][42]=(6.6964285714285715e-04)*D;
  A[57][43]=(0.0)*D;
  A[57][44]=(0.0)*D;
  A[57][45]=(2.2321428571428571e-04)*D;
  A[57][46]=(0.0)*D;
  A[57][47]=(0.0)*D;
  A[57][48]=(-4.4642857142857141e-04)*D;
  A[57][49]=(0.0)*D;
  A[57][50]=(0.0)*D;
  A[57][51]=(-4.4642857142857141e-04)*D;
  A[57][52]=(0.0)*D;
  A[57][53]=(0.0)*D;
  A[57][54]=(-4.4642857142857141e-04)*D;
  A[57][55]=(0.0)*D;
  A[57][56]=(0.0)*D;
  A[57][57]=(5.9523809523809529e-04)*D;
  A[57][58]=(0.0)*D;
  A[57][59]=(0.0)*D;
  A[58][0]=(0.0)*D;
  A[58][1]=(7.4404761904761911e-05)*D;
  A[58][2]=(0.0)*D;
  A[58][3]=(0.0)*D;
  A[58][4]=(1.1160714285714285e-04)*D;
  A[58][5]=(0.0)*D;
  A[58][6]=(0.0)*D;
  A[58][7]=(1.1160714285714285e-04)*D;
  A[58][8]=(0.0)*D;
  A[58][9]=(0.0)*D;
  A[58][10]=(7.4404761904761911e-05)*D;
  A[58][11]=(0.0)*D;
  A[58][12]=(0.0)*D;
  A[58][13]=(1.1160714285714285e-04)*D;
  A[58][14]=(0.0)*D;
  A[58][15]=(0.0)*D;
  A[58][16]=(1.3392857142857143e-03)*D;
  A[58][17]=(0.0)*D;
  A[58][18]=(0.0)*D;
  A[58][19]=(1.1160714285714285e-04)*D;
  A[58][20]=(0.0)*D;
  A[58][21]=(0.0)*D;
  A[58][22]=(1.1160714285714285e-04)*D;
  A[58][23]=(0.0)*D;
  A[58][24]=(0.0)*D;
  A[58][25]=(1.1160714285714285e-04)*D;
  A[58][26]=(0.0)*D;
  A[58][27]=(0.0)*D;
  A[58][28]=(7.4404761904761911e-05)*D;
  A[58][29]=(0.0)*D;
  A[58][30]=(0.0)*D;
  A[58][31]=(2.2321428571428571e-04)*D;
  A[58][32]=(0.0)*D;
  A[58][33]=(0.0)*D;
  A[58][34]=(6.6964285714285715e-04)*D;
  A[58][35]=(0.0)*D;
  A[58][36]=(0.0)*D;
  A[58][37]=(2.2321428571428571e-04)*D;
  A[58][38]=(0.0)*D;
  A[58][39]=(0.0)*D;
  A[58][40]=(6.6964285714285715e-04)*D;
  A[58][41]=(0.0)*D;
  A[58][42]=(0.0)*D;
  A[58][43]=(6.6964285714285715e-04)*D;
  A[58][44]=(0.0)*D;
  A[58][45]=(0.0)*D;
  A[58][46]=(2.2321428571428571e-04)*D;
  A[58][47]=(0.0)*D;
  A[58][48]=(0.0)*D;
  A[58][49]=(-4.4642857142857141e-04)*D;
  A[58][50]=(0.0)*D;
  A[58][51]=(0.0)*D;
  A[58][52]=(-4.4642857142857141e-04)*D;
  A[58][53]=(0.0)*D;
  A[58][54]=(0.0)*D;
  A[58][55]=(-4.4642857142857141e-04)*D;
  A[58][56]=(0.0)*D;
  A[58][57]=(0.0)*D;
  A[58][58]=(5.9523809523809529e-04)*D;
  A[58][59]=(0.0)*D;
  A[59][0]=(0.0)*D;
  A[59][1]=(0.0)*D;
  A[59][2]=(7.4404761904761911e-05)*D;
  A[59][3]=(0.0)*D;
  A[59][4]=(0.0)*D;
  A[59][5]=(1.1160714285714285e-04)*D;
  A[59][6]=(0.0)*D;
  A[59][7]=(0.0)*D;
  A[59][8]=(1.1160714285714285e-04)*D;
  A[59][9]=(0.0)*D;
  A[59][10]=(0.0)*D;
  A[59][11]=(7.4404761904761911e-05)*D;
  A[59][12]=(0.0)*D;
  A[59][13]=(0.0)*D;
  A[59][14]=(1.1160714285714285e-04)*D;
  A[59][15]=(0.0)*D;
  A[59][16]=(0.0)*D;
  A[59][17]=(1.3392857142857143e-03)*D;
  A[59][18]=(0.0)*D;
  A[59][19]=(0.0)*D;
  A[59][20]=(1.1160714285714285e-04)*D;
  A[59][21]=(0.0)*D;
  A[59][22]=(0.0)*D;
  A[59][23]=(1.1160714285714285e-04)*D;
  A[59][24]=(0.0)*D;
  A[59][25]=(0.0)*D;
  A[59][26]=(1.1160714285714285e-04)*D;
  A[59][27]=(0.0)*D;
  A[59][28]=(0.0)*D;
  A[59][29]=(7.4404761904761911e-05)*D;
  A[59][30]=(0.0)*D;
  A[59][31]=(0.0)*D;
  A[59][32]=(2.2321428571428571e-04)*D;
  A[59][33]=(0.0)*D;
  A[59][34]=(0.0)*D;
  A[59][35]=(6.6964285714285715e-04)*D;
  A[59][36]=(0.0)*D;
  A[59][37]=(0.0)*D;
  A[59][38]=(2.2321428571428571e-04)*D;
  A[59][39]=(0.0)*D;
  A[59][40]=(0.0)*D;
  A[59][41]=(6.6964285714285715e-04)*D;
  A[59][42]=(0.0)*D;
  A[59][43]=(0.0)*D;
  A[59][44]=(6.6964285714285715e-04)*D;
  A[59][45]=(0.0)*D;
  A[59][46]=(0.0)*D;
  A[59][47]=(2.2321428571428571e-04)*D;
  A[59][48]=(0.0)*D;
  A[59][49]=(0.0)*D;
  A[59][50]=(-4.4642857142857141e-04)*D;
  A[59][51]=(0.0)*D;
  A[59][52]=(0.0)*D;
  A[59][53]=(-4.4642857142857141e-04)*D;
  A[59][54]=(0.0)*D;
  A[59][55]=(0.0)*D;
  A[59][56]=(-4.4642857142857141e-04)*D;
  A[59][57]=(0.0)*D;
  A[59][58]=(0.0)*D;
  A[59][59]=(5.9523809523809529e-04)*D;
  int nbf = 60;  

  pair<int,int> index; 
  for (int i=0; i< nbf; i++) {
    index.first = iidof[i]; 
    for (int j=0; j< nbf; j++) {
      index.second = iidof[j]; 
      matrix[index] += A[i][j];   
    }
  }

}
