
#include <math.h>
void matrix_factory_stiffness_3D (double A[4][4], double M[3][3], double p0[3], double p1[3], double p2[3], double p3[3]){



  double x0 = p0[0]; double y0 = p0[1]; double z0 = p0[2];  
  double x1 = p1[0]; double y1 = p1[1]; double z1 = p1[2];  
  double x2 = p2[0]; double y2 = p2[1]; double z2 = p2[2];  
  double x3 = p3[0]; double y3 = p3[1]; double z3 = p3[2];  

  double M00 = M[0][0]; double M10 = M[1][0]; double M20 = M[2][0];  
  double M01 = M[0][1]; double M11 = M[1][1]; double M21 = M[2][1];  
  double M02 = M[0][2]; double M12 = M[1][2]; double M22 = M[2][2];  



  double a   = x1 - x0;
  double d   = y1 - y0;
  double g   = z1 - z0;

  double b   = x2 - x0;
  double e   = y2 - y0;
  double h   = z2 - z0;

  double c   = x3 - x0;
  double f   = y3 - y0;
  double k   = z3 - z0;

  double JJ00 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(k*e-h*f);
  double JJ01 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(g*f-k*d);
  double JJ02 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(h*d-g*e);
  double JJ10 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(h*c-k*b);
  double JJ11 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(k*a-c*g);
  double JJ12 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(-h*a+b*g);
  double JJ20 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(b*f-c*e);
  double JJ21 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(-f*a+c*d);
  double JJ22 = 1.0/(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a)*(a*e-b*d);

  //variables 

  double w0 = pow(k*a*e+h*c*d-c*g*e-k*b*d+b*g*f-h*f*a,2.0); 
 
  double D = a*(e*k-f*h) - b*(d*k-f*g) + c*(d*h-g*e);   


  A[0][0]=(1.0/w0*k*h*M00*e*d/3.0-1.0/w0*k*(b*b)*M12*f/6.0-1.0/w0*h*M20*c*e*d/6.0-1.0/w0*g*a*(e*e)*M02/6.0-1.0/w0*k*b*e*d*M02/6.0-1.0/w0*c*a*M22*(e*e)/3.0-1.0/w0*h*(c*c)*M12*e/6.0-1.0/w0*k*M00*g*f*d/3.0-1.0/w0*c*b*(g*g)*M11/3.0+1.0/w0*M21*c*b*g*d/3.0-1.0/w0*k*M21*f*(a*a)/6.0+1.0/w0*(h*h)*M00*(d*d)/6.0+1.0/w0*(c*c)*M22*(e*e)/6.0+1.0/w0*k*M20*f*a*d/6.0+1.0/w0*h*M20*a*e*d/6.0+1.0/w0*h*b*f*d*M02/3.0+1.0/w0*k*b*g*M11*a/3.0-1.0/w0*k*h*M01*a*e/6.0-1.0/w0*k*M12*f*(a*a)/6.0+1.0/w0*c*g*(e*e)*M02/6.0+1.0/w0*h*b*g*M10*d/6.0-1.0/w0*c*b*f*M22*e/3.0+1.0/w0*c*(g*g)*e*M10/6.0-1.0/w0*k*M21*b*a*d/6.0-1.0/w0*h*M20*b*(d*d)/6.0-1.0/w0*h*b*(d*d)*M02/6.0+1.0/w0*h*a*e*d*M02/6.0-1.0/w0*M21*(c*c)*g*d/6.0+1.0/w0*(a*a)*M22*(e*e)/6.0-1.0/w0*k*h*c*b*M11/3.0+1.0/w0*(b*b)*(g*g)*M11/6.0-1.0/w0*k*f*a*e*M02/6.0-1.0/w0*c*g*e*d*M02/6.0-1.0/w0*M21*b*g*f*a/6.0-1.0/w0*(c*c)*g*M12*d/6.0+1.0/w0*M21*h*c*b*f/6.0+1.0/w0*(h*h)*f*a*M10/6.0-1.0/w0*h*M00*g*(f*f)/3.0-1.0/w0*h*M20*f*a*e/6.0+1.0/w0*(k*k)*M11*(a*a)/6.0-1.0/w0*k*h*M01*f*a/6.0+1.0/w0*h*c*g*M11*a/3.0+1.0/w0*k*a*(e*e)*M02/6.0-1.0/w0*k*M20*c*(e*e)/6.0+1.0/w0*h*M12*f*(a*a)/6.0+1.0/w0*c*a*M22*e*d/3.0-1.0/w0*c*(g*g)*f*M10/6.0+1.0/w0*M21*b*g*a*e/6.0+1.0/w0*(k*k)*b*M10*d/6.0+1.0/w0*k*M21*(b*b)*d/6.0-1.0/w0*c*b*g*M12*e/6.0+1.0/w0*k*b*(d*d)*M02/6.0+1.0/w0*(k*k)*M01*b*d/6.0+1.0/w0*k*c*g*M10*d/6.0+1.0/w0*k*M20*b*(d*d)/6.0+1.0/w0*b*f*a*M22*d/3.0+1.0/w0*k*h*a*M10*d/3.0-1.0/w0*h*c*e*d*M02/6.0+1.0/w0*k*M21*c*b*e/6.0-1.0/w0*k*c*(e*e)*M02/6.0+1.0/w0*h*M00*g*f*e/3.0-1.0/w0*M01*b*(g*g)*e/6.0+1.0/w0*(h*h)*(c*c)*M11/6.0-1.0/w0*M21*h*c*a*d/6.0-1.0/w0*k*h*c*M10*d/6.0+1.0/w0*(h*h)*c*M01*d/6.0+1.0/w0*(b*b)*(f*f)*M22/6.0-1.0/w0*h*M01*b*g*f/6.0-1.0/w0*(c*c)*M22*e*d/3.0+1.0/w0*k*M00*g*e*d/3.0+1.0/w0*k*h*M00*f*d/3.0-1.0/w0*h*M20*c*f*d/6.0+1.0/w0*h*M20*(f*f)*a/6.0-1.0/w0*k*M21*b*a*e/6.0-1.0/w0*g*(f*f)*a*M02/6.0+1.0/w0*M21*c*g*f*a/6.0+1.0/w0*k*h*b*f*M10/6.0-1.0/w0*(b*b)*g*M12*d/6.0+1.0/w0*c*b*f*M22*d/3.0+1.0/w0*(c*c)*g*M12*e/6.0-1.0/w0*h*c*g*M10*d/6.0+1.0/w0*M21*(c*c)*g*e/6.0-1.0/w0*b*(g*g)*e*M10/6.0-1.0/w0*h*c*f*d*M02/6.0-1.0/w0*k*c*g*M11*a/3.0-1.0/w0*k*M20*f*a*e/6.0+1.0/w0*h*M20*c*(d*d)/6.0-1.0/w0*(k*k)*b*M11*a/3.0+1.0/w0*k*h*M01*a*d/3.0+1.0/w0*(c*c)*M22*(d*d)/6.0-1.0/w0*h*M00*g*e*d/3.0-1.0/w0*k*M01*b*g*f/6.0+1.0/w0*c*b*M22*e*d/3.0-1.0/w0*M21*c*b*g*e/6.0+1.0/w0*g*f*a*e*M02/3.0+1.0/w0*h*(f*f)*a*M02/6.0-1.0/w0*b*g*M12*f*a/6.0-1.0/w0*M21*h*c*f*a/6.0+1.0/w0*k*h*M01*b*f/6.0+1.0/w0*k*c*e*d*M02/3.0+1.0/w0*k*M00*g*f*e/3.0+1.0/w0*h*(c*c)*M12*d/6.0+1.0/w0*k*h*c*M11*a/3.0-1.0/w0*M20*g*a*(e*e)/6.0+1.0/w0*M21*h*c*a*e/3.0+1.0/w0*b*g*M12*a*e/6.0+1.0/w0*M00*(g*g)*(e*e)/6.0-1.0/w0*(h*h)*c*f*M10/6.0+1.0/w0*h*M20*c*f*e/6.0+1.0/w0*c*g*f*d*M02/6.0-1.0/w0*k*h*M00*f*e/3.0-1.0/w0*k*M21*c*b*d/6.0-1.0/w0*h*(c*c)*g*M11/3.0+1.0/w0*k*M20*c*e*d/3.0-1.0/w0*b*g*f*e*M02/6.0+1.0/w0*h*c*b*M12*f/6.0+1.0/w0*h*M00*g*f*d/3.0-1.0/w0*M21*h*(a*a)*e/6.0-1.0/w0*k*b*g*M10*d/6.0+1.0/w0*b*f*a*M22*e/3.0-1.0/w0*(k*k)*M01*b*e/6.0-1.0/w0*M21*c*g*a*e/6.0-1.0/w0*(b*b)*f*M22*d/3.0-1.0/w0*h*f*a*e*M02/6.0+1.0/w0*M21*(b*b)*g*f/6.0+1.0/w0*b*g*(f*f)*M02/6.0+1.0/w0*c*b*g*M12*d/3.0-1.0/w0*k*a*e*d*M02/6.0+1.0/w0*k*M21*b*f*a/3.0-1.0/w0*k*M20*c*(d*d)/6.0-1.0/w0*h*M20*f*a*d/6.0+1.0/w0*b*(g*g)*f*M10/6.0+1.0/w0*(k*k)*a*e*M10/6.0+1.0/w0*c*M01*(g*g)*e/6.0-1.0/w0*k*h*M11*(a*a)/3.0+1.0/w0*h*c*M01*g*f/3.0-1.0/w0*h*b*g*M11*a/3.0-1.0/w0*k*b*f*d*M02/6.0-1.0/w0*k*M20*a*e*d/6.0-1.0/w0*M00*(g*g)*f*e/3.0-1.0/w0*k*c*(d*d)*M02/6.0-1.0/w0*h*M12*(a*a)*e/6.0-1.0/w0*M20*c*g*e*d/6.0+1.0/w0*h*M01*g*a*e/6.0+1.0/w0*(b*b)*g*M12*f/6.0-1.0/w0*k*M00*g*(e*e)/3.0-1.0/w0*k*c*M01*g*e/6.0+1.0/w0*h*c*g*f*M10/3.0+1.0/w0*h*M20*b*f*d/3.0-1.0/w0*(k*k)*a*M10*d/6.0-1.0/w0*h*b*(f*f)*M02/6.0-1.0/w0*k*h*M01*b*d/6.0+1.0/w0*(k*k)*M00*(d*d)/6.0-1.0/w0*c*f*a*M22*d/3.0-1.0/w0*k*M01*b*g*d/6.0+1.0/w0*M21*h*b*a*d/6.0-1.0/w0*k*h*b*M10*d/6.0-1.0/w0*b*a*M22*e*d/3.0+1.0/w0*k*b*g*e*M10/3.0-1.0/w0*k*b*M12*a*d/6.0+1.0/w0*h*c*b*g*M11/3.0-1.0/w0*h*b*M12*f*a/6.0-1.0/w0*k*c*M12*a*e/6.0+1.0/w0*k*c*b*M12*e/6.0+1.0/w0*k*M20*b*f*e/6.0+1.0/w0*b*g*e*d*M02/6.0+1.0/w0*M20*g*f*a*e/3.0+1.0/w0*M01*b*(g*g)*f/6.0-1.0/w0*k*b*g*f*M10/6.0-1.0/w0*(h*h)*a*M10*d/6.0+1.0/w0*k*f*a*d*M02/6.0+1.0/w0*k*M20*a*(e*e)/6.0+1.0/w0*(k*k)*M01*a*e/6.0-1.0/w0*k*h*f*a*M10/6.0+1.0/w0*(h*h)*M01*f*a/6.0+1.0/w0*k*M21*(a*a)*e/6.0-1.0/w0*h*c*M12*a*d/6.0-1.0/w0*h*c*g*e*M10/6.0-1.0/w0*f*(a*a)*M22*e/3.0-1.0/w0*h*c*b*M12*d/6.0+1.0/w0*(h*h)*c*M10*d/6.0-1.0/w0*k*h*c*M01*d/6.0-1.0/w0*M21*(b*b)*g*d/6.0+1.0/w0*(c*c)*(g*g)*M11/6.0-1.0/w0*c*b*g*M12*f/6.0+1.0/w0*k*M12*(a*a)*e/6.0+1.0/w0*k*M21*c*a*d/6.0-1.0/w0*h*M01*g*f*a/6.0-1.0/w0*(h*h)*M00*f*d/3.0+1.0/w0*h*c*(d*d)*M02/6.0-1.0/w0*M20*b*g*f*e/6.0+1.0/w0*(h*h)*M11*(a*a)/6.0-1.0/w0*h*c*M01*g*d/6.0+1.0/w0*k*g*f*a*M10/6.0+1.0/w0*M21*h*(c*c)*d/6.0-1.0/w0*(k*k)*M00*e*d/3.0+1.0/w0*h*g*a*e*M10/6.0-1.0/w0*b*(f*f)*a*M22/3.0+1.0/w0*M20*c*g*f*d/6.0-1.0/w0*k*b*M12*a*e/6.0-1.0/w0*h*c*M12*f*a/6.0-1.0/w0*(k*k)*b*e*M10/6.0-1.0/w0*h*f*a*d*M02/6.0-1.0/w0*k*c*b*M12*d/6.0+1.0/w0*k*(b*b)*M12*d/6.0-1.0/w0*k*h*a*e*M10/6.0-1.0/w0*k*c*g*e*M10/6.0-1.0/w0*(h*h)*M01*a*d/6.0-1.0/w0*k*M20*b*e*d/6.0+1.0/w0*k*c*M12*a*d/6.0+1.0/w0*(k*k)*M00*(e*e)/6.0+1.0/w0*k*b*f*e*M02/6.0-1.0/w0*M21*c*b*g*f/6.0-1.0/w0*k*h*M00*(d*d)/3.0-1.0/w0*h*b*g*f*M10/6.0+1.0/w0*(h*h)*M00*(f*f)/6.0+1.0/w0*M21*h*f*(a*a)/6.0+1.0/w0*c*f*a*M22*e/3.0+1.0/w0*k*M01*b*g*e/3.0+1.0/w0*k*h*c*e*M10/6.0-1.0/w0*h*g*f*a*M10/6.0+1.0/w0*k*c*M01*g*d/6.0+1.0/w0*(f*f)*(a*a)*M22/6.0-1.0/w0*c*g*f*e*M02/6.0-1.0/w0*k*g*a*e*M10/6.0+1.0/w0*M20*c*g*(e*e)/6.0-1.0/w0*(h*h)*c*M11*a/3.0-1.0/w0*c*g*M12*a*e/6.0-1.0/w0*b*g*f*d*M02/6.0+1.0/w0*M20*b*g*e*d/6.0+1.0/w0*k*M01*g*f*a/6.0-1.0/w0*h*M20*b*(f*f)/6.0-1.0/w0*h*c*M01*g*e/6.0-1.0/w0*c*M01*(g*g)*f/6.0-1.0/w0*M20*b*g*f*d/6.0-1.0/w0*c*b*M22*(d*d)/3.0-1.0/w0*M21*h*c*b*d/6.0-1.0/w0*M20*c*g*f*e/6.0+1.0/w0*M20*b*g*(f*f)/6.0-1.0/w0*M21*h*(c*c)*e/6.0-1.0/w0*k*M21*(b*b)*f/6.0-1.0/w0*k*M01*g*a*e/6.0+1.0/w0*k*h*c*M01*e/6.0-1.0/w0*k*M21*c*a*e/6.0+1.0/w0*c*g*M12*f*a/6.0+1.0/w0*k*c*b*g*M11/3.0+1.0/w0*k*h*b*M11*a/3.0+1.0/w0*h*b*M12*a*d/6.0-1.0/w0*(k*k)*M01*a*d/6.0-1.0/w0*k*(b*b)*g*M11/3.0+1.0/w0*(k*k)*(b*b)*M11/6.0+1.0/w0*h*c*M12*a*e/3.0+1.0/w0*k*b*M12*f*a/3.0+1.0/w0*M00*(g*g)*(f*f)/6.0-1.0/w0*k*M20*b*f*d/6.0-1.0/w0*M21*h*b*f*a/6.0+1.0/w0*h*c*f*e*M02/6.0-1.0/w0*M20*g*(f*f)*a/6.0-1.0/w0*(h*h)*c*M01*f/6.0+1.0/w0*(b*b)*M22*(d*d)/6.0+1.0/w0*h*M01*b*g*d/6.0)*D;
  A[0][1]=(-1.0/w0*k*h*M00*e*d/6.0+1.0/w0*k*(b*b)*M12*f/6.0+1.0/w0*h*M20*c*e*d/6.0+1.0/w0*k*b*e*d*M02/6.0+1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*h*(c*c)*M12*e/6.0-1.0/w0*(c*c)*M22*(e*e)/6.0-1.0/w0*h*b*f*d*M02/6.0+1.0/w0*k*h*M01*a*e/6.0+1.0/w0*c*b*f*M22*e/3.0+1.0/w0*k*h*c*b*M11/3.0+1.0/w0*k*f*a*e*M02/6.0-1.0/w0*M21*h*c*b*f/6.0+1.0/w0*h*M00*g*(f*f)/6.0+1.0/w0*k*h*M01*f*a/6.0-1.0/w0*k*a*(e*e)*M02/6.0+1.0/w0*k*M20*c*(e*e)/6.0-1.0/w0*(k*k)*b*M10*d/6.0-1.0/w0*k*M21*c*b*e/6.0+1.0/w0*k*c*(e*e)*M02/6.0-1.0/w0*h*M00*g*f*e/6.0-1.0/w0*(h*h)*(c*c)*M11/6.0+1.0/w0*k*h*c*M10*d/6.0-1.0/w0*(b*b)*(f*f)*M22/6.0+1.0/w0*h*M01*b*g*f/6.0+1.0/w0*(c*c)*M22*e*d/6.0-1.0/w0*k*h*M00*f*d/6.0-1.0/w0*k*h*b*f*M10/6.0-1.0/w0*c*b*f*M22*d/6.0-1.0/w0*M21*(c*c)*g*e/6.0+1.0/w0*h*c*f*d*M02/6.0+1.0/w0*(k*k)*b*M11*a/6.0-1.0/w0*c*b*M22*e*d/6.0+1.0/w0*M21*c*b*g*e/6.0-1.0/w0*h*(f*f)*a*M02/6.0-1.0/w0*k*h*M01*b*f/6.0-1.0/w0*k*c*e*d*M02/6.0-1.0/w0*k*M00*g*f*e/6.0-1.0/w0*h*(c*c)*M12*d/6.0-1.0/w0*k*h*c*M11*a/6.0-1.0/w0*M21*h*c*a*e/6.0+1.0/w0*(h*h)*c*f*M10/6.0-1.0/w0*h*M20*c*f*e/6.0+1.0/w0*k*h*M00*f*e/3.0+1.0/w0*h*(c*c)*g*M11/6.0-1.0/w0*k*M20*c*e*d/6.0-1.0/w0*h*c*b*M12*f/6.0-1.0/w0*b*f*a*M22*e/6.0+1.0/w0*(k*k)*M01*b*e/6.0+1.0/w0*(b*b)*f*M22*d/6.0+1.0/w0*h*f*a*e*M02/6.0-1.0/w0*M21*(b*b)*g*f/6.0-1.0/w0*k*M21*b*f*a/6.0-1.0/w0*h*c*M01*g*f/6.0+1.0/w0*k*M00*g*(e*e)/6.0+1.0/w0*k*c*M01*g*e/6.0-1.0/w0*h*c*g*f*M10/6.0-1.0/w0*h*M20*b*f*d/6.0+1.0/w0*h*b*(f*f)*M02/6.0+1.0/w0*k*h*b*M10*d/6.0-1.0/w0*k*b*g*e*M10/6.0-1.0/w0*h*c*b*g*M11/6.0-1.0/w0*k*c*b*M12*e/6.0-1.0/w0*k*M20*b*f*e/6.0+1.0/w0*k*b*g*f*M10/6.0-1.0/w0*(k*k)*M01*a*e/6.0-1.0/w0*(h*h)*M01*f*a/6.0+1.0/w0*h*c*g*e*M10/6.0+1.0/w0*h*c*b*M12*d/6.0-1.0/w0*(h*h)*c*M10*d/6.0+1.0/w0*(h*h)*M00*f*d/6.0+1.0/w0*M20*b*g*f*e/6.0+1.0/w0*(k*k)*M00*e*d/6.0+1.0/w0*b*(f*f)*a*M22/6.0+1.0/w0*k*b*M12*a*e/6.0+1.0/w0*h*c*M12*f*a/6.0+1.0/w0*(k*k)*b*e*M10/6.0+1.0/w0*k*c*b*M12*d/6.0-1.0/w0*k*(b*b)*M12*d/6.0-1.0/w0*(k*k)*M00*(e*e)/6.0-1.0/w0*k*b*f*e*M02/6.0+1.0/w0*M21*c*b*g*f/6.0-1.0/w0*(h*h)*M00*(f*f)/6.0-1.0/w0*c*f*a*M22*e/6.0-1.0/w0*k*M01*b*g*e/6.0-1.0/w0*k*h*c*e*M10/6.0-1.0/w0*M20*c*g*(e*e)/6.0+1.0/w0*(h*h)*c*M11*a/6.0+1.0/w0*h*M20*b*(f*f)/6.0+1.0/w0*M20*c*g*f*e/6.0-1.0/w0*M20*b*g*(f*f)/6.0+1.0/w0*M21*h*(c*c)*e/6.0+1.0/w0*k*M21*(b*b)*f/6.0-1.0/w0*k*h*c*M01*e/6.0+1.0/w0*k*M21*c*a*e/6.0-1.0/w0*k*c*b*g*M11/6.0-1.0/w0*k*h*b*M11*a/6.0+1.0/w0*k*(b*b)*g*M11/6.0-1.0/w0*(k*k)*(b*b)*M11/6.0-1.0/w0*h*c*M12*a*e/6.0-1.0/w0*k*b*M12*f*a/6.0+1.0/w0*k*M20*b*f*d/6.0+1.0/w0*M21*h*b*f*a/6.0-1.0/w0*h*c*f*e*M02/6.0+1.0/w0*(h*h)*c*M01*f/6.0)*D;
  A[0][2]=(1.0/w0*k*M00*g*f*d/3.0+1.0/w0*c*b*(g*g)*M11/6.0-1.0/w0*M21*c*b*g*d/6.0+1.0/w0*k*M21*f*(a*a)/6.0-1.0/w0*k*M20*f*a*d/6.0-1.0/w0*k*b*g*M11*a/6.0+1.0/w0*k*M12*f*(a*a)/6.0-1.0/w0*c*(g*g)*e*M10/6.0+1.0/w0*M21*(c*c)*g*d/6.0+1.0/w0*M21*b*g*f*a/6.0+1.0/w0*(c*c)*g*M12*d/6.0+1.0/w0*h*M00*g*(f*f)/6.0-1.0/w0*(k*k)*M11*(a*a)/6.0-1.0/w0*h*c*g*M11*a/6.0-1.0/w0*c*a*M22*e*d/6.0+1.0/w0*c*(g*g)*f*M10/6.0-1.0/w0*k*b*(d*d)*M02/6.0-1.0/w0*(k*k)*M01*b*d/6.0-1.0/w0*k*c*g*M10*d/6.0-1.0/w0*b*f*a*M22*d/6.0-1.0/w0*k*h*a*M10*d/6.0+1.0/w0*M21*h*c*a*d/6.0+1.0/w0*(c*c)*M22*e*d/6.0-1.0/w0*k*M00*g*e*d/6.0-1.0/w0*k*h*M00*f*d/6.0+1.0/w0*h*M20*c*f*d/6.0-1.0/w0*h*M20*(f*f)*a/6.0+1.0/w0*g*(f*f)*a*M02/6.0-1.0/w0*M21*c*g*f*a/6.0-1.0/w0*c*b*f*M22*d/6.0-1.0/w0*(c*c)*g*M12*e/6.0+1.0/w0*h*c*g*M10*d/6.0+1.0/w0*k*c*g*M11*a/3.0+1.0/w0*k*M20*f*a*e/6.0-1.0/w0*h*M20*c*(d*d)/6.0+1.0/w0*(k*k)*b*M11*a/6.0-1.0/w0*k*h*M01*a*d/6.0-1.0/w0*(c*c)*M22*(d*d)/6.0+1.0/w0*k*M01*b*g*f/6.0-1.0/w0*g*f*a*e*M02/6.0+1.0/w0*M21*h*c*f*a/6.0-1.0/w0*k*c*e*d*M02/6.0-1.0/w0*k*M00*g*f*e/6.0-1.0/w0*k*h*c*M11*a/6.0-1.0/w0*c*g*f*d*M02/6.0+1.0/w0*k*M21*c*b*d/6.0+1.0/w0*h*(c*c)*g*M11/6.0-1.0/w0*k*M20*c*e*d/6.0-1.0/w0*h*M00*g*f*d/6.0-1.0/w0*b*g*(f*f)*M02/6.0-1.0/w0*c*b*g*M12*d/6.0+1.0/w0*k*a*e*d*M02/6.0-1.0/w0*k*M21*b*f*a/6.0+1.0/w0*k*M20*c*(d*d)/6.0+1.0/w0*h*M20*f*a*d/6.0-1.0/w0*(k*k)*a*e*M10/6.0+1.0/w0*k*h*M11*(a*a)/6.0-1.0/w0*h*c*M01*g*f/6.0+1.0/w0*k*b*f*d*M02/6.0+1.0/w0*M00*(g*g)*f*e/6.0+1.0/w0*k*c*(d*d)*M02/6.0+1.0/w0*M20*c*g*e*d/6.0-1.0/w0*h*c*g*f*M10/6.0+1.0/w0*(k*k)*a*M10*d/6.0-1.0/w0*(k*k)*M00*(d*d)/6.0+1.0/w0*c*f*a*M22*d/3.0+1.0/w0*k*M01*b*g*d/6.0+1.0/w0*k*b*M12*a*d/6.0+1.0/w0*k*c*M12*a*e/6.0-1.0/w0*M20*g*f*a*e/6.0-1.0/w0*M01*b*(g*g)*f/6.0-1.0/w0*k*f*a*d*M02/6.0+1.0/w0*k*h*f*a*M10/6.0+1.0/w0*f*(a*a)*M22*e/6.0+1.0/w0*k*h*c*M01*d/6.0-1.0/w0*(c*c)*(g*g)*M11/6.0+1.0/w0*c*b*g*M12*f/6.0-1.0/w0*k*M12*(a*a)*e/6.0-1.0/w0*k*M21*c*a*d/6.0+1.0/w0*h*M01*g*f*a/6.0-1.0/w0*k*g*f*a*M10/6.0-1.0/w0*M21*h*(c*c)*d/6.0+1.0/w0*(k*k)*M00*e*d/6.0+1.0/w0*b*(f*f)*a*M22/6.0-1.0/w0*M20*c*g*f*d/6.0+1.0/w0*k*c*g*e*M10/6.0-1.0/w0*k*c*M12*a*d/6.0+1.0/w0*k*h*M00*(d*d)/6.0-1.0/w0*M21*h*f*(a*a)/6.0-1.0/w0*c*f*a*M22*e/6.0-1.0/w0*k*c*M01*g*d/6.0-1.0/w0*(f*f)*(a*a)*M22/6.0+1.0/w0*c*g*f*e*M02/6.0+1.0/w0*k*g*a*e*M10/6.0+1.0/w0*c*g*M12*a*e/6.0+1.0/w0*b*g*f*d*M02/6.0-1.0/w0*k*M01*g*f*a/6.0+1.0/w0*c*M01*(g*g)*f/6.0+1.0/w0*c*b*M22*(d*d)/6.0-1.0/w0*c*g*M12*f*a/6.0-1.0/w0*k*c*b*g*M11/6.0+1.0/w0*(k*k)*M01*a*d/6.0-1.0/w0*k*b*M12*f*a/6.0-1.0/w0*M00*(g*g)*(f*f)/6.0+1.0/w0*M20*g*(f*f)*a/6.0)*D;
  A[0][3]=(-1.0/w0*k*h*M00*e*d/6.0+1.0/w0*g*a*(e*e)*M02/6.0+1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*c*b*(g*g)*M11/6.0-1.0/w0*M21*c*b*g*d/6.0-1.0/w0*(h*h)*M00*(d*d)/6.0-1.0/w0*h*M20*a*e*d/6.0-1.0/w0*h*b*f*d*M02/6.0-1.0/w0*k*b*g*M11*a/6.0-1.0/w0*c*g*(e*e)*M02/6.0-1.0/w0*h*b*g*M10*d/6.0+1.0/w0*k*M21*b*a*d/6.0+1.0/w0*h*M20*b*(d*d)/6.0+1.0/w0*h*b*(d*d)*M02/6.0-1.0/w0*h*a*e*d*M02/6.0-1.0/w0*(a*a)*M22*(e*e)/6.0-1.0/w0*(b*b)*(g*g)*M11/6.0+1.0/w0*c*g*e*d*M02/6.0-1.0/w0*(h*h)*f*a*M10/6.0+1.0/w0*h*M20*f*a*e/6.0-1.0/w0*h*c*g*M11*a/6.0-1.0/w0*h*M12*f*(a*a)/6.0-1.0/w0*c*a*M22*e*d/6.0-1.0/w0*M21*b*g*a*e/6.0-1.0/w0*k*M21*(b*b)*d/6.0+1.0/w0*c*b*g*M12*e/6.0-1.0/w0*k*M20*b*(d*d)/6.0-1.0/w0*b*f*a*M22*d/6.0-1.0/w0*k*h*a*M10*d/6.0+1.0/w0*h*c*e*d*M02/6.0-1.0/w0*h*M00*g*f*e/6.0+1.0/w0*M01*b*(g*g)*e/6.0-1.0/w0*(h*h)*c*M01*d/6.0-1.0/w0*k*M00*g*e*d/6.0+1.0/w0*k*M21*b*a*e/6.0+1.0/w0*(b*b)*g*M12*d/6.0+1.0/w0*b*(g*g)*e*M10/6.0-1.0/w0*k*h*M01*a*d/6.0+1.0/w0*h*M00*g*e*d/3.0-1.0/w0*c*b*M22*e*d/6.0-1.0/w0*g*f*a*e*M02/6.0+1.0/w0*b*g*M12*f*a/6.0+1.0/w0*M20*g*a*(e*e)/6.0-1.0/w0*M21*h*c*a*e/6.0-1.0/w0*b*g*M12*a*e/6.0-1.0/w0*M00*(g*g)*(e*e)/6.0+1.0/w0*b*g*f*e*M02/6.0-1.0/w0*h*M00*g*f*d/6.0+1.0/w0*M21*h*(a*a)*e/6.0+1.0/w0*k*b*g*M10*d/6.0-1.0/w0*b*f*a*M22*e/6.0+1.0/w0*M21*c*g*a*e/6.0+1.0/w0*(b*b)*f*M22*d/6.0-1.0/w0*c*b*g*M12*d/6.0-1.0/w0*b*(g*g)*f*M10/6.0-1.0/w0*c*M01*(g*g)*e/6.0+1.0/w0*k*h*M11*(a*a)/6.0+1.0/w0*h*b*g*M11*a/3.0+1.0/w0*k*M20*a*e*d/6.0+1.0/w0*M00*(g*g)*f*e/6.0+1.0/w0*h*M12*(a*a)*e/6.0-1.0/w0*h*M01*g*a*e/6.0-1.0/w0*(b*b)*g*M12*f/6.0+1.0/w0*k*M00*g*(e*e)/6.0-1.0/w0*h*M20*b*f*d/6.0+1.0/w0*k*h*M01*b*d/6.0-1.0/w0*M21*h*b*a*d/6.0+1.0/w0*b*a*M22*e*d/3.0-1.0/w0*k*b*g*e*M10/6.0-1.0/w0*h*c*b*g*M11/6.0+1.0/w0*h*b*M12*f*a/6.0-1.0/w0*b*g*e*d*M02/6.0-1.0/w0*M20*g*f*a*e/6.0+1.0/w0*(h*h)*a*M10*d/6.0-1.0/w0*k*M20*a*(e*e)/6.0-1.0/w0*k*M21*(a*a)*e/6.0+1.0/w0*h*c*M12*a*d/6.0+1.0/w0*f*(a*a)*M22*e/6.0+1.0/w0*M21*(b*b)*g*d/6.0+1.0/w0*(h*h)*M00*f*d/6.0-1.0/w0*h*c*(d*d)*M02/6.0-1.0/w0*(h*h)*M11*(a*a)/6.0+1.0/w0*h*c*M01*g*d/6.0-1.0/w0*h*g*a*e*M10/6.0+1.0/w0*h*f*a*d*M02/6.0+1.0/w0*k*h*a*e*M10/6.0+1.0/w0*(h*h)*M01*a*d/6.0+1.0/w0*k*M20*b*e*d/6.0+1.0/w0*k*h*M00*(d*d)/6.0+1.0/w0*h*b*g*f*M10/6.0-1.0/w0*k*M01*b*g*e/6.0+1.0/w0*h*g*f*a*M10/6.0+1.0/w0*(h*h)*c*M11*a/6.0-1.0/w0*M20*b*g*e*d/6.0+1.0/w0*h*c*M01*g*e/6.0+1.0/w0*M20*b*g*f*d/6.0+1.0/w0*c*b*M22*(d*d)/6.0+1.0/w0*M21*h*c*b*d/6.0+1.0/w0*k*M01*g*a*e/6.0-1.0/w0*k*h*b*M11*a/6.0-1.0/w0*h*b*M12*a*d/6.0+1.0/w0*k*(b*b)*g*M11/6.0-1.0/w0*h*c*M12*a*e/6.0-1.0/w0*(b*b)*M22*(d*d)/6.0-1.0/w0*h*M01*b*g*d/6.0)*D;
  A[1][0]=(-1.0/w0*k*h*M00*e*d/6.0+1.0/w0*k*(b*b)*M12*f/6.0+1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*h*(c*c)*M12*e/6.0-1.0/w0*(c*c)*M22*(e*e)/6.0-1.0/w0*h*b*f*d*M02/6.0-1.0/w0*c*g*(e*e)*M02/6.0+1.0/w0*c*b*f*M22*e/3.0+1.0/w0*k*h*c*b*M11/3.0-1.0/w0*M21*h*c*b*f/6.0-1.0/w0*(h*h)*f*a*M10/6.0+1.0/w0*h*M00*g*(f*f)/6.0+1.0/w0*h*M20*f*a*e/6.0+1.0/w0*k*M20*c*(e*e)/6.0-1.0/w0*k*M21*(b*b)*d/6.0+1.0/w0*c*b*g*M12*e/6.0-1.0/w0*(k*k)*M01*b*d/6.0+1.0/w0*h*c*e*d*M02/6.0-1.0/w0*k*M21*c*b*e/6.0+1.0/w0*k*c*(e*e)*M02/6.0-1.0/w0*h*M00*g*f*e/6.0-1.0/w0*(h*h)*(c*c)*M11/6.0-1.0/w0*(h*h)*c*M01*d/6.0-1.0/w0*(b*b)*(f*f)*M22/6.0+1.0/w0*(c*c)*M22*e*d/6.0-1.0/w0*k*h*M00*f*d/6.0+1.0/w0*h*M20*c*f*d/6.0-1.0/w0*h*M20*(f*f)*a/6.0+1.0/w0*k*M21*b*a*e/6.0-1.0/w0*k*h*b*f*M10/6.0-1.0/w0*c*b*f*M22*d/6.0-1.0/w0*(c*c)*g*M12*e/6.0+1.0/w0*k*M20*f*a*e/6.0+1.0/w0*(k*k)*b*M11*a/6.0+1.0/w0*k*M01*b*g*f/6.0-1.0/w0*c*b*M22*e*d/6.0+1.0/w0*M21*h*c*f*a/6.0-1.0/w0*k*h*M01*b*f/6.0-1.0/w0*k*c*e*d*M02/6.0-1.0/w0*k*M00*g*f*e/6.0-1.0/w0*k*h*c*M11*a/6.0-1.0/w0*M21*h*c*a*e/6.0+1.0/w0*(h*h)*c*f*M10/6.0-1.0/w0*h*M20*c*f*e/6.0+1.0/w0*k*h*M00*f*e/3.0+1.0/w0*k*M21*c*b*d/6.0+1.0/w0*h*(c*c)*g*M11/6.0-1.0/w0*k*M20*c*e*d/6.0+1.0/w0*b*g*f*e*M02/6.0-1.0/w0*h*c*b*M12*f/6.0-1.0/w0*b*f*a*M22*e/6.0+1.0/w0*(k*k)*M01*b*e/6.0+1.0/w0*(b*b)*f*M22*d/6.0-1.0/w0*b*g*(f*f)*M02/6.0-1.0/w0*k*M21*b*f*a/6.0-1.0/w0*(k*k)*a*e*M10/6.0-1.0/w0*h*c*M01*g*f/6.0+1.0/w0*k*b*f*d*M02/6.0-1.0/w0*(b*b)*g*M12*f/6.0+1.0/w0*k*M00*g*(e*e)/6.0-1.0/w0*h*c*g*f*M10/6.0-1.0/w0*h*M20*b*f*d/6.0+1.0/w0*h*b*(f*f)*M02/6.0+1.0/w0*k*h*M01*b*d/6.0-1.0/w0*k*b*g*e*M10/6.0-1.0/w0*h*c*b*g*M11/6.0+1.0/w0*h*b*M12*f*a/6.0+1.0/w0*k*c*M12*a*e/6.0-1.0/w0*k*c*b*M12*e/6.0-1.0/w0*k*M20*b*f*e/6.0-1.0/w0*k*M20*a*(e*e)/6.0+1.0/w0*k*h*f*a*M10/6.0+1.0/w0*k*h*c*M01*d/6.0+1.0/w0*c*b*g*M12*f/6.0+1.0/w0*(h*h)*M00*f*d/6.0-1.0/w0*M21*h*(c*c)*d/6.0+1.0/w0*(k*k)*M00*e*d/6.0+1.0/w0*b*(f*f)*a*M22/6.0+1.0/w0*(k*k)*b*e*M10/6.0+1.0/w0*k*h*a*e*M10/6.0+1.0/w0*k*c*g*e*M10/6.0+1.0/w0*k*M20*b*e*d/6.0-1.0/w0*(k*k)*M00*(e*e)/6.0-1.0/w0*k*b*f*e*M02/6.0+1.0/w0*h*b*g*f*M10/6.0-1.0/w0*(h*h)*M00*(f*f)/6.0-1.0/w0*c*f*a*M22*e/6.0-1.0/w0*k*M01*b*g*e/6.0-1.0/w0*k*h*c*e*M10/6.0+1.0/w0*c*g*f*e*M02/6.0+1.0/w0*(h*h)*c*M11*a/6.0+1.0/w0*h*M20*b*(f*f)/6.0+1.0/w0*h*c*M01*g*e/6.0+1.0/w0*M21*h*c*b*d/6.0+1.0/w0*M21*h*(c*c)*e/6.0+1.0/w0*k*M21*(b*b)*f/6.0-1.0/w0*k*h*c*M01*e/6.0-1.0/w0*k*c*b*g*M11/6.0-1.0/w0*k*h*b*M11*a/6.0+1.0/w0*k*(b*b)*g*M11/6.0-1.0/w0*(k*k)*(b*b)*M11/6.0-1.0/w0*h*c*M12*a*e/6.0-1.0/w0*k*b*M12*f*a/6.0-1.0/w0*h*c*f*e*M02/6.0+1.0/w0*(h*h)*c*M01*f/6.0)*D;
  A[1][1]=(-1.0/w0*k*(b*b)*M12*f/6.0-1.0/w0*h*(c*c)*M12*e/6.0+1.0/w0*(c*c)*M22*(e*e)/6.0-1.0/w0*c*b*f*M22*e/3.0-1.0/w0*k*h*c*b*M11/3.0+1.0/w0*M21*h*c*b*f/6.0-1.0/w0*k*M20*c*(e*e)/6.0+1.0/w0*k*M21*c*b*e/6.0-1.0/w0*k*c*(e*e)*M02/6.0+1.0/w0*(h*h)*(c*c)*M11/6.0+1.0/w0*(b*b)*(f*f)*M22/6.0+1.0/w0*k*h*b*f*M10/6.0+1.0/w0*k*h*M01*b*f/6.0-1.0/w0*(h*h)*c*f*M10/6.0+1.0/w0*h*M20*c*f*e/6.0-1.0/w0*k*h*M00*f*e/3.0+1.0/w0*h*c*b*M12*f/6.0-1.0/w0*(k*k)*M01*b*e/6.0-1.0/w0*h*b*(f*f)*M02/6.0+1.0/w0*k*c*b*M12*e/6.0+1.0/w0*k*M20*b*f*e/6.0-1.0/w0*(k*k)*b*e*M10/6.0+1.0/w0*(k*k)*M00*(e*e)/6.0+1.0/w0*k*b*f*e*M02/6.0+1.0/w0*(h*h)*M00*(f*f)/6.0+1.0/w0*k*h*c*e*M10/6.0-1.0/w0*h*M20*b*(f*f)/6.0-1.0/w0*M21*h*(c*c)*e/6.0-1.0/w0*k*M21*(b*b)*f/6.0+1.0/w0*k*h*c*M01*e/6.0+1.0/w0*(k*k)*(b*b)*M11/6.0+1.0/w0*h*c*f*e*M02/6.0-1.0/w0*(h*h)*c*M01*f/6.0)*D;
  A[1][2]=(-1.0/w0*h*M00*g*(f*f)/6.0+1.0/w0*(k*k)*M01*b*d/6.0-1.0/w0*(c*c)*M22*e*d/6.0+1.0/w0*k*h*M00*f*d/6.0-1.0/w0*h*M20*c*f*d/6.0+1.0/w0*h*M20*(f*f)*a/6.0+1.0/w0*c*b*f*M22*d/6.0+1.0/w0*(c*c)*g*M12*e/6.0-1.0/w0*k*M20*f*a*e/6.0-1.0/w0*(k*k)*b*M11*a/6.0-1.0/w0*k*M01*b*g*f/6.0-1.0/w0*M21*h*c*f*a/6.0+1.0/w0*k*c*e*d*M02/6.0+1.0/w0*k*M00*g*f*e/6.0+1.0/w0*k*h*c*M11*a/6.0-1.0/w0*k*M21*c*b*d/6.0-1.0/w0*h*(c*c)*g*M11/6.0+1.0/w0*k*M20*c*e*d/6.0+1.0/w0*b*g*(f*f)*M02/6.0+1.0/w0*k*M21*b*f*a/6.0+1.0/w0*(k*k)*a*e*M10/6.0+1.0/w0*h*c*M01*g*f/6.0-1.0/w0*k*b*f*d*M02/6.0+1.0/w0*h*c*g*f*M10/6.0-1.0/w0*k*c*M12*a*e/6.0-1.0/w0*k*h*f*a*M10/6.0-1.0/w0*k*h*c*M01*d/6.0-1.0/w0*c*b*g*M12*f/6.0+1.0/w0*M21*h*(c*c)*d/6.0-1.0/w0*(k*k)*M00*e*d/6.0-1.0/w0*b*(f*f)*a*M22/6.0-1.0/w0*k*c*g*e*M10/6.0+1.0/w0*c*f*a*M22*e/6.0-1.0/w0*c*g*f*e*M02/6.0+1.0/w0*k*c*b*g*M11/6.0+1.0/w0*k*b*M12*f*a/6.0)*D;
  A[1][3]=(1.0/w0*k*h*M00*e*d/6.0-1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*h*b*f*d*M02/6.0+1.0/w0*c*g*(e*e)*M02/6.0+1.0/w0*(h*h)*f*a*M10/6.0-1.0/w0*h*M20*f*a*e/6.0+1.0/w0*k*M21*(b*b)*d/6.0-1.0/w0*c*b*g*M12*e/6.0-1.0/w0*h*c*e*d*M02/6.0+1.0/w0*h*M00*g*f*e/6.0+1.0/w0*(h*h)*c*M01*d/6.0-1.0/w0*k*M21*b*a*e/6.0+1.0/w0*c*b*M22*e*d/6.0+1.0/w0*M21*h*c*a*e/6.0-1.0/w0*b*g*f*e*M02/6.0+1.0/w0*b*f*a*M22*e/6.0-1.0/w0*(b*b)*f*M22*d/6.0+1.0/w0*(b*b)*g*M12*f/6.0-1.0/w0*k*M00*g*(e*e)/6.0+1.0/w0*h*M20*b*f*d/6.0-1.0/w0*k*h*M01*b*d/6.0+1.0/w0*k*b*g*e*M10/6.0+1.0/w0*h*c*b*g*M11/6.0-1.0/w0*h*b*M12*f*a/6.0+1.0/w0*k*M20*a*(e*e)/6.0-1.0/w0*(h*h)*M00*f*d/6.0-1.0/w0*k*h*a*e*M10/6.0-1.0/w0*k*M20*b*e*d/6.0-1.0/w0*h*b*g*f*M10/6.0+1.0/w0*k*M01*b*g*e/6.0-1.0/w0*(h*h)*c*M11*a/6.0-1.0/w0*h*c*M01*g*e/6.0-1.0/w0*M21*h*c*b*d/6.0+1.0/w0*k*h*b*M11*a/6.0-1.0/w0*k*(b*b)*g*M11/6.0+1.0/w0*h*c*M12*a*e/6.0)*D;
  A[2][0]=(1.0/w0*k*M00*g*f*d/3.0+1.0/w0*c*b*(g*g)*M11/6.0-1.0/w0*M21*c*b*g*d/6.0+1.0/w0*k*M21*f*(a*a)/6.0-1.0/w0*k*M20*f*a*d/6.0-1.0/w0*k*b*g*M11*a/6.0+1.0/w0*k*M12*f*(a*a)/6.0+1.0/w0*k*M21*b*a*d/6.0+1.0/w0*M21*(c*c)*g*d/6.0+1.0/w0*k*f*a*e*M02/6.0+1.0/w0*c*g*e*d*M02/6.0+1.0/w0*(c*c)*g*M12*d/6.0+1.0/w0*h*M00*g*(f*f)/6.0-1.0/w0*(k*k)*M11*(a*a)/6.0+1.0/w0*k*h*M01*f*a/6.0-1.0/w0*h*c*g*M11*a/6.0-1.0/w0*h*M12*f*(a*a)/6.0-1.0/w0*c*a*M22*e*d/6.0+1.0/w0*c*(g*g)*f*M10/6.0-1.0/w0*(k*k)*b*M10*d/6.0-1.0/w0*k*c*g*M10*d/6.0-1.0/w0*k*M20*b*(d*d)/6.0-1.0/w0*b*f*a*M22*d/6.0-1.0/w0*k*h*a*M10*d/6.0+1.0/w0*k*h*c*M10*d/6.0+1.0/w0*(c*c)*M22*e*d/6.0-1.0/w0*k*M00*g*e*d/6.0-1.0/w0*k*h*M00*f*d/6.0+1.0/w0*g*(f*f)*a*M02/6.0-1.0/w0*M21*c*g*f*a/6.0-1.0/w0*c*b*f*M22*d/6.0-1.0/w0*M21*(c*c)*g*e/6.0+1.0/w0*h*c*f*d*M02/6.0+1.0/w0*k*c*g*M11*a/3.0+1.0/w0*(k*k)*b*M11*a/6.0-1.0/w0*k*h*M01*a*d/6.0-1.0/w0*(c*c)*M22*(d*d)/6.0-1.0/w0*g*f*a*e*M02/6.0-1.0/w0*h*(f*f)*a*M02/6.0+1.0/w0*b*g*M12*f*a/6.0-1.0/w0*k*c*e*d*M02/6.0-1.0/w0*k*M00*g*f*e/6.0-1.0/w0*h*(c*c)*M12*d/6.0-1.0/w0*k*h*c*M11*a/6.0-1.0/w0*c*g*f*d*M02/6.0+1.0/w0*h*(c*c)*g*M11/6.0-1.0/w0*k*M20*c*e*d/6.0-1.0/w0*h*M00*g*f*d/6.0+1.0/w0*k*b*g*M10*d/6.0+1.0/w0*M21*c*g*a*e/6.0-1.0/w0*c*b*g*M12*d/6.0-1.0/w0*k*M21*b*f*a/6.0+1.0/w0*k*M20*c*(d*d)/6.0-1.0/w0*b*(g*g)*f*M10/6.0-1.0/w0*c*M01*(g*g)*e/6.0+1.0/w0*k*h*M11*(a*a)/6.0-1.0/w0*h*c*M01*g*f/6.0+1.0/w0*k*M20*a*e*d/6.0+1.0/w0*M00*(g*g)*f*e/6.0+1.0/w0*k*c*(d*d)*M02/6.0+1.0/w0*k*c*M01*g*e/6.0-1.0/w0*h*c*g*f*M10/6.0+1.0/w0*(k*k)*a*M10*d/6.0-1.0/w0*(k*k)*M00*(d*d)/6.0+1.0/w0*c*f*a*M22*d/3.0-1.0/w0*M20*g*f*a*e/6.0+1.0/w0*k*b*g*f*M10/6.0-1.0/w0*k*f*a*d*M02/6.0-1.0/w0*(k*k)*M01*a*e/6.0-1.0/w0*k*M21*(a*a)*e/6.0+1.0/w0*h*c*M12*a*d/6.0+1.0/w0*f*(a*a)*M22*e/6.0-1.0/w0*(c*c)*(g*g)*M11/6.0-1.0/w0*k*M21*c*a*d/6.0-1.0/w0*h*c*(d*d)*M02/6.0+1.0/w0*h*c*M01*g*d/6.0-1.0/w0*k*g*f*a*M10/6.0+1.0/w0*(k*k)*M00*e*d/6.0+1.0/w0*b*(f*f)*a*M22/6.0-1.0/w0*M20*c*g*f*d/6.0+1.0/w0*h*c*M12*f*a/6.0+1.0/w0*h*f*a*d*M02/6.0+1.0/w0*k*c*b*M12*d/6.0-1.0/w0*k*c*M12*a*d/6.0+1.0/w0*M21*c*b*g*f/6.0+1.0/w0*k*h*M00*(d*d)/6.0-1.0/w0*c*f*a*M22*e/6.0+1.0/w0*h*g*f*a*M10/6.0-1.0/w0*k*c*M01*g*d/6.0-1.0/w0*(f*f)*(a*a)*M22/6.0-1.0/w0*k*M01*g*f*a/6.0+1.0/w0*c*M01*(g*g)*f/6.0+1.0/w0*M20*b*g*f*d/6.0+1.0/w0*c*b*M22*(d*d)/6.0+1.0/w0*M20*c*g*f*e/6.0-1.0/w0*M20*b*g*(f*f)/6.0+1.0/w0*k*M01*g*a*e/6.0+1.0/w0*k*M21*c*a*e/6.0-1.0/w0*c*g*M12*f*a/6.0-1.0/w0*k*c*b*g*M11/6.0+1.0/w0*(k*k)*M01*a*d/6.0-1.0/w0*k*b*M12*f*a/6.0-1.0/w0*M00*(g*g)*(f*f)/6.0+1.0/w0*k*M20*b*f*d/6.0+1.0/w0*M20*g*(f*f)*a/6.0)*D;
  A[2][1]=(-1.0/w0*k*f*a*e*M02/6.0-1.0/w0*h*M00*g*(f*f)/6.0-1.0/w0*k*h*M01*f*a/6.0+1.0/w0*(k*k)*b*M10*d/6.0-1.0/w0*k*h*c*M10*d/6.0-1.0/w0*(c*c)*M22*e*d/6.0+1.0/w0*k*h*M00*f*d/6.0+1.0/w0*c*b*f*M22*d/6.0+1.0/w0*M21*(c*c)*g*e/6.0-1.0/w0*h*c*f*d*M02/6.0-1.0/w0*(k*k)*b*M11*a/6.0+1.0/w0*h*(f*f)*a*M02/6.0+1.0/w0*k*c*e*d*M02/6.0+1.0/w0*k*M00*g*f*e/6.0+1.0/w0*h*(c*c)*M12*d/6.0+1.0/w0*k*h*c*M11*a/6.0-1.0/w0*h*(c*c)*g*M11/6.0+1.0/w0*k*M20*c*e*d/6.0+1.0/w0*k*M21*b*f*a/6.0+1.0/w0*h*c*M01*g*f/6.0-1.0/w0*k*c*M01*g*e/6.0+1.0/w0*h*c*g*f*M10/6.0-1.0/w0*k*b*g*f*M10/6.0+1.0/w0*(k*k)*M01*a*e/6.0-1.0/w0*(k*k)*M00*e*d/6.0-1.0/w0*b*(f*f)*a*M22/6.0-1.0/w0*h*c*M12*f*a/6.0-1.0/w0*k*c*b*M12*d/6.0-1.0/w0*M21*c*b*g*f/6.0+1.0/w0*c*f*a*M22*e/6.0-1.0/w0*M20*c*g*f*e/6.0+1.0/w0*M20*b*g*(f*f)/6.0-1.0/w0*k*M21*c*a*e/6.0+1.0/w0*k*c*b*g*M11/6.0+1.0/w0*k*b*M12*f*a/6.0-1.0/w0*k*M20*b*f*d/6.0)*D;
  A[2][2]=(-1.0/w0*k*M00*g*f*d/3.0-1.0/w0*k*M21*f*(a*a)/6.0+1.0/w0*k*M20*f*a*d/6.0-1.0/w0*k*M12*f*(a*a)/6.0-1.0/w0*M21*(c*c)*g*d/6.0-1.0/w0*(c*c)*g*M12*d/6.0+1.0/w0*(k*k)*M11*(a*a)/6.0-1.0/w0*c*(g*g)*f*M10/6.0+1.0/w0*k*c*g*M10*d/6.0-1.0/w0*g*(f*f)*a*M02/6.0+1.0/w0*M21*c*g*f*a/6.0-1.0/w0*k*c*g*M11*a/3.0+1.0/w0*(c*c)*M22*(d*d)/6.0+1.0/w0*c*g*f*d*M02/6.0-1.0/w0*k*M20*c*(d*d)/6.0-1.0/w0*k*c*(d*d)*M02/6.0-1.0/w0*(k*k)*a*M10*d/6.0+1.0/w0*(k*k)*M00*(d*d)/6.0-1.0/w0*c*f*a*M22*d/3.0+1.0/w0*k*f*a*d*M02/6.0+1.0/w0*(c*c)*(g*g)*M11/6.0+1.0/w0*k*M21*c*a*d/6.0+1.0/w0*k*g*f*a*M10/6.0+1.0/w0*M20*c*g*f*d/6.0+1.0/w0*k*c*M12*a*d/6.0+1.0/w0*k*c*M01*g*d/6.0+1.0/w0*(f*f)*(a*a)*M22/6.0+1.0/w0*k*M01*g*f*a/6.0-1.0/w0*c*M01*(g*g)*f/6.0+1.0/w0*c*g*M12*f*a/6.0-1.0/w0*(k*k)*M01*a*d/6.0+1.0/w0*M00*(g*g)*(f*f)/6.0-1.0/w0*M20*g*(f*f)*a/6.0)*D;
  A[2][3]=(-1.0/w0*c*b*(g*g)*M11/6.0+1.0/w0*M21*c*b*g*d/6.0+1.0/w0*k*b*g*M11*a/6.0-1.0/w0*k*M21*b*a*d/6.0-1.0/w0*c*g*e*d*M02/6.0+1.0/w0*h*c*g*M11*a/6.0+1.0/w0*h*M12*f*(a*a)/6.0+1.0/w0*c*a*M22*e*d/6.0+1.0/w0*k*M20*b*(d*d)/6.0+1.0/w0*b*f*a*M22*d/6.0+1.0/w0*k*h*a*M10*d/6.0+1.0/w0*k*M00*g*e*d/6.0+1.0/w0*k*h*M01*a*d/6.0+1.0/w0*g*f*a*e*M02/6.0-1.0/w0*b*g*M12*f*a/6.0+1.0/w0*h*M00*g*f*d/6.0-1.0/w0*k*b*g*M10*d/6.0-1.0/w0*M21*c*g*a*e/6.0+1.0/w0*c*b*g*M12*d/6.0+1.0/w0*b*(g*g)*f*M10/6.0+1.0/w0*c*M01*(g*g)*e/6.0-1.0/w0*k*h*M11*(a*a)/6.0-1.0/w0*k*M20*a*e*d/6.0-1.0/w0*M00*(g*g)*f*e/6.0+1.0/w0*M20*g*f*a*e/6.0+1.0/w0*k*M21*(a*a)*e/6.0-1.0/w0*h*c*M12*a*d/6.0-1.0/w0*f*(a*a)*M22*e/6.0+1.0/w0*h*c*(d*d)*M02/6.0-1.0/w0*h*c*M01*g*d/6.0-1.0/w0*h*f*a*d*M02/6.0-1.0/w0*k*h*M00*(d*d)/6.0-1.0/w0*h*g*f*a*M10/6.0-1.0/w0*M20*b*g*f*d/6.0-1.0/w0*c*b*M22*(d*d)/6.0-1.0/w0*k*M01*g*a*e/6.0)*D;
  A[3][0]=(-1.0/w0*k*h*M00*e*d/6.0+1.0/w0*h*M20*c*e*d/6.0+1.0/w0*g*a*(e*e)*M02/6.0+1.0/w0*k*b*e*d*M02/6.0+1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*c*b*(g*g)*M11/6.0-1.0/w0*M21*c*b*g*d/6.0-1.0/w0*(h*h)*M00*(d*d)/6.0-1.0/w0*h*M20*a*e*d/6.0-1.0/w0*h*b*f*d*M02/6.0-1.0/w0*k*b*g*M11*a/6.0+1.0/w0*k*h*M01*a*e/6.0-1.0/w0*h*b*g*M10*d/6.0-1.0/w0*c*(g*g)*e*M10/6.0+1.0/w0*h*M20*b*(d*d)/6.0+1.0/w0*h*b*(d*d)*M02/6.0-1.0/w0*h*a*e*d*M02/6.0-1.0/w0*(a*a)*M22*(e*e)/6.0-1.0/w0*(b*b)*(g*g)*M11/6.0+1.0/w0*M21*b*g*f*a/6.0-1.0/w0*h*c*g*M11*a/6.0-1.0/w0*k*a*(e*e)*M02/6.0-1.0/w0*c*a*M22*e*d/6.0-1.0/w0*M21*b*g*a*e/6.0-1.0/w0*k*b*(d*d)*M02/6.0-1.0/w0*b*f*a*M22*d/6.0-1.0/w0*k*h*a*M10*d/6.0-1.0/w0*h*M00*g*f*e/6.0+1.0/w0*M01*b*(g*g)*e/6.0+1.0/w0*M21*h*c*a*d/6.0+1.0/w0*h*M01*b*g*f/6.0-1.0/w0*k*M00*g*e*d/6.0+1.0/w0*(b*b)*g*M12*d/6.0+1.0/w0*h*c*g*M10*d/6.0+1.0/w0*b*(g*g)*e*M10/6.0-1.0/w0*h*M20*c*(d*d)/6.0-1.0/w0*k*h*M01*a*d/6.0+1.0/w0*h*M00*g*e*d/3.0-1.0/w0*c*b*M22*e*d/6.0+1.0/w0*M21*c*b*g*e/6.0-1.0/w0*g*f*a*e*M02/6.0+1.0/w0*M20*g*a*(e*e)/6.0-1.0/w0*M21*h*c*a*e/6.0-1.0/w0*b*g*M12*a*e/6.0-1.0/w0*M00*(g*g)*(e*e)/6.0-1.0/w0*h*M00*g*f*d/6.0+1.0/w0*M21*h*(a*a)*e/6.0-1.0/w0*b*f*a*M22*e/6.0+1.0/w0*(b*b)*f*M22*d/6.0+1.0/w0*h*f*a*e*M02/6.0-1.0/w0*M21*(b*b)*g*f/6.0-1.0/w0*c*b*g*M12*d/6.0+1.0/w0*k*a*e*d*M02/6.0+1.0/w0*h*M20*f*a*d/6.0+1.0/w0*k*h*M11*(a*a)/6.0+1.0/w0*h*b*g*M11*a/3.0+1.0/w0*M00*(g*g)*f*e/6.0+1.0/w0*h*M12*(a*a)*e/6.0+1.0/w0*M20*c*g*e*d/6.0-1.0/w0*h*M01*g*a*e/6.0+1.0/w0*k*M00*g*(e*e)/6.0-1.0/w0*h*M20*b*f*d/6.0+1.0/w0*k*M01*b*g*d/6.0-1.0/w0*M21*h*b*a*d/6.0+1.0/w0*k*h*b*M10*d/6.0+1.0/w0*b*a*M22*e*d/3.0-1.0/w0*k*b*g*e*M10/6.0+1.0/w0*k*b*M12*a*d/6.0-1.0/w0*h*c*b*g*M11/6.0-1.0/w0*b*g*e*d*M02/6.0-1.0/w0*M20*g*f*a*e/6.0-1.0/w0*M01*b*(g*g)*f/6.0+1.0/w0*(h*h)*a*M10*d/6.0-1.0/w0*(h*h)*M01*f*a/6.0+1.0/w0*h*c*g*e*M10/6.0+1.0/w0*f*(a*a)*M22*e/6.0+1.0/w0*h*c*b*M12*d/6.0-1.0/w0*(h*h)*c*M10*d/6.0+1.0/w0*M21*(b*b)*g*d/6.0-1.0/w0*k*M12*(a*a)*e/6.0+1.0/w0*h*M01*g*f*a/6.0+1.0/w0*(h*h)*M00*f*d/6.0+1.0/w0*M20*b*g*f*e/6.0-1.0/w0*(h*h)*M11*(a*a)/6.0-1.0/w0*h*g*a*e*M10/6.0+1.0/w0*k*b*M12*a*e/6.0-1.0/w0*k*(b*b)*M12*d/6.0+1.0/w0*(h*h)*M01*a*d/6.0+1.0/w0*k*h*M00*(d*d)/6.0-1.0/w0*M21*h*f*(a*a)/6.0-1.0/w0*k*M01*b*g*e/6.0+1.0/w0*k*g*a*e*M10/6.0-1.0/w0*M20*c*g*(e*e)/6.0+1.0/w0*(h*h)*c*M11*a/6.0+1.0/w0*c*g*M12*a*e/6.0+1.0/w0*b*g*f*d*M02/6.0-1.0/w0*M20*b*g*e*d/6.0+1.0/w0*c*b*M22*(d*d)/6.0-1.0/w0*k*h*b*M11*a/6.0-1.0/w0*h*b*M12*a*d/6.0+1.0/w0*k*(b*b)*g*M11/6.0-1.0/w0*h*c*M12*a*e/6.0+1.0/w0*M21*h*b*f*a/6.0-1.0/w0*(b*b)*M22*(d*d)/6.0-1.0/w0*h*M01*b*g*d/6.0)*D;
  A[3][1]=(1.0/w0*k*h*M00*e*d/6.0-1.0/w0*h*M20*c*e*d/6.0-1.0/w0*k*b*e*d*M02/6.0-1.0/w0*c*a*M22*(e*e)/6.0+1.0/w0*h*b*f*d*M02/6.0-1.0/w0*k*h*M01*a*e/6.0+1.0/w0*k*a*(e*e)*M02/6.0+1.0/w0*h*M00*g*f*e/6.0-1.0/w0*h*M01*b*g*f/6.0+1.0/w0*c*b*M22*e*d/6.0-1.0/w0*M21*c*b*g*e/6.0+1.0/w0*M21*h*c*a*e/6.0+1.0/w0*b*f*a*M22*e/6.0-1.0/w0*(b*b)*f*M22*d/6.0-1.0/w0*h*f*a*e*M02/6.0+1.0/w0*M21*(b*b)*g*f/6.0-1.0/w0*k*M00*g*(e*e)/6.0+1.0/w0*h*M20*b*f*d/6.0-1.0/w0*k*h*b*M10*d/6.0+1.0/w0*k*b*g*e*M10/6.0+1.0/w0*h*c*b*g*M11/6.0+1.0/w0*(h*h)*M01*f*a/6.0-1.0/w0*h*c*g*e*M10/6.0-1.0/w0*h*c*b*M12*d/6.0+1.0/w0*(h*h)*c*M10*d/6.0-1.0/w0*(h*h)*M00*f*d/6.0-1.0/w0*M20*b*g*f*e/6.0-1.0/w0*k*b*M12*a*e/6.0+1.0/w0*k*(b*b)*M12*d/6.0+1.0/w0*k*M01*b*g*e/6.0+1.0/w0*M20*c*g*(e*e)/6.0-1.0/w0*(h*h)*c*M11*a/6.0+1.0/w0*k*h*b*M11*a/6.0-1.0/w0*k*(b*b)*g*M11/6.0+1.0/w0*h*c*M12*a*e/6.0-1.0/w0*M21*h*b*f*a/6.0)*D;
  A[3][2]=(-1.0/w0*c*b*(g*g)*M11/6.0+1.0/w0*M21*c*b*g*d/6.0+1.0/w0*k*b*g*M11*a/6.0+1.0/w0*c*(g*g)*e*M10/6.0-1.0/w0*M21*b*g*f*a/6.0+1.0/w0*h*c*g*M11*a/6.0+1.0/w0*c*a*M22*e*d/6.0+1.0/w0*k*b*(d*d)*M02/6.0+1.0/w0*b*f*a*M22*d/6.0+1.0/w0*k*h*a*M10*d/6.0-1.0/w0*M21*h*c*a*d/6.0+1.0/w0*k*M00*g*e*d/6.0-1.0/w0*h*c*g*M10*d/6.0+1.0/w0*h*M20*c*(d*d)/6.0+1.0/w0*k*h*M01*a*d/6.0+1.0/w0*g*f*a*e*M02/6.0+1.0/w0*h*M00*g*f*d/6.0+1.0/w0*c*b*g*M12*d/6.0-1.0/w0*k*a*e*d*M02/6.0-1.0/w0*h*M20*f*a*d/6.0-1.0/w0*k*h*M11*(a*a)/6.0-1.0/w0*M00*(g*g)*f*e/6.0-1.0/w0*M20*c*g*e*d/6.0-1.0/w0*k*M01*b*g*d/6.0-1.0/w0*k*b*M12*a*d/6.0+1.0/w0*M20*g*f*a*e/6.0+1.0/w0*M01*b*(g*g)*f/6.0-1.0/w0*f*(a*a)*M22*e/6.0+1.0/w0*k*M12*(a*a)*e/6.0-1.0/w0*h*M01*g*f*a/6.0-1.0/w0*k*h*M00*(d*d)/6.0+1.0/w0*M21*h*f*(a*a)/6.0-1.0/w0*k*g*a*e*M10/6.0-1.0/w0*c*g*M12*a*e/6.0-1.0/w0*b*g*f*d*M02/6.0-1.0/w0*c*b*M22*(d*d)/6.0)*D;
  A[3][3]=(-1.0/w0*g*a*(e*e)*M02/6.0+1.0/w0*(h*h)*M00*(d*d)/6.0+1.0/w0*h*M20*a*e*d/6.0+1.0/w0*h*b*g*M10*d/6.0-1.0/w0*h*M20*b*(d*d)/6.0-1.0/w0*h*b*(d*d)*M02/6.0+1.0/w0*h*a*e*d*M02/6.0+1.0/w0*(a*a)*M22*(e*e)/6.0+1.0/w0*(b*b)*(g*g)*M11/6.0+1.0/w0*M21*b*g*a*e/6.0-1.0/w0*M01*b*(g*g)*e/6.0-1.0/w0*(b*b)*g*M12*d/6.0-1.0/w0*b*(g*g)*e*M10/6.0-1.0/w0*h*M00*g*e*d/3.0-1.0/w0*M20*g*a*(e*e)/6.0+1.0/w0*b*g*M12*a*e/6.0+1.0/w0*M00*(g*g)*(e*e)/6.0-1.0/w0*M21*h*(a*a)*e/6.0-1.0/w0*h*b*g*M11*a/3.0-1.0/w0*h*M12*(a*a)*e/6.0+1.0/w0*h*M01*g*a*e/6.0+1.0/w0*M21*h*b*a*d/6.0-1.0/w0*b*a*M22*e*d/3.0+1.0/w0*b*g*e*d*M02/6.0-1.0/w0*(h*h)*a*M10*d/6.0-1.0/w0*M21*(b*b)*g*d/6.0+1.0/w0*(h*h)*M11*(a*a)/6.0+1.0/w0*h*g*a*e*M10/6.0-1.0/w0*(h*h)*M01*a*d/6.0+1.0/w0*M20*b*g*e*d/6.0+1.0/w0*h*b*M12*a*d/6.0+1.0/w0*(b*b)*M22*(d*d)/6.0+1.0/w0*h*M01*b*g*d/6.0)*D;

}

